!$top_left_corner:t=location:c=1:d=-225,225,0
!$h_length:t=real:c=1:d=450
!$v_length:t=real:c=1:d=450
!$h_cell:t=real:c=1:d=50
!$v_cell:t=real:c=1:d=50
!$radius:t=real:c=1:d=1
!$material:t=material:c=1:d=.materials.aluminum

var set var=myMod &
	object=(eval(DB_DEFAULT( system_defaults , "model" )))

if condition=(MOD($h_length,$h_cell)==0.0 && MOD($v_length,$v_cell)==0.0)
	
	! horizontal links
	for variable=h_linkCntr start=0 end=(eval(RTOI($h_length/$h_cell-1)))
		for variable=v_linkCntr start=0 end=(eval(RTOI($v_length/$v_cell)))
			part create rigid_body name_and_position &
				part_name=(eval(myMod//".hlnk_"//RTOI(h_linkCntr)//"_"//RTOI(v_linkCntr)))
			part modify rigid_body mass_properties &
				part_name=(eval(myMod//".hlnk_"//RTOI(h_linkCntr)//"_"//RTOI(v_linkCntr))) material=$material
			part attributes &
				part_name=(eval(myMod//".hlnk_"//RTOI(h_linkCntr)//"_"//RTOI(v_linkCntr))) &
				color=RED name_vis=off
			marker create marker=(eval(myMod//".hlnk_"//RTOI(h_linkCntr)//"_"//RTOI(v_linkCntr)//".cntMar")) &
				location=(eval({$top_left_corner}+{h_linkCntr*$h_cell,-v_linkCntr*$v_cell,0})) &
				orientation=90.0, 90.0, 0.0
			geometry create shape cylinder &
				cylinder_name=(eval(myMod//".hlnk_"//RTOI(h_linkCntr)//"_"//RTOI(v_linkCntr)//".cyl")) &
				length=($h_cell) &
				radius=($radius) &
				angle=360.0d &
				side_count_for_body=20 &
				segment_count_for_ends=20 &
				center_marker=(eval(myMod//".hlnk_"//RTOI(h_linkCntr)//"_"//RTOI(v_linkCntr)//".cntMar"))
			marker create marker=(eval(myMod//".hlnk_"//RTOI(h_linkCntr)//"_"//RTOI(v_linkCntr)//".endMar")) &
				location=(eval({$top_left_corner}+{(h_linkCntr+1)*$h_cell,-v_linkCntr*$v_cell,0})) &
				orientation=0.0, 0.0, 0.0
			marker create marker=(eval(myMod//".hlnk_"//RTOI(h_linkCntr)//"_"//RTOI(v_linkCntr)//".cmMar")) &
				location=(eval(stoo(myMod//".hlnk_"//RTOI(h_linkCntr)//"_"//RTOI(v_linkCntr)//".cm").loc)) &
				orientation=0.0, 0.0, 0.0
		end
	end
	
	! vertical links
	for variable=h_linkCntr start=0 end=(eval(RTOI($h_length/$h_cell)))
		for variable=v_linkCntr start=0 end=(eval(RTOI($v_length/$v_cell-1)))
			part create rigid_body name_and_position &
				part_name=(eval(myMod//".vlnk_"//RTOI(h_linkCntr)//"_"//RTOI(v_linkCntr)))
			part modify rigid_body mass_properties &
				part_name=(eval(myMod//".vlnk_"//RTOI(h_linkCntr)//"_"//RTOI(v_linkCntr))) material=$material
			part attributes &
				part_name=(eval(myMod//".vlnk_"//RTOI(h_linkCntr)//"_"//RTOI(v_linkCntr))) &
				color=RED name_vis=off
			marker create marker=(eval(myMod//".vlnk_"//RTOI(h_linkCntr)//"_"//RTOI(v_linkCntr)//".cntMar")) &
				location=(eval({$top_left_corner}+{h_linkCntr*$h_cell,-v_linkCntr*$v_cell,0})) &
				orientation=0.0, 90.0, 0.0
			geometry create shape cylinder &
				cylinder_name=(eval(myMod//".vlnk_"//RTOI(h_linkCntr)//"_"//RTOI(v_linkCntr)//".cyl")) &
				length=($h_cell) &
				radius=($radius) &
				angle=360.0d &
				side_count_for_body=20 &
				segment_count_for_ends=20 &
				center_marker=(eval(myMod//".vlnk_"//RTOI(h_linkCntr)//"_"//RTOI(v_linkCntr)//".cntMar"))
			marker create marker=(eval(myMod//".vlnk_"//RTOI(h_linkCntr)//"_"//RTOI(v_linkCntr)//".endMar")) &
				location=(eval({$top_left_corner}+{h_linkCntr*$h_cell,-(v_linkCntr+1)*$v_cell,0})) &
				orientation=270.0, 0.0, 0.0
			marker create marker=(eval(myMod//".vlnk_"//RTOI(h_linkCntr)//"_"//RTOI(v_linkCntr)//".cmMar")) &
				location=(eval(stoo(myMod//".vlnk_"//RTOI(h_linkCntr)//"_"//RTOI(v_linkCntr)//".cm").loc)) &
				orientation=270.0, 0.0, 0.0
		end
	end
	
	! horizontal beams
	for variable=h_linkCntr start=0 end=(eval(RTOI($h_length/$h_cell-1)))
		for variable=v_linkCntr start=0 end=(eval(RTOI($v_length/$v_cell)))
			!if condition=(h_linkCntr+1<RTOI($h_length/$h_cell))
			!	force create element_like beam  &
			!		beam_name = (eval(myMod//".hBeam_"//RTOI(h_linkCntr)//"_"//RTOI(v_linkCntr)))  &
			!		ixx = (eval(PI/2*$radius**4))  &
			!		iyy = (eval(PI/4*$radius**4))  &
			!		izz = (eval(PI/4*$radius**4))  &
			!		y_shear_area_ratio = 1.0  &
			!		z_shear_area_ratio = 1.0  &
			!		youngs_modulus = (eval($material.youngs_modulus))  &
			!		shear_modulus = (eval($material.youngs_modulus/2/(1+(eval($material.poissons_ratio)))))   &
			!		length = (eval($h_cell))  &
			!		area_of_cross_section = (eval(PI*$radius**2))  &
			!		damping_ratio = 1.0E-05  &
			!		formulation = linear  &
			!		location = (eval(stoo(myMod//".hlnk_"//RTOI(h_linkCntr)//"_"//RTOI(v_linkCntr)//".cmMar").loc)) &
			!		orientation = 0.0,0.0,0.0 &
			!		i_part_name = (eval(myMod//".hlnk_"//RTOI(h_linkCntr+1)//"_"//RTOI(v_linkCntr)))  &
			!		j_part_name = (eval(myMod//".hlnk_"//RTOI(h_linkCntr)//"_"//RTOI(v_linkCntr)))
			!end
			if condition=(v_linkCntr<RTOI($v_length/$v_cell))
				! left hand side H to V
				force create element_like beam  &
					beam_name = (eval(myMod//".hBeam_"//RTOI(h_linkCntr)//"_"//RTOI(v_linkCntr)//"_L"))  &
					ixx = (eval(PI/2*$radius**4))  &
					iyy = (eval(PI/4*$radius**4))  &
					izz = (eval(PI/4*$radius**4))  &
					y_shear_area_ratio = 1.0  &
					z_shear_area_ratio = 1.0  &
					youngs_modulus = (eval($material.youngs_modulus))  &
					shear_modulus = (eval($material.youngs_modulus/2/(1+(eval($material.poissons_ratio)))))   &
					length = (eval($h_cell/2))  &
					area_of_cross_section = (eval(PI*$radius**2))  &
					damping_ratio = 1.0E-05  &
					formulation = linear  &
					location = (eval(stoo(myMod//".hlnk_"//RTOI(h_linkCntr)//"_"//RTOI(v_linkCntr)//".cntMar").loc)) &
					orientation = 0.0,0.0,0.0 &
					i_part_name = (eval(myMod//".hlnk_"//RTOI(h_linkCntr)//"_"//RTOI(v_linkCntr)))  &
					j_part_name = (eval(myMod//".vlnk_"//RTOI(h_linkCntr)//"_"//RTOI(v_linkCntr)))
				
				! right hand side H to V
				force create element_like beam  &
					beam_name = (eval(myMod//".hBeam_"//RTOI(h_linkCntr)//"_"//RTOI(v_linkCntr)//"_R"))  &
					ixx = (eval(PI/2*$radius**4))  &
					iyy = (eval(PI/4*$radius**4))  &
					izz = (eval(PI/4*$radius**4))  &
					y_shear_area_ratio = 1.0  &
					z_shear_area_ratio = 1.0  &
					youngs_modulus = (eval($material.youngs_modulus))  &
					shear_modulus = (eval($material.youngs_modulus/2/(1+(eval($material.poissons_ratio)))))   &
					length = (eval($h_cell/2))  &
					area_of_cross_section = (eval(PI*$radius**2))  &
					damping_ratio = 1.0E-05  &
					formulation = linear  &
					location = (eval(stoo(myMod//".hlnk_"//RTOI(h_linkCntr)//"_"//RTOI(v_linkCntr)//".cmMar").loc)) &
					orientation = 0.0,0.0,0.0 &
					i_part_name = (eval(myMod//".hlnk_"//RTOI(h_linkCntr)//"_"//RTOI(v_linkCntr)))  &
					j_part_name = (eval(myMod//".vlnk_"//RTOI(h_linkCntr+1)//"_"//RTOI(v_linkCntr)))
			else
				! left hand side H to V - last one
				force create element_like beam  &
					beam_name = (eval(myMod//".hBeam_"//RTOI(h_linkCntr)//"_"//RTOI(v_linkCntr)//"_L"))  &
					ixx = (eval(PI/2*$radius**4))  &
					iyy = (eval(PI/4*$radius**4))  &
					izz = (eval(PI/4*$radius**4))  &
					y_shear_area_ratio = 1.0  &
					z_shear_area_ratio = 1.0  &
					youngs_modulus = (eval($material.youngs_modulus))  &
					shear_modulus = (eval($material.youngs_modulus/2/(1+(eval($material.poissons_ratio)))))   &
					length = (eval($h_cell/2))  &
					area_of_cross_section = (eval(PI*$radius**2))  &
					damping_ratio = 1.0E-05  &
					formulation = linear  &
					location = (eval(stoo(myMod//".hlnk_"//RTOI(h_linkCntr)//"_"//RTOI(v_linkCntr)//".cntMar").loc)) &
					orientation = 0.0,0.0,0.0 &
					i_part_name = (eval(myMod//".hlnk_"//RTOI(h_linkCntr)//"_"//RTOI(v_linkCntr-1)))  &
					j_part_name = (eval(myMod//".vlnk_"//RTOI(h_linkCntr)//"_"//RTOI(v_linkCntr-1)))
				
				! right hand side H to V - last one
				force create element_like beam  &
					beam_name = (eval(myMod//".hBeam_"//RTOI(h_linkCntr)//"_"//RTOI(v_linkCntr)//"_R"))  &
					ixx = (eval(PI/2*$radius**4))  &
					iyy = (eval(PI/4*$radius**4))  &
					izz = (eval(PI/4*$radius**4))  &
					y_shear_area_ratio = 1.0  &
					z_shear_area_ratio = 1.0  &
					youngs_modulus = (eval($material.youngs_modulus))  &
					shear_modulus = (eval($material.youngs_modulus/2/(1+(eval($material.poissons_ratio)))))   &
					length = (eval($h_cell/2))  &
					area_of_cross_section = (eval(PI*$radius**2))  &
					damping_ratio = 1.0E-05  &
					formulation = linear  &
					location = (eval(stoo(myMod//".hlnk_"//RTOI(h_linkCntr)//"_"//RTOI(v_linkCntr)//".cmMar").loc)) &
					orientation = 0.0,0.0,0.0 &
					i_part_name = (eval(myMod//".hlnk_"//RTOI(h_linkCntr)//"_"//RTOI(v_linkCntr-1)))  &
					j_part_name = (eval(myMod//".vlnk_"//RTOI(h_linkCntr+1)//"_"//RTOI(v_linkCntr-1)))
			end
		end
	end
	
	! vertical beams
	for variable=h_linkCntr start=0 end=(eval(RTOI($h_length/$h_cell)))
		for variable=v_linkCntr start=0 end=(eval(RTOI($v_length/$v_cell-1)))
			!if condition=(v_linkCntr+1<RTOI($v_length/$v_cell))
			!	force create element_like beam  &
			!		beam_name = (eval(myMod//".vBeam_"//RTOI(h_linkCntr)//"_"//RTOI(v_linkCntr)))  &
			!		ixx = (eval(PI/2*$radius**4))  &
			!		iyy = (eval(PI/4*$radius**4))  &
			!		izz = (eval(PI/4*$radius**4))  &
			!		y_shear_area_ratio = 1.0  &
			!		z_shear_area_ratio = 1.0  &
			!		youngs_modulus = (eval($material.youngs_modulus))  &
			!		shear_modulus = (eval($material.youngs_modulus/2/(1+(eval($material.poissons_ratio)))))   &
			!		length = (eval($v_cell))  &
			!		area_of_cross_section = (eval(PI*$radius**2))  &
			!		damping_ratio = 1.0E-05  &
			!		formulation = linear  &
			!		location = (eval(stoo(myMod//".vlnk_"//RTOI(h_linkCntr)//"_"//RTOI(v_linkCntr)//".cmMar").loc)) &
			!		orientation = 270.0,0.0,0.0 &
			!		i_part_name = (eval(myMod//".vlnk_"//RTOI(h_linkCntr)//"_"//RTOI(v_linkCntr+1)))  &
			!		j_part_name = (eval(myMod//".vlnk_"//RTOI(h_linkCntr)//"_"//RTOI(v_linkCntr)))
			!end
			if condition=(h_linkCntr<RTOI($h_length/$h_cell))
				force create element_like beam  &
					beam_name = (eval(myMod//".vBeam_"//RTOI(h_linkCntr)//"_"//RTOI(v_linkCntr))//"_L")  &
					ixx = (eval(PI/2*$radius**4))  &
					iyy = (eval(PI/4*$radius**4))  &
					izz = (eval(PI/4*$radius**4))  &
					y_shear_area_ratio = 1.0  &
					z_shear_area_ratio = 1.0  &
					youngs_modulus = (eval($material.youngs_modulus))  &
					shear_modulus = (eval($material.youngs_modulus/2/(1+(eval($material.poissons_ratio)))))   &
					length = (eval($v_cell/2))  &
					area_of_cross_section = (eval(PI*$radius**2))  &
					damping_ratio = 1.0E-05  &
					formulation = linear  &
					location = (eval(stoo(myMod//".vlnk_"//RTOI(h_linkCntr)//"_"//RTOI(v_linkCntr)//".cntMar").loc)) &
					orientation = 270.0,0.0,0.0 &
					i_part_name = (eval(myMod//".vlnk_"//RTOI(h_linkCntr)//"_"//RTOI(v_linkCntr)))  &
					j_part_name = (eval(myMod//".hlnk_"//RTOI(h_linkCntr)//"_"//RTOI(v_linkCntr)))
				force create element_like beam  &
					beam_name = (eval(myMod//".vBeam_"//RTOI(h_linkCntr)//"_"//RTOI(v_linkCntr)//"_R"))  &
					ixx = (eval(PI/2*$radius**4))  &
					iyy = (eval(PI/4*$radius**4))  &
					izz = (eval(PI/4*$radius**4))  &
					y_shear_area_ratio = 1.0  &
					z_shear_area_ratio = 1.0  &
					youngs_modulus = (eval($material.youngs_modulus))  &
					shear_modulus = (eval($material.youngs_modulus/2/(1+(eval($material.poissons_ratio)))))   &
					length = (eval($v_cell/2))  &
					area_of_cross_section = (eval(PI*$radius**2))  &
					damping_ratio = 1.0E-05  &
					formulation = linear  &
					location = (eval(stoo(myMod//".vlnk_"//RTOI(h_linkCntr)//"_"//RTOI(v_linkCntr)//".cmMar").loc)) &
					orientation = 270.0,0.0,0.0 &
					i_part_name = (eval(myMod//".vlnk_"//RTOI(h_linkCntr)//"_"//RTOI(v_linkCntr)))  &
					j_part_name = (eval(myMod//".hlnk_"//RTOI(h_linkCntr)//"_"//RTOI(v_linkCntr+1)))
			else
				force create element_like beam  &
					beam_name = (eval(myMod//".vBeam_"//RTOI(h_linkCntr)//"_"//RTOI(v_linkCntr)//"_L"))  &
					ixx = (eval(PI/2*$radius**4))  &
					iyy = (eval(PI/4*$radius**4))  &
					izz = (eval(PI/4*$radius**4))  &
					y_shear_area_ratio = 1.0  &
					z_shear_area_ratio = 1.0  &
					youngs_modulus = (eval($material.youngs_modulus))  &
					shear_modulus = (eval($material.youngs_modulus/2/(1+(eval($material.poissons_ratio)))))   &
					length = (eval($v_cell/2))  &
					area_of_cross_section = (eval(PI*$radius**2))  &
					damping_ratio = 1.0E-05  &
					formulation = linear  &
					location = (eval(stoo(myMod//".vlnk_"//RTOI(h_linkCntr)//"_"//RTOI(v_linkCntr)//".cntMar").loc)) &
					orientation = 270.0,0.0,0.0 &
					i_part_name = (eval(myMod//".vlnk_"//RTOI(h_linkCntr-1)//"_"//RTOI(v_linkCntr)))  &
					j_part_name = (eval(myMod//".hlnk_"//RTOI(h_linkCntr-1)//"_"//RTOI(v_linkCntr+1)))
				force create element_like beam  &
					beam_name = (eval(myMod//".vBeam_"//RTOI(h_linkCntr)//"_"//RTOI(v_linkCntr)//"_R"))  &
					ixx = (eval(PI/2*$radius**4))  &
					iyy = (eval(PI/4*$radius**4))  &
					izz = (eval(PI/4*$radius**4))  &
					y_shear_area_ratio = 1.0  &
					z_shear_area_ratio = 1.0  &
					youngs_modulus = (eval($material.youngs_modulus))  &
					shear_modulus = (eval($material.youngs_modulus/2/(1+(eval($material.poissons_ratio)))))   &
					length = (eval($v_cell/2))  &
					area_of_cross_section = (eval(PI*$radius**2))  &
					damping_ratio = 1.0E-05  &
					formulation = linear  &
					location = (eval(stoo(myMod//".vlnk_"//RTOI(h_linkCntr)//"_"//RTOI(v_linkCntr)//".cmMar").loc)) &
					orientation = 270.0,0.0,0.0 &
					i_part_name = (eval(myMod//".vlnk_"//RTOI(h_linkCntr-1)//"_"//RTOI(v_linkCntr)))  &
					j_part_name = (eval(myMod//".hlnk_"//RTOI(h_linkCntr-1)//"_"//RTOI(v_linkCntr+1)))
			end
		end
	end
end

model attributes model=(eval(myMod)) size_of_icons=20