!
!-------------------------- Default Units for Model ---------------------------!
!
!
defaults units  &
   length = mm  &
   angle = deg  &
   force = newton  &
   mass = kg  &
   time = sec
!
defaults units  &
   coordinate_system_type = cartesian  &
   orientation_type = body313
!
!------------------------ Default Attributes for Model ------------------------!
!
!
defaults attributes  &
   inheritance = bottom_up  &
   icon_visibility = on  &
   grid_visibility = off  &
   size_of_icons = 50.0  &
   spacing_for_grid = 1000.0
!
!------------------------------ Adams View Model ------------------------------!
!
!
model create  &
   model_name = net_ball
!
model attributes  &
   model_name = .net_ball  &
   size_of_icons = 20.0
!
view erase
!
!--------------------------------- Materials ----------------------------------!
!
!
material create  &
   material_name = .net_ball.steel  &
   adams_id = 2  &
   density = 7.801E-06  &
   youngs_modulus = 2.07E+05  &
   poissons_ratio = 0.29
!
material create  &
   material_name = .net_ball.aluminum  &
   adams_id = 1  &
   density = 2.74E-06  &
   youngs_modulus = 7.1705E+04  &
   poissons_ratio = 0.33
!
!-------------------------------- Rigid Parts ---------------------------------!
!
! Create parts and their dependent markers and graphics
!
!----------------------------------- ground -----------------------------------!
!
!
! ****** Ground Part ******
!
defaults model  &
   part_name = ground
!
defaults coordinate_system  &
   default_coordinate_system = .net_ball.ground
!
! ****** Markers for current part ******
!
marker create  &
   marker_name = .net_ball.ground.MARKER_722  &
   adams_id = 722  &
   location = -225.0, 225.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker attributes  &
   marker_name = .net_ball.ground.MARKER_722  &
   visibility = on
!
marker create  &
   marker_name = .net_ball.ground.MARKER_724  &
   adams_id = 724  &
   location = 225.0, 225.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker attributes  &
   marker_name = .net_ball.ground.MARKER_724  &
   visibility = on
!
marker create  &
   marker_name = .net_ball.ground.MARKER_726  &
   adams_id = 726  &
   location = -225.0, -225.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker attributes  &
   marker_name = .net_ball.ground.MARKER_726  &
   visibility = on
!
marker create  &
   marker_name = .net_ball.ground.MARKER_728  &
   adams_id = 728  &
   location = 225.0, -225.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker attributes  &
   marker_name = .net_ball.ground.MARKER_728  &
   visibility = on
!
marker create  &
   marker_name = .net_ball.ground.MARKER_1452  &
   adams_id = 1452  &
   location = 0.0, 0.0, 500.0  &
   orientation = 16.9657251287d, 80.1558210195d, 359.5068548178d
!
marker attributes  &
   marker_name = .net_ball.ground.MARKER_1452  &
   visibility = on
!
part create rigid_body mass_properties  &
   part_name = .net_ball.ground  &
   material_type = .net_ball.steel
!
part attributes  &
   part_name = .net_ball.ground  &
   name_visibility = off
!
!---------------------------------- hlnk_0_0 ----------------------------------!
!
!
defaults coordinate_system  &
   default_coordinate_system = .net_ball.ground
!
part create rigid_body name_and_position  &
   part_name = .net_ball.hlnk_0_0  &
   adams_id = 3  &
   location = 0.0, 0.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
defaults coordinate_system  &
   default_coordinate_system = .net_ball.hlnk_0_0
!
! ****** Markers for current part ******
!
marker create  &
   marker_name = .net_ball.hlnk_0_0.cntMar  &
   adams_id = 730  &
   location = -225.0, 225.0, 0.0  &
   orientation = 90.0d, 90.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_0_0.cm  &
   adams_id = 731  &
   location = -200.0, 225.0, 0.0  &
   orientation = 90.0d, 90.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_0_0.endMar  &
   adams_id = 732  &
   location = -175.0, 225.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_0_0.cmMar  &
   adams_id = 733  &
   location = -200.0, 225.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_0_0.MARKER_1  &
   adams_id = 1  &
   location = -200.0, 225.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_0_0.MARKER_3  &
   adams_id = 3  &
   location = -175.0, 225.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_0_0.MARKER_362  &
   adams_id = 362  &
   location = -225.0, 225.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_0_0.MARKER_721  &
   adams_id = 721  &
   location = -225.0, 225.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
part create rigid_body mass_properties  &
   part_name = .net_ball.hlnk_0_0  &
   material_type = .net_ball.aluminum
!
! ****** Graphics for current part ******
!
geometry create shape cylinder  &
   cylinder_name = .net_ball.hlnk_0_0.cyl  &
   adams_id = 188  &
   center_marker = .net_ball.hlnk_0_0.cntMar  &
   angle_extent = 360.0  &
   length = 50.0  &
   radius = 1.0  &
   side_count_for_body = 20  &
   segment_count_for_ends = 20
!
part attributes  &
   part_name = .net_ball.hlnk_0_0  &
   color = RED  &
   name_visibility = off
!
!---------------------------------- hlnk_0_1 ----------------------------------!
!
!
defaults coordinate_system  &
   default_coordinate_system = .net_ball.ground
!
part create rigid_body name_and_position  &
   part_name = .net_ball.hlnk_0_1  &
   adams_id = 4  &
   location = 0.0, 0.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
defaults coordinate_system  &
   default_coordinate_system = .net_ball.hlnk_0_1
!
! ****** Markers for current part ******
!
marker create  &
   marker_name = .net_ball.hlnk_0_1.cntMar  &
   adams_id = 734  &
   location = -225.0, 175.0, 0.0  &
   orientation = 90.0d, 90.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_0_1.cm  &
   adams_id = 735  &
   location = -200.0, 175.0, 0.0  &
   orientation = 90.0d, 90.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_0_1.endMar  &
   adams_id = 736  &
   location = -175.0, 175.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_0_1.cmMar  &
   adams_id = 737  &
   location = -200.0, 175.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_0_1.MARKER_5  &
   adams_id = 5  &
   location = -200.0, 175.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_0_1.MARKER_7  &
   adams_id = 7  &
   location = -175.0, 175.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_0_1.MARKER_364  &
   adams_id = 364  &
   location = -225.0, 200.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_0_1.MARKER_366  &
   adams_id = 366  &
   location = -225.0, 175.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
part create rigid_body mass_properties  &
   part_name = .net_ball.hlnk_0_1  &
   material_type = .net_ball.aluminum
!
! ****** Graphics for current part ******
!
geometry create shape cylinder  &
   cylinder_name = .net_ball.hlnk_0_1.cyl  &
   adams_id = 189  &
   center_marker = .net_ball.hlnk_0_1.cntMar  &
   angle_extent = 360.0  &
   length = 50.0  &
   radius = 1.0  &
   side_count_for_body = 20  &
   segment_count_for_ends = 20
!
part attributes  &
   part_name = .net_ball.hlnk_0_1  &
   color = RED  &
   name_visibility = off
!
!---------------------------------- hlnk_0_2 ----------------------------------!
!
!
defaults coordinate_system  &
   default_coordinate_system = .net_ball.ground
!
part create rigid_body name_and_position  &
   part_name = .net_ball.hlnk_0_2  &
   adams_id = 5  &
   location = 0.0, 0.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
defaults coordinate_system  &
   default_coordinate_system = .net_ball.hlnk_0_2
!
! ****** Markers for current part ******
!
marker create  &
   marker_name = .net_ball.hlnk_0_2.cntMar  &
   adams_id = 738  &
   location = -225.0, 125.0, 0.0  &
   orientation = 90.0d, 90.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_0_2.cm  &
   adams_id = 739  &
   location = -200.0, 125.0, 0.0  &
   orientation = 90.0d, 90.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_0_2.endMar  &
   adams_id = 740  &
   location = -175.0, 125.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_0_2.cmMar  &
   adams_id = 741  &
   location = -200.0, 125.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_0_2.MARKER_9  &
   adams_id = 9  &
   location = -200.0, 125.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_0_2.MARKER_11  &
   adams_id = 11  &
   location = -175.0, 125.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_0_2.MARKER_368  &
   adams_id = 368  &
   location = -225.0, 150.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_0_2.MARKER_370  &
   adams_id = 370  &
   location = -225.0, 125.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
part create rigid_body mass_properties  &
   part_name = .net_ball.hlnk_0_2  &
   material_type = .net_ball.aluminum
!
! ****** Graphics for current part ******
!
geometry create shape cylinder  &
   cylinder_name = .net_ball.hlnk_0_2.cyl  &
   adams_id = 190  &
   center_marker = .net_ball.hlnk_0_2.cntMar  &
   angle_extent = 360.0  &
   length = 50.0  &
   radius = 1.0  &
   side_count_for_body = 20  &
   segment_count_for_ends = 20
!
part attributes  &
   part_name = .net_ball.hlnk_0_2  &
   color = RED  &
   name_visibility = off
!
!---------------------------------- hlnk_0_3 ----------------------------------!
!
!
defaults coordinate_system  &
   default_coordinate_system = .net_ball.ground
!
part create rigid_body name_and_position  &
   part_name = .net_ball.hlnk_0_3  &
   adams_id = 6  &
   location = 0.0, 0.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
defaults coordinate_system  &
   default_coordinate_system = .net_ball.hlnk_0_3
!
! ****** Markers for current part ******
!
marker create  &
   marker_name = .net_ball.hlnk_0_3.cntMar  &
   adams_id = 742  &
   location = -225.0, 75.0, 0.0  &
   orientation = 90.0d, 90.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_0_3.cm  &
   adams_id = 743  &
   location = -200.0, 75.0, 0.0  &
   orientation = 90.0d, 90.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_0_3.endMar  &
   adams_id = 744  &
   location = -175.0, 75.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_0_3.cmMar  &
   adams_id = 745  &
   location = -200.0, 75.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_0_3.MARKER_13  &
   adams_id = 13  &
   location = -200.0, 75.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_0_3.MARKER_15  &
   adams_id = 15  &
   location = -175.0, 75.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_0_3.MARKER_372  &
   adams_id = 372  &
   location = -225.0, 100.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_0_3.MARKER_374  &
   adams_id = 374  &
   location = -225.0, 75.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
part create rigid_body mass_properties  &
   part_name = .net_ball.hlnk_0_3  &
   material_type = .net_ball.aluminum
!
! ****** Graphics for current part ******
!
geometry create shape cylinder  &
   cylinder_name = .net_ball.hlnk_0_3.cyl  &
   adams_id = 191  &
   center_marker = .net_ball.hlnk_0_3.cntMar  &
   angle_extent = 360.0  &
   length = 50.0  &
   radius = 1.0  &
   side_count_for_body = 20  &
   segment_count_for_ends = 20
!
part attributes  &
   part_name = .net_ball.hlnk_0_3  &
   color = RED  &
   name_visibility = off
!
!---------------------------------- hlnk_0_4 ----------------------------------!
!
!
defaults coordinate_system  &
   default_coordinate_system = .net_ball.ground
!
part create rigid_body name_and_position  &
   part_name = .net_ball.hlnk_0_4  &
   adams_id = 7  &
   location = 0.0, 0.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
defaults coordinate_system  &
   default_coordinate_system = .net_ball.hlnk_0_4
!
! ****** Markers for current part ******
!
marker create  &
   marker_name = .net_ball.hlnk_0_4.cntMar  &
   adams_id = 746  &
   location = -225.0, 25.0, 0.0  &
   orientation = 90.0d, 90.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_0_4.cm  &
   adams_id = 747  &
   location = -200.0, 25.0, 0.0  &
   orientation = 90.0d, 90.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_0_4.endMar  &
   adams_id = 748  &
   location = -175.0, 25.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_0_4.cmMar  &
   adams_id = 749  &
   location = -200.0, 25.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_0_4.MARKER_17  &
   adams_id = 17  &
   location = -200.0, 25.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_0_4.MARKER_19  &
   adams_id = 19  &
   location = -175.0, 25.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_0_4.MARKER_376  &
   adams_id = 376  &
   location = -225.0, 50.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_0_4.MARKER_378  &
   adams_id = 378  &
   location = -225.0, 25.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
part create rigid_body mass_properties  &
   part_name = .net_ball.hlnk_0_4  &
   material_type = .net_ball.aluminum
!
! ****** Graphics for current part ******
!
geometry create shape cylinder  &
   cylinder_name = .net_ball.hlnk_0_4.cyl  &
   adams_id = 192  &
   center_marker = .net_ball.hlnk_0_4.cntMar  &
   angle_extent = 360.0  &
   length = 50.0  &
   radius = 1.0  &
   side_count_for_body = 20  &
   segment_count_for_ends = 20
!
part attributes  &
   part_name = .net_ball.hlnk_0_4  &
   color = RED  &
   name_visibility = off
!
!---------------------------------- hlnk_0_5 ----------------------------------!
!
!
defaults coordinate_system  &
   default_coordinate_system = .net_ball.ground
!
part create rigid_body name_and_position  &
   part_name = .net_ball.hlnk_0_5  &
   adams_id = 8  &
   location = 0.0, 0.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
defaults coordinate_system  &
   default_coordinate_system = .net_ball.hlnk_0_5
!
! ****** Markers for current part ******
!
marker create  &
   marker_name = .net_ball.hlnk_0_5.cntMar  &
   adams_id = 750  &
   location = -225.0, -25.0, 0.0  &
   orientation = 90.0d, 90.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_0_5.cm  &
   adams_id = 751  &
   location = -200.0, -25.0, 0.0  &
   orientation = 90.0d, 90.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_0_5.endMar  &
   adams_id = 752  &
   location = -175.0, -25.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_0_5.cmMar  &
   adams_id = 753  &
   location = -200.0, -25.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_0_5.MARKER_21  &
   adams_id = 21  &
   location = -200.0, -25.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_0_5.MARKER_23  &
   adams_id = 23  &
   location = -175.0, -25.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_0_5.MARKER_380  &
   adams_id = 380  &
   location = -225.0, 0.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_0_5.MARKER_382  &
   adams_id = 382  &
   location = -225.0, -25.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
part create rigid_body mass_properties  &
   part_name = .net_ball.hlnk_0_5  &
   material_type = .net_ball.aluminum
!
! ****** Graphics for current part ******
!
geometry create shape cylinder  &
   cylinder_name = .net_ball.hlnk_0_5.cyl  &
   adams_id = 193  &
   center_marker = .net_ball.hlnk_0_5.cntMar  &
   angle_extent = 360.0  &
   length = 50.0  &
   radius = 1.0  &
   side_count_for_body = 20  &
   segment_count_for_ends = 20
!
part attributes  &
   part_name = .net_ball.hlnk_0_5  &
   color = RED  &
   name_visibility = off
!
!---------------------------------- hlnk_0_6 ----------------------------------!
!
!
defaults coordinate_system  &
   default_coordinate_system = .net_ball.ground
!
part create rigid_body name_and_position  &
   part_name = .net_ball.hlnk_0_6  &
   adams_id = 9  &
   location = 0.0, 0.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
defaults coordinate_system  &
   default_coordinate_system = .net_ball.hlnk_0_6
!
! ****** Markers for current part ******
!
marker create  &
   marker_name = .net_ball.hlnk_0_6.cntMar  &
   adams_id = 754  &
   location = -225.0, -75.0, 0.0  &
   orientation = 90.0d, 90.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_0_6.cm  &
   adams_id = 755  &
   location = -200.0, -75.0, 0.0  &
   orientation = 90.0d, 90.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_0_6.endMar  &
   adams_id = 756  &
   location = -175.0, -75.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_0_6.cmMar  &
   adams_id = 757  &
   location = -200.0, -75.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_0_6.MARKER_25  &
   adams_id = 25  &
   location = -200.0, -75.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_0_6.MARKER_27  &
   adams_id = 27  &
   location = -175.0, -75.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_0_6.MARKER_384  &
   adams_id = 384  &
   location = -225.0, -50.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_0_6.MARKER_386  &
   adams_id = 386  &
   location = -225.0, -75.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
part create rigid_body mass_properties  &
   part_name = .net_ball.hlnk_0_6  &
   material_type = .net_ball.aluminum
!
! ****** Graphics for current part ******
!
geometry create shape cylinder  &
   cylinder_name = .net_ball.hlnk_0_6.cyl  &
   adams_id = 194  &
   center_marker = .net_ball.hlnk_0_6.cntMar  &
   angle_extent = 360.0  &
   length = 50.0  &
   radius = 1.0  &
   side_count_for_body = 20  &
   segment_count_for_ends = 20
!
part attributes  &
   part_name = .net_ball.hlnk_0_6  &
   color = RED  &
   name_visibility = off
!
!---------------------------------- hlnk_0_7 ----------------------------------!
!
!
defaults coordinate_system  &
   default_coordinate_system = .net_ball.ground
!
part create rigid_body name_and_position  &
   part_name = .net_ball.hlnk_0_7  &
   adams_id = 10  &
   location = 0.0, 0.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
defaults coordinate_system  &
   default_coordinate_system = .net_ball.hlnk_0_7
!
! ****** Markers for current part ******
!
marker create  &
   marker_name = .net_ball.hlnk_0_7.cntMar  &
   adams_id = 758  &
   location = -225.0, -125.0, 0.0  &
   orientation = 90.0d, 90.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_0_7.cm  &
   adams_id = 759  &
   location = -200.0, -125.0, 0.0  &
   orientation = 90.0d, 90.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_0_7.endMar  &
   adams_id = 760  &
   location = -175.0, -125.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_0_7.cmMar  &
   adams_id = 761  &
   location = -200.0, -125.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_0_7.MARKER_29  &
   adams_id = 29  &
   location = -200.0, -125.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_0_7.MARKER_31  &
   adams_id = 31  &
   location = -175.0, -125.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_0_7.MARKER_388  &
   adams_id = 388  &
   location = -225.0, -100.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_0_7.MARKER_390  &
   adams_id = 390  &
   location = -225.0, -125.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
part create rigid_body mass_properties  &
   part_name = .net_ball.hlnk_0_7  &
   material_type = .net_ball.aluminum
!
! ****** Graphics for current part ******
!
geometry create shape cylinder  &
   cylinder_name = .net_ball.hlnk_0_7.cyl  &
   adams_id = 195  &
   center_marker = .net_ball.hlnk_0_7.cntMar  &
   angle_extent = 360.0  &
   length = 50.0  &
   radius = 1.0  &
   side_count_for_body = 20  &
   segment_count_for_ends = 20
!
part attributes  &
   part_name = .net_ball.hlnk_0_7  &
   color = RED  &
   name_visibility = off
!
!---------------------------------- hlnk_0_8 ----------------------------------!
!
!
defaults coordinate_system  &
   default_coordinate_system = .net_ball.ground
!
part create rigid_body name_and_position  &
   part_name = .net_ball.hlnk_0_8  &
   adams_id = 11  &
   location = 0.0, 0.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
defaults coordinate_system  &
   default_coordinate_system = .net_ball.hlnk_0_8
!
! ****** Markers for current part ******
!
marker create  &
   marker_name = .net_ball.hlnk_0_8.cntMar  &
   adams_id = 762  &
   location = -225.0, -175.0, 0.0  &
   orientation = 90.0d, 90.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_0_8.cm  &
   adams_id = 763  &
   location = -200.0, -175.0, 0.0  &
   orientation = 90.0d, 90.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_0_8.endMar  &
   adams_id = 764  &
   location = -175.0, -175.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_0_8.cmMar  &
   adams_id = 765  &
   location = -200.0, -175.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_0_8.MARKER_33  &
   adams_id = 33  &
   location = -200.0, -175.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_0_8.MARKER_35  &
   adams_id = 35  &
   location = -175.0, -175.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_0_8.MARKER_37  &
   adams_id = 37  &
   location = -200.0, -225.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_0_8.MARKER_39  &
   adams_id = 39  &
   location = -175.0, -225.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_0_8.MARKER_392  &
   adams_id = 392  &
   location = -225.0, -150.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_0_8.MARKER_394  &
   adams_id = 394  &
   location = -225.0, -175.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
part create rigid_body mass_properties  &
   part_name = .net_ball.hlnk_0_8  &
   material_type = .net_ball.aluminum
!
! ****** Graphics for current part ******
!
geometry create shape cylinder  &
   cylinder_name = .net_ball.hlnk_0_8.cyl  &
   adams_id = 196  &
   center_marker = .net_ball.hlnk_0_8.cntMar  &
   angle_extent = 360.0  &
   length = 50.0  &
   radius = 1.0  &
   side_count_for_body = 20  &
   segment_count_for_ends = 20
!
part attributes  &
   part_name = .net_ball.hlnk_0_8  &
   color = RED  &
   name_visibility = off
!
!---------------------------------- hlnk_0_9 ----------------------------------!
!
!
defaults coordinate_system  &
   default_coordinate_system = .net_ball.ground
!
part create rigid_body name_and_position  &
   part_name = .net_ball.hlnk_0_9  &
   adams_id = 12  &
   location = 0.0, 0.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
defaults coordinate_system  &
   default_coordinate_system = .net_ball.hlnk_0_9
!
! ****** Markers for current part ******
!
marker create  &
   marker_name = .net_ball.hlnk_0_9.cntMar  &
   adams_id = 766  &
   location = -225.0, -225.0, 0.0  &
   orientation = 90.0d, 90.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_0_9.cm  &
   adams_id = 767  &
   location = -200.0, -225.0, 0.0  &
   orientation = 90.0d, 90.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_0_9.endMar  &
   adams_id = 768  &
   location = -175.0, -225.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_0_9.cmMar  &
   adams_id = 769  &
   location = -200.0, -225.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_0_9.MARKER_396  &
   adams_id = 396  &
   location = -225.0, -200.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_0_9.MARKER_725  &
   adams_id = 725  &
   location = -225.0, -225.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
part create rigid_body mass_properties  &
   part_name = .net_ball.hlnk_0_9  &
   material_type = .net_ball.aluminum
!
! ****** Graphics for current part ******
!
geometry create shape cylinder  &
   cylinder_name = .net_ball.hlnk_0_9.cyl  &
   adams_id = 197  &
   center_marker = .net_ball.hlnk_0_9.cntMar  &
   angle_extent = 360.0  &
   length = 50.0  &
   radius = 1.0  &
   side_count_for_body = 20  &
   segment_count_for_ends = 20
!
part attributes  &
   part_name = .net_ball.hlnk_0_9  &
   color = RED  &
   name_visibility = off
!
!---------------------------------- hlnk_1_0 ----------------------------------!
!
!
defaults coordinate_system  &
   default_coordinate_system = .net_ball.ground
!
part create rigid_body name_and_position  &
   part_name = .net_ball.hlnk_1_0  &
   adams_id = 13  &
   location = 0.0, 0.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
defaults coordinate_system  &
   default_coordinate_system = .net_ball.hlnk_1_0
!
! ****** Markers for current part ******
!
marker create  &
   marker_name = .net_ball.hlnk_1_0.cntMar  &
   adams_id = 770  &
   location = -175.0, 225.0, 0.0  &
   orientation = 90.0d, 90.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_1_0.cm  &
   adams_id = 771  &
   location = -150.0, 225.0, 0.0  &
   orientation = 90.0d, 90.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_1_0.endMar  &
   adams_id = 772  &
   location = -125.0, 225.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_1_0.cmMar  &
   adams_id = 773  &
   location = -150.0, 225.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_1_0.MARKER_41  &
   adams_id = 41  &
   location = -150.0, 225.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_1_0.MARKER_43  &
   adams_id = 43  &
   location = -125.0, 225.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_1_0.MARKER_398  &
   adams_id = 398  &
   location = -175.0, 225.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
part create rigid_body mass_properties  &
   part_name = .net_ball.hlnk_1_0  &
   material_type = .net_ball.aluminum
!
! ****** Graphics for current part ******
!
geometry create shape cylinder  &
   cylinder_name = .net_ball.hlnk_1_0.cyl  &
   adams_id = 198  &
   center_marker = .net_ball.hlnk_1_0.cntMar  &
   angle_extent = 360.0  &
   length = 50.0  &
   radius = 1.0  &
   side_count_for_body = 20  &
   segment_count_for_ends = 20
!
part attributes  &
   part_name = .net_ball.hlnk_1_0  &
   color = RED  &
   name_visibility = off
!
!---------------------------------- hlnk_1_1 ----------------------------------!
!
!
defaults coordinate_system  &
   default_coordinate_system = .net_ball.ground
!
part create rigid_body name_and_position  &
   part_name = .net_ball.hlnk_1_1  &
   adams_id = 14  &
   location = 0.0, 0.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
defaults coordinate_system  &
   default_coordinate_system = .net_ball.hlnk_1_1
!
! ****** Markers for current part ******
!
marker create  &
   marker_name = .net_ball.hlnk_1_1.cntMar  &
   adams_id = 774  &
   location = -175.0, 175.0, 0.0  &
   orientation = 90.0d, 90.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_1_1.cm  &
   adams_id = 775  &
   location = -150.0, 175.0, 0.0  &
   orientation = 90.0d, 90.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_1_1.endMar  &
   adams_id = 776  &
   location = -125.0, 175.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_1_1.cmMar  &
   adams_id = 777  &
   location = -150.0, 175.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_1_1.MARKER_45  &
   adams_id = 45  &
   location = -150.0, 175.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_1_1.MARKER_47  &
   adams_id = 47  &
   location = -125.0, 175.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_1_1.MARKER_400  &
   adams_id = 400  &
   location = -175.0, 200.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_1_1.MARKER_402  &
   adams_id = 402  &
   location = -175.0, 175.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
part create rigid_body mass_properties  &
   part_name = .net_ball.hlnk_1_1  &
   material_type = .net_ball.aluminum
!
! ****** Graphics for current part ******
!
geometry create shape cylinder  &
   cylinder_name = .net_ball.hlnk_1_1.cyl  &
   adams_id = 199  &
   center_marker = .net_ball.hlnk_1_1.cntMar  &
   angle_extent = 360.0  &
   length = 50.0  &
   radius = 1.0  &
   side_count_for_body = 20  &
   segment_count_for_ends = 20
!
part attributes  &
   part_name = .net_ball.hlnk_1_1  &
   color = RED  &
   name_visibility = off
!
!---------------------------------- hlnk_1_2 ----------------------------------!
!
!
defaults coordinate_system  &
   default_coordinate_system = .net_ball.ground
!
part create rigid_body name_and_position  &
   part_name = .net_ball.hlnk_1_2  &
   adams_id = 15  &
   location = 0.0, 0.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
defaults coordinate_system  &
   default_coordinate_system = .net_ball.hlnk_1_2
!
! ****** Markers for current part ******
!
marker create  &
   marker_name = .net_ball.hlnk_1_2.cntMar  &
   adams_id = 778  &
   location = -175.0, 125.0, 0.0  &
   orientation = 90.0d, 90.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_1_2.cm  &
   adams_id = 779  &
   location = -150.0, 125.0, 0.0  &
   orientation = 90.0d, 90.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_1_2.endMar  &
   adams_id = 780  &
   location = -125.0, 125.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_1_2.cmMar  &
   adams_id = 781  &
   location = -150.0, 125.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_1_2.MARKER_49  &
   adams_id = 49  &
   location = -150.0, 125.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_1_2.MARKER_51  &
   adams_id = 51  &
   location = -125.0, 125.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_1_2.MARKER_404  &
   adams_id = 404  &
   location = -175.0, 150.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_1_2.MARKER_406  &
   adams_id = 406  &
   location = -175.0, 125.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
part create rigid_body mass_properties  &
   part_name = .net_ball.hlnk_1_2  &
   material_type = .net_ball.aluminum
!
! ****** Graphics for current part ******
!
geometry create shape cylinder  &
   cylinder_name = .net_ball.hlnk_1_2.cyl  &
   adams_id = 200  &
   center_marker = .net_ball.hlnk_1_2.cntMar  &
   angle_extent = 360.0  &
   length = 50.0  &
   radius = 1.0  &
   side_count_for_body = 20  &
   segment_count_for_ends = 20
!
part attributes  &
   part_name = .net_ball.hlnk_1_2  &
   color = RED  &
   name_visibility = off
!
!---------------------------------- hlnk_1_3 ----------------------------------!
!
!
defaults coordinate_system  &
   default_coordinate_system = .net_ball.ground
!
part create rigid_body name_and_position  &
   part_name = .net_ball.hlnk_1_3  &
   adams_id = 16  &
   location = 0.0, 0.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
defaults coordinate_system  &
   default_coordinate_system = .net_ball.hlnk_1_3
!
! ****** Markers for current part ******
!
marker create  &
   marker_name = .net_ball.hlnk_1_3.cntMar  &
   adams_id = 782  &
   location = -175.0, 75.0, 0.0  &
   orientation = 90.0d, 90.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_1_3.cm  &
   adams_id = 783  &
   location = -150.0, 75.0, 0.0  &
   orientation = 270.0d, 90.0d, 90.0d
!
marker create  &
   marker_name = .net_ball.hlnk_1_3.endMar  &
   adams_id = 784  &
   location = -125.0, 75.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_1_3.cmMar  &
   adams_id = 785  &
   location = -150.0, 75.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_1_3.MARKER_53  &
   adams_id = 53  &
   location = -150.0, 75.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_1_3.MARKER_55  &
   adams_id = 55  &
   location = -125.0, 75.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_1_3.MARKER_408  &
   adams_id = 408  &
   location = -175.0, 100.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_1_3.MARKER_410  &
   adams_id = 410  &
   location = -175.0, 75.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
part create rigid_body mass_properties  &
   part_name = .net_ball.hlnk_1_3  &
   material_type = .net_ball.aluminum
!
! ****** Graphics for current part ******
!
geometry create shape cylinder  &
   cylinder_name = .net_ball.hlnk_1_3.cyl  &
   adams_id = 201  &
   center_marker = .net_ball.hlnk_1_3.cntMar  &
   angle_extent = 360.0  &
   length = 50.0  &
   radius = 1.0  &
   side_count_for_body = 20  &
   segment_count_for_ends = 20
!
part attributes  &
   part_name = .net_ball.hlnk_1_3  &
   color = RED  &
   name_visibility = off
!
!---------------------------------- hlnk_1_4 ----------------------------------!
!
!
defaults coordinate_system  &
   default_coordinate_system = .net_ball.ground
!
part create rigid_body name_and_position  &
   part_name = .net_ball.hlnk_1_4  &
   adams_id = 17  &
   location = 0.0, 0.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
defaults coordinate_system  &
   default_coordinate_system = .net_ball.hlnk_1_4
!
! ****** Markers for current part ******
!
marker create  &
   marker_name = .net_ball.hlnk_1_4.cntMar  &
   adams_id = 786  &
   location = -175.0, 25.0, 0.0  &
   orientation = 90.0d, 90.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_1_4.cm  &
   adams_id = 787  &
   location = -150.0, 25.0, 0.0  &
   orientation = 90.0d, 90.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_1_4.endMar  &
   adams_id = 788  &
   location = -125.0, 25.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_1_4.cmMar  &
   adams_id = 789  &
   location = -150.0, 25.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_1_4.MARKER_57  &
   adams_id = 57  &
   location = -150.0, 25.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_1_4.MARKER_59  &
   adams_id = 59  &
   location = -125.0, 25.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_1_4.MARKER_412  &
   adams_id = 412  &
   location = -175.0, 50.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_1_4.MARKER_414  &
   adams_id = 414  &
   location = -175.0, 25.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
part create rigid_body mass_properties  &
   part_name = .net_ball.hlnk_1_4  &
   material_type = .net_ball.aluminum
!
! ****** Graphics for current part ******
!
geometry create shape cylinder  &
   cylinder_name = .net_ball.hlnk_1_4.cyl  &
   adams_id = 202  &
   center_marker = .net_ball.hlnk_1_4.cntMar  &
   angle_extent = 360.0  &
   length = 50.0  &
   radius = 1.0  &
   side_count_for_body = 20  &
   segment_count_for_ends = 20
!
part attributes  &
   part_name = .net_ball.hlnk_1_4  &
   color = RED  &
   name_visibility = off
!
!---------------------------------- hlnk_1_5 ----------------------------------!
!
!
defaults coordinate_system  &
   default_coordinate_system = .net_ball.ground
!
part create rigid_body name_and_position  &
   part_name = .net_ball.hlnk_1_5  &
   adams_id = 18  &
   location = 0.0, 0.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
defaults coordinate_system  &
   default_coordinate_system = .net_ball.hlnk_1_5
!
! ****** Markers for current part ******
!
marker create  &
   marker_name = .net_ball.hlnk_1_5.cntMar  &
   adams_id = 790  &
   location = -175.0, -25.0, 0.0  &
   orientation = 90.0d, 90.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_1_5.cm  &
   adams_id = 791  &
   location = -150.0, -25.0, 0.0  &
   orientation = 90.0d, 90.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_1_5.endMar  &
   adams_id = 792  &
   location = -125.0, -25.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_1_5.cmMar  &
   adams_id = 793  &
   location = -150.0, -25.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_1_5.MARKER_61  &
   adams_id = 61  &
   location = -150.0, -25.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_1_5.MARKER_63  &
   adams_id = 63  &
   location = -125.0, -25.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_1_5.MARKER_416  &
   adams_id = 416  &
   location = -175.0, 0.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_1_5.MARKER_418  &
   adams_id = 418  &
   location = -175.0, -25.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
part create rigid_body mass_properties  &
   part_name = .net_ball.hlnk_1_5  &
   material_type = .net_ball.aluminum
!
! ****** Graphics for current part ******
!
geometry create shape cylinder  &
   cylinder_name = .net_ball.hlnk_1_5.cyl  &
   adams_id = 203  &
   center_marker = .net_ball.hlnk_1_5.cntMar  &
   angle_extent = 360.0  &
   length = 50.0  &
   radius = 1.0  &
   side_count_for_body = 20  &
   segment_count_for_ends = 20
!
part attributes  &
   part_name = .net_ball.hlnk_1_5  &
   color = RED  &
   name_visibility = off
!
!---------------------------------- hlnk_1_6 ----------------------------------!
!
!
defaults coordinate_system  &
   default_coordinate_system = .net_ball.ground
!
part create rigid_body name_and_position  &
   part_name = .net_ball.hlnk_1_6  &
   adams_id = 19  &
   location = 0.0, 0.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
defaults coordinate_system  &
   default_coordinate_system = .net_ball.hlnk_1_6
!
! ****** Markers for current part ******
!
marker create  &
   marker_name = .net_ball.hlnk_1_6.cntMar  &
   adams_id = 794  &
   location = -175.0, -75.0, 0.0  &
   orientation = 90.0d, 90.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_1_6.cm  &
   adams_id = 795  &
   location = -150.0, -75.0, 0.0  &
   orientation = 270.0d, 90.0d, 90.0d
!
marker create  &
   marker_name = .net_ball.hlnk_1_6.endMar  &
   adams_id = 796  &
   location = -125.0, -75.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_1_6.cmMar  &
   adams_id = 797  &
   location = -150.0, -75.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_1_6.MARKER_65  &
   adams_id = 65  &
   location = -150.0, -75.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_1_6.MARKER_67  &
   adams_id = 67  &
   location = -125.0, -75.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_1_6.MARKER_420  &
   adams_id = 420  &
   location = -175.0, -50.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_1_6.MARKER_422  &
   adams_id = 422  &
   location = -175.0, -75.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
part create rigid_body mass_properties  &
   part_name = .net_ball.hlnk_1_6  &
   material_type = .net_ball.aluminum
!
! ****** Graphics for current part ******
!
geometry create shape cylinder  &
   cylinder_name = .net_ball.hlnk_1_6.cyl  &
   adams_id = 204  &
   center_marker = .net_ball.hlnk_1_6.cntMar  &
   angle_extent = 360.0  &
   length = 50.0  &
   radius = 1.0  &
   side_count_for_body = 20  &
   segment_count_for_ends = 20
!
part attributes  &
   part_name = .net_ball.hlnk_1_6  &
   color = RED  &
   name_visibility = off
!
!---------------------------------- hlnk_1_7 ----------------------------------!
!
!
defaults coordinate_system  &
   default_coordinate_system = .net_ball.ground
!
part create rigid_body name_and_position  &
   part_name = .net_ball.hlnk_1_7  &
   adams_id = 20  &
   location = 0.0, 0.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
defaults coordinate_system  &
   default_coordinate_system = .net_ball.hlnk_1_7
!
! ****** Markers for current part ******
!
marker create  &
   marker_name = .net_ball.hlnk_1_7.cntMar  &
   adams_id = 798  &
   location = -175.0, -125.0, 0.0  &
   orientation = 90.0d, 90.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_1_7.cm  &
   adams_id = 799  &
   location = -150.0, -125.0, 0.0  &
   orientation = 90.0d, 90.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_1_7.endMar  &
   adams_id = 800  &
   location = -125.0, -125.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_1_7.cmMar  &
   adams_id = 801  &
   location = -150.0, -125.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_1_7.MARKER_69  &
   adams_id = 69  &
   location = -150.0, -125.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_1_7.MARKER_71  &
   adams_id = 71  &
   location = -125.0, -125.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_1_7.MARKER_424  &
   adams_id = 424  &
   location = -175.0, -100.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_1_7.MARKER_426  &
   adams_id = 426  &
   location = -175.0, -125.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
part create rigid_body mass_properties  &
   part_name = .net_ball.hlnk_1_7  &
   material_type = .net_ball.aluminum
!
! ****** Graphics for current part ******
!
geometry create shape cylinder  &
   cylinder_name = .net_ball.hlnk_1_7.cyl  &
   adams_id = 205  &
   center_marker = .net_ball.hlnk_1_7.cntMar  &
   angle_extent = 360.0  &
   length = 50.0  &
   radius = 1.0  &
   side_count_for_body = 20  &
   segment_count_for_ends = 20
!
part attributes  &
   part_name = .net_ball.hlnk_1_7  &
   color = RED  &
   name_visibility = off
!
!---------------------------------- hlnk_1_8 ----------------------------------!
!
!
defaults coordinate_system  &
   default_coordinate_system = .net_ball.ground
!
part create rigid_body name_and_position  &
   part_name = .net_ball.hlnk_1_8  &
   adams_id = 21  &
   location = 0.0, 0.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
defaults coordinate_system  &
   default_coordinate_system = .net_ball.hlnk_1_8
!
! ****** Markers for current part ******
!
marker create  &
   marker_name = .net_ball.hlnk_1_8.cntMar  &
   adams_id = 802  &
   location = -175.0, -175.0, 0.0  &
   orientation = 90.0d, 90.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_1_8.cm  &
   adams_id = 803  &
   location = -150.0, -175.0, 0.0  &
   orientation = 90.0d, 90.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_1_8.endMar  &
   adams_id = 804  &
   location = -125.0, -175.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_1_8.cmMar  &
   adams_id = 805  &
   location = -150.0, -175.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_1_8.MARKER_73  &
   adams_id = 73  &
   location = -150.0, -175.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_1_8.MARKER_75  &
   adams_id = 75  &
   location = -125.0, -175.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_1_8.MARKER_77  &
   adams_id = 77  &
   location = -150.0, -225.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_1_8.MARKER_79  &
   adams_id = 79  &
   location = -125.0, -225.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_1_8.MARKER_428  &
   adams_id = 428  &
   location = -175.0, -150.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_1_8.MARKER_430  &
   adams_id = 430  &
   location = -175.0, -175.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
part create rigid_body mass_properties  &
   part_name = .net_ball.hlnk_1_8  &
   material_type = .net_ball.aluminum
!
! ****** Graphics for current part ******
!
geometry create shape cylinder  &
   cylinder_name = .net_ball.hlnk_1_8.cyl  &
   adams_id = 206  &
   center_marker = .net_ball.hlnk_1_8.cntMar  &
   angle_extent = 360.0  &
   length = 50.0  &
   radius = 1.0  &
   side_count_for_body = 20  &
   segment_count_for_ends = 20
!
part attributes  &
   part_name = .net_ball.hlnk_1_8  &
   color = RED  &
   name_visibility = off
!
!---------------------------------- hlnk_1_9 ----------------------------------!
!
!
defaults coordinate_system  &
   default_coordinate_system = .net_ball.ground
!
part create rigid_body name_and_position  &
   part_name = .net_ball.hlnk_1_9  &
   adams_id = 22  &
   location = 0.0, 0.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
defaults coordinate_system  &
   default_coordinate_system = .net_ball.hlnk_1_9
!
! ****** Markers for current part ******
!
marker create  &
   marker_name = .net_ball.hlnk_1_9.cntMar  &
   adams_id = 806  &
   location = -175.0, -225.0, 0.0  &
   orientation = 90.0d, 90.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_1_9.cm  &
   adams_id = 807  &
   location = -150.0, -225.0, 0.0  &
   orientation = 90.0d, 90.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_1_9.endMar  &
   adams_id = 808  &
   location = -125.0, -225.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_1_9.cmMar  &
   adams_id = 809  &
   location = -150.0, -225.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_1_9.MARKER_432  &
   adams_id = 432  &
   location = -175.0, -200.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
part create rigid_body mass_properties  &
   part_name = .net_ball.hlnk_1_9  &
   material_type = .net_ball.aluminum
!
! ****** Graphics for current part ******
!
geometry create shape cylinder  &
   cylinder_name = .net_ball.hlnk_1_9.cyl  &
   adams_id = 207  &
   center_marker = .net_ball.hlnk_1_9.cntMar  &
   angle_extent = 360.0  &
   length = 50.0  &
   radius = 1.0  &
   side_count_for_body = 20  &
   segment_count_for_ends = 20
!
part attributes  &
   part_name = .net_ball.hlnk_1_9  &
   color = RED  &
   name_visibility = off
!
!---------------------------------- hlnk_2_0 ----------------------------------!
!
!
defaults coordinate_system  &
   default_coordinate_system = .net_ball.ground
!
part create rigid_body name_and_position  &
   part_name = .net_ball.hlnk_2_0  &
   adams_id = 23  &
   location = 0.0, 0.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
defaults coordinate_system  &
   default_coordinate_system = .net_ball.hlnk_2_0
!
! ****** Markers for current part ******
!
marker create  &
   marker_name = .net_ball.hlnk_2_0.cntMar  &
   adams_id = 810  &
   location = -125.0, 225.0, 0.0  &
   orientation = 90.0d, 90.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_2_0.cm  &
   adams_id = 811  &
   location = -100.0, 225.0, 0.0  &
   orientation = 90.0d, 90.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_2_0.endMar  &
   adams_id = 812  &
   location = -75.0, 225.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_2_0.cmMar  &
   adams_id = 813  &
   location = -100.0, 225.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_2_0.MARKER_81  &
   adams_id = 81  &
   location = -100.0, 225.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_2_0.MARKER_83  &
   adams_id = 83  &
   location = -75.0, 225.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_2_0.MARKER_434  &
   adams_id = 434  &
   location = -125.0, 225.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
part create rigid_body mass_properties  &
   part_name = .net_ball.hlnk_2_0  &
   material_type = .net_ball.aluminum
!
! ****** Graphics for current part ******
!
geometry create shape cylinder  &
   cylinder_name = .net_ball.hlnk_2_0.cyl  &
   adams_id = 208  &
   center_marker = .net_ball.hlnk_2_0.cntMar  &
   angle_extent = 360.0  &
   length = 50.0  &
   radius = 1.0  &
   side_count_for_body = 20  &
   segment_count_for_ends = 20
!
part attributes  &
   part_name = .net_ball.hlnk_2_0  &
   color = RED  &
   name_visibility = off
!
!---------------------------------- hlnk_2_1 ----------------------------------!
!
!
defaults coordinate_system  &
   default_coordinate_system = .net_ball.ground
!
part create rigid_body name_and_position  &
   part_name = .net_ball.hlnk_2_1  &
   adams_id = 24  &
   location = 0.0, 0.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
defaults coordinate_system  &
   default_coordinate_system = .net_ball.hlnk_2_1
!
! ****** Markers for current part ******
!
marker create  &
   marker_name = .net_ball.hlnk_2_1.cntMar  &
   adams_id = 814  &
   location = -125.0, 175.0, 0.0  &
   orientation = 90.0d, 90.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_2_1.cm  &
   adams_id = 815  &
   location = -100.0, 175.0, 0.0  &
   orientation = 270.0d, 90.0d, 90.0d
!
marker create  &
   marker_name = .net_ball.hlnk_2_1.endMar  &
   adams_id = 816  &
   location = -75.0, 175.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_2_1.cmMar  &
   adams_id = 817  &
   location = -100.0, 175.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_2_1.MARKER_85  &
   adams_id = 85  &
   location = -100.0, 175.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_2_1.MARKER_87  &
   adams_id = 87  &
   location = -75.0, 175.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_2_1.MARKER_436  &
   adams_id = 436  &
   location = -125.0, 200.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_2_1.MARKER_438  &
   adams_id = 438  &
   location = -125.0, 175.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
part create rigid_body mass_properties  &
   part_name = .net_ball.hlnk_2_1  &
   material_type = .net_ball.aluminum
!
! ****** Graphics for current part ******
!
geometry create shape cylinder  &
   cylinder_name = .net_ball.hlnk_2_1.cyl  &
   adams_id = 209  &
   center_marker = .net_ball.hlnk_2_1.cntMar  &
   angle_extent = 360.0  &
   length = 50.0  &
   radius = 1.0  &
   side_count_for_body = 20  &
   segment_count_for_ends = 20
!
part attributes  &
   part_name = .net_ball.hlnk_2_1  &
   color = RED  &
   name_visibility = off
!
!---------------------------------- hlnk_2_2 ----------------------------------!
!
!
defaults coordinate_system  &
   default_coordinate_system = .net_ball.ground
!
part create rigid_body name_and_position  &
   part_name = .net_ball.hlnk_2_2  &
   adams_id = 25  &
   location = 0.0, 0.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
defaults coordinate_system  &
   default_coordinate_system = .net_ball.hlnk_2_2
!
! ****** Markers for current part ******
!
marker create  &
   marker_name = .net_ball.hlnk_2_2.cntMar  &
   adams_id = 818  &
   location = -125.0, 125.0, 0.0  &
   orientation = 90.0d, 90.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_2_2.cm  &
   adams_id = 819  &
   location = -100.0, 125.0, 0.0  &
   orientation = 90.0d, 90.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_2_2.endMar  &
   adams_id = 820  &
   location = -75.0, 125.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_2_2.cmMar  &
   adams_id = 821  &
   location = -100.0, 125.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_2_2.MARKER_89  &
   adams_id = 89  &
   location = -100.0, 125.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_2_2.MARKER_91  &
   adams_id = 91  &
   location = -75.0, 125.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_2_2.MARKER_440  &
   adams_id = 440  &
   location = -125.0, 150.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_2_2.MARKER_442  &
   adams_id = 442  &
   location = -125.0, 125.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
part create rigid_body mass_properties  &
   part_name = .net_ball.hlnk_2_2  &
   material_type = .net_ball.aluminum
!
! ****** Graphics for current part ******
!
geometry create shape cylinder  &
   cylinder_name = .net_ball.hlnk_2_2.cyl  &
   adams_id = 210  &
   center_marker = .net_ball.hlnk_2_2.cntMar  &
   angle_extent = 360.0  &
   length = 50.0  &
   radius = 1.0  &
   side_count_for_body = 20  &
   segment_count_for_ends = 20
!
part attributes  &
   part_name = .net_ball.hlnk_2_2  &
   color = RED  &
   name_visibility = off
!
!---------------------------------- hlnk_2_3 ----------------------------------!
!
!
defaults coordinate_system  &
   default_coordinate_system = .net_ball.ground
!
part create rigid_body name_and_position  &
   part_name = .net_ball.hlnk_2_3  &
   adams_id = 26  &
   location = 0.0, 0.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
defaults coordinate_system  &
   default_coordinate_system = .net_ball.hlnk_2_3
!
! ****** Markers for current part ******
!
marker create  &
   marker_name = .net_ball.hlnk_2_3.cntMar  &
   adams_id = 822  &
   location = -125.0, 75.0, 0.0  &
   orientation = 90.0d, 90.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_2_3.cm  &
   adams_id = 823  &
   location = -100.0, 75.0, 0.0  &
   orientation = 270.0d, 90.0d, 90.0d
!
marker create  &
   marker_name = .net_ball.hlnk_2_3.endMar  &
   adams_id = 824  &
   location = -75.0, 75.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_2_3.cmMar  &
   adams_id = 825  &
   location = -100.0, 75.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_2_3.MARKER_93  &
   adams_id = 93  &
   location = -100.0, 75.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_2_3.MARKER_95  &
   adams_id = 95  &
   location = -75.0, 75.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_2_3.MARKER_444  &
   adams_id = 444  &
   location = -125.0, 100.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_2_3.MARKER_446  &
   adams_id = 446  &
   location = -125.0, 75.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
part create rigid_body mass_properties  &
   part_name = .net_ball.hlnk_2_3  &
   material_type = .net_ball.aluminum
!
! ****** Graphics for current part ******
!
geometry create shape cylinder  &
   cylinder_name = .net_ball.hlnk_2_3.cyl  &
   adams_id = 211  &
   center_marker = .net_ball.hlnk_2_3.cntMar  &
   angle_extent = 360.0  &
   length = 50.0  &
   radius = 1.0  &
   side_count_for_body = 20  &
   segment_count_for_ends = 20
!
part attributes  &
   part_name = .net_ball.hlnk_2_3  &
   color = RED  &
   name_visibility = off
!
!---------------------------------- hlnk_2_4 ----------------------------------!
!
!
defaults coordinate_system  &
   default_coordinate_system = .net_ball.ground
!
part create rigid_body name_and_position  &
   part_name = .net_ball.hlnk_2_4  &
   adams_id = 27  &
   location = 0.0, 0.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
defaults coordinate_system  &
   default_coordinate_system = .net_ball.hlnk_2_4
!
! ****** Markers for current part ******
!
marker create  &
   marker_name = .net_ball.hlnk_2_4.cntMar  &
   adams_id = 826  &
   location = -125.0, 25.0, 0.0  &
   orientation = 90.0d, 90.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_2_4.cm  &
   adams_id = 827  &
   location = -100.0, 25.0, 0.0  &
   orientation = 90.0d, 90.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_2_4.endMar  &
   adams_id = 828  &
   location = -75.0, 25.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_2_4.cmMar  &
   adams_id = 829  &
   location = -100.0, 25.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_2_4.MARKER_97  &
   adams_id = 97  &
   location = -100.0, 25.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_2_4.MARKER_99  &
   adams_id = 99  &
   location = -75.0, 25.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_2_4.MARKER_448  &
   adams_id = 448  &
   location = -125.0, 50.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_2_4.MARKER_450  &
   adams_id = 450  &
   location = -125.0, 25.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
part create rigid_body mass_properties  &
   part_name = .net_ball.hlnk_2_4  &
   material_type = .net_ball.aluminum
!
! ****** Graphics for current part ******
!
geometry create shape cylinder  &
   cylinder_name = .net_ball.hlnk_2_4.cyl  &
   adams_id = 212  &
   center_marker = .net_ball.hlnk_2_4.cntMar  &
   angle_extent = 360.0  &
   length = 50.0  &
   radius = 1.0  &
   side_count_for_body = 20  &
   segment_count_for_ends = 20
!
part attributes  &
   part_name = .net_ball.hlnk_2_4  &
   color = RED  &
   name_visibility = off
!
!---------------------------------- hlnk_2_5 ----------------------------------!
!
!
defaults coordinate_system  &
   default_coordinate_system = .net_ball.ground
!
part create rigid_body name_and_position  &
   part_name = .net_ball.hlnk_2_5  &
   adams_id = 28  &
   location = 0.0, 0.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
defaults coordinate_system  &
   default_coordinate_system = .net_ball.hlnk_2_5
!
! ****** Markers for current part ******
!
marker create  &
   marker_name = .net_ball.hlnk_2_5.cntMar  &
   adams_id = 830  &
   location = -125.0, -25.0, 0.0  &
   orientation = 90.0d, 90.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_2_5.cm  &
   adams_id = 831  &
   location = -100.0, -25.0, 0.0  &
   orientation = 90.0d, 90.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_2_5.endMar  &
   adams_id = 832  &
   location = -75.0, -25.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_2_5.cmMar  &
   adams_id = 833  &
   location = -100.0, -25.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_2_5.MARKER_101  &
   adams_id = 101  &
   location = -100.0, -25.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_2_5.MARKER_103  &
   adams_id = 103  &
   location = -75.0, -25.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_2_5.MARKER_452  &
   adams_id = 452  &
   location = -125.0, 0.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_2_5.MARKER_454  &
   adams_id = 454  &
   location = -125.0, -25.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
part create rigid_body mass_properties  &
   part_name = .net_ball.hlnk_2_5  &
   material_type = .net_ball.aluminum
!
! ****** Graphics for current part ******
!
geometry create shape cylinder  &
   cylinder_name = .net_ball.hlnk_2_5.cyl  &
   adams_id = 213  &
   center_marker = .net_ball.hlnk_2_5.cntMar  &
   angle_extent = 360.0  &
   length = 50.0  &
   radius = 1.0  &
   side_count_for_body = 20  &
   segment_count_for_ends = 20
!
part attributes  &
   part_name = .net_ball.hlnk_2_5  &
   color = RED  &
   name_visibility = off
!
!---------------------------------- hlnk_2_6 ----------------------------------!
!
!
defaults coordinate_system  &
   default_coordinate_system = .net_ball.ground
!
part create rigid_body name_and_position  &
   part_name = .net_ball.hlnk_2_6  &
   adams_id = 29  &
   location = 0.0, 0.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
defaults coordinate_system  &
   default_coordinate_system = .net_ball.hlnk_2_6
!
! ****** Markers for current part ******
!
marker create  &
   marker_name = .net_ball.hlnk_2_6.cntMar  &
   adams_id = 834  &
   location = -125.0, -75.0, 0.0  &
   orientation = 90.0d, 90.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_2_6.cm  &
   adams_id = 835  &
   location = -100.0, -75.0, 0.0  &
   orientation = 270.0d, 90.0d, 90.0d
!
marker create  &
   marker_name = .net_ball.hlnk_2_6.endMar  &
   adams_id = 836  &
   location = -75.0, -75.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_2_6.cmMar  &
   adams_id = 837  &
   location = -100.0, -75.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_2_6.MARKER_105  &
   adams_id = 105  &
   location = -100.0, -75.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_2_6.MARKER_107  &
   adams_id = 107  &
   location = -75.0, -75.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_2_6.MARKER_456  &
   adams_id = 456  &
   location = -125.0, -50.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_2_6.MARKER_458  &
   adams_id = 458  &
   location = -125.0, -75.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
part create rigid_body mass_properties  &
   part_name = .net_ball.hlnk_2_6  &
   material_type = .net_ball.aluminum
!
! ****** Graphics for current part ******
!
geometry create shape cylinder  &
   cylinder_name = .net_ball.hlnk_2_6.cyl  &
   adams_id = 214  &
   center_marker = .net_ball.hlnk_2_6.cntMar  &
   angle_extent = 360.0  &
   length = 50.0  &
   radius = 1.0  &
   side_count_for_body = 20  &
   segment_count_for_ends = 20
!
part attributes  &
   part_name = .net_ball.hlnk_2_6  &
   color = RED  &
   name_visibility = off
!
!---------------------------------- hlnk_2_7 ----------------------------------!
!
!
defaults coordinate_system  &
   default_coordinate_system = .net_ball.ground
!
part create rigid_body name_and_position  &
   part_name = .net_ball.hlnk_2_7  &
   adams_id = 30  &
   location = 0.0, 0.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
defaults coordinate_system  &
   default_coordinate_system = .net_ball.hlnk_2_7
!
! ****** Markers for current part ******
!
marker create  &
   marker_name = .net_ball.hlnk_2_7.cntMar  &
   adams_id = 838  &
   location = -125.0, -125.0, 0.0  &
   orientation = 90.0d, 90.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_2_7.cm  &
   adams_id = 839  &
   location = -100.0, -125.0, 0.0  &
   orientation = 90.0d, 90.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_2_7.endMar  &
   adams_id = 840  &
   location = -75.0, -125.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_2_7.cmMar  &
   adams_id = 841  &
   location = -100.0, -125.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_2_7.MARKER_109  &
   adams_id = 109  &
   location = -100.0, -125.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_2_7.MARKER_111  &
   adams_id = 111  &
   location = -75.0, -125.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_2_7.MARKER_460  &
   adams_id = 460  &
   location = -125.0, -100.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_2_7.MARKER_462  &
   adams_id = 462  &
   location = -125.0, -125.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
part create rigid_body mass_properties  &
   part_name = .net_ball.hlnk_2_7  &
   material_type = .net_ball.aluminum
!
! ****** Graphics for current part ******
!
geometry create shape cylinder  &
   cylinder_name = .net_ball.hlnk_2_7.cyl  &
   adams_id = 215  &
   center_marker = .net_ball.hlnk_2_7.cntMar  &
   angle_extent = 360.0  &
   length = 50.0  &
   radius = 1.0  &
   side_count_for_body = 20  &
   segment_count_for_ends = 20
!
part attributes  &
   part_name = .net_ball.hlnk_2_7  &
   color = RED  &
   name_visibility = off
!
!---------------------------------- hlnk_2_8 ----------------------------------!
!
!
defaults coordinate_system  &
   default_coordinate_system = .net_ball.ground
!
part create rigid_body name_and_position  &
   part_name = .net_ball.hlnk_2_8  &
   adams_id = 31  &
   location = 0.0, 0.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
defaults coordinate_system  &
   default_coordinate_system = .net_ball.hlnk_2_8
!
! ****** Markers for current part ******
!
marker create  &
   marker_name = .net_ball.hlnk_2_8.cntMar  &
   adams_id = 842  &
   location = -125.0, -175.0, 0.0  &
   orientation = 90.0d, 90.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_2_8.cm  &
   adams_id = 843  &
   location = -100.0, -175.0, 0.0  &
   orientation = 270.0d, 90.0d, 90.0d
!
marker create  &
   marker_name = .net_ball.hlnk_2_8.endMar  &
   adams_id = 844  &
   location = -75.0, -175.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_2_8.cmMar  &
   adams_id = 845  &
   location = -100.0, -175.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_2_8.MARKER_113  &
   adams_id = 113  &
   location = -100.0, -175.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_2_8.MARKER_115  &
   adams_id = 115  &
   location = -75.0, -175.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_2_8.MARKER_117  &
   adams_id = 117  &
   location = -100.0, -225.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_2_8.MARKER_119  &
   adams_id = 119  &
   location = -75.0, -225.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_2_8.MARKER_464  &
   adams_id = 464  &
   location = -125.0, -150.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_2_8.MARKER_466  &
   adams_id = 466  &
   location = -125.0, -175.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
part create rigid_body mass_properties  &
   part_name = .net_ball.hlnk_2_8  &
   material_type = .net_ball.aluminum
!
! ****** Graphics for current part ******
!
geometry create shape cylinder  &
   cylinder_name = .net_ball.hlnk_2_8.cyl  &
   adams_id = 216  &
   center_marker = .net_ball.hlnk_2_8.cntMar  &
   angle_extent = 360.0  &
   length = 50.0  &
   radius = 1.0  &
   side_count_for_body = 20  &
   segment_count_for_ends = 20
!
part attributes  &
   part_name = .net_ball.hlnk_2_8  &
   color = RED  &
   name_visibility = off
!
!---------------------------------- hlnk_2_9 ----------------------------------!
!
!
defaults coordinate_system  &
   default_coordinate_system = .net_ball.ground
!
part create rigid_body name_and_position  &
   part_name = .net_ball.hlnk_2_9  &
   adams_id = 32  &
   location = 0.0, 0.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
defaults coordinate_system  &
   default_coordinate_system = .net_ball.hlnk_2_9
!
! ****** Markers for current part ******
!
marker create  &
   marker_name = .net_ball.hlnk_2_9.cntMar  &
   adams_id = 846  &
   location = -125.0, -225.0, 0.0  &
   orientation = 90.0d, 90.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_2_9.cm  &
   adams_id = 847  &
   location = -100.0, -225.0, 0.0  &
   orientation = 90.0d, 90.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_2_9.endMar  &
   adams_id = 848  &
   location = -75.0, -225.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_2_9.cmMar  &
   adams_id = 849  &
   location = -100.0, -225.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_2_9.MARKER_468  &
   adams_id = 468  &
   location = -125.0, -200.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
part create rigid_body mass_properties  &
   part_name = .net_ball.hlnk_2_9  &
   material_type = .net_ball.aluminum
!
! ****** Graphics for current part ******
!
geometry create shape cylinder  &
   cylinder_name = .net_ball.hlnk_2_9.cyl  &
   adams_id = 217  &
   center_marker = .net_ball.hlnk_2_9.cntMar  &
   angle_extent = 360.0  &
   length = 50.0  &
   radius = 1.0  &
   side_count_for_body = 20  &
   segment_count_for_ends = 20
!
part attributes  &
   part_name = .net_ball.hlnk_2_9  &
   color = RED  &
   name_visibility = off
!
!---------------------------------- hlnk_3_0 ----------------------------------!
!
!
defaults coordinate_system  &
   default_coordinate_system = .net_ball.ground
!
part create rigid_body name_and_position  &
   part_name = .net_ball.hlnk_3_0  &
   adams_id = 33  &
   location = 0.0, 0.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
defaults coordinate_system  &
   default_coordinate_system = .net_ball.hlnk_3_0
!
! ****** Markers for current part ******
!
marker create  &
   marker_name = .net_ball.hlnk_3_0.cntMar  &
   adams_id = 850  &
   location = -75.0, 225.0, 0.0  &
   orientation = 90.0d, 90.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_3_0.cm  &
   adams_id = 851  &
   location = -50.0, 225.0, 0.0  &
   orientation = 90.0d, 90.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_3_0.endMar  &
   adams_id = 852  &
   location = -25.0, 225.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_3_0.cmMar  &
   adams_id = 853  &
   location = -50.0, 225.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_3_0.MARKER_121  &
   adams_id = 121  &
   location = -50.0, 225.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_3_0.MARKER_123  &
   adams_id = 123  &
   location = -25.0, 225.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_3_0.MARKER_470  &
   adams_id = 470  &
   location = -75.0, 225.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
part create rigid_body mass_properties  &
   part_name = .net_ball.hlnk_3_0  &
   material_type = .net_ball.aluminum
!
! ****** Graphics for current part ******
!
geometry create shape cylinder  &
   cylinder_name = .net_ball.hlnk_3_0.cyl  &
   adams_id = 218  &
   center_marker = .net_ball.hlnk_3_0.cntMar  &
   angle_extent = 360.0  &
   length = 50.0  &
   radius = 1.0  &
   side_count_for_body = 20  &
   segment_count_for_ends = 20
!
part attributes  &
   part_name = .net_ball.hlnk_3_0  &
   color = RED  &
   name_visibility = off
!
!---------------------------------- hlnk_3_1 ----------------------------------!
!
!
defaults coordinate_system  &
   default_coordinate_system = .net_ball.ground
!
part create rigid_body name_and_position  &
   part_name = .net_ball.hlnk_3_1  &
   adams_id = 34  &
   location = 0.0, 0.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
defaults coordinate_system  &
   default_coordinate_system = .net_ball.hlnk_3_1
!
! ****** Markers for current part ******
!
marker create  &
   marker_name = .net_ball.hlnk_3_1.cntMar  &
   adams_id = 854  &
   location = -75.0, 175.0, 0.0  &
   orientation = 90.0d, 90.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_3_1.cm  &
   adams_id = 855  &
   location = -50.0, 175.0, 0.0  &
   orientation = 90.0d, 90.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_3_1.endMar  &
   adams_id = 856  &
   location = -25.0, 175.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_3_1.cmMar  &
   adams_id = 857  &
   location = -50.0, 175.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_3_1.MARKER_125  &
   adams_id = 125  &
   location = -50.0, 175.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_3_1.MARKER_127  &
   adams_id = 127  &
   location = -25.0, 175.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_3_1.MARKER_472  &
   adams_id = 472  &
   location = -75.0, 200.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_3_1.MARKER_474  &
   adams_id = 474  &
   location = -75.0, 175.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
part create rigid_body mass_properties  &
   part_name = .net_ball.hlnk_3_1  &
   material_type = .net_ball.aluminum
!
! ****** Graphics for current part ******
!
geometry create shape cylinder  &
   cylinder_name = .net_ball.hlnk_3_1.cyl  &
   adams_id = 219  &
   center_marker = .net_ball.hlnk_3_1.cntMar  &
   angle_extent = 360.0  &
   length = 50.0  &
   radius = 1.0  &
   side_count_for_body = 20  &
   segment_count_for_ends = 20
!
part attributes  &
   part_name = .net_ball.hlnk_3_1  &
   color = RED  &
   name_visibility = off
!
!---------------------------------- hlnk_3_2 ----------------------------------!
!
!
defaults coordinate_system  &
   default_coordinate_system = .net_ball.ground
!
part create rigid_body name_and_position  &
   part_name = .net_ball.hlnk_3_2  &
   adams_id = 35  &
   location = 0.0, 0.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
defaults coordinate_system  &
   default_coordinate_system = .net_ball.hlnk_3_2
!
! ****** Markers for current part ******
!
marker create  &
   marker_name = .net_ball.hlnk_3_2.cntMar  &
   adams_id = 858  &
   location = -75.0, 125.0, 0.0  &
   orientation = 90.0d, 90.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_3_2.cm  &
   adams_id = 859  &
   location = -50.0, 125.0, 0.0  &
   orientation = 90.0d, 90.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_3_2.endMar  &
   adams_id = 860  &
   location = -25.0, 125.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_3_2.cmMar  &
   adams_id = 861  &
   location = -50.0, 125.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_3_2.MARKER_129  &
   adams_id = 129  &
   location = -50.0, 125.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_3_2.MARKER_131  &
   adams_id = 131  &
   location = -25.0, 125.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_3_2.MARKER_476  &
   adams_id = 476  &
   location = -75.0, 150.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_3_2.MARKER_478  &
   adams_id = 478  &
   location = -75.0, 125.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
part create rigid_body mass_properties  &
   part_name = .net_ball.hlnk_3_2  &
   material_type = .net_ball.aluminum
!
! ****** Graphics for current part ******
!
geometry create shape cylinder  &
   cylinder_name = .net_ball.hlnk_3_2.cyl  &
   adams_id = 220  &
   center_marker = .net_ball.hlnk_3_2.cntMar  &
   angle_extent = 360.0  &
   length = 50.0  &
   radius = 1.0  &
   side_count_for_body = 20  &
   segment_count_for_ends = 20
!
part attributes  &
   part_name = .net_ball.hlnk_3_2  &
   color = RED  &
   name_visibility = off
!
!---------------------------------- hlnk_3_3 ----------------------------------!
!
!
defaults coordinate_system  &
   default_coordinate_system = .net_ball.ground
!
part create rigid_body name_and_position  &
   part_name = .net_ball.hlnk_3_3  &
   adams_id = 36  &
   location = 0.0, 0.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
defaults coordinate_system  &
   default_coordinate_system = .net_ball.hlnk_3_3
!
! ****** Markers for current part ******
!
marker create  &
   marker_name = .net_ball.hlnk_3_3.cntMar  &
   adams_id = 862  &
   location = -75.0, 75.0, 0.0  &
   orientation = 90.0d, 90.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_3_3.cm  &
   adams_id = 863  &
   location = -50.0, 75.0, 0.0  &
   orientation = 270.0d, 90.0d, 90.0d
!
marker create  &
   marker_name = .net_ball.hlnk_3_3.endMar  &
   adams_id = 864  &
   location = -25.0, 75.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_3_3.cmMar  &
   adams_id = 865  &
   location = -50.0, 75.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_3_3.MARKER_133  &
   adams_id = 133  &
   location = -50.0, 75.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_3_3.MARKER_135  &
   adams_id = 135  &
   location = -25.0, 75.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_3_3.MARKER_480  &
   adams_id = 480  &
   location = -75.0, 100.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_3_3.MARKER_482  &
   adams_id = 482  &
   location = -75.0, 75.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
part create rigid_body mass_properties  &
   part_name = .net_ball.hlnk_3_3  &
   material_type = .net_ball.aluminum
!
! ****** Graphics for current part ******
!
geometry create shape cylinder  &
   cylinder_name = .net_ball.hlnk_3_3.cyl  &
   adams_id = 221  &
   center_marker = .net_ball.hlnk_3_3.cntMar  &
   angle_extent = 360.0  &
   length = 50.0  &
   radius = 1.0  &
   side_count_for_body = 20  &
   segment_count_for_ends = 20
!
part attributes  &
   part_name = .net_ball.hlnk_3_3  &
   color = RED  &
   name_visibility = off
!
!---------------------------------- hlnk_3_4 ----------------------------------!
!
!
defaults coordinate_system  &
   default_coordinate_system = .net_ball.ground
!
part create rigid_body name_and_position  &
   part_name = .net_ball.hlnk_3_4  &
   adams_id = 37  &
   location = 0.0, 0.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
defaults coordinate_system  &
   default_coordinate_system = .net_ball.hlnk_3_4
!
! ****** Markers for current part ******
!
marker create  &
   marker_name = .net_ball.hlnk_3_4.cntMar  &
   adams_id = 866  &
   location = -75.0, 25.0, 0.0  &
   orientation = 90.0d, 90.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_3_4.cm  &
   adams_id = 867  &
   location = -50.0, 25.0, 0.0  &
   orientation = 90.0d, 90.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_3_4.endMar  &
   adams_id = 868  &
   location = -25.0, 25.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_3_4.cmMar  &
   adams_id = 869  &
   location = -50.0, 25.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_3_4.MARKER_137  &
   adams_id = 137  &
   location = -50.0, 25.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_3_4.MARKER_139  &
   adams_id = 139  &
   location = -25.0, 25.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_3_4.MARKER_484  &
   adams_id = 484  &
   location = -75.0, 50.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_3_4.MARKER_486  &
   adams_id = 486  &
   location = -75.0, 25.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
part create rigid_body mass_properties  &
   part_name = .net_ball.hlnk_3_4  &
   material_type = .net_ball.aluminum
!
! ****** Graphics for current part ******
!
geometry create shape cylinder  &
   cylinder_name = .net_ball.hlnk_3_4.cyl  &
   adams_id = 222  &
   center_marker = .net_ball.hlnk_3_4.cntMar  &
   angle_extent = 360.0  &
   length = 50.0  &
   radius = 1.0  &
   side_count_for_body = 20  &
   segment_count_for_ends = 20
!
part attributes  &
   part_name = .net_ball.hlnk_3_4  &
   color = RED  &
   name_visibility = off
!
!---------------------------------- hlnk_3_5 ----------------------------------!
!
!
defaults coordinate_system  &
   default_coordinate_system = .net_ball.ground
!
part create rigid_body name_and_position  &
   part_name = .net_ball.hlnk_3_5  &
   adams_id = 38  &
   location = 0.0, 0.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
defaults coordinate_system  &
   default_coordinate_system = .net_ball.hlnk_3_5
!
! ****** Markers for current part ******
!
marker create  &
   marker_name = .net_ball.hlnk_3_5.cntMar  &
   adams_id = 870  &
   location = -75.0, -25.0, 0.0  &
   orientation = 90.0d, 90.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_3_5.cm  &
   adams_id = 871  &
   location = -50.0, -25.0, 0.0  &
   orientation = 90.0d, 90.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_3_5.endMar  &
   adams_id = 872  &
   location = -25.0, -25.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_3_5.cmMar  &
   adams_id = 873  &
   location = -50.0, -25.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_3_5.MARKER_141  &
   adams_id = 141  &
   location = -50.0, -25.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_3_5.MARKER_143  &
   adams_id = 143  &
   location = -25.0, -25.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_3_5.MARKER_488  &
   adams_id = 488  &
   location = -75.0, 0.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_3_5.MARKER_490  &
   adams_id = 490  &
   location = -75.0, -25.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
part create rigid_body mass_properties  &
   part_name = .net_ball.hlnk_3_5  &
   material_type = .net_ball.aluminum
!
! ****** Graphics for current part ******
!
geometry create shape cylinder  &
   cylinder_name = .net_ball.hlnk_3_5.cyl  &
   adams_id = 223  &
   center_marker = .net_ball.hlnk_3_5.cntMar  &
   angle_extent = 360.0  &
   length = 50.0  &
   radius = 1.0  &
   side_count_for_body = 20  &
   segment_count_for_ends = 20
!
part attributes  &
   part_name = .net_ball.hlnk_3_5  &
   color = RED  &
   name_visibility = off
!
!---------------------------------- hlnk_3_6 ----------------------------------!
!
!
defaults coordinate_system  &
   default_coordinate_system = .net_ball.ground
!
part create rigid_body name_and_position  &
   part_name = .net_ball.hlnk_3_6  &
   adams_id = 39  &
   location = 0.0, 0.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
defaults coordinate_system  &
   default_coordinate_system = .net_ball.hlnk_3_6
!
! ****** Markers for current part ******
!
marker create  &
   marker_name = .net_ball.hlnk_3_6.cntMar  &
   adams_id = 874  &
   location = -75.0, -75.0, 0.0  &
   orientation = 90.0d, 90.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_3_6.cm  &
   adams_id = 875  &
   location = -50.0, -75.0, 0.0  &
   orientation = 270.0d, 90.0d, 90.0d
!
marker create  &
   marker_name = .net_ball.hlnk_3_6.endMar  &
   adams_id = 876  &
   location = -25.0, -75.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_3_6.cmMar  &
   adams_id = 877  &
   location = -50.0, -75.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_3_6.MARKER_145  &
   adams_id = 145  &
   location = -50.0, -75.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_3_6.MARKER_147  &
   adams_id = 147  &
   location = -25.0, -75.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_3_6.MARKER_492  &
   adams_id = 492  &
   location = -75.0, -50.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_3_6.MARKER_494  &
   adams_id = 494  &
   location = -75.0, -75.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
part create rigid_body mass_properties  &
   part_name = .net_ball.hlnk_3_6  &
   material_type = .net_ball.aluminum
!
! ****** Graphics for current part ******
!
geometry create shape cylinder  &
   cylinder_name = .net_ball.hlnk_3_6.cyl  &
   adams_id = 224  &
   center_marker = .net_ball.hlnk_3_6.cntMar  &
   angle_extent = 360.0  &
   length = 50.0  &
   radius = 1.0  &
   side_count_for_body = 20  &
   segment_count_for_ends = 20
!
part attributes  &
   part_name = .net_ball.hlnk_3_6  &
   color = RED  &
   name_visibility = off
!
!---------------------------------- hlnk_3_7 ----------------------------------!
!
!
defaults coordinate_system  &
   default_coordinate_system = .net_ball.ground
!
part create rigid_body name_and_position  &
   part_name = .net_ball.hlnk_3_7  &
   adams_id = 40  &
   location = 0.0, 0.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
defaults coordinate_system  &
   default_coordinate_system = .net_ball.hlnk_3_7
!
! ****** Markers for current part ******
!
marker create  &
   marker_name = .net_ball.hlnk_3_7.cntMar  &
   adams_id = 878  &
   location = -75.0, -125.0, 0.0  &
   orientation = 90.0d, 90.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_3_7.cm  &
   adams_id = 879  &
   location = -50.0, -125.0, 0.0  &
   orientation = 90.0d, 90.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_3_7.endMar  &
   adams_id = 880  &
   location = -25.0, -125.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_3_7.cmMar  &
   adams_id = 881  &
   location = -50.0, -125.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_3_7.MARKER_149  &
   adams_id = 149  &
   location = -50.0, -125.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_3_7.MARKER_151  &
   adams_id = 151  &
   location = -25.0, -125.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_3_7.MARKER_496  &
   adams_id = 496  &
   location = -75.0, -100.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_3_7.MARKER_498  &
   adams_id = 498  &
   location = -75.0, -125.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
part create rigid_body mass_properties  &
   part_name = .net_ball.hlnk_3_7  &
   material_type = .net_ball.aluminum
!
! ****** Graphics for current part ******
!
geometry create shape cylinder  &
   cylinder_name = .net_ball.hlnk_3_7.cyl  &
   adams_id = 225  &
   center_marker = .net_ball.hlnk_3_7.cntMar  &
   angle_extent = 360.0  &
   length = 50.0  &
   radius = 1.0  &
   side_count_for_body = 20  &
   segment_count_for_ends = 20
!
part attributes  &
   part_name = .net_ball.hlnk_3_7  &
   color = RED  &
   name_visibility = off
!
!---------------------------------- hlnk_3_8 ----------------------------------!
!
!
defaults coordinate_system  &
   default_coordinate_system = .net_ball.ground
!
part create rigid_body name_and_position  &
   part_name = .net_ball.hlnk_3_8  &
   adams_id = 41  &
   location = 0.0, 0.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
defaults coordinate_system  &
   default_coordinate_system = .net_ball.hlnk_3_8
!
! ****** Markers for current part ******
!
marker create  &
   marker_name = .net_ball.hlnk_3_8.cntMar  &
   adams_id = 882  &
   location = -75.0, -175.0, 0.0  &
   orientation = 90.0d, 90.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_3_8.cm  &
   adams_id = 883  &
   location = -50.0, -175.0, 0.0  &
   orientation = 90.0d, 90.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_3_8.endMar  &
   adams_id = 884  &
   location = -25.0, -175.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_3_8.cmMar  &
   adams_id = 885  &
   location = -50.0, -175.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_3_8.MARKER_153  &
   adams_id = 153  &
   location = -50.0, -175.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_3_8.MARKER_155  &
   adams_id = 155  &
   location = -25.0, -175.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_3_8.MARKER_157  &
   adams_id = 157  &
   location = -50.0, -225.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_3_8.MARKER_159  &
   adams_id = 159  &
   location = -25.0, -225.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_3_8.MARKER_500  &
   adams_id = 500  &
   location = -75.0, -150.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_3_8.MARKER_502  &
   adams_id = 502  &
   location = -75.0, -175.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
part create rigid_body mass_properties  &
   part_name = .net_ball.hlnk_3_8  &
   material_type = .net_ball.aluminum
!
! ****** Graphics for current part ******
!
geometry create shape cylinder  &
   cylinder_name = .net_ball.hlnk_3_8.cyl  &
   adams_id = 226  &
   center_marker = .net_ball.hlnk_3_8.cntMar  &
   angle_extent = 360.0  &
   length = 50.0  &
   radius = 1.0  &
   side_count_for_body = 20  &
   segment_count_for_ends = 20
!
part attributes  &
   part_name = .net_ball.hlnk_3_8  &
   color = RED  &
   name_visibility = off
!
!---------------------------------- hlnk_3_9 ----------------------------------!
!
!
defaults coordinate_system  &
   default_coordinate_system = .net_ball.ground
!
part create rigid_body name_and_position  &
   part_name = .net_ball.hlnk_3_9  &
   adams_id = 42  &
   location = 0.0, 0.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
defaults coordinate_system  &
   default_coordinate_system = .net_ball.hlnk_3_9
!
! ****** Markers for current part ******
!
marker create  &
   marker_name = .net_ball.hlnk_3_9.cntMar  &
   adams_id = 886  &
   location = -75.0, -225.0, 0.0  &
   orientation = 90.0d, 90.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_3_9.cm  &
   adams_id = 887  &
   location = -50.0, -225.0, 0.0  &
   orientation = 90.0d, 90.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_3_9.endMar  &
   adams_id = 888  &
   location = -25.0, -225.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_3_9.cmMar  &
   adams_id = 889  &
   location = -50.0, -225.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_3_9.MARKER_504  &
   adams_id = 504  &
   location = -75.0, -200.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
part create rigid_body mass_properties  &
   part_name = .net_ball.hlnk_3_9  &
   material_type = .net_ball.aluminum
!
! ****** Graphics for current part ******
!
geometry create shape cylinder  &
   cylinder_name = .net_ball.hlnk_3_9.cyl  &
   adams_id = 227  &
   center_marker = .net_ball.hlnk_3_9.cntMar  &
   angle_extent = 360.0  &
   length = 50.0  &
   radius = 1.0  &
   side_count_for_body = 20  &
   segment_count_for_ends = 20
!
part attributes  &
   part_name = .net_ball.hlnk_3_9  &
   color = RED  &
   name_visibility = off
!
!---------------------------------- hlnk_4_0 ----------------------------------!
!
!
defaults coordinate_system  &
   default_coordinate_system = .net_ball.ground
!
part create rigid_body name_and_position  &
   part_name = .net_ball.hlnk_4_0  &
   adams_id = 43  &
   location = 0.0, 0.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
defaults coordinate_system  &
   default_coordinate_system = .net_ball.hlnk_4_0
!
! ****** Markers for current part ******
!
marker create  &
   marker_name = .net_ball.hlnk_4_0.cntMar  &
   adams_id = 890  &
   location = -25.0, 225.0, 0.0  &
   orientation = 90.0d, 90.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_4_0.cm  &
   adams_id = 891  &
   location = 0.0, 225.0, 0.0  &
   orientation = 90.0d, 90.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_4_0.endMar  &
   adams_id = 892  &
   location = 25.0, 225.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_4_0.cmMar  &
   adams_id = 893  &
   location = 0.0, 225.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_4_0.MARKER_161  &
   adams_id = 161  &
   location = 0.0, 225.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_4_0.MARKER_163  &
   adams_id = 163  &
   location = 25.0, 225.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_4_0.MARKER_506  &
   adams_id = 506  &
   location = -25.0, 225.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
part create rigid_body mass_properties  &
   part_name = .net_ball.hlnk_4_0  &
   material_type = .net_ball.aluminum
!
! ****** Graphics for current part ******
!
geometry create shape cylinder  &
   cylinder_name = .net_ball.hlnk_4_0.cyl  &
   adams_id = 228  &
   center_marker = .net_ball.hlnk_4_0.cntMar  &
   angle_extent = 360.0  &
   length = 50.0  &
   radius = 1.0  &
   side_count_for_body = 20  &
   segment_count_for_ends = 20
!
part attributes  &
   part_name = .net_ball.hlnk_4_0  &
   color = RED  &
   name_visibility = off
!
!---------------------------------- hlnk_4_1 ----------------------------------!
!
!
defaults coordinate_system  &
   default_coordinate_system = .net_ball.ground
!
part create rigid_body name_and_position  &
   part_name = .net_ball.hlnk_4_1  &
   adams_id = 44  &
   location = 0.0, 0.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
defaults coordinate_system  &
   default_coordinate_system = .net_ball.hlnk_4_1
!
! ****** Markers for current part ******
!
marker create  &
   marker_name = .net_ball.hlnk_4_1.cntMar  &
   adams_id = 894  &
   location = -25.0, 175.0, 0.0  &
   orientation = 90.0d, 90.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_4_1.cm  &
   adams_id = 895  &
   location = 0.0, 175.0, 0.0  &
   orientation = 270.0d, 90.0d, 90.0d
!
marker create  &
   marker_name = .net_ball.hlnk_4_1.endMar  &
   adams_id = 896  &
   location = 25.0, 175.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_4_1.cmMar  &
   adams_id = 897  &
   location = 0.0, 175.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_4_1.MARKER_165  &
   adams_id = 165  &
   location = 0.0, 175.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_4_1.MARKER_167  &
   adams_id = 167  &
   location = 25.0, 175.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_4_1.MARKER_508  &
   adams_id = 508  &
   location = -25.0, 200.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_4_1.MARKER_510  &
   adams_id = 510  &
   location = -25.0, 175.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
part create rigid_body mass_properties  &
   part_name = .net_ball.hlnk_4_1  &
   material_type = .net_ball.aluminum
!
! ****** Graphics for current part ******
!
geometry create shape cylinder  &
   cylinder_name = .net_ball.hlnk_4_1.cyl  &
   adams_id = 229  &
   center_marker = .net_ball.hlnk_4_1.cntMar  &
   angle_extent = 360.0  &
   length = 50.0  &
   radius = 1.0  &
   side_count_for_body = 20  &
   segment_count_for_ends = 20
!
part attributes  &
   part_name = .net_ball.hlnk_4_1  &
   color = RED  &
   name_visibility = off
!
!---------------------------------- hlnk_4_2 ----------------------------------!
!
!
defaults coordinate_system  &
   default_coordinate_system = .net_ball.ground
!
part create rigid_body name_and_position  &
   part_name = .net_ball.hlnk_4_2  &
   adams_id = 45  &
   location = 0.0, 0.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
defaults coordinate_system  &
   default_coordinate_system = .net_ball.hlnk_4_2
!
! ****** Markers for current part ******
!
marker create  &
   marker_name = .net_ball.hlnk_4_2.cntMar  &
   adams_id = 898  &
   location = -25.0, 125.0, 0.0  &
   orientation = 90.0d, 90.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_4_2.cm  &
   adams_id = 899  &
   location = 0.0, 125.0, 0.0  &
   orientation = 270.0d, 90.0d, 90.0d
!
marker create  &
   marker_name = .net_ball.hlnk_4_2.endMar  &
   adams_id = 900  &
   location = 25.0, 125.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_4_2.cmMar  &
   adams_id = 901  &
   location = 0.0, 125.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_4_2.MARKER_169  &
   adams_id = 169  &
   location = 0.0, 125.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_4_2.MARKER_171  &
   adams_id = 171  &
   location = 25.0, 125.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_4_2.MARKER_512  &
   adams_id = 512  &
   location = -25.0, 150.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_4_2.MARKER_514  &
   adams_id = 514  &
   location = -25.0, 125.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
part create rigid_body mass_properties  &
   part_name = .net_ball.hlnk_4_2  &
   material_type = .net_ball.aluminum
!
! ****** Graphics for current part ******
!
geometry create shape cylinder  &
   cylinder_name = .net_ball.hlnk_4_2.cyl  &
   adams_id = 230  &
   center_marker = .net_ball.hlnk_4_2.cntMar  &
   angle_extent = 360.0  &
   length = 50.0  &
   radius = 1.0  &
   side_count_for_body = 20  &
   segment_count_for_ends = 20
!
part attributes  &
   part_name = .net_ball.hlnk_4_2  &
   color = RED  &
   name_visibility = off
!
!---------------------------------- hlnk_4_3 ----------------------------------!
!
!
defaults coordinate_system  &
   default_coordinate_system = .net_ball.ground
!
part create rigid_body name_and_position  &
   part_name = .net_ball.hlnk_4_3  &
   adams_id = 46  &
   location = 0.0, 0.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
defaults coordinate_system  &
   default_coordinate_system = .net_ball.hlnk_4_3
!
! ****** Markers for current part ******
!
marker create  &
   marker_name = .net_ball.hlnk_4_3.cntMar  &
   adams_id = 902  &
   location = -25.0, 75.0, 0.0  &
   orientation = 90.0d, 90.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_4_3.cm  &
   adams_id = 903  &
   location = 0.0, 75.0, 0.0  &
   orientation = 90.0d, 90.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_4_3.endMar  &
   adams_id = 904  &
   location = 25.0, 75.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_4_3.cmMar  &
   adams_id = 905  &
   location = 0.0, 75.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_4_3.MARKER_173  &
   adams_id = 173  &
   location = 0.0, 75.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_4_3.MARKER_175  &
   adams_id = 175  &
   location = 25.0, 75.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_4_3.MARKER_516  &
   adams_id = 516  &
   location = -25.0, 100.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_4_3.MARKER_518  &
   adams_id = 518  &
   location = -25.0, 75.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
part create rigid_body mass_properties  &
   part_name = .net_ball.hlnk_4_3  &
   material_type = .net_ball.aluminum
!
! ****** Graphics for current part ******
!
geometry create shape cylinder  &
   cylinder_name = .net_ball.hlnk_4_3.cyl  &
   adams_id = 231  &
   center_marker = .net_ball.hlnk_4_3.cntMar  &
   angle_extent = 360.0  &
   length = 50.0  &
   radius = 1.0  &
   side_count_for_body = 20  &
   segment_count_for_ends = 20
!
part attributes  &
   part_name = .net_ball.hlnk_4_3  &
   color = RED  &
   name_visibility = off
!
!---------------------------------- hlnk_4_4 ----------------------------------!
!
!
defaults coordinate_system  &
   default_coordinate_system = .net_ball.ground
!
part create rigid_body name_and_position  &
   part_name = .net_ball.hlnk_4_4  &
   adams_id = 47  &
   location = 0.0, 0.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
defaults coordinate_system  &
   default_coordinate_system = .net_ball.hlnk_4_4
!
! ****** Markers for current part ******
!
marker create  &
   marker_name = .net_ball.hlnk_4_4.cntMar  &
   adams_id = 906  &
   location = -25.0, 25.0, 0.0  &
   orientation = 90.0d, 90.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_4_4.cm  &
   adams_id = 907  &
   location = 0.0, 25.0, 0.0  &
   orientation = 270.0d, 90.0d, 90.0d
!
marker create  &
   marker_name = .net_ball.hlnk_4_4.endMar  &
   adams_id = 908  &
   location = 25.0, 25.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_4_4.cmMar  &
   adams_id = 909  &
   location = 0.0, 25.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_4_4.MARKER_177  &
   adams_id = 177  &
   location = 0.0, 25.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_4_4.MARKER_179  &
   adams_id = 179  &
   location = 25.0, 25.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_4_4.MARKER_520  &
   adams_id = 520  &
   location = -25.0, 50.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_4_4.MARKER_522  &
   adams_id = 522  &
   location = -25.0, 25.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
part create rigid_body mass_properties  &
   part_name = .net_ball.hlnk_4_4  &
   material_type = .net_ball.aluminum
!
! ****** Graphics for current part ******
!
geometry create shape cylinder  &
   cylinder_name = .net_ball.hlnk_4_4.cyl  &
   adams_id = 232  &
   center_marker = .net_ball.hlnk_4_4.cntMar  &
   angle_extent = 360.0  &
   length = 50.0  &
   radius = 1.0  &
   side_count_for_body = 20  &
   segment_count_for_ends = 20
!
part attributes  &
   part_name = .net_ball.hlnk_4_4  &
   color = RED  &
   name_visibility = off
!
!---------------------------------- hlnk_4_5 ----------------------------------!
!
!
defaults coordinate_system  &
   default_coordinate_system = .net_ball.ground
!
part create rigid_body name_and_position  &
   part_name = .net_ball.hlnk_4_5  &
   adams_id = 48  &
   location = 0.0, 0.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
defaults coordinate_system  &
   default_coordinate_system = .net_ball.hlnk_4_5
!
! ****** Markers for current part ******
!
marker create  &
   marker_name = .net_ball.hlnk_4_5.cntMar  &
   adams_id = 910  &
   location = -25.0, -25.0, 0.0  &
   orientation = 90.0d, 90.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_4_5.cm  &
   adams_id = 911  &
   location = 0.0, -25.0, 0.0  &
   orientation = 270.0d, 90.0d, 90.0d
!
marker create  &
   marker_name = .net_ball.hlnk_4_5.endMar  &
   adams_id = 912  &
   location = 25.0, -25.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_4_5.cmMar  &
   adams_id = 913  &
   location = 0.0, -25.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_4_5.MARKER_181  &
   adams_id = 181  &
   location = 0.0, -25.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_4_5.MARKER_183  &
   adams_id = 183  &
   location = 25.0, -25.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_4_5.MARKER_524  &
   adams_id = 524  &
   location = -25.0, 0.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_4_5.MARKER_526  &
   adams_id = 526  &
   location = -25.0, -25.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
part create rigid_body mass_properties  &
   part_name = .net_ball.hlnk_4_5  &
   material_type = .net_ball.aluminum
!
! ****** Graphics for current part ******
!
geometry create shape cylinder  &
   cylinder_name = .net_ball.hlnk_4_5.cyl  &
   adams_id = 233  &
   center_marker = .net_ball.hlnk_4_5.cntMar  &
   angle_extent = 360.0  &
   length = 50.0  &
   radius = 1.0  &
   side_count_for_body = 20  &
   segment_count_for_ends = 20
!
part attributes  &
   part_name = .net_ball.hlnk_4_5  &
   color = RED  &
   name_visibility = off
!
!---------------------------------- hlnk_4_6 ----------------------------------!
!
!
defaults coordinate_system  &
   default_coordinate_system = .net_ball.ground
!
part create rigid_body name_and_position  &
   part_name = .net_ball.hlnk_4_6  &
   adams_id = 49  &
   location = 0.0, 0.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
defaults coordinate_system  &
   default_coordinate_system = .net_ball.hlnk_4_6
!
! ****** Markers for current part ******
!
marker create  &
   marker_name = .net_ball.hlnk_4_6.cntMar  &
   adams_id = 914  &
   location = -25.0, -75.0, 0.0  &
   orientation = 90.0d, 90.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_4_6.cm  &
   adams_id = 915  &
   location = 0.0, -75.0, 0.0  &
   orientation = 90.0d, 90.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_4_6.endMar  &
   adams_id = 916  &
   location = 25.0, -75.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_4_6.cmMar  &
   adams_id = 917  &
   location = 0.0, -75.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_4_6.MARKER_185  &
   adams_id = 185  &
   location = 0.0, -75.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_4_6.MARKER_187  &
   adams_id = 187  &
   location = 25.0, -75.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_4_6.MARKER_528  &
   adams_id = 528  &
   location = -25.0, -50.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_4_6.MARKER_530  &
   adams_id = 530  &
   location = -25.0, -75.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
part create rigid_body mass_properties  &
   part_name = .net_ball.hlnk_4_6  &
   material_type = .net_ball.aluminum
!
! ****** Graphics for current part ******
!
geometry create shape cylinder  &
   cylinder_name = .net_ball.hlnk_4_6.cyl  &
   adams_id = 234  &
   center_marker = .net_ball.hlnk_4_6.cntMar  &
   angle_extent = 360.0  &
   length = 50.0  &
   radius = 1.0  &
   side_count_for_body = 20  &
   segment_count_for_ends = 20
!
part attributes  &
   part_name = .net_ball.hlnk_4_6  &
   color = RED  &
   name_visibility = off
!
!---------------------------------- hlnk_4_7 ----------------------------------!
!
!
defaults coordinate_system  &
   default_coordinate_system = .net_ball.ground
!
part create rigid_body name_and_position  &
   part_name = .net_ball.hlnk_4_7  &
   adams_id = 50  &
   location = 0.0, 0.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
defaults coordinate_system  &
   default_coordinate_system = .net_ball.hlnk_4_7
!
! ****** Markers for current part ******
!
marker create  &
   marker_name = .net_ball.hlnk_4_7.cntMar  &
   adams_id = 918  &
   location = -25.0, -125.0, 0.0  &
   orientation = 90.0d, 90.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_4_7.cm  &
   adams_id = 919  &
   location = 0.0, -125.0, 0.0  &
   orientation = 270.0d, 90.0d, 90.0d
!
marker create  &
   marker_name = .net_ball.hlnk_4_7.endMar  &
   adams_id = 920  &
   location = 25.0, -125.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_4_7.cmMar  &
   adams_id = 921  &
   location = 0.0, -125.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_4_7.MARKER_189  &
   adams_id = 189  &
   location = 0.0, -125.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_4_7.MARKER_191  &
   adams_id = 191  &
   location = 25.0, -125.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_4_7.MARKER_532  &
   adams_id = 532  &
   location = -25.0, -100.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_4_7.MARKER_534  &
   adams_id = 534  &
   location = -25.0, -125.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
part create rigid_body mass_properties  &
   part_name = .net_ball.hlnk_4_7  &
   material_type = .net_ball.aluminum
!
! ****** Graphics for current part ******
!
geometry create shape cylinder  &
   cylinder_name = .net_ball.hlnk_4_7.cyl  &
   adams_id = 235  &
   center_marker = .net_ball.hlnk_4_7.cntMar  &
   angle_extent = 360.0  &
   length = 50.0  &
   radius = 1.0  &
   side_count_for_body = 20  &
   segment_count_for_ends = 20
!
part attributes  &
   part_name = .net_ball.hlnk_4_7  &
   color = RED  &
   name_visibility = off
!
!---------------------------------- hlnk_4_8 ----------------------------------!
!
!
defaults coordinate_system  &
   default_coordinate_system = .net_ball.ground
!
part create rigid_body name_and_position  &
   part_name = .net_ball.hlnk_4_8  &
   adams_id = 51  &
   location = 0.0, 0.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
defaults coordinate_system  &
   default_coordinate_system = .net_ball.hlnk_4_8
!
! ****** Markers for current part ******
!
marker create  &
   marker_name = .net_ball.hlnk_4_8.cntMar  &
   adams_id = 922  &
   location = -25.0, -175.0, 0.0  &
   orientation = 90.0d, 90.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_4_8.cm  &
   adams_id = 923  &
   location = 0.0, -175.0, 0.0  &
   orientation = 270.0d, 90.0d, 90.0d
!
marker create  &
   marker_name = .net_ball.hlnk_4_8.endMar  &
   adams_id = 924  &
   location = 25.0, -175.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_4_8.cmMar  &
   adams_id = 925  &
   location = 0.0, -175.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_4_8.MARKER_193  &
   adams_id = 193  &
   location = 0.0, -175.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_4_8.MARKER_195  &
   adams_id = 195  &
   location = 25.0, -175.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_4_8.MARKER_197  &
   adams_id = 197  &
   location = 0.0, -225.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_4_8.MARKER_199  &
   adams_id = 199  &
   location = 25.0, -225.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_4_8.MARKER_536  &
   adams_id = 536  &
   location = -25.0, -150.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_4_8.MARKER_538  &
   adams_id = 538  &
   location = -25.0, -175.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
part create rigid_body mass_properties  &
   part_name = .net_ball.hlnk_4_8  &
   material_type = .net_ball.aluminum
!
! ****** Graphics for current part ******
!
geometry create shape cylinder  &
   cylinder_name = .net_ball.hlnk_4_8.cyl  &
   adams_id = 236  &
   center_marker = .net_ball.hlnk_4_8.cntMar  &
   angle_extent = 360.0  &
   length = 50.0  &
   radius = 1.0  &
   side_count_for_body = 20  &
   segment_count_for_ends = 20
!
part attributes  &
   part_name = .net_ball.hlnk_4_8  &
   color = RED  &
   name_visibility = off
!
!---------------------------------- hlnk_4_9 ----------------------------------!
!
!
defaults coordinate_system  &
   default_coordinate_system = .net_ball.ground
!
part create rigid_body name_and_position  &
   part_name = .net_ball.hlnk_4_9  &
   adams_id = 52  &
   location = 0.0, 0.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
defaults coordinate_system  &
   default_coordinate_system = .net_ball.hlnk_4_9
!
! ****** Markers for current part ******
!
marker create  &
   marker_name = .net_ball.hlnk_4_9.cntMar  &
   adams_id = 926  &
   location = -25.0, -225.0, 0.0  &
   orientation = 90.0d, 90.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_4_9.cm  &
   adams_id = 927  &
   location = 0.0, -225.0, 0.0  &
   orientation = 90.0d, 90.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_4_9.endMar  &
   adams_id = 928  &
   location = 25.0, -225.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_4_9.cmMar  &
   adams_id = 929  &
   location = 0.0, -225.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_4_9.MARKER_540  &
   adams_id = 540  &
   location = -25.0, -200.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
part create rigid_body mass_properties  &
   part_name = .net_ball.hlnk_4_9  &
   material_type = .net_ball.aluminum
!
! ****** Graphics for current part ******
!
geometry create shape cylinder  &
   cylinder_name = .net_ball.hlnk_4_9.cyl  &
   adams_id = 237  &
   center_marker = .net_ball.hlnk_4_9.cntMar  &
   angle_extent = 360.0  &
   length = 50.0  &
   radius = 1.0  &
   side_count_for_body = 20  &
   segment_count_for_ends = 20
!
part attributes  &
   part_name = .net_ball.hlnk_4_9  &
   color = RED  &
   name_visibility = off
!
!---------------------------------- hlnk_5_0 ----------------------------------!
!
!
defaults coordinate_system  &
   default_coordinate_system = .net_ball.ground
!
part create rigid_body name_and_position  &
   part_name = .net_ball.hlnk_5_0  &
   adams_id = 53  &
   location = 0.0, 0.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
defaults coordinate_system  &
   default_coordinate_system = .net_ball.hlnk_5_0
!
! ****** Markers for current part ******
!
marker create  &
   marker_name = .net_ball.hlnk_5_0.cntMar  &
   adams_id = 930  &
   location = 25.0, 225.0, 0.0  &
   orientation = 90.0d, 90.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_5_0.cm  &
   adams_id = 931  &
   location = 50.0, 225.0, 0.0  &
   orientation = 90.0d, 90.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_5_0.endMar  &
   adams_id = 932  &
   location = 75.0, 225.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_5_0.cmMar  &
   adams_id = 933  &
   location = 50.0, 225.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_5_0.MARKER_201  &
   adams_id = 201  &
   location = 50.0, 225.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_5_0.MARKER_203  &
   adams_id = 203  &
   location = 75.0, 225.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_5_0.MARKER_542  &
   adams_id = 542  &
   location = 25.0, 225.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
part create rigid_body mass_properties  &
   part_name = .net_ball.hlnk_5_0  &
   material_type = .net_ball.aluminum
!
! ****** Graphics for current part ******
!
geometry create shape cylinder  &
   cylinder_name = .net_ball.hlnk_5_0.cyl  &
   adams_id = 238  &
   center_marker = .net_ball.hlnk_5_0.cntMar  &
   angle_extent = 360.0  &
   length = 50.0  &
   radius = 1.0  &
   side_count_for_body = 20  &
   segment_count_for_ends = 20
!
part attributes  &
   part_name = .net_ball.hlnk_5_0  &
   color = RED  &
   name_visibility = off
!
!---------------------------------- hlnk_5_1 ----------------------------------!
!
!
defaults coordinate_system  &
   default_coordinate_system = .net_ball.ground
!
part create rigid_body name_and_position  &
   part_name = .net_ball.hlnk_5_1  &
   adams_id = 54  &
   location = 0.0, 0.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
defaults coordinate_system  &
   default_coordinate_system = .net_ball.hlnk_5_1
!
! ****** Markers for current part ******
!
marker create  &
   marker_name = .net_ball.hlnk_5_1.cntMar  &
   adams_id = 934  &
   location = 25.0, 175.0, 0.0  &
   orientation = 90.0d, 90.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_5_1.cm  &
   adams_id = 935  &
   location = 50.0, 175.0, 0.0  &
   orientation = 90.0d, 90.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_5_1.endMar  &
   adams_id = 936  &
   location = 75.0, 175.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_5_1.cmMar  &
   adams_id = 937  &
   location = 50.0, 175.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_5_1.MARKER_205  &
   adams_id = 205  &
   location = 50.0, 175.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_5_1.MARKER_207  &
   adams_id = 207  &
   location = 75.0, 175.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_5_1.MARKER_544  &
   adams_id = 544  &
   location = 25.0, 200.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_5_1.MARKER_546  &
   adams_id = 546  &
   location = 25.0, 175.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
part create rigid_body mass_properties  &
   part_name = .net_ball.hlnk_5_1  &
   material_type = .net_ball.aluminum
!
! ****** Graphics for current part ******
!
geometry create shape cylinder  &
   cylinder_name = .net_ball.hlnk_5_1.cyl  &
   adams_id = 239  &
   center_marker = .net_ball.hlnk_5_1.cntMar  &
   angle_extent = 360.0  &
   length = 50.0  &
   radius = 1.0  &
   side_count_for_body = 20  &
   segment_count_for_ends = 20
!
part attributes  &
   part_name = .net_ball.hlnk_5_1  &
   color = RED  &
   name_visibility = off
!
!---------------------------------- hlnk_5_2 ----------------------------------!
!
!
defaults coordinate_system  &
   default_coordinate_system = .net_ball.ground
!
part create rigid_body name_and_position  &
   part_name = .net_ball.hlnk_5_2  &
   adams_id = 55  &
   location = 0.0, 0.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
defaults coordinate_system  &
   default_coordinate_system = .net_ball.hlnk_5_2
!
! ****** Markers for current part ******
!
marker create  &
   marker_name = .net_ball.hlnk_5_2.cntMar  &
   adams_id = 938  &
   location = 25.0, 125.0, 0.0  &
   orientation = 90.0d, 90.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_5_2.cm  &
   adams_id = 939  &
   location = 50.0, 125.0, 0.0  &
   orientation = 90.0d, 90.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_5_2.endMar  &
   adams_id = 940  &
   location = 75.0, 125.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_5_2.cmMar  &
   adams_id = 941  &
   location = 50.0, 125.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_5_2.MARKER_209  &
   adams_id = 209  &
   location = 50.0, 125.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_5_2.MARKER_211  &
   adams_id = 211  &
   location = 75.0, 125.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_5_2.MARKER_548  &
   adams_id = 548  &
   location = 25.0, 150.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_5_2.MARKER_550  &
   adams_id = 550  &
   location = 25.0, 125.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
part create rigid_body mass_properties  &
   part_name = .net_ball.hlnk_5_2  &
   material_type = .net_ball.aluminum
!
! ****** Graphics for current part ******
!
geometry create shape cylinder  &
   cylinder_name = .net_ball.hlnk_5_2.cyl  &
   adams_id = 240  &
   center_marker = .net_ball.hlnk_5_2.cntMar  &
   angle_extent = 360.0  &
   length = 50.0  &
   radius = 1.0  &
   side_count_for_body = 20  &
   segment_count_for_ends = 20
!
part attributes  &
   part_name = .net_ball.hlnk_5_2  &
   color = RED  &
   name_visibility = off
!
!---------------------------------- hlnk_5_3 ----------------------------------!
!
!
defaults coordinate_system  &
   default_coordinate_system = .net_ball.ground
!
part create rigid_body name_and_position  &
   part_name = .net_ball.hlnk_5_3  &
   adams_id = 56  &
   location = 0.0, 0.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
defaults coordinate_system  &
   default_coordinate_system = .net_ball.hlnk_5_3
!
! ****** Markers for current part ******
!
marker create  &
   marker_name = .net_ball.hlnk_5_3.cntMar  &
   adams_id = 942  &
   location = 25.0, 75.0, 0.0  &
   orientation = 90.0d, 90.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_5_3.cm  &
   adams_id = 943  &
   location = 50.0, 75.0, 0.0  &
   orientation = 270.0d, 90.0d, 90.0d
!
marker create  &
   marker_name = .net_ball.hlnk_5_3.endMar  &
   adams_id = 944  &
   location = 75.0, 75.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_5_3.cmMar  &
   adams_id = 945  &
   location = 50.0, 75.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_5_3.MARKER_213  &
   adams_id = 213  &
   location = 50.0, 75.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_5_3.MARKER_215  &
   adams_id = 215  &
   location = 75.0, 75.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_5_3.MARKER_552  &
   adams_id = 552  &
   location = 25.0, 100.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_5_3.MARKER_554  &
   adams_id = 554  &
   location = 25.0, 75.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
part create rigid_body mass_properties  &
   part_name = .net_ball.hlnk_5_3  &
   material_type = .net_ball.aluminum
!
! ****** Graphics for current part ******
!
geometry create shape cylinder  &
   cylinder_name = .net_ball.hlnk_5_3.cyl  &
   adams_id = 241  &
   center_marker = .net_ball.hlnk_5_3.cntMar  &
   angle_extent = 360.0  &
   length = 50.0  &
   radius = 1.0  &
   side_count_for_body = 20  &
   segment_count_for_ends = 20
!
part attributes  &
   part_name = .net_ball.hlnk_5_3  &
   color = RED  &
   name_visibility = off
!
!---------------------------------- hlnk_5_4 ----------------------------------!
!
!
defaults coordinate_system  &
   default_coordinate_system = .net_ball.ground
!
part create rigid_body name_and_position  &
   part_name = .net_ball.hlnk_5_4  &
   adams_id = 57  &
   location = 0.0, 0.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
defaults coordinate_system  &
   default_coordinate_system = .net_ball.hlnk_5_4
!
! ****** Markers for current part ******
!
marker create  &
   marker_name = .net_ball.hlnk_5_4.cntMar  &
   adams_id = 946  &
   location = 25.0, 25.0, 0.0  &
   orientation = 90.0d, 90.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_5_4.cm  &
   adams_id = 947  &
   location = 50.0, 25.0, 0.0  &
   orientation = 90.0d, 90.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_5_4.endMar  &
   adams_id = 948  &
   location = 75.0, 25.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_5_4.cmMar  &
   adams_id = 949  &
   location = 50.0, 25.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_5_4.MARKER_217  &
   adams_id = 217  &
   location = 50.0, 25.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_5_4.MARKER_219  &
   adams_id = 219  &
   location = 75.0, 25.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_5_4.MARKER_556  &
   adams_id = 556  &
   location = 25.0, 50.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_5_4.MARKER_558  &
   adams_id = 558  &
   location = 25.0, 25.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
part create rigid_body mass_properties  &
   part_name = .net_ball.hlnk_5_4  &
   material_type = .net_ball.aluminum
!
! ****** Graphics for current part ******
!
geometry create shape cylinder  &
   cylinder_name = .net_ball.hlnk_5_4.cyl  &
   adams_id = 242  &
   center_marker = .net_ball.hlnk_5_4.cntMar  &
   angle_extent = 360.0  &
   length = 50.0  &
   radius = 1.0  &
   side_count_for_body = 20  &
   segment_count_for_ends = 20
!
part attributes  &
   part_name = .net_ball.hlnk_5_4  &
   color = RED  &
   name_visibility = off
!
!---------------------------------- hlnk_5_5 ----------------------------------!
!
!
defaults coordinate_system  &
   default_coordinate_system = .net_ball.ground
!
part create rigid_body name_and_position  &
   part_name = .net_ball.hlnk_5_5  &
   adams_id = 58  &
   location = 0.0, 0.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
defaults coordinate_system  &
   default_coordinate_system = .net_ball.hlnk_5_5
!
! ****** Markers for current part ******
!
marker create  &
   marker_name = .net_ball.hlnk_5_5.cntMar  &
   adams_id = 950  &
   location = 25.0, -25.0, 0.0  &
   orientation = 90.0d, 90.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_5_5.cm  &
   adams_id = 951  &
   location = 50.0, -25.0, 0.0  &
   orientation = 90.0d, 90.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_5_5.endMar  &
   adams_id = 952  &
   location = 75.0, -25.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_5_5.cmMar  &
   adams_id = 953  &
   location = 50.0, -25.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_5_5.MARKER_221  &
   adams_id = 221  &
   location = 50.0, -25.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_5_5.MARKER_223  &
   adams_id = 223  &
   location = 75.0, -25.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_5_5.MARKER_560  &
   adams_id = 560  &
   location = 25.0, 0.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_5_5.MARKER_562  &
   adams_id = 562  &
   location = 25.0, -25.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
part create rigid_body mass_properties  &
   part_name = .net_ball.hlnk_5_5  &
   material_type = .net_ball.aluminum
!
! ****** Graphics for current part ******
!
geometry create shape cylinder  &
   cylinder_name = .net_ball.hlnk_5_5.cyl  &
   adams_id = 243  &
   center_marker = .net_ball.hlnk_5_5.cntMar  &
   angle_extent = 360.0  &
   length = 50.0  &
   radius = 1.0  &
   side_count_for_body = 20  &
   segment_count_for_ends = 20
!
part attributes  &
   part_name = .net_ball.hlnk_5_5  &
   color = RED  &
   name_visibility = off
!
!---------------------------------- hlnk_5_6 ----------------------------------!
!
!
defaults coordinate_system  &
   default_coordinate_system = .net_ball.ground
!
part create rigid_body name_and_position  &
   part_name = .net_ball.hlnk_5_6  &
   adams_id = 59  &
   location = 0.0, 0.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
defaults coordinate_system  &
   default_coordinate_system = .net_ball.hlnk_5_6
!
! ****** Markers for current part ******
!
marker create  &
   marker_name = .net_ball.hlnk_5_6.cntMar  &
   adams_id = 954  &
   location = 25.0, -75.0, 0.0  &
   orientation = 90.0d, 90.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_5_6.cm  &
   adams_id = 955  &
   location = 50.0, -75.0, 0.0  &
   orientation = 270.0d, 90.0d, 90.0d
!
marker create  &
   marker_name = .net_ball.hlnk_5_6.endMar  &
   adams_id = 956  &
   location = 75.0, -75.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_5_6.cmMar  &
   adams_id = 957  &
   location = 50.0, -75.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_5_6.MARKER_225  &
   adams_id = 225  &
   location = 50.0, -75.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_5_6.MARKER_227  &
   adams_id = 227  &
   location = 75.0, -75.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_5_6.MARKER_564  &
   adams_id = 564  &
   location = 25.0, -50.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_5_6.MARKER_566  &
   adams_id = 566  &
   location = 25.0, -75.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
part create rigid_body mass_properties  &
   part_name = .net_ball.hlnk_5_6  &
   material_type = .net_ball.aluminum
!
! ****** Graphics for current part ******
!
geometry create shape cylinder  &
   cylinder_name = .net_ball.hlnk_5_6.cyl  &
   adams_id = 244  &
   center_marker = .net_ball.hlnk_5_6.cntMar  &
   angle_extent = 360.0  &
   length = 50.0  &
   radius = 1.0  &
   side_count_for_body = 20  &
   segment_count_for_ends = 20
!
part attributes  &
   part_name = .net_ball.hlnk_5_6  &
   color = RED  &
   name_visibility = off
!
!---------------------------------- hlnk_5_7 ----------------------------------!
!
!
defaults coordinate_system  &
   default_coordinate_system = .net_ball.ground
!
part create rigid_body name_and_position  &
   part_name = .net_ball.hlnk_5_7  &
   adams_id = 60  &
   location = 0.0, 0.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
defaults coordinate_system  &
   default_coordinate_system = .net_ball.hlnk_5_7
!
! ****** Markers for current part ******
!
marker create  &
   marker_name = .net_ball.hlnk_5_7.cntMar  &
   adams_id = 958  &
   location = 25.0, -125.0, 0.0  &
   orientation = 90.0d, 90.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_5_7.cm  &
   adams_id = 959  &
   location = 50.0, -125.0, 0.0  &
   orientation = 90.0d, 90.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_5_7.endMar  &
   adams_id = 960  &
   location = 75.0, -125.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_5_7.cmMar  &
   adams_id = 961  &
   location = 50.0, -125.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_5_7.MARKER_229  &
   adams_id = 229  &
   location = 50.0, -125.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_5_7.MARKER_231  &
   adams_id = 231  &
   location = 75.0, -125.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_5_7.MARKER_568  &
   adams_id = 568  &
   location = 25.0, -100.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_5_7.MARKER_570  &
   adams_id = 570  &
   location = 25.0, -125.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
part create rigid_body mass_properties  &
   part_name = .net_ball.hlnk_5_7  &
   material_type = .net_ball.aluminum
!
! ****** Graphics for current part ******
!
geometry create shape cylinder  &
   cylinder_name = .net_ball.hlnk_5_7.cyl  &
   adams_id = 245  &
   center_marker = .net_ball.hlnk_5_7.cntMar  &
   angle_extent = 360.0  &
   length = 50.0  &
   radius = 1.0  &
   side_count_for_body = 20  &
   segment_count_for_ends = 20
!
part attributes  &
   part_name = .net_ball.hlnk_5_7  &
   color = RED  &
   name_visibility = off
!
!---------------------------------- hlnk_5_8 ----------------------------------!
!
!
defaults coordinate_system  &
   default_coordinate_system = .net_ball.ground
!
part create rigid_body name_and_position  &
   part_name = .net_ball.hlnk_5_8  &
   adams_id = 61  &
   location = 0.0, 0.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
defaults coordinate_system  &
   default_coordinate_system = .net_ball.hlnk_5_8
!
! ****** Markers for current part ******
!
marker create  &
   marker_name = .net_ball.hlnk_5_8.cntMar  &
   adams_id = 962  &
   location = 25.0, -175.0, 0.0  &
   orientation = 90.0d, 90.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_5_8.cm  &
   adams_id = 963  &
   location = 50.0, -175.0, 0.0  &
   orientation = 90.0d, 90.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_5_8.endMar  &
   adams_id = 964  &
   location = 75.0, -175.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_5_8.cmMar  &
   adams_id = 965  &
   location = 50.0, -175.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_5_8.MARKER_233  &
   adams_id = 233  &
   location = 50.0, -175.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_5_8.MARKER_235  &
   adams_id = 235  &
   location = 75.0, -175.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_5_8.MARKER_237  &
   adams_id = 237  &
   location = 50.0, -225.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_5_8.MARKER_239  &
   adams_id = 239  &
   location = 75.0, -225.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_5_8.MARKER_572  &
   adams_id = 572  &
   location = 25.0, -150.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_5_8.MARKER_574  &
   adams_id = 574  &
   location = 25.0, -175.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
part create rigid_body mass_properties  &
   part_name = .net_ball.hlnk_5_8  &
   material_type = .net_ball.aluminum
!
! ****** Graphics for current part ******
!
geometry create shape cylinder  &
   cylinder_name = .net_ball.hlnk_5_8.cyl  &
   adams_id = 246  &
   center_marker = .net_ball.hlnk_5_8.cntMar  &
   angle_extent = 360.0  &
   length = 50.0  &
   radius = 1.0  &
   side_count_for_body = 20  &
   segment_count_for_ends = 20
!
part attributes  &
   part_name = .net_ball.hlnk_5_8  &
   color = RED  &
   name_visibility = off
!
!---------------------------------- hlnk_5_9 ----------------------------------!
!
!
defaults coordinate_system  &
   default_coordinate_system = .net_ball.ground
!
part create rigid_body name_and_position  &
   part_name = .net_ball.hlnk_5_9  &
   adams_id = 62  &
   location = 0.0, 0.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
defaults coordinate_system  &
   default_coordinate_system = .net_ball.hlnk_5_9
!
! ****** Markers for current part ******
!
marker create  &
   marker_name = .net_ball.hlnk_5_9.cntMar  &
   adams_id = 966  &
   location = 25.0, -225.0, 0.0  &
   orientation = 90.0d, 90.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_5_9.cm  &
   adams_id = 967  &
   location = 50.0, -225.0, 0.0  &
   orientation = 90.0d, 90.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_5_9.endMar  &
   adams_id = 968  &
   location = 75.0, -225.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_5_9.cmMar  &
   adams_id = 969  &
   location = 50.0, -225.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_5_9.MARKER_576  &
   adams_id = 576  &
   location = 25.0, -200.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
part create rigid_body mass_properties  &
   part_name = .net_ball.hlnk_5_9  &
   material_type = .net_ball.aluminum
!
! ****** Graphics for current part ******
!
geometry create shape cylinder  &
   cylinder_name = .net_ball.hlnk_5_9.cyl  &
   adams_id = 247  &
   center_marker = .net_ball.hlnk_5_9.cntMar  &
   angle_extent = 360.0  &
   length = 50.0  &
   radius = 1.0  &
   side_count_for_body = 20  &
   segment_count_for_ends = 20
!
part attributes  &
   part_name = .net_ball.hlnk_5_9  &
   color = RED  &
   name_visibility = off
!
!---------------------------------- hlnk_6_0 ----------------------------------!
!
!
defaults coordinate_system  &
   default_coordinate_system = .net_ball.ground
!
part create rigid_body name_and_position  &
   part_name = .net_ball.hlnk_6_0  &
   adams_id = 63  &
   location = 0.0, 0.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
defaults coordinate_system  &
   default_coordinate_system = .net_ball.hlnk_6_0
!
! ****** Markers for current part ******
!
marker create  &
   marker_name = .net_ball.hlnk_6_0.cntMar  &
   adams_id = 970  &
   location = 75.0, 225.0, 0.0  &
   orientation = 90.0d, 90.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_6_0.cm  &
   adams_id = 971  &
   location = 100.0, 225.0, 0.0  &
   orientation = 90.0d, 90.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_6_0.endMar  &
   adams_id = 972  &
   location = 125.0, 225.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_6_0.cmMar  &
   adams_id = 973  &
   location = 100.0, 225.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_6_0.MARKER_241  &
   adams_id = 241  &
   location = 100.0, 225.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_6_0.MARKER_243  &
   adams_id = 243  &
   location = 125.0, 225.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_6_0.MARKER_578  &
   adams_id = 578  &
   location = 75.0, 225.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
part create rigid_body mass_properties  &
   part_name = .net_ball.hlnk_6_0  &
   material_type = .net_ball.aluminum
!
! ****** Graphics for current part ******
!
geometry create shape cylinder  &
   cylinder_name = .net_ball.hlnk_6_0.cyl  &
   adams_id = 248  &
   center_marker = .net_ball.hlnk_6_0.cntMar  &
   angle_extent = 360.0  &
   length = 50.0  &
   radius = 1.0  &
   side_count_for_body = 20  &
   segment_count_for_ends = 20
!
part attributes  &
   part_name = .net_ball.hlnk_6_0  &
   color = RED  &
   name_visibility = off
!
!---------------------------------- hlnk_6_1 ----------------------------------!
!
!
defaults coordinate_system  &
   default_coordinate_system = .net_ball.ground
!
part create rigid_body name_and_position  &
   part_name = .net_ball.hlnk_6_1  &
   adams_id = 64  &
   location = 0.0, 0.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
defaults coordinate_system  &
   default_coordinate_system = .net_ball.hlnk_6_1
!
! ****** Markers for current part ******
!
marker create  &
   marker_name = .net_ball.hlnk_6_1.cntMar  &
   adams_id = 974  &
   location = 75.0, 175.0, 0.0  &
   orientation = 90.0d, 90.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_6_1.cm  &
   adams_id = 975  &
   location = 100.0, 175.0, 0.0  &
   orientation = 270.0d, 90.0d, 90.0d
!
marker create  &
   marker_name = .net_ball.hlnk_6_1.endMar  &
   adams_id = 976  &
   location = 125.0, 175.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_6_1.cmMar  &
   adams_id = 977  &
   location = 100.0, 175.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_6_1.MARKER_245  &
   adams_id = 245  &
   location = 100.0, 175.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_6_1.MARKER_247  &
   adams_id = 247  &
   location = 125.0, 175.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_6_1.MARKER_580  &
   adams_id = 580  &
   location = 75.0, 200.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_6_1.MARKER_582  &
   adams_id = 582  &
   location = 75.0, 175.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
part create rigid_body mass_properties  &
   part_name = .net_ball.hlnk_6_1  &
   material_type = .net_ball.aluminum
!
! ****** Graphics for current part ******
!
geometry create shape cylinder  &
   cylinder_name = .net_ball.hlnk_6_1.cyl  &
   adams_id = 249  &
   center_marker = .net_ball.hlnk_6_1.cntMar  &
   angle_extent = 360.0  &
   length = 50.0  &
   radius = 1.0  &
   side_count_for_body = 20  &
   segment_count_for_ends = 20
!
part attributes  &
   part_name = .net_ball.hlnk_6_1  &
   color = RED  &
   name_visibility = off
!
!---------------------------------- hlnk_6_2 ----------------------------------!
!
!
defaults coordinate_system  &
   default_coordinate_system = .net_ball.ground
!
part create rigid_body name_and_position  &
   part_name = .net_ball.hlnk_6_2  &
   adams_id = 65  &
   location = 0.0, 0.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
defaults coordinate_system  &
   default_coordinate_system = .net_ball.hlnk_6_2
!
! ****** Markers for current part ******
!
marker create  &
   marker_name = .net_ball.hlnk_6_2.cntMar  &
   adams_id = 978  &
   location = 75.0, 125.0, 0.0  &
   orientation = 90.0d, 90.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_6_2.cm  &
   adams_id = 979  &
   location = 100.0, 125.0, 0.0  &
   orientation = 90.0d, 90.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_6_2.endMar  &
   adams_id = 980  &
   location = 125.0, 125.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_6_2.cmMar  &
   adams_id = 981  &
   location = 100.0, 125.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_6_2.MARKER_249  &
   adams_id = 249  &
   location = 100.0, 125.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_6_2.MARKER_251  &
   adams_id = 251  &
   location = 125.0, 125.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_6_2.MARKER_584  &
   adams_id = 584  &
   location = 75.0, 150.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_6_2.MARKER_586  &
   adams_id = 586  &
   location = 75.0, 125.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
part create rigid_body mass_properties  &
   part_name = .net_ball.hlnk_6_2  &
   material_type = .net_ball.aluminum
!
! ****** Graphics for current part ******
!
geometry create shape cylinder  &
   cylinder_name = .net_ball.hlnk_6_2.cyl  &
   adams_id = 250  &
   center_marker = .net_ball.hlnk_6_2.cntMar  &
   angle_extent = 360.0  &
   length = 50.0  &
   radius = 1.0  &
   side_count_for_body = 20  &
   segment_count_for_ends = 20
!
part attributes  &
   part_name = .net_ball.hlnk_6_2  &
   color = RED  &
   name_visibility = off
!
!---------------------------------- hlnk_6_3 ----------------------------------!
!
!
defaults coordinate_system  &
   default_coordinate_system = .net_ball.ground
!
part create rigid_body name_and_position  &
   part_name = .net_ball.hlnk_6_3  &
   adams_id = 66  &
   location = 0.0, 0.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
defaults coordinate_system  &
   default_coordinate_system = .net_ball.hlnk_6_3
!
! ****** Markers for current part ******
!
marker create  &
   marker_name = .net_ball.hlnk_6_3.cntMar  &
   adams_id = 982  &
   location = 75.0, 75.0, 0.0  &
   orientation = 90.0d, 90.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_6_3.cm  &
   adams_id = 983  &
   location = 100.0, 75.0, 0.0  &
   orientation = 90.0d, 90.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_6_3.endMar  &
   adams_id = 984  &
   location = 125.0, 75.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_6_3.cmMar  &
   adams_id = 985  &
   location = 100.0, 75.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_6_3.MARKER_253  &
   adams_id = 253  &
   location = 100.0, 75.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_6_3.MARKER_255  &
   adams_id = 255  &
   location = 125.0, 75.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_6_3.MARKER_588  &
   adams_id = 588  &
   location = 75.0, 100.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_6_3.MARKER_590  &
   adams_id = 590  &
   location = 75.0, 75.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
part create rigid_body mass_properties  &
   part_name = .net_ball.hlnk_6_3  &
   material_type = .net_ball.aluminum
!
! ****** Graphics for current part ******
!
geometry create shape cylinder  &
   cylinder_name = .net_ball.hlnk_6_3.cyl  &
   adams_id = 251  &
   center_marker = .net_ball.hlnk_6_3.cntMar  &
   angle_extent = 360.0  &
   length = 50.0  &
   radius = 1.0  &
   side_count_for_body = 20  &
   segment_count_for_ends = 20
!
part attributes  &
   part_name = .net_ball.hlnk_6_3  &
   color = RED  &
   name_visibility = off
!
!---------------------------------- hlnk_6_4 ----------------------------------!
!
!
defaults coordinate_system  &
   default_coordinate_system = .net_ball.ground
!
part create rigid_body name_and_position  &
   part_name = .net_ball.hlnk_6_4  &
   adams_id = 67  &
   location = 0.0, 0.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
defaults coordinate_system  &
   default_coordinate_system = .net_ball.hlnk_6_4
!
! ****** Markers for current part ******
!
marker create  &
   marker_name = .net_ball.hlnk_6_4.cntMar  &
   adams_id = 986  &
   location = 75.0, 25.0, 0.0  &
   orientation = 90.0d, 90.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_6_4.cm  &
   adams_id = 987  &
   location = 100.0, 25.0, 0.0  &
   orientation = 90.0d, 90.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_6_4.endMar  &
   adams_id = 988  &
   location = 125.0, 25.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_6_4.cmMar  &
   adams_id = 989  &
   location = 100.0, 25.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_6_4.MARKER_257  &
   adams_id = 257  &
   location = 100.0, 25.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_6_4.MARKER_259  &
   adams_id = 259  &
   location = 125.0, 25.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_6_4.MARKER_592  &
   adams_id = 592  &
   location = 75.0, 50.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_6_4.MARKER_594  &
   adams_id = 594  &
   location = 75.0, 25.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
part create rigid_body mass_properties  &
   part_name = .net_ball.hlnk_6_4  &
   material_type = .net_ball.aluminum
!
! ****** Graphics for current part ******
!
geometry create shape cylinder  &
   cylinder_name = .net_ball.hlnk_6_4.cyl  &
   adams_id = 252  &
   center_marker = .net_ball.hlnk_6_4.cntMar  &
   angle_extent = 360.0  &
   length = 50.0  &
   radius = 1.0  &
   side_count_for_body = 20  &
   segment_count_for_ends = 20
!
part attributes  &
   part_name = .net_ball.hlnk_6_4  &
   color = RED  &
   name_visibility = off
!
!---------------------------------- hlnk_6_5 ----------------------------------!
!
!
defaults coordinate_system  &
   default_coordinate_system = .net_ball.ground
!
part create rigid_body name_and_position  &
   part_name = .net_ball.hlnk_6_5  &
   adams_id = 68  &
   location = 0.0, 0.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
defaults coordinate_system  &
   default_coordinate_system = .net_ball.hlnk_6_5
!
! ****** Markers for current part ******
!
marker create  &
   marker_name = .net_ball.hlnk_6_5.cntMar  &
   adams_id = 990  &
   location = 75.0, -25.0, 0.0  &
   orientation = 90.0d, 90.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_6_5.cm  &
   adams_id = 991  &
   location = 100.0, -25.0, 0.0  &
   orientation = 90.0d, 90.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_6_5.endMar  &
   adams_id = 992  &
   location = 125.0, -25.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_6_5.cmMar  &
   adams_id = 993  &
   location = 100.0, -25.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_6_5.MARKER_261  &
   adams_id = 261  &
   location = 100.0, -25.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_6_5.MARKER_263  &
   adams_id = 263  &
   location = 125.0, -25.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_6_5.MARKER_596  &
   adams_id = 596  &
   location = 75.0, 0.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_6_5.MARKER_598  &
   adams_id = 598  &
   location = 75.0, -25.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
part create rigid_body mass_properties  &
   part_name = .net_ball.hlnk_6_5  &
   material_type = .net_ball.aluminum
!
! ****** Graphics for current part ******
!
geometry create shape cylinder  &
   cylinder_name = .net_ball.hlnk_6_5.cyl  &
   adams_id = 253  &
   center_marker = .net_ball.hlnk_6_5.cntMar  &
   angle_extent = 360.0  &
   length = 50.0  &
   radius = 1.0  &
   side_count_for_body = 20  &
   segment_count_for_ends = 20
!
part attributes  &
   part_name = .net_ball.hlnk_6_5  &
   color = RED  &
   name_visibility = off
!
!---------------------------------- hlnk_6_6 ----------------------------------!
!
!
defaults coordinate_system  &
   default_coordinate_system = .net_ball.ground
!
part create rigid_body name_and_position  &
   part_name = .net_ball.hlnk_6_6  &
   adams_id = 69  &
   location = 0.0, 0.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
defaults coordinate_system  &
   default_coordinate_system = .net_ball.hlnk_6_6
!
! ****** Markers for current part ******
!
marker create  &
   marker_name = .net_ball.hlnk_6_6.cntMar  &
   adams_id = 994  &
   location = 75.0, -75.0, 0.0  &
   orientation = 90.0d, 90.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_6_6.cm  &
   adams_id = 995  &
   location = 100.0, -75.0, 0.0  &
   orientation = 90.0d, 90.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_6_6.endMar  &
   adams_id = 996  &
   location = 125.0, -75.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_6_6.cmMar  &
   adams_id = 997  &
   location = 100.0, -75.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_6_6.MARKER_265  &
   adams_id = 265  &
   location = 100.0, -75.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_6_6.MARKER_267  &
   adams_id = 267  &
   location = 125.0, -75.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_6_6.MARKER_600  &
   adams_id = 600  &
   location = 75.0, -50.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_6_6.MARKER_602  &
   adams_id = 602  &
   location = 75.0, -75.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
part create rigid_body mass_properties  &
   part_name = .net_ball.hlnk_6_6  &
   material_type = .net_ball.aluminum
!
! ****** Graphics for current part ******
!
geometry create shape cylinder  &
   cylinder_name = .net_ball.hlnk_6_6.cyl  &
   adams_id = 254  &
   center_marker = .net_ball.hlnk_6_6.cntMar  &
   angle_extent = 360.0  &
   length = 50.0  &
   radius = 1.0  &
   side_count_for_body = 20  &
   segment_count_for_ends = 20
!
part attributes  &
   part_name = .net_ball.hlnk_6_6  &
   color = RED  &
   name_visibility = off
!
!---------------------------------- hlnk_6_7 ----------------------------------!
!
!
defaults coordinate_system  &
   default_coordinate_system = .net_ball.ground
!
part create rigid_body name_and_position  &
   part_name = .net_ball.hlnk_6_7  &
   adams_id = 70  &
   location = 0.0, 0.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
defaults coordinate_system  &
   default_coordinate_system = .net_ball.hlnk_6_7
!
! ****** Markers for current part ******
!
marker create  &
   marker_name = .net_ball.hlnk_6_7.cntMar  &
   adams_id = 998  &
   location = 75.0, -125.0, 0.0  &
   orientation = 90.0d, 90.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_6_7.cm  &
   adams_id = 999  &
   location = 100.0, -125.0, 0.0  &
   orientation = 90.0d, 90.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_6_7.endMar  &
   adams_id = 1000  &
   location = 125.0, -125.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_6_7.cmMar  &
   adams_id = 1001  &
   location = 100.0, -125.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_6_7.MARKER_269  &
   adams_id = 269  &
   location = 100.0, -125.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_6_7.MARKER_271  &
   adams_id = 271  &
   location = 125.0, -125.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_6_7.MARKER_604  &
   adams_id = 604  &
   location = 75.0, -100.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_6_7.MARKER_606  &
   adams_id = 606  &
   location = 75.0, -125.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
part create rigid_body mass_properties  &
   part_name = .net_ball.hlnk_6_7  &
   material_type = .net_ball.aluminum
!
! ****** Graphics for current part ******
!
geometry create shape cylinder  &
   cylinder_name = .net_ball.hlnk_6_7.cyl  &
   adams_id = 255  &
   center_marker = .net_ball.hlnk_6_7.cntMar  &
   angle_extent = 360.0  &
   length = 50.0  &
   radius = 1.0  &
   side_count_for_body = 20  &
   segment_count_for_ends = 20
!
part attributes  &
   part_name = .net_ball.hlnk_6_7  &
   color = RED  &
   name_visibility = off
!
!---------------------------------- hlnk_6_8 ----------------------------------!
!
!
defaults coordinate_system  &
   default_coordinate_system = .net_ball.ground
!
part create rigid_body name_and_position  &
   part_name = .net_ball.hlnk_6_8  &
   adams_id = 71  &
   location = 0.0, 0.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
defaults coordinate_system  &
   default_coordinate_system = .net_ball.hlnk_6_8
!
! ****** Markers for current part ******
!
marker create  &
   marker_name = .net_ball.hlnk_6_8.cntMar  &
   adams_id = 1002  &
   location = 75.0, -175.0, 0.0  &
   orientation = 90.0d, 90.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_6_8.cm  &
   adams_id = 1003  &
   location = 100.0, -175.0, 0.0  &
   orientation = 270.0d, 90.0d, 90.0d
!
marker create  &
   marker_name = .net_ball.hlnk_6_8.endMar  &
   adams_id = 1004  &
   location = 125.0, -175.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_6_8.cmMar  &
   adams_id = 1005  &
   location = 100.0, -175.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_6_8.MARKER_273  &
   adams_id = 273  &
   location = 100.0, -175.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_6_8.MARKER_275  &
   adams_id = 275  &
   location = 125.0, -175.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_6_8.MARKER_277  &
   adams_id = 277  &
   location = 100.0, -225.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_6_8.MARKER_279  &
   adams_id = 279  &
   location = 125.0, -225.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_6_8.MARKER_608  &
   adams_id = 608  &
   location = 75.0, -150.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_6_8.MARKER_610  &
   adams_id = 610  &
   location = 75.0, -175.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
part create rigid_body mass_properties  &
   part_name = .net_ball.hlnk_6_8  &
   material_type = .net_ball.aluminum
!
! ****** Graphics for current part ******
!
geometry create shape cylinder  &
   cylinder_name = .net_ball.hlnk_6_8.cyl  &
   adams_id = 256  &
   center_marker = .net_ball.hlnk_6_8.cntMar  &
   angle_extent = 360.0  &
   length = 50.0  &
   radius = 1.0  &
   side_count_for_body = 20  &
   segment_count_for_ends = 20
!
part attributes  &
   part_name = .net_ball.hlnk_6_8  &
   color = RED  &
   name_visibility = off
!
!---------------------------------- hlnk_6_9 ----------------------------------!
!
!
defaults coordinate_system  &
   default_coordinate_system = .net_ball.ground
!
part create rigid_body name_and_position  &
   part_name = .net_ball.hlnk_6_9  &
   adams_id = 72  &
   location = 0.0, 0.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
defaults coordinate_system  &
   default_coordinate_system = .net_ball.hlnk_6_9
!
! ****** Markers for current part ******
!
marker create  &
   marker_name = .net_ball.hlnk_6_9.cntMar  &
   adams_id = 1006  &
   location = 75.0, -225.0, 0.0  &
   orientation = 90.0d, 90.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_6_9.cm  &
   adams_id = 1007  &
   location = 100.0, -225.0, 0.0  &
   orientation = 90.0d, 90.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_6_9.endMar  &
   adams_id = 1008  &
   location = 125.0, -225.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_6_9.cmMar  &
   adams_id = 1009  &
   location = 100.0, -225.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_6_9.MARKER_612  &
   adams_id = 612  &
   location = 75.0, -200.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
part create rigid_body mass_properties  &
   part_name = .net_ball.hlnk_6_9  &
   material_type = .net_ball.aluminum
!
! ****** Graphics for current part ******
!
geometry create shape cylinder  &
   cylinder_name = .net_ball.hlnk_6_9.cyl  &
   adams_id = 257  &
   center_marker = .net_ball.hlnk_6_9.cntMar  &
   angle_extent = 360.0  &
   length = 50.0  &
   radius = 1.0  &
   side_count_for_body = 20  &
   segment_count_for_ends = 20
!
part attributes  &
   part_name = .net_ball.hlnk_6_9  &
   color = RED  &
   name_visibility = off
!
!---------------------------------- hlnk_7_0 ----------------------------------!
!
!
defaults coordinate_system  &
   default_coordinate_system = .net_ball.ground
!
part create rigid_body name_and_position  &
   part_name = .net_ball.hlnk_7_0  &
   adams_id = 73  &
   location = 0.0, 0.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
defaults coordinate_system  &
   default_coordinate_system = .net_ball.hlnk_7_0
!
! ****** Markers for current part ******
!
marker create  &
   marker_name = .net_ball.hlnk_7_0.cntMar  &
   adams_id = 1010  &
   location = 125.0, 225.0, 0.0  &
   orientation = 90.0d, 90.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_7_0.cm  &
   adams_id = 1011  &
   location = 150.0, 225.0, 0.0  &
   orientation = 90.0d, 90.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_7_0.endMar  &
   adams_id = 1012  &
   location = 175.0, 225.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_7_0.cmMar  &
   adams_id = 1013  &
   location = 150.0, 225.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_7_0.MARKER_281  &
   adams_id = 281  &
   location = 150.0, 225.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_7_0.MARKER_283  &
   adams_id = 283  &
   location = 175.0, 225.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_7_0.MARKER_614  &
   adams_id = 614  &
   location = 125.0, 225.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
part create rigid_body mass_properties  &
   part_name = .net_ball.hlnk_7_0  &
   material_type = .net_ball.aluminum
!
! ****** Graphics for current part ******
!
geometry create shape cylinder  &
   cylinder_name = .net_ball.hlnk_7_0.cyl  &
   adams_id = 258  &
   center_marker = .net_ball.hlnk_7_0.cntMar  &
   angle_extent = 360.0  &
   length = 50.0  &
   radius = 1.0  &
   side_count_for_body = 20  &
   segment_count_for_ends = 20
!
part attributes  &
   part_name = .net_ball.hlnk_7_0  &
   color = RED  &
   name_visibility = off
!
!---------------------------------- hlnk_7_1 ----------------------------------!
!
!
defaults coordinate_system  &
   default_coordinate_system = .net_ball.ground
!
part create rigid_body name_and_position  &
   part_name = .net_ball.hlnk_7_1  &
   adams_id = 74  &
   location = 0.0, 0.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
defaults coordinate_system  &
   default_coordinate_system = .net_ball.hlnk_7_1
!
! ****** Markers for current part ******
!
marker create  &
   marker_name = .net_ball.hlnk_7_1.cntMar  &
   adams_id = 1014  &
   location = 125.0, 175.0, 0.0  &
   orientation = 90.0d, 90.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_7_1.cm  &
   adams_id = 1015  &
   location = 150.0, 175.0, 0.0  &
   orientation = 90.0d, 90.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_7_1.endMar  &
   adams_id = 1016  &
   location = 175.0, 175.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_7_1.cmMar  &
   adams_id = 1017  &
   location = 150.0, 175.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_7_1.MARKER_285  &
   adams_id = 285  &
   location = 150.0, 175.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_7_1.MARKER_287  &
   adams_id = 287  &
   location = 175.0, 175.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_7_1.MARKER_616  &
   adams_id = 616  &
   location = 125.0, 200.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_7_1.MARKER_618  &
   adams_id = 618  &
   location = 125.0, 175.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
part create rigid_body mass_properties  &
   part_name = .net_ball.hlnk_7_1  &
   material_type = .net_ball.aluminum
!
! ****** Graphics for current part ******
!
geometry create shape cylinder  &
   cylinder_name = .net_ball.hlnk_7_1.cyl  &
   adams_id = 259  &
   center_marker = .net_ball.hlnk_7_1.cntMar  &
   angle_extent = 360.0  &
   length = 50.0  &
   radius = 1.0  &
   side_count_for_body = 20  &
   segment_count_for_ends = 20
!
part attributes  &
   part_name = .net_ball.hlnk_7_1  &
   color = RED  &
   name_visibility = off
!
!---------------------------------- hlnk_7_2 ----------------------------------!
!
!
defaults coordinate_system  &
   default_coordinate_system = .net_ball.ground
!
part create rigid_body name_and_position  &
   part_name = .net_ball.hlnk_7_2  &
   adams_id = 75  &
   location = 0.0, 0.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
defaults coordinate_system  &
   default_coordinate_system = .net_ball.hlnk_7_2
!
! ****** Markers for current part ******
!
marker create  &
   marker_name = .net_ball.hlnk_7_2.cntMar  &
   adams_id = 1018  &
   location = 125.0, 125.0, 0.0  &
   orientation = 90.0d, 90.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_7_2.cm  &
   adams_id = 1019  &
   location = 150.0, 125.0, 0.0  &
   orientation = 90.0d, 90.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_7_2.endMar  &
   adams_id = 1020  &
   location = 175.0, 125.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_7_2.cmMar  &
   adams_id = 1021  &
   location = 150.0, 125.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_7_2.MARKER_289  &
   adams_id = 289  &
   location = 150.0, 125.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_7_2.MARKER_291  &
   adams_id = 291  &
   location = 175.0, 125.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_7_2.MARKER_620  &
   adams_id = 620  &
   location = 125.0, 150.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_7_2.MARKER_622  &
   adams_id = 622  &
   location = 125.0, 125.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
part create rigid_body mass_properties  &
   part_name = .net_ball.hlnk_7_2  &
   material_type = .net_ball.aluminum
!
! ****** Graphics for current part ******
!
geometry create shape cylinder  &
   cylinder_name = .net_ball.hlnk_7_2.cyl  &
   adams_id = 260  &
   center_marker = .net_ball.hlnk_7_2.cntMar  &
   angle_extent = 360.0  &
   length = 50.0  &
   radius = 1.0  &
   side_count_for_body = 20  &
   segment_count_for_ends = 20
!
part attributes  &
   part_name = .net_ball.hlnk_7_2  &
   color = RED  &
   name_visibility = off
!
!---------------------------------- hlnk_7_3 ----------------------------------!
!
!
defaults coordinate_system  &
   default_coordinate_system = .net_ball.ground
!
part create rigid_body name_and_position  &
   part_name = .net_ball.hlnk_7_3  &
   adams_id = 76  &
   location = 0.0, 0.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
defaults coordinate_system  &
   default_coordinate_system = .net_ball.hlnk_7_3
!
! ****** Markers for current part ******
!
marker create  &
   marker_name = .net_ball.hlnk_7_3.cntMar  &
   adams_id = 1022  &
   location = 125.0, 75.0, 0.0  &
   orientation = 90.0d, 90.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_7_3.cm  &
   adams_id = 1023  &
   location = 150.0, 75.0, 0.0  &
   orientation = 270.0d, 90.0d, 90.0d
!
marker create  &
   marker_name = .net_ball.hlnk_7_3.endMar  &
   adams_id = 1024  &
   location = 175.0, 75.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_7_3.cmMar  &
   adams_id = 1025  &
   location = 150.0, 75.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_7_3.MARKER_293  &
   adams_id = 293  &
   location = 150.0, 75.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_7_3.MARKER_295  &
   adams_id = 295  &
   location = 175.0, 75.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_7_3.MARKER_624  &
   adams_id = 624  &
   location = 125.0, 100.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_7_3.MARKER_626  &
   adams_id = 626  &
   location = 125.0, 75.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
part create rigid_body mass_properties  &
   part_name = .net_ball.hlnk_7_3  &
   material_type = .net_ball.aluminum
!
! ****** Graphics for current part ******
!
geometry create shape cylinder  &
   cylinder_name = .net_ball.hlnk_7_3.cyl  &
   adams_id = 261  &
   center_marker = .net_ball.hlnk_7_3.cntMar  &
   angle_extent = 360.0  &
   length = 50.0  &
   radius = 1.0  &
   side_count_for_body = 20  &
   segment_count_for_ends = 20
!
part attributes  &
   part_name = .net_ball.hlnk_7_3  &
   color = RED  &
   name_visibility = off
!
!---------------------------------- hlnk_7_4 ----------------------------------!
!
!
defaults coordinate_system  &
   default_coordinate_system = .net_ball.ground
!
part create rigid_body name_and_position  &
   part_name = .net_ball.hlnk_7_4  &
   adams_id = 77  &
   location = 0.0, 0.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
defaults coordinate_system  &
   default_coordinate_system = .net_ball.hlnk_7_4
!
! ****** Markers for current part ******
!
marker create  &
   marker_name = .net_ball.hlnk_7_4.cntMar  &
   adams_id = 1026  &
   location = 125.0, 25.0, 0.0  &
   orientation = 90.0d, 90.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_7_4.cm  &
   adams_id = 1027  &
   location = 150.0, 25.0, 0.0  &
   orientation = 90.0d, 90.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_7_4.endMar  &
   adams_id = 1028  &
   location = 175.0, 25.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_7_4.cmMar  &
   adams_id = 1029  &
   location = 150.0, 25.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_7_4.MARKER_297  &
   adams_id = 297  &
   location = 150.0, 25.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_7_4.MARKER_299  &
   adams_id = 299  &
   location = 175.0, 25.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_7_4.MARKER_628  &
   adams_id = 628  &
   location = 125.0, 50.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_7_4.MARKER_630  &
   adams_id = 630  &
   location = 125.0, 25.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
part create rigid_body mass_properties  &
   part_name = .net_ball.hlnk_7_4  &
   material_type = .net_ball.aluminum
!
! ****** Graphics for current part ******
!
geometry create shape cylinder  &
   cylinder_name = .net_ball.hlnk_7_4.cyl  &
   adams_id = 262  &
   center_marker = .net_ball.hlnk_7_4.cntMar  &
   angle_extent = 360.0  &
   length = 50.0  &
   radius = 1.0  &
   side_count_for_body = 20  &
   segment_count_for_ends = 20
!
part attributes  &
   part_name = .net_ball.hlnk_7_4  &
   color = RED  &
   name_visibility = off
!
!---------------------------------- hlnk_7_5 ----------------------------------!
!
!
defaults coordinate_system  &
   default_coordinate_system = .net_ball.ground
!
part create rigid_body name_and_position  &
   part_name = .net_ball.hlnk_7_5  &
   adams_id = 78  &
   location = 0.0, 0.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
defaults coordinate_system  &
   default_coordinate_system = .net_ball.hlnk_7_5
!
! ****** Markers for current part ******
!
marker create  &
   marker_name = .net_ball.hlnk_7_5.cntMar  &
   adams_id = 1030  &
   location = 125.0, -25.0, 0.0  &
   orientation = 90.0d, 90.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_7_5.cm  &
   adams_id = 1031  &
   location = 150.0, -25.0, 0.0  &
   orientation = 90.0d, 90.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_7_5.endMar  &
   adams_id = 1032  &
   location = 175.0, -25.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_7_5.cmMar  &
   adams_id = 1033  &
   location = 150.0, -25.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_7_5.MARKER_301  &
   adams_id = 301  &
   location = 150.0, -25.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_7_5.MARKER_303  &
   adams_id = 303  &
   location = 175.0, -25.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_7_5.MARKER_632  &
   adams_id = 632  &
   location = 125.0, 0.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_7_5.MARKER_634  &
   adams_id = 634  &
   location = 125.0, -25.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
part create rigid_body mass_properties  &
   part_name = .net_ball.hlnk_7_5  &
   material_type = .net_ball.aluminum
!
! ****** Graphics for current part ******
!
geometry create shape cylinder  &
   cylinder_name = .net_ball.hlnk_7_5.cyl  &
   adams_id = 263  &
   center_marker = .net_ball.hlnk_7_5.cntMar  &
   angle_extent = 360.0  &
   length = 50.0  &
   radius = 1.0  &
   side_count_for_body = 20  &
   segment_count_for_ends = 20
!
part attributes  &
   part_name = .net_ball.hlnk_7_5  &
   color = RED  &
   name_visibility = off
!
!---------------------------------- hlnk_7_6 ----------------------------------!
!
!
defaults coordinate_system  &
   default_coordinate_system = .net_ball.ground
!
part create rigid_body name_and_position  &
   part_name = .net_ball.hlnk_7_6  &
   adams_id = 79  &
   location = 0.0, 0.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
defaults coordinate_system  &
   default_coordinate_system = .net_ball.hlnk_7_6
!
! ****** Markers for current part ******
!
marker create  &
   marker_name = .net_ball.hlnk_7_6.cntMar  &
   adams_id = 1034  &
   location = 125.0, -75.0, 0.0  &
   orientation = 90.0d, 90.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_7_6.cm  &
   adams_id = 1035  &
   location = 150.0, -75.0, 0.0  &
   orientation = 270.0d, 90.0d, 90.0d
!
marker create  &
   marker_name = .net_ball.hlnk_7_6.endMar  &
   adams_id = 1036  &
   location = 175.0, -75.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_7_6.cmMar  &
   adams_id = 1037  &
   location = 150.0, -75.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_7_6.MARKER_305  &
   adams_id = 305  &
   location = 150.0, -75.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_7_6.MARKER_307  &
   adams_id = 307  &
   location = 175.0, -75.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_7_6.MARKER_636  &
   adams_id = 636  &
   location = 125.0, -50.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_7_6.MARKER_638  &
   adams_id = 638  &
   location = 125.0, -75.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
part create rigid_body mass_properties  &
   part_name = .net_ball.hlnk_7_6  &
   material_type = .net_ball.aluminum
!
! ****** Graphics for current part ******
!
geometry create shape cylinder  &
   cylinder_name = .net_ball.hlnk_7_6.cyl  &
   adams_id = 264  &
   center_marker = .net_ball.hlnk_7_6.cntMar  &
   angle_extent = 360.0  &
   length = 50.0  &
   radius = 1.0  &
   side_count_for_body = 20  &
   segment_count_for_ends = 20
!
part attributes  &
   part_name = .net_ball.hlnk_7_6  &
   color = RED  &
   name_visibility = off
!
!---------------------------------- hlnk_7_7 ----------------------------------!
!
!
defaults coordinate_system  &
   default_coordinate_system = .net_ball.ground
!
part create rigid_body name_and_position  &
   part_name = .net_ball.hlnk_7_7  &
   adams_id = 80  &
   location = 0.0, 0.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
defaults coordinate_system  &
   default_coordinate_system = .net_ball.hlnk_7_7
!
! ****** Markers for current part ******
!
marker create  &
   marker_name = .net_ball.hlnk_7_7.cntMar  &
   adams_id = 1038  &
   location = 125.0, -125.0, 0.0  &
   orientation = 90.0d, 90.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_7_7.cm  &
   adams_id = 1039  &
   location = 150.0, -125.0, 0.0  &
   orientation = 90.0d, 90.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_7_7.endMar  &
   adams_id = 1040  &
   location = 175.0, -125.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_7_7.cmMar  &
   adams_id = 1041  &
   location = 150.0, -125.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_7_7.MARKER_309  &
   adams_id = 309  &
   location = 150.0, -125.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_7_7.MARKER_311  &
   adams_id = 311  &
   location = 175.0, -125.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_7_7.MARKER_640  &
   adams_id = 640  &
   location = 125.0, -100.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_7_7.MARKER_642  &
   adams_id = 642  &
   location = 125.0, -125.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
part create rigid_body mass_properties  &
   part_name = .net_ball.hlnk_7_7  &
   material_type = .net_ball.aluminum
!
! ****** Graphics for current part ******
!
geometry create shape cylinder  &
   cylinder_name = .net_ball.hlnk_7_7.cyl  &
   adams_id = 265  &
   center_marker = .net_ball.hlnk_7_7.cntMar  &
   angle_extent = 360.0  &
   length = 50.0  &
   radius = 1.0  &
   side_count_for_body = 20  &
   segment_count_for_ends = 20
!
part attributes  &
   part_name = .net_ball.hlnk_7_7  &
   color = RED  &
   name_visibility = off
!
!---------------------------------- hlnk_7_8 ----------------------------------!
!
!
defaults coordinate_system  &
   default_coordinate_system = .net_ball.ground
!
part create rigid_body name_and_position  &
   part_name = .net_ball.hlnk_7_8  &
   adams_id = 81  &
   location = 0.0, 0.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
defaults coordinate_system  &
   default_coordinate_system = .net_ball.hlnk_7_8
!
! ****** Markers for current part ******
!
marker create  &
   marker_name = .net_ball.hlnk_7_8.cntMar  &
   adams_id = 1042  &
   location = 125.0, -175.0, 0.0  &
   orientation = 90.0d, 90.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_7_8.cm  &
   adams_id = 1043  &
   location = 150.0, -175.0, 0.0  &
   orientation = 90.0d, 90.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_7_8.endMar  &
   adams_id = 1044  &
   location = 175.0, -175.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_7_8.cmMar  &
   adams_id = 1045  &
   location = 150.0, -175.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_7_8.MARKER_313  &
   adams_id = 313  &
   location = 150.0, -175.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_7_8.MARKER_315  &
   adams_id = 315  &
   location = 175.0, -175.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_7_8.MARKER_317  &
   adams_id = 317  &
   location = 150.0, -225.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_7_8.MARKER_319  &
   adams_id = 319  &
   location = 175.0, -225.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_7_8.MARKER_644  &
   adams_id = 644  &
   location = 125.0, -150.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_7_8.MARKER_646  &
   adams_id = 646  &
   location = 125.0, -175.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
part create rigid_body mass_properties  &
   part_name = .net_ball.hlnk_7_8  &
   material_type = .net_ball.aluminum
!
! ****** Graphics for current part ******
!
geometry create shape cylinder  &
   cylinder_name = .net_ball.hlnk_7_8.cyl  &
   adams_id = 266  &
   center_marker = .net_ball.hlnk_7_8.cntMar  &
   angle_extent = 360.0  &
   length = 50.0  &
   radius = 1.0  &
   side_count_for_body = 20  &
   segment_count_for_ends = 20
!
part attributes  &
   part_name = .net_ball.hlnk_7_8  &
   color = RED  &
   name_visibility = off
!
!---------------------------------- hlnk_7_9 ----------------------------------!
!
!
defaults coordinate_system  &
   default_coordinate_system = .net_ball.ground
!
part create rigid_body name_and_position  &
   part_name = .net_ball.hlnk_7_9  &
   adams_id = 82  &
   location = 0.0, 0.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
defaults coordinate_system  &
   default_coordinate_system = .net_ball.hlnk_7_9
!
! ****** Markers for current part ******
!
marker create  &
   marker_name = .net_ball.hlnk_7_9.cntMar  &
   adams_id = 1046  &
   location = 125.0, -225.0, 0.0  &
   orientation = 90.0d, 90.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_7_9.cm  &
   adams_id = 1047  &
   location = 150.0, -225.0, 0.0  &
   orientation = 90.0d, 90.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_7_9.endMar  &
   adams_id = 1048  &
   location = 175.0, -225.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_7_9.cmMar  &
   adams_id = 1049  &
   location = 150.0, -225.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_7_9.MARKER_648  &
   adams_id = 648  &
   location = 125.0, -200.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
part create rigid_body mass_properties  &
   part_name = .net_ball.hlnk_7_9  &
   material_type = .net_ball.aluminum
!
! ****** Graphics for current part ******
!
geometry create shape cylinder  &
   cylinder_name = .net_ball.hlnk_7_9.cyl  &
   adams_id = 267  &
   center_marker = .net_ball.hlnk_7_9.cntMar  &
   angle_extent = 360.0  &
   length = 50.0  &
   radius = 1.0  &
   side_count_for_body = 20  &
   segment_count_for_ends = 20
!
part attributes  &
   part_name = .net_ball.hlnk_7_9  &
   color = RED  &
   name_visibility = off
!
!---------------------------------- hlnk_8_0 ----------------------------------!
!
!
defaults coordinate_system  &
   default_coordinate_system = .net_ball.ground
!
part create rigid_body name_and_position  &
   part_name = .net_ball.hlnk_8_0  &
   adams_id = 83  &
   location = 0.0, 0.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
defaults coordinate_system  &
   default_coordinate_system = .net_ball.hlnk_8_0
!
! ****** Markers for current part ******
!
marker create  &
   marker_name = .net_ball.hlnk_8_0.cntMar  &
   adams_id = 1050  &
   location = 175.0, 225.0, 0.0  &
   orientation = 90.0d, 90.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_8_0.cm  &
   adams_id = 1051  &
   location = 200.0, 225.0, 0.0  &
   orientation = 90.0d, 90.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_8_0.endMar  &
   adams_id = 1052  &
   location = 225.0, 225.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_8_0.cmMar  &
   adams_id = 1053  &
   location = 200.0, 225.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_8_0.MARKER_321  &
   adams_id = 321  &
   location = 200.0, 225.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_8_0.MARKER_323  &
   adams_id = 323  &
   location = 225.0, 225.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_8_0.MARKER_650  &
   adams_id = 650  &
   location = 175.0, 225.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_8_0.MARKER_723  &
   adams_id = 723  &
   location = 225.0, 225.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
part create rigid_body mass_properties  &
   part_name = .net_ball.hlnk_8_0  &
   material_type = .net_ball.aluminum
!
! ****** Graphics for current part ******
!
geometry create shape cylinder  &
   cylinder_name = .net_ball.hlnk_8_0.cyl  &
   adams_id = 268  &
   center_marker = .net_ball.hlnk_8_0.cntMar  &
   angle_extent = 360.0  &
   length = 50.0  &
   radius = 1.0  &
   side_count_for_body = 20  &
   segment_count_for_ends = 20
!
part attributes  &
   part_name = .net_ball.hlnk_8_0  &
   color = RED  &
   name_visibility = off
!
!---------------------------------- hlnk_8_1 ----------------------------------!
!
!
defaults coordinate_system  &
   default_coordinate_system = .net_ball.ground
!
part create rigid_body name_and_position  &
   part_name = .net_ball.hlnk_8_1  &
   adams_id = 84  &
   location = 0.0, 0.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
defaults coordinate_system  &
   default_coordinate_system = .net_ball.hlnk_8_1
!
! ****** Markers for current part ******
!
marker create  &
   marker_name = .net_ball.hlnk_8_1.cntMar  &
   adams_id = 1054  &
   location = 175.0, 175.0, 0.0  &
   orientation = 90.0d, 90.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_8_1.cm  &
   adams_id = 1055  &
   location = 200.0, 175.0, 0.0  &
   orientation = 90.0d, 90.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_8_1.endMar  &
   adams_id = 1056  &
   location = 225.0, 175.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_8_1.cmMar  &
   adams_id = 1057  &
   location = 200.0, 175.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_8_1.MARKER_325  &
   adams_id = 325  &
   location = 200.0, 175.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_8_1.MARKER_327  &
   adams_id = 327  &
   location = 225.0, 175.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_8_1.MARKER_652  &
   adams_id = 652  &
   location = 175.0, 200.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_8_1.MARKER_654  &
   adams_id = 654  &
   location = 175.0, 175.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_8_1.MARKER_686  &
   adams_id = 686  &
   location = 225.0, 225.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_8_1.MARKER_688  &
   adams_id = 688  &
   location = 225.0, 200.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
part create rigid_body mass_properties  &
   part_name = .net_ball.hlnk_8_1  &
   material_type = .net_ball.aluminum
!
! ****** Graphics for current part ******
!
geometry create shape cylinder  &
   cylinder_name = .net_ball.hlnk_8_1.cyl  &
   adams_id = 269  &
   center_marker = .net_ball.hlnk_8_1.cntMar  &
   angle_extent = 360.0  &
   length = 50.0  &
   radius = 1.0  &
   side_count_for_body = 20  &
   segment_count_for_ends = 20
!
part attributes  &
   part_name = .net_ball.hlnk_8_1  &
   color = RED  &
   name_visibility = off
!
!---------------------------------- hlnk_8_2 ----------------------------------!
!
!
defaults coordinate_system  &
   default_coordinate_system = .net_ball.ground
!
part create rigid_body name_and_position  &
   part_name = .net_ball.hlnk_8_2  &
   adams_id = 85  &
   location = 0.0, 0.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
defaults coordinate_system  &
   default_coordinate_system = .net_ball.hlnk_8_2
!
! ****** Markers for current part ******
!
marker create  &
   marker_name = .net_ball.hlnk_8_2.cntMar  &
   adams_id = 1058  &
   location = 175.0, 125.0, 0.0  &
   orientation = 90.0d, 90.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_8_2.cm  &
   adams_id = 1059  &
   location = 200.0, 125.0, 0.0  &
   orientation = 90.0d, 90.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_8_2.endMar  &
   adams_id = 1060  &
   location = 225.0, 125.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_8_2.cmMar  &
   adams_id = 1061  &
   location = 200.0, 125.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_8_2.MARKER_329  &
   adams_id = 329  &
   location = 200.0, 125.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_8_2.MARKER_331  &
   adams_id = 331  &
   location = 225.0, 125.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_8_2.MARKER_656  &
   adams_id = 656  &
   location = 175.0, 150.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_8_2.MARKER_658  &
   adams_id = 658  &
   location = 175.0, 125.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_8_2.MARKER_690  &
   adams_id = 690  &
   location = 225.0, 175.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_8_2.MARKER_692  &
   adams_id = 692  &
   location = 225.0, 150.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
part create rigid_body mass_properties  &
   part_name = .net_ball.hlnk_8_2  &
   material_type = .net_ball.aluminum
!
! ****** Graphics for current part ******
!
geometry create shape cylinder  &
   cylinder_name = .net_ball.hlnk_8_2.cyl  &
   adams_id = 270  &
   center_marker = .net_ball.hlnk_8_2.cntMar  &
   angle_extent = 360.0  &
   length = 50.0  &
   radius = 1.0  &
   side_count_for_body = 20  &
   segment_count_for_ends = 20
!
part attributes  &
   part_name = .net_ball.hlnk_8_2  &
   color = RED  &
   name_visibility = off
!
!---------------------------------- hlnk_8_3 ----------------------------------!
!
!
defaults coordinate_system  &
   default_coordinate_system = .net_ball.ground
!
part create rigid_body name_and_position  &
   part_name = .net_ball.hlnk_8_3  &
   adams_id = 86  &
   location = 0.0, 0.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
defaults coordinate_system  &
   default_coordinate_system = .net_ball.hlnk_8_3
!
! ****** Markers for current part ******
!
marker create  &
   marker_name = .net_ball.hlnk_8_3.cntMar  &
   adams_id = 1062  &
   location = 175.0, 75.0, 0.0  &
   orientation = 90.0d, 90.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_8_3.cm  &
   adams_id = 1063  &
   location = 200.0, 75.0, 0.0  &
   orientation = 90.0d, 90.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_8_3.endMar  &
   adams_id = 1064  &
   location = 225.0, 75.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_8_3.cmMar  &
   adams_id = 1065  &
   location = 200.0, 75.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_8_3.MARKER_333  &
   adams_id = 333  &
   location = 200.0, 75.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_8_3.MARKER_335  &
   adams_id = 335  &
   location = 225.0, 75.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_8_3.MARKER_660  &
   adams_id = 660  &
   location = 175.0, 100.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_8_3.MARKER_662  &
   adams_id = 662  &
   location = 175.0, 75.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_8_3.MARKER_694  &
   adams_id = 694  &
   location = 225.0, 125.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_8_3.MARKER_696  &
   adams_id = 696  &
   location = 225.0, 100.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
part create rigid_body mass_properties  &
   part_name = .net_ball.hlnk_8_3  &
   material_type = .net_ball.aluminum
!
! ****** Graphics for current part ******
!
geometry create shape cylinder  &
   cylinder_name = .net_ball.hlnk_8_3.cyl  &
   adams_id = 271  &
   center_marker = .net_ball.hlnk_8_3.cntMar  &
   angle_extent = 360.0  &
   length = 50.0  &
   radius = 1.0  &
   side_count_for_body = 20  &
   segment_count_for_ends = 20
!
part attributes  &
   part_name = .net_ball.hlnk_8_3  &
   color = RED  &
   name_visibility = off
!
!---------------------------------- hlnk_8_4 ----------------------------------!
!
!
defaults coordinate_system  &
   default_coordinate_system = .net_ball.ground
!
part create rigid_body name_and_position  &
   part_name = .net_ball.hlnk_8_4  &
   adams_id = 87  &
   location = 0.0, 0.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
defaults coordinate_system  &
   default_coordinate_system = .net_ball.hlnk_8_4
!
! ****** Markers for current part ******
!
marker create  &
   marker_name = .net_ball.hlnk_8_4.cntMar  &
   adams_id = 1066  &
   location = 175.0, 25.0, 0.0  &
   orientation = 90.0d, 90.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_8_4.cm  &
   adams_id = 1067  &
   location = 200.0, 25.0, 0.0  &
   orientation = 90.0d, 90.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_8_4.endMar  &
   adams_id = 1068  &
   location = 225.0, 25.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_8_4.cmMar  &
   adams_id = 1069  &
   location = 200.0, 25.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_8_4.MARKER_337  &
   adams_id = 337  &
   location = 200.0, 25.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_8_4.MARKER_339  &
   adams_id = 339  &
   location = 225.0, 25.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_8_4.MARKER_664  &
   adams_id = 664  &
   location = 175.0, 50.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_8_4.MARKER_666  &
   adams_id = 666  &
   location = 175.0, 25.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_8_4.MARKER_698  &
   adams_id = 698  &
   location = 225.0, 75.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_8_4.MARKER_700  &
   adams_id = 700  &
   location = 225.0, 50.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
part create rigid_body mass_properties  &
   part_name = .net_ball.hlnk_8_4  &
   material_type = .net_ball.aluminum
!
! ****** Graphics for current part ******
!
geometry create shape cylinder  &
   cylinder_name = .net_ball.hlnk_8_4.cyl  &
   adams_id = 272  &
   center_marker = .net_ball.hlnk_8_4.cntMar  &
   angle_extent = 360.0  &
   length = 50.0  &
   radius = 1.0  &
   side_count_for_body = 20  &
   segment_count_for_ends = 20
!
part attributes  &
   part_name = .net_ball.hlnk_8_4  &
   color = RED  &
   name_visibility = off
!
!---------------------------------- hlnk_8_5 ----------------------------------!
!
!
defaults coordinate_system  &
   default_coordinate_system = .net_ball.ground
!
part create rigid_body name_and_position  &
   part_name = .net_ball.hlnk_8_5  &
   adams_id = 88  &
   location = 0.0, 0.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
defaults coordinate_system  &
   default_coordinate_system = .net_ball.hlnk_8_5
!
! ****** Markers for current part ******
!
marker create  &
   marker_name = .net_ball.hlnk_8_5.cntMar  &
   adams_id = 1070  &
   location = 175.0, -25.0, 0.0  &
   orientation = 90.0d, 90.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_8_5.cm  &
   adams_id = 1071  &
   location = 200.0, -25.0, 0.0  &
   orientation = 90.0d, 90.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_8_5.endMar  &
   adams_id = 1072  &
   location = 225.0, -25.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_8_5.cmMar  &
   adams_id = 1073  &
   location = 200.0, -25.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_8_5.MARKER_341  &
   adams_id = 341  &
   location = 200.0, -25.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_8_5.MARKER_343  &
   adams_id = 343  &
   location = 225.0, -25.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_8_5.MARKER_668  &
   adams_id = 668  &
   location = 175.0, 0.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_8_5.MARKER_670  &
   adams_id = 670  &
   location = 175.0, -25.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_8_5.MARKER_702  &
   adams_id = 702  &
   location = 225.0, 25.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_8_5.MARKER_704  &
   adams_id = 704  &
   location = 225.0, 0.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
part create rigid_body mass_properties  &
   part_name = .net_ball.hlnk_8_5  &
   material_type = .net_ball.aluminum
!
! ****** Graphics for current part ******
!
geometry create shape cylinder  &
   cylinder_name = .net_ball.hlnk_8_5.cyl  &
   adams_id = 273  &
   center_marker = .net_ball.hlnk_8_5.cntMar  &
   angle_extent = 360.0  &
   length = 50.0  &
   radius = 1.0  &
   side_count_for_body = 20  &
   segment_count_for_ends = 20
!
part attributes  &
   part_name = .net_ball.hlnk_8_5  &
   color = RED  &
   name_visibility = off
!
!---------------------------------- hlnk_8_6 ----------------------------------!
!
!
defaults coordinate_system  &
   default_coordinate_system = .net_ball.ground
!
part create rigid_body name_and_position  &
   part_name = .net_ball.hlnk_8_6  &
   adams_id = 89  &
   location = 0.0, 0.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
defaults coordinate_system  &
   default_coordinate_system = .net_ball.hlnk_8_6
!
! ****** Markers for current part ******
!
marker create  &
   marker_name = .net_ball.hlnk_8_6.cntMar  &
   adams_id = 1074  &
   location = 175.0, -75.0, 0.0  &
   orientation = 90.0d, 90.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_8_6.cm  &
   adams_id = 1075  &
   location = 200.0, -75.0, 0.0  &
   orientation = 90.0d, 90.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_8_6.endMar  &
   adams_id = 1076  &
   location = 225.0, -75.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_8_6.cmMar  &
   adams_id = 1077  &
   location = 200.0, -75.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_8_6.MARKER_345  &
   adams_id = 345  &
   location = 200.0, -75.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_8_6.MARKER_347  &
   adams_id = 347  &
   location = 225.0, -75.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_8_6.MARKER_672  &
   adams_id = 672  &
   location = 175.0, -50.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_8_6.MARKER_674  &
   adams_id = 674  &
   location = 175.0, -75.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_8_6.MARKER_706  &
   adams_id = 706  &
   location = 225.0, -25.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_8_6.MARKER_708  &
   adams_id = 708  &
   location = 225.0, -50.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
part create rigid_body mass_properties  &
   part_name = .net_ball.hlnk_8_6  &
   material_type = .net_ball.aluminum
!
! ****** Graphics for current part ******
!
geometry create shape cylinder  &
   cylinder_name = .net_ball.hlnk_8_6.cyl  &
   adams_id = 274  &
   center_marker = .net_ball.hlnk_8_6.cntMar  &
   angle_extent = 360.0  &
   length = 50.0  &
   radius = 1.0  &
   side_count_for_body = 20  &
   segment_count_for_ends = 20
!
part attributes  &
   part_name = .net_ball.hlnk_8_6  &
   color = RED  &
   name_visibility = off
!
!---------------------------------- hlnk_8_7 ----------------------------------!
!
!
defaults coordinate_system  &
   default_coordinate_system = .net_ball.ground
!
part create rigid_body name_and_position  &
   part_name = .net_ball.hlnk_8_7  &
   adams_id = 90  &
   location = 0.0, 0.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
defaults coordinate_system  &
   default_coordinate_system = .net_ball.hlnk_8_7
!
! ****** Markers for current part ******
!
marker create  &
   marker_name = .net_ball.hlnk_8_7.cntMar  &
   adams_id = 1078  &
   location = 175.0, -125.0, 0.0  &
   orientation = 90.0d, 90.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_8_7.cm  &
   adams_id = 1079  &
   location = 200.0, -125.0, 0.0  &
   orientation = 90.0d, 90.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_8_7.endMar  &
   adams_id = 1080  &
   location = 225.0, -125.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_8_7.cmMar  &
   adams_id = 1081  &
   location = 200.0, -125.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_8_7.MARKER_349  &
   adams_id = 349  &
   location = 200.0, -125.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_8_7.MARKER_351  &
   adams_id = 351  &
   location = 225.0, -125.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_8_7.MARKER_676  &
   adams_id = 676  &
   location = 175.0, -100.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_8_7.MARKER_678  &
   adams_id = 678  &
   location = 175.0, -125.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_8_7.MARKER_710  &
   adams_id = 710  &
   location = 225.0, -75.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_8_7.MARKER_712  &
   adams_id = 712  &
   location = 225.0, -100.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
part create rigid_body mass_properties  &
   part_name = .net_ball.hlnk_8_7  &
   material_type = .net_ball.aluminum
!
! ****** Graphics for current part ******
!
geometry create shape cylinder  &
   cylinder_name = .net_ball.hlnk_8_7.cyl  &
   adams_id = 275  &
   center_marker = .net_ball.hlnk_8_7.cntMar  &
   angle_extent = 360.0  &
   length = 50.0  &
   radius = 1.0  &
   side_count_for_body = 20  &
   segment_count_for_ends = 20
!
part attributes  &
   part_name = .net_ball.hlnk_8_7  &
   color = RED  &
   name_visibility = off
!
!---------------------------------- hlnk_8_8 ----------------------------------!
!
!
defaults coordinate_system  &
   default_coordinate_system = .net_ball.ground
!
part create rigid_body name_and_position  &
   part_name = .net_ball.hlnk_8_8  &
   adams_id = 91  &
   location = 0.0, 0.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
defaults coordinate_system  &
   default_coordinate_system = .net_ball.hlnk_8_8
!
! ****** Markers for current part ******
!
marker create  &
   marker_name = .net_ball.hlnk_8_8.cntMar  &
   adams_id = 1082  &
   location = 175.0, -175.0, 0.0  &
   orientation = 90.0d, 90.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_8_8.cm  &
   adams_id = 1083  &
   location = 200.0, -175.0, 0.0  &
   orientation = 90.0d, 90.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_8_8.endMar  &
   adams_id = 1084  &
   location = 225.0, -175.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_8_8.cmMar  &
   adams_id = 1085  &
   location = 200.0, -175.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_8_8.MARKER_353  &
   adams_id = 353  &
   location = 200.0, -175.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_8_8.MARKER_355  &
   adams_id = 355  &
   location = 225.0, -175.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_8_8.MARKER_357  &
   adams_id = 357  &
   location = 200.0, -225.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_8_8.MARKER_359  &
   adams_id = 359  &
   location = 225.0, -225.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_8_8.MARKER_680  &
   adams_id = 680  &
   location = 175.0, -150.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_8_8.MARKER_682  &
   adams_id = 682  &
   location = 175.0, -175.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_8_8.MARKER_714  &
   adams_id = 714  &
   location = 225.0, -125.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_8_8.MARKER_716  &
   adams_id = 716  &
   location = 225.0, -150.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
part create rigid_body mass_properties  &
   part_name = .net_ball.hlnk_8_8  &
   material_type = .net_ball.aluminum
!
! ****** Graphics for current part ******
!
geometry create shape cylinder  &
   cylinder_name = .net_ball.hlnk_8_8.cyl  &
   adams_id = 276  &
   center_marker = .net_ball.hlnk_8_8.cntMar  &
   angle_extent = 360.0  &
   length = 50.0  &
   radius = 1.0  &
   side_count_for_body = 20  &
   segment_count_for_ends = 20
!
part attributes  &
   part_name = .net_ball.hlnk_8_8  &
   color = RED  &
   name_visibility = off
!
!---------------------------------- hlnk_8_9 ----------------------------------!
!
!
defaults coordinate_system  &
   default_coordinate_system = .net_ball.ground
!
part create rigid_body name_and_position  &
   part_name = .net_ball.hlnk_8_9  &
   adams_id = 92  &
   location = 0.0, 0.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
defaults coordinate_system  &
   default_coordinate_system = .net_ball.hlnk_8_9
!
! ****** Markers for current part ******
!
marker create  &
   marker_name = .net_ball.hlnk_8_9.cntMar  &
   adams_id = 1086  &
   location = 175.0, -225.0, 0.0  &
   orientation = 90.0d, 90.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_8_9.cm  &
   adams_id = 1087  &
   location = 200.0, -225.0, 0.0  &
   orientation = 90.0d, 90.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_8_9.endMar  &
   adams_id = 1088  &
   location = 225.0, -225.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_8_9.cmMar  &
   adams_id = 1089  &
   location = 200.0, -225.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_8_9.MARKER_684  &
   adams_id = 684  &
   location = 175.0, -200.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_8_9.MARKER_718  &
   adams_id = 718  &
   location = 225.0, -175.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_8_9.MARKER_720  &
   adams_id = 720  &
   location = 225.0, -200.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.hlnk_8_9.MARKER_727  &
   adams_id = 727  &
   location = 225.0, -225.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
part create rigid_body mass_properties  &
   part_name = .net_ball.hlnk_8_9  &
   material_type = .net_ball.aluminum
!
! ****** Graphics for current part ******
!
geometry create shape cylinder  &
   cylinder_name = .net_ball.hlnk_8_9.cyl  &
   adams_id = 277  &
   center_marker = .net_ball.hlnk_8_9.cntMar  &
   angle_extent = 360.0  &
   length = 50.0  &
   radius = 1.0  &
   side_count_for_body = 20  &
   segment_count_for_ends = 20
!
part attributes  &
   part_name = .net_ball.hlnk_8_9  &
   color = RED  &
   name_visibility = off
!
!---------------------------------- vlnk_0_0 ----------------------------------!
!
!
defaults coordinate_system  &
   default_coordinate_system = .net_ball.ground
!
part create rigid_body name_and_position  &
   part_name = .net_ball.vlnk_0_0  &
   adams_id = 93  &
   location = 0.0, 0.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
defaults coordinate_system  &
   default_coordinate_system = .net_ball.vlnk_0_0
!
! ****** Markers for current part ******
!
marker create  &
   marker_name = .net_ball.vlnk_0_0.cntMar  &
   adams_id = 1090  &
   location = -225.0, 225.0, 0.0  &
   orientation = 0.0d, 90.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_0_0.cm  &
   adams_id = 1091  &
   location = -225.0, 200.0, 0.0  &
   orientation = 180.0d, 90.0d, 90.0d
!
marker create  &
   marker_name = .net_ball.vlnk_0_0.endMar  &
   adams_id = 1092  &
   location = -225.0, 175.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_0_0.cmMar  &
   adams_id = 1093  &
   location = -225.0, 200.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_0_0.MARKER_2  &
   adams_id = 2  &
   location = -225.0, 225.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_0_0.MARKER_361  &
   adams_id = 361  &
   location = -225.0, 200.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_0_0.MARKER_363  &
   adams_id = 363  &
   location = -225.0, 175.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
part create rigid_body mass_properties  &
   part_name = .net_ball.vlnk_0_0  &
   material_type = .net_ball.aluminum
!
! ****** Graphics for current part ******
!
geometry create shape cylinder  &
   cylinder_name = .net_ball.vlnk_0_0.cyl  &
   adams_id = 278  &
   center_marker = .net_ball.vlnk_0_0.cntMar  &
   angle_extent = 360.0  &
   length = 50.0  &
   radius = 1.0  &
   side_count_for_body = 20  &
   segment_count_for_ends = 20
!
part attributes  &
   part_name = .net_ball.vlnk_0_0  &
   color = RED  &
   name_visibility = off
!
!---------------------------------- vlnk_0_1 ----------------------------------!
!
!
defaults coordinate_system  &
   default_coordinate_system = .net_ball.ground
!
part create rigid_body name_and_position  &
   part_name = .net_ball.vlnk_0_1  &
   adams_id = 94  &
   location = 0.0, 0.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
defaults coordinate_system  &
   default_coordinate_system = .net_ball.vlnk_0_1
!
! ****** Markers for current part ******
!
marker create  &
   marker_name = .net_ball.vlnk_0_1.cntMar  &
   adams_id = 1094  &
   location = -225.0, 175.0, 0.0  &
   orientation = 0.0d, 90.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_0_1.cm  &
   adams_id = 1095  &
   location = -225.0, 150.0, 0.0  &
   orientation = 180.0d, 90.0d, 90.0d
!
marker create  &
   marker_name = .net_ball.vlnk_0_1.endMar  &
   adams_id = 1096  &
   location = -225.0, 125.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_0_1.cmMar  &
   adams_id = 1097  &
   location = -225.0, 150.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_0_1.MARKER_6  &
   adams_id = 6  &
   location = -225.0, 175.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_0_1.MARKER_365  &
   adams_id = 365  &
   location = -225.0, 150.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_0_1.MARKER_367  &
   adams_id = 367  &
   location = -225.0, 125.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
part create rigid_body mass_properties  &
   part_name = .net_ball.vlnk_0_1  &
   material_type = .net_ball.aluminum
!
! ****** Graphics for current part ******
!
geometry create shape cylinder  &
   cylinder_name = .net_ball.vlnk_0_1.cyl  &
   adams_id = 279  &
   center_marker = .net_ball.vlnk_0_1.cntMar  &
   angle_extent = 360.0  &
   length = 50.0  &
   radius = 1.0  &
   side_count_for_body = 20  &
   segment_count_for_ends = 20
!
part attributes  &
   part_name = .net_ball.vlnk_0_1  &
   color = RED  &
   name_visibility = off
!
!---------------------------------- vlnk_0_2 ----------------------------------!
!
!
defaults coordinate_system  &
   default_coordinate_system = .net_ball.ground
!
part create rigid_body name_and_position  &
   part_name = .net_ball.vlnk_0_2  &
   adams_id = 95  &
   location = 0.0, 0.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
defaults coordinate_system  &
   default_coordinate_system = .net_ball.vlnk_0_2
!
! ****** Markers for current part ******
!
marker create  &
   marker_name = .net_ball.vlnk_0_2.cntMar  &
   adams_id = 1098  &
   location = -225.0, 125.0, 0.0  &
   orientation = 0.0d, 90.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_0_2.cm  &
   adams_id = 1099  &
   location = -225.0, 100.0, 0.0  &
   orientation = 180.0d, 90.0d, 90.0d
!
marker create  &
   marker_name = .net_ball.vlnk_0_2.endMar  &
   adams_id = 1100  &
   location = -225.0, 75.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_0_2.cmMar  &
   adams_id = 1101  &
   location = -225.0, 100.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_0_2.MARKER_10  &
   adams_id = 10  &
   location = -225.0, 125.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_0_2.MARKER_369  &
   adams_id = 369  &
   location = -225.0, 100.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_0_2.MARKER_371  &
   adams_id = 371  &
   location = -225.0, 75.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
part create rigid_body mass_properties  &
   part_name = .net_ball.vlnk_0_2  &
   material_type = .net_ball.aluminum
!
! ****** Graphics for current part ******
!
geometry create shape cylinder  &
   cylinder_name = .net_ball.vlnk_0_2.cyl  &
   adams_id = 280  &
   center_marker = .net_ball.vlnk_0_2.cntMar  &
   angle_extent = 360.0  &
   length = 50.0  &
   radius = 1.0  &
   side_count_for_body = 20  &
   segment_count_for_ends = 20
!
part attributes  &
   part_name = .net_ball.vlnk_0_2  &
   color = RED  &
   name_visibility = off
!
!---------------------------------- vlnk_0_3 ----------------------------------!
!
!
defaults coordinate_system  &
   default_coordinate_system = .net_ball.ground
!
part create rigid_body name_and_position  &
   part_name = .net_ball.vlnk_0_3  &
   adams_id = 96  &
   location = 0.0, 0.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
defaults coordinate_system  &
   default_coordinate_system = .net_ball.vlnk_0_3
!
! ****** Markers for current part ******
!
marker create  &
   marker_name = .net_ball.vlnk_0_3.cntMar  &
   adams_id = 1102  &
   location = -225.0, 75.0, 0.0  &
   orientation = 0.0d, 90.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_0_3.cm  &
   adams_id = 1103  &
   location = -225.0, 50.0, 0.0  &
   orientation = 180.0d, 90.0d, 90.0d
!
marker create  &
   marker_name = .net_ball.vlnk_0_3.endMar  &
   adams_id = 1104  &
   location = -225.0, 25.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_0_3.cmMar  &
   adams_id = 1105  &
   location = -225.0, 50.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_0_3.MARKER_14  &
   adams_id = 14  &
   location = -225.0, 75.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_0_3.MARKER_373  &
   adams_id = 373  &
   location = -225.0, 50.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_0_3.MARKER_375  &
   adams_id = 375  &
   location = -225.0, 25.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
part create rigid_body mass_properties  &
   part_name = .net_ball.vlnk_0_3  &
   material_type = .net_ball.aluminum
!
! ****** Graphics for current part ******
!
geometry create shape cylinder  &
   cylinder_name = .net_ball.vlnk_0_3.cyl  &
   adams_id = 281  &
   center_marker = .net_ball.vlnk_0_3.cntMar  &
   angle_extent = 360.0  &
   length = 50.0  &
   radius = 1.0  &
   side_count_for_body = 20  &
   segment_count_for_ends = 20
!
part attributes  &
   part_name = .net_ball.vlnk_0_3  &
   color = RED  &
   name_visibility = off
!
!---------------------------------- vlnk_0_4 ----------------------------------!
!
!
defaults coordinate_system  &
   default_coordinate_system = .net_ball.ground
!
part create rigid_body name_and_position  &
   part_name = .net_ball.vlnk_0_4  &
   adams_id = 97  &
   location = 0.0, 0.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
defaults coordinate_system  &
   default_coordinate_system = .net_ball.vlnk_0_4
!
! ****** Markers for current part ******
!
marker create  &
   marker_name = .net_ball.vlnk_0_4.cntMar  &
   adams_id = 1106  &
   location = -225.0, 25.0, 0.0  &
   orientation = 0.0d, 90.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_0_4.cm  &
   adams_id = 1107  &
   location = -225.0, 0.0, 0.0  &
   orientation = 180.0d, 90.0d, 90.0d
!
marker create  &
   marker_name = .net_ball.vlnk_0_4.endMar  &
   adams_id = 1108  &
   location = -225.0, -25.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_0_4.cmMar  &
   adams_id = 1109  &
   location = -225.0, 0.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_0_4.MARKER_18  &
   adams_id = 18  &
   location = -225.0, 25.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_0_4.MARKER_377  &
   adams_id = 377  &
   location = -225.0, 0.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_0_4.MARKER_379  &
   adams_id = 379  &
   location = -225.0, -25.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
part create rigid_body mass_properties  &
   part_name = .net_ball.vlnk_0_4  &
   material_type = .net_ball.aluminum
!
! ****** Graphics for current part ******
!
geometry create shape cylinder  &
   cylinder_name = .net_ball.vlnk_0_4.cyl  &
   adams_id = 282  &
   center_marker = .net_ball.vlnk_0_4.cntMar  &
   angle_extent = 360.0  &
   length = 50.0  &
   radius = 1.0  &
   side_count_for_body = 20  &
   segment_count_for_ends = 20
!
part attributes  &
   part_name = .net_ball.vlnk_0_4  &
   color = RED  &
   name_visibility = off
!
!---------------------------------- vlnk_0_5 ----------------------------------!
!
!
defaults coordinate_system  &
   default_coordinate_system = .net_ball.ground
!
part create rigid_body name_and_position  &
   part_name = .net_ball.vlnk_0_5  &
   adams_id = 98  &
   location = 0.0, 0.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
defaults coordinate_system  &
   default_coordinate_system = .net_ball.vlnk_0_5
!
! ****** Markers for current part ******
!
marker create  &
   marker_name = .net_ball.vlnk_0_5.cntMar  &
   adams_id = 1110  &
   location = -225.0, -25.0, 0.0  &
   orientation = 0.0d, 90.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_0_5.cm  &
   adams_id = 1111  &
   location = -225.0, -50.0, 0.0  &
   orientation = 180.0d, 90.0d, 90.0d
!
marker create  &
   marker_name = .net_ball.vlnk_0_5.endMar  &
   adams_id = 1112  &
   location = -225.0, -75.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_0_5.cmMar  &
   adams_id = 1113  &
   location = -225.0, -50.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_0_5.MARKER_22  &
   adams_id = 22  &
   location = -225.0, -25.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_0_5.MARKER_381  &
   adams_id = 381  &
   location = -225.0, -50.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_0_5.MARKER_383  &
   adams_id = 383  &
   location = -225.0, -75.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
part create rigid_body mass_properties  &
   part_name = .net_ball.vlnk_0_5  &
   material_type = .net_ball.aluminum
!
! ****** Graphics for current part ******
!
geometry create shape cylinder  &
   cylinder_name = .net_ball.vlnk_0_5.cyl  &
   adams_id = 283  &
   center_marker = .net_ball.vlnk_0_5.cntMar  &
   angle_extent = 360.0  &
   length = 50.0  &
   radius = 1.0  &
   side_count_for_body = 20  &
   segment_count_for_ends = 20
!
part attributes  &
   part_name = .net_ball.vlnk_0_5  &
   color = RED  &
   name_visibility = off
!
!---------------------------------- vlnk_0_6 ----------------------------------!
!
!
defaults coordinate_system  &
   default_coordinate_system = .net_ball.ground
!
part create rigid_body name_and_position  &
   part_name = .net_ball.vlnk_0_6  &
   adams_id = 99  &
   location = 0.0, 0.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
defaults coordinate_system  &
   default_coordinate_system = .net_ball.vlnk_0_6
!
! ****** Markers for current part ******
!
marker create  &
   marker_name = .net_ball.vlnk_0_6.cntMar  &
   adams_id = 1114  &
   location = -225.0, -75.0, 0.0  &
   orientation = 0.0d, 90.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_0_6.cm  &
   adams_id = 1115  &
   location = -225.0, -100.0, 0.0  &
   orientation = 180.0d, 90.0d, 90.0d
!
marker create  &
   marker_name = .net_ball.vlnk_0_6.endMar  &
   adams_id = 1116  &
   location = -225.0, -125.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_0_6.cmMar  &
   adams_id = 1117  &
   location = -225.0, -100.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_0_6.MARKER_26  &
   adams_id = 26  &
   location = -225.0, -75.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_0_6.MARKER_385  &
   adams_id = 385  &
   location = -225.0, -100.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_0_6.MARKER_387  &
   adams_id = 387  &
   location = -225.0, -125.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
part create rigid_body mass_properties  &
   part_name = .net_ball.vlnk_0_6  &
   material_type = .net_ball.aluminum
!
! ****** Graphics for current part ******
!
geometry create shape cylinder  &
   cylinder_name = .net_ball.vlnk_0_6.cyl  &
   adams_id = 284  &
   center_marker = .net_ball.vlnk_0_6.cntMar  &
   angle_extent = 360.0  &
   length = 50.0  &
   radius = 1.0  &
   side_count_for_body = 20  &
   segment_count_for_ends = 20
!
part attributes  &
   part_name = .net_ball.vlnk_0_6  &
   color = RED  &
   name_visibility = off
!
!---------------------------------- vlnk_0_7 ----------------------------------!
!
!
defaults coordinate_system  &
   default_coordinate_system = .net_ball.ground
!
part create rigid_body name_and_position  &
   part_name = .net_ball.vlnk_0_7  &
   adams_id = 100  &
   location = 0.0, 0.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
defaults coordinate_system  &
   default_coordinate_system = .net_ball.vlnk_0_7
!
! ****** Markers for current part ******
!
marker create  &
   marker_name = .net_ball.vlnk_0_7.cntMar  &
   adams_id = 1118  &
   location = -225.0, -125.0, 0.0  &
   orientation = 0.0d, 90.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_0_7.cm  &
   adams_id = 1119  &
   location = -225.0, -150.0, 0.0  &
   orientation = 180.0d, 90.0d, 90.0d
!
marker create  &
   marker_name = .net_ball.vlnk_0_7.endMar  &
   adams_id = 1120  &
   location = -225.0, -175.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_0_7.cmMar  &
   adams_id = 1121  &
   location = -225.0, -150.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_0_7.MARKER_30  &
   adams_id = 30  &
   location = -225.0, -125.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_0_7.MARKER_389  &
   adams_id = 389  &
   location = -225.0, -150.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_0_7.MARKER_391  &
   adams_id = 391  &
   location = -225.0, -175.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
part create rigid_body mass_properties  &
   part_name = .net_ball.vlnk_0_7  &
   material_type = .net_ball.aluminum
!
! ****** Graphics for current part ******
!
geometry create shape cylinder  &
   cylinder_name = .net_ball.vlnk_0_7.cyl  &
   adams_id = 285  &
   center_marker = .net_ball.vlnk_0_7.cntMar  &
   angle_extent = 360.0  &
   length = 50.0  &
   radius = 1.0  &
   side_count_for_body = 20  &
   segment_count_for_ends = 20
!
part attributes  &
   part_name = .net_ball.vlnk_0_7  &
   color = RED  &
   name_visibility = off
!
!---------------------------------- vlnk_0_8 ----------------------------------!
!
!
defaults coordinate_system  &
   default_coordinate_system = .net_ball.ground
!
part create rigid_body name_and_position  &
   part_name = .net_ball.vlnk_0_8  &
   adams_id = 101  &
   location = 0.0, 0.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
defaults coordinate_system  &
   default_coordinate_system = .net_ball.vlnk_0_8
!
! ****** Markers for current part ******
!
marker create  &
   marker_name = .net_ball.vlnk_0_8.cntMar  &
   adams_id = 1122  &
   location = -225.0, -175.0, 0.0  &
   orientation = 0.0d, 90.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_0_8.cm  &
   adams_id = 1123  &
   location = -225.0, -200.0, 0.0  &
   orientation = 180.0d, 90.0d, 90.0d
!
marker create  &
   marker_name = .net_ball.vlnk_0_8.endMar  &
   adams_id = 1124  &
   location = -225.0, -225.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_0_8.cmMar  &
   adams_id = 1125  &
   location = -225.0, -200.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_0_8.MARKER_34  &
   adams_id = 34  &
   location = -225.0, -175.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_0_8.MARKER_38  &
   adams_id = 38  &
   location = -225.0, -225.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_0_8.MARKER_393  &
   adams_id = 393  &
   location = -225.0, -200.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_0_8.MARKER_395  &
   adams_id = 395  &
   location = -225.0, -225.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
part create rigid_body mass_properties  &
   part_name = .net_ball.vlnk_0_8  &
   material_type = .net_ball.aluminum
!
! ****** Graphics for current part ******
!
geometry create shape cylinder  &
   cylinder_name = .net_ball.vlnk_0_8.cyl  &
   adams_id = 286  &
   center_marker = .net_ball.vlnk_0_8.cntMar  &
   angle_extent = 360.0  &
   length = 50.0  &
   radius = 1.0  &
   side_count_for_body = 20  &
   segment_count_for_ends = 20
!
part attributes  &
   part_name = .net_ball.vlnk_0_8  &
   color = RED  &
   name_visibility = off
!
!---------------------------------- vlnk_1_0 ----------------------------------!
!
!
defaults coordinate_system  &
   default_coordinate_system = .net_ball.ground
!
part create rigid_body name_and_position  &
   part_name = .net_ball.vlnk_1_0  &
   adams_id = 102  &
   location = 0.0, 0.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
defaults coordinate_system  &
   default_coordinate_system = .net_ball.vlnk_1_0
!
! ****** Markers for current part ******
!
marker create  &
   marker_name = .net_ball.vlnk_1_0.cntMar  &
   adams_id = 1126  &
   location = -175.0, 225.0, 0.0  &
   orientation = 0.0d, 90.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_1_0.cm  &
   adams_id = 1127  &
   location = -175.0, 200.0, 0.0  &
   orientation = 180.0d, 90.0d, 90.0d
!
marker create  &
   marker_name = .net_ball.vlnk_1_0.endMar  &
   adams_id = 1128  &
   location = -175.0, 175.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_1_0.cmMar  &
   adams_id = 1129  &
   location = -175.0, 200.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_1_0.MARKER_4  &
   adams_id = 4  &
   location = -200.0, 225.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_1_0.MARKER_42  &
   adams_id = 42  &
   location = -175.0, 225.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_1_0.MARKER_397  &
   adams_id = 397  &
   location = -175.0, 200.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_1_0.MARKER_399  &
   adams_id = 399  &
   location = -175.0, 175.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
part create rigid_body mass_properties  &
   part_name = .net_ball.vlnk_1_0  &
   material_type = .net_ball.aluminum
!
! ****** Graphics for current part ******
!
geometry create shape cylinder  &
   cylinder_name = .net_ball.vlnk_1_0.cyl  &
   adams_id = 287  &
   center_marker = .net_ball.vlnk_1_0.cntMar  &
   angle_extent = 360.0  &
   length = 50.0  &
   radius = 1.0  &
   side_count_for_body = 20  &
   segment_count_for_ends = 20
!
part attributes  &
   part_name = .net_ball.vlnk_1_0  &
   color = RED  &
   name_visibility = off
!
!---------------------------------- vlnk_1_1 ----------------------------------!
!
!
defaults coordinate_system  &
   default_coordinate_system = .net_ball.ground
!
part create rigid_body name_and_position  &
   part_name = .net_ball.vlnk_1_1  &
   adams_id = 103  &
   location = 0.0, 0.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
defaults coordinate_system  &
   default_coordinate_system = .net_ball.vlnk_1_1
!
! ****** Markers for current part ******
!
marker create  &
   marker_name = .net_ball.vlnk_1_1.cntMar  &
   adams_id = 1130  &
   location = -175.0, 175.0, 0.0  &
   orientation = 0.0d, 90.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_1_1.cm  &
   adams_id = 1131  &
   location = -175.0, 150.0, 0.0  &
   orientation = 180.0d, 90.0d, 90.0d
!
marker create  &
   marker_name = .net_ball.vlnk_1_1.endMar  &
   adams_id = 1132  &
   location = -175.0, 125.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_1_1.cmMar  &
   adams_id = 1133  &
   location = -175.0, 150.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_1_1.MARKER_8  &
   adams_id = 8  &
   location = -200.0, 175.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_1_1.MARKER_46  &
   adams_id = 46  &
   location = -175.0, 175.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_1_1.MARKER_401  &
   adams_id = 401  &
   location = -175.0, 150.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_1_1.MARKER_403  &
   adams_id = 403  &
   location = -175.0, 125.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
part create rigid_body mass_properties  &
   part_name = .net_ball.vlnk_1_1  &
   material_type = .net_ball.aluminum
!
! ****** Graphics for current part ******
!
geometry create shape cylinder  &
   cylinder_name = .net_ball.vlnk_1_1.cyl  &
   adams_id = 288  &
   center_marker = .net_ball.vlnk_1_1.cntMar  &
   angle_extent = 360.0  &
   length = 50.0  &
   radius = 1.0  &
   side_count_for_body = 20  &
   segment_count_for_ends = 20
!
part attributes  &
   part_name = .net_ball.vlnk_1_1  &
   color = RED  &
   name_visibility = off
!
!---------------------------------- vlnk_1_2 ----------------------------------!
!
!
defaults coordinate_system  &
   default_coordinate_system = .net_ball.ground
!
part create rigid_body name_and_position  &
   part_name = .net_ball.vlnk_1_2  &
   adams_id = 104  &
   location = 0.0, 0.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
defaults coordinate_system  &
   default_coordinate_system = .net_ball.vlnk_1_2
!
! ****** Markers for current part ******
!
marker create  &
   marker_name = .net_ball.vlnk_1_2.cntMar  &
   adams_id = 1134  &
   location = -175.0, 125.0, 0.0  &
   orientation = 0.0d, 90.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_1_2.cm  &
   adams_id = 1135  &
   location = -175.0, 100.0, 0.0  &
   orientation = 180.0d, 90.0d, 90.0d
!
marker create  &
   marker_name = .net_ball.vlnk_1_2.endMar  &
   adams_id = 1136  &
   location = -175.0, 75.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_1_2.cmMar  &
   adams_id = 1137  &
   location = -175.0, 100.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_1_2.MARKER_12  &
   adams_id = 12  &
   location = -200.0, 125.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_1_2.MARKER_50  &
   adams_id = 50  &
   location = -175.0, 125.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_1_2.MARKER_405  &
   adams_id = 405  &
   location = -175.0, 100.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_1_2.MARKER_407  &
   adams_id = 407  &
   location = -175.0, 75.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
part create rigid_body mass_properties  &
   part_name = .net_ball.vlnk_1_2  &
   material_type = .net_ball.aluminum
!
! ****** Graphics for current part ******
!
geometry create shape cylinder  &
   cylinder_name = .net_ball.vlnk_1_2.cyl  &
   adams_id = 289  &
   center_marker = .net_ball.vlnk_1_2.cntMar  &
   angle_extent = 360.0  &
   length = 50.0  &
   radius = 1.0  &
   side_count_for_body = 20  &
   segment_count_for_ends = 20
!
part attributes  &
   part_name = .net_ball.vlnk_1_2  &
   color = RED  &
   name_visibility = off
!
!---------------------------------- vlnk_1_3 ----------------------------------!
!
!
defaults coordinate_system  &
   default_coordinate_system = .net_ball.ground
!
part create rigid_body name_and_position  &
   part_name = .net_ball.vlnk_1_3  &
   adams_id = 105  &
   location = 0.0, 0.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
defaults coordinate_system  &
   default_coordinate_system = .net_ball.vlnk_1_3
!
! ****** Markers for current part ******
!
marker create  &
   marker_name = .net_ball.vlnk_1_3.cntMar  &
   adams_id = 1138  &
   location = -175.0, 75.0, 0.0  &
   orientation = 0.0d, 90.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_1_3.cm  &
   adams_id = 1139  &
   location = -175.0, 50.0, 0.0  &
   orientation = 180.0d, 90.0d, 90.0d
!
marker create  &
   marker_name = .net_ball.vlnk_1_3.endMar  &
   adams_id = 1140  &
   location = -175.0, 25.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_1_3.cmMar  &
   adams_id = 1141  &
   location = -175.0, 50.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_1_3.MARKER_16  &
   adams_id = 16  &
   location = -200.0, 75.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_1_3.MARKER_54  &
   adams_id = 54  &
   location = -175.0, 75.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_1_3.MARKER_409  &
   adams_id = 409  &
   location = -175.0, 50.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_1_3.MARKER_411  &
   adams_id = 411  &
   location = -175.0, 25.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
part create rigid_body mass_properties  &
   part_name = .net_ball.vlnk_1_3  &
   material_type = .net_ball.aluminum
!
! ****** Graphics for current part ******
!
geometry create shape cylinder  &
   cylinder_name = .net_ball.vlnk_1_3.cyl  &
   adams_id = 290  &
   center_marker = .net_ball.vlnk_1_3.cntMar  &
   angle_extent = 360.0  &
   length = 50.0  &
   radius = 1.0  &
   side_count_for_body = 20  &
   segment_count_for_ends = 20
!
part attributes  &
   part_name = .net_ball.vlnk_1_3  &
   color = RED  &
   name_visibility = off
!
!---------------------------------- vlnk_1_4 ----------------------------------!
!
!
defaults coordinate_system  &
   default_coordinate_system = .net_ball.ground
!
part create rigid_body name_and_position  &
   part_name = .net_ball.vlnk_1_4  &
   adams_id = 106  &
   location = 0.0, 0.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
defaults coordinate_system  &
   default_coordinate_system = .net_ball.vlnk_1_4
!
! ****** Markers for current part ******
!
marker create  &
   marker_name = .net_ball.vlnk_1_4.cntMar  &
   adams_id = 1142  &
   location = -175.0, 25.0, 0.0  &
   orientation = 0.0d, 90.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_1_4.cm  &
   adams_id = 1143  &
   location = -175.0, 0.0, 0.0  &
   orientation = 180.0d, 90.0d, 90.0d
!
marker create  &
   marker_name = .net_ball.vlnk_1_4.endMar  &
   adams_id = 1144  &
   location = -175.0, -25.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_1_4.cmMar  &
   adams_id = 1145  &
   location = -175.0, 0.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_1_4.MARKER_20  &
   adams_id = 20  &
   location = -200.0, 25.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_1_4.MARKER_58  &
   adams_id = 58  &
   location = -175.0, 25.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_1_4.MARKER_413  &
   adams_id = 413  &
   location = -175.0, 0.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_1_4.MARKER_415  &
   adams_id = 415  &
   location = -175.0, -25.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
part create rigid_body mass_properties  &
   part_name = .net_ball.vlnk_1_4  &
   material_type = .net_ball.aluminum
!
! ****** Graphics for current part ******
!
geometry create shape cylinder  &
   cylinder_name = .net_ball.vlnk_1_4.cyl  &
   adams_id = 291  &
   center_marker = .net_ball.vlnk_1_4.cntMar  &
   angle_extent = 360.0  &
   length = 50.0  &
   radius = 1.0  &
   side_count_for_body = 20  &
   segment_count_for_ends = 20
!
part attributes  &
   part_name = .net_ball.vlnk_1_4  &
   color = RED  &
   name_visibility = off
!
!---------------------------------- vlnk_1_5 ----------------------------------!
!
!
defaults coordinate_system  &
   default_coordinate_system = .net_ball.ground
!
part create rigid_body name_and_position  &
   part_name = .net_ball.vlnk_1_5  &
   adams_id = 107  &
   location = 0.0, 0.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
defaults coordinate_system  &
   default_coordinate_system = .net_ball.vlnk_1_5
!
! ****** Markers for current part ******
!
marker create  &
   marker_name = .net_ball.vlnk_1_5.cntMar  &
   adams_id = 1146  &
   location = -175.0, -25.0, 0.0  &
   orientation = 0.0d, 90.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_1_5.cm  &
   adams_id = 1147  &
   location = -175.0, -50.0, 0.0  &
   orientation = 180.0d, 90.0d, 90.0d
!
marker create  &
   marker_name = .net_ball.vlnk_1_5.endMar  &
   adams_id = 1148  &
   location = -175.0, -75.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_1_5.cmMar  &
   adams_id = 1149  &
   location = -175.0, -50.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_1_5.MARKER_24  &
   adams_id = 24  &
   location = -200.0, -25.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_1_5.MARKER_62  &
   adams_id = 62  &
   location = -175.0, -25.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_1_5.MARKER_417  &
   adams_id = 417  &
   location = -175.0, -50.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_1_5.MARKER_419  &
   adams_id = 419  &
   location = -175.0, -75.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
part create rigid_body mass_properties  &
   part_name = .net_ball.vlnk_1_5  &
   material_type = .net_ball.aluminum
!
! ****** Graphics for current part ******
!
geometry create shape cylinder  &
   cylinder_name = .net_ball.vlnk_1_5.cyl  &
   adams_id = 292  &
   center_marker = .net_ball.vlnk_1_5.cntMar  &
   angle_extent = 360.0  &
   length = 50.0  &
   radius = 1.0  &
   side_count_for_body = 20  &
   segment_count_for_ends = 20
!
part attributes  &
   part_name = .net_ball.vlnk_1_5  &
   color = RED  &
   name_visibility = off
!
!---------------------------------- vlnk_1_6 ----------------------------------!
!
!
defaults coordinate_system  &
   default_coordinate_system = .net_ball.ground
!
part create rigid_body name_and_position  &
   part_name = .net_ball.vlnk_1_6  &
   adams_id = 108  &
   location = 0.0, 0.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
defaults coordinate_system  &
   default_coordinate_system = .net_ball.vlnk_1_6
!
! ****** Markers for current part ******
!
marker create  &
   marker_name = .net_ball.vlnk_1_6.cntMar  &
   adams_id = 1150  &
   location = -175.0, -75.0, 0.0  &
   orientation = 0.0d, 90.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_1_6.cm  &
   adams_id = 1151  &
   location = -175.0, -100.0, 0.0  &
   orientation = 180.0d, 90.0d, 90.0d
!
marker create  &
   marker_name = .net_ball.vlnk_1_6.endMar  &
   adams_id = 1152  &
   location = -175.0, -125.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_1_6.cmMar  &
   adams_id = 1153  &
   location = -175.0, -100.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_1_6.MARKER_28  &
   adams_id = 28  &
   location = -200.0, -75.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_1_6.MARKER_66  &
   adams_id = 66  &
   location = -175.0, -75.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_1_6.MARKER_421  &
   adams_id = 421  &
   location = -175.0, -100.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_1_6.MARKER_423  &
   adams_id = 423  &
   location = -175.0, -125.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
part create rigid_body mass_properties  &
   part_name = .net_ball.vlnk_1_6  &
   material_type = .net_ball.aluminum
!
! ****** Graphics for current part ******
!
geometry create shape cylinder  &
   cylinder_name = .net_ball.vlnk_1_6.cyl  &
   adams_id = 293  &
   center_marker = .net_ball.vlnk_1_6.cntMar  &
   angle_extent = 360.0  &
   length = 50.0  &
   radius = 1.0  &
   side_count_for_body = 20  &
   segment_count_for_ends = 20
!
part attributes  &
   part_name = .net_ball.vlnk_1_6  &
   color = RED  &
   name_visibility = off
!
!---------------------------------- vlnk_1_7 ----------------------------------!
!
!
defaults coordinate_system  &
   default_coordinate_system = .net_ball.ground
!
part create rigid_body name_and_position  &
   part_name = .net_ball.vlnk_1_7  &
   adams_id = 109  &
   location = 0.0, 0.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
defaults coordinate_system  &
   default_coordinate_system = .net_ball.vlnk_1_7
!
! ****** Markers for current part ******
!
marker create  &
   marker_name = .net_ball.vlnk_1_7.cntMar  &
   adams_id = 1154  &
   location = -175.0, -125.0, 0.0  &
   orientation = 0.0d, 90.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_1_7.cm  &
   adams_id = 1155  &
   location = -175.0, -150.0, 0.0  &
   orientation = 180.0d, 90.0d, 90.0d
!
marker create  &
   marker_name = .net_ball.vlnk_1_7.endMar  &
   adams_id = 1156  &
   location = -175.0, -175.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_1_7.cmMar  &
   adams_id = 1157  &
   location = -175.0, -150.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_1_7.MARKER_32  &
   adams_id = 32  &
   location = -200.0, -125.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_1_7.MARKER_70  &
   adams_id = 70  &
   location = -175.0, -125.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_1_7.MARKER_425  &
   adams_id = 425  &
   location = -175.0, -150.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_1_7.MARKER_427  &
   adams_id = 427  &
   location = -175.0, -175.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
part create rigid_body mass_properties  &
   part_name = .net_ball.vlnk_1_7  &
   material_type = .net_ball.aluminum
!
! ****** Graphics for current part ******
!
geometry create shape cylinder  &
   cylinder_name = .net_ball.vlnk_1_7.cyl  &
   adams_id = 294  &
   center_marker = .net_ball.vlnk_1_7.cntMar  &
   angle_extent = 360.0  &
   length = 50.0  &
   radius = 1.0  &
   side_count_for_body = 20  &
   segment_count_for_ends = 20
!
part attributes  &
   part_name = .net_ball.vlnk_1_7  &
   color = RED  &
   name_visibility = off
!
!---------------------------------- vlnk_1_8 ----------------------------------!
!
!
defaults coordinate_system  &
   default_coordinate_system = .net_ball.ground
!
part create rigid_body name_and_position  &
   part_name = .net_ball.vlnk_1_8  &
   adams_id = 110  &
   location = 0.0, 0.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
defaults coordinate_system  &
   default_coordinate_system = .net_ball.vlnk_1_8
!
! ****** Markers for current part ******
!
marker create  &
   marker_name = .net_ball.vlnk_1_8.cntMar  &
   adams_id = 1158  &
   location = -175.0, -175.0, 0.0  &
   orientation = 0.0d, 90.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_1_8.cm  &
   adams_id = 1159  &
   location = -175.0, -200.0, 0.0  &
   orientation = 0.0d, 90.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_1_8.endMar  &
   adams_id = 1160  &
   location = -175.0, -225.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_1_8.cmMar  &
   adams_id = 1161  &
   location = -175.0, -200.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_1_8.MARKER_36  &
   adams_id = 36  &
   location = -200.0, -175.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_1_8.MARKER_40  &
   adams_id = 40  &
   location = -200.0, -225.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_1_8.MARKER_74  &
   adams_id = 74  &
   location = -175.0, -175.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_1_8.MARKER_78  &
   adams_id = 78  &
   location = -175.0, -225.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_1_8.MARKER_429  &
   adams_id = 429  &
   location = -175.0, -200.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_1_8.MARKER_431  &
   adams_id = 431  &
   location = -175.0, -225.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
part create rigid_body mass_properties  &
   part_name = .net_ball.vlnk_1_8  &
   material_type = .net_ball.aluminum
!
! ****** Graphics for current part ******
!
geometry create shape cylinder  &
   cylinder_name = .net_ball.vlnk_1_8.cyl  &
   adams_id = 295  &
   center_marker = .net_ball.vlnk_1_8.cntMar  &
   angle_extent = 360.0  &
   length = 50.0  &
   radius = 1.0  &
   side_count_for_body = 20  &
   segment_count_for_ends = 20
!
part attributes  &
   part_name = .net_ball.vlnk_1_8  &
   color = RED  &
   name_visibility = off
!
!---------------------------------- vlnk_2_0 ----------------------------------!
!
!
defaults coordinate_system  &
   default_coordinate_system = .net_ball.ground
!
part create rigid_body name_and_position  &
   part_name = .net_ball.vlnk_2_0  &
   adams_id = 111  &
   location = 0.0, 0.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
defaults coordinate_system  &
   default_coordinate_system = .net_ball.vlnk_2_0
!
! ****** Markers for current part ******
!
marker create  &
   marker_name = .net_ball.vlnk_2_0.cntMar  &
   adams_id = 1162  &
   location = -125.0, 225.0, 0.0  &
   orientation = 0.0d, 90.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_2_0.cm  &
   adams_id = 1163  &
   location = -125.0, 200.0, 0.0  &
   orientation = 180.0d, 90.0d, 90.0d
!
marker create  &
   marker_name = .net_ball.vlnk_2_0.endMar  &
   adams_id = 1164  &
   location = -125.0, 175.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_2_0.cmMar  &
   adams_id = 1165  &
   location = -125.0, 200.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_2_0.MARKER_44  &
   adams_id = 44  &
   location = -150.0, 225.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_2_0.MARKER_82  &
   adams_id = 82  &
   location = -125.0, 225.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_2_0.MARKER_433  &
   adams_id = 433  &
   location = -125.0, 200.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_2_0.MARKER_435  &
   adams_id = 435  &
   location = -125.0, 175.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
part create rigid_body mass_properties  &
   part_name = .net_ball.vlnk_2_0  &
   material_type = .net_ball.aluminum
!
! ****** Graphics for current part ******
!
geometry create shape cylinder  &
   cylinder_name = .net_ball.vlnk_2_0.cyl  &
   adams_id = 296  &
   center_marker = .net_ball.vlnk_2_0.cntMar  &
   angle_extent = 360.0  &
   length = 50.0  &
   radius = 1.0  &
   side_count_for_body = 20  &
   segment_count_for_ends = 20
!
part attributes  &
   part_name = .net_ball.vlnk_2_0  &
   color = RED  &
   name_visibility = off
!
!---------------------------------- vlnk_2_1 ----------------------------------!
!
!
defaults coordinate_system  &
   default_coordinate_system = .net_ball.ground
!
part create rigid_body name_and_position  &
   part_name = .net_ball.vlnk_2_1  &
   adams_id = 112  &
   location = 0.0, 0.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
defaults coordinate_system  &
   default_coordinate_system = .net_ball.vlnk_2_1
!
! ****** Markers for current part ******
!
marker create  &
   marker_name = .net_ball.vlnk_2_1.cntMar  &
   adams_id = 1166  &
   location = -125.0, 175.0, 0.0  &
   orientation = 0.0d, 90.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_2_1.cm  &
   adams_id = 1167  &
   location = -125.0, 150.0, 0.0  &
   orientation = 180.0d, 90.0d, 90.0d
!
marker create  &
   marker_name = .net_ball.vlnk_2_1.endMar  &
   adams_id = 1168  &
   location = -125.0, 125.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_2_1.cmMar  &
   adams_id = 1169  &
   location = -125.0, 150.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_2_1.MARKER_48  &
   adams_id = 48  &
   location = -150.0, 175.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_2_1.MARKER_86  &
   adams_id = 86  &
   location = -125.0, 175.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_2_1.MARKER_437  &
   adams_id = 437  &
   location = -125.0, 150.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_2_1.MARKER_439  &
   adams_id = 439  &
   location = -125.0, 125.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
part create rigid_body mass_properties  &
   part_name = .net_ball.vlnk_2_1  &
   material_type = .net_ball.aluminum
!
! ****** Graphics for current part ******
!
geometry create shape cylinder  &
   cylinder_name = .net_ball.vlnk_2_1.cyl  &
   adams_id = 297  &
   center_marker = .net_ball.vlnk_2_1.cntMar  &
   angle_extent = 360.0  &
   length = 50.0  &
   radius = 1.0  &
   side_count_for_body = 20  &
   segment_count_for_ends = 20
!
part attributes  &
   part_name = .net_ball.vlnk_2_1  &
   color = RED  &
   name_visibility = off
!
!---------------------------------- vlnk_2_2 ----------------------------------!
!
!
defaults coordinate_system  &
   default_coordinate_system = .net_ball.ground
!
part create rigid_body name_and_position  &
   part_name = .net_ball.vlnk_2_2  &
   adams_id = 113  &
   location = 0.0, 0.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
defaults coordinate_system  &
   default_coordinate_system = .net_ball.vlnk_2_2
!
! ****** Markers for current part ******
!
marker create  &
   marker_name = .net_ball.vlnk_2_2.cntMar  &
   adams_id = 1170  &
   location = -125.0, 125.0, 0.0  &
   orientation = 0.0d, 90.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_2_2.cm  &
   adams_id = 1171  &
   location = -125.0, 100.0, 0.0  &
   orientation = 0.0d, 90.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_2_2.endMar  &
   adams_id = 1172  &
   location = -125.0, 75.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_2_2.cmMar  &
   adams_id = 1173  &
   location = -125.0, 100.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_2_2.MARKER_52  &
   adams_id = 52  &
   location = -150.0, 125.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_2_2.MARKER_90  &
   adams_id = 90  &
   location = -125.0, 125.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_2_2.MARKER_441  &
   adams_id = 441  &
   location = -125.0, 100.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_2_2.MARKER_443  &
   adams_id = 443  &
   location = -125.0, 75.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
part create rigid_body mass_properties  &
   part_name = .net_ball.vlnk_2_2  &
   material_type = .net_ball.aluminum
!
! ****** Graphics for current part ******
!
geometry create shape cylinder  &
   cylinder_name = .net_ball.vlnk_2_2.cyl  &
   adams_id = 298  &
   center_marker = .net_ball.vlnk_2_2.cntMar  &
   angle_extent = 360.0  &
   length = 50.0  &
   radius = 1.0  &
   side_count_for_body = 20  &
   segment_count_for_ends = 20
!
part attributes  &
   part_name = .net_ball.vlnk_2_2  &
   color = RED  &
   name_visibility = off
!
!---------------------------------- vlnk_2_3 ----------------------------------!
!
!
defaults coordinate_system  &
   default_coordinate_system = .net_ball.ground
!
part create rigid_body name_and_position  &
   part_name = .net_ball.vlnk_2_3  &
   adams_id = 114  &
   location = 0.0, 0.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
defaults coordinate_system  &
   default_coordinate_system = .net_ball.vlnk_2_3
!
! ****** Markers for current part ******
!
marker create  &
   marker_name = .net_ball.vlnk_2_3.cntMar  &
   adams_id = 1174  &
   location = -125.0, 75.0, 0.0  &
   orientation = 0.0d, 90.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_2_3.cm  &
   adams_id = 1175  &
   location = -125.0, 50.0, 0.0  &
   orientation = 180.0d, 90.0d, 90.0d
!
marker create  &
   marker_name = .net_ball.vlnk_2_3.endMar  &
   adams_id = 1176  &
   location = -125.0, 25.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_2_3.cmMar  &
   adams_id = 1177  &
   location = -125.0, 50.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_2_3.MARKER_56  &
   adams_id = 56  &
   location = -150.0, 75.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_2_3.MARKER_94  &
   adams_id = 94  &
   location = -125.0, 75.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_2_3.MARKER_445  &
   adams_id = 445  &
   location = -125.0, 50.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_2_3.MARKER_447  &
   adams_id = 447  &
   location = -125.0, 25.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
part create rigid_body mass_properties  &
   part_name = .net_ball.vlnk_2_3  &
   material_type = .net_ball.aluminum
!
! ****** Graphics for current part ******
!
geometry create shape cylinder  &
   cylinder_name = .net_ball.vlnk_2_3.cyl  &
   adams_id = 299  &
   center_marker = .net_ball.vlnk_2_3.cntMar  &
   angle_extent = 360.0  &
   length = 50.0  &
   radius = 1.0  &
   side_count_for_body = 20  &
   segment_count_for_ends = 20
!
part attributes  &
   part_name = .net_ball.vlnk_2_3  &
   color = RED  &
   name_visibility = off
!
!---------------------------------- vlnk_2_4 ----------------------------------!
!
!
defaults coordinate_system  &
   default_coordinate_system = .net_ball.ground
!
part create rigid_body name_and_position  &
   part_name = .net_ball.vlnk_2_4  &
   adams_id = 115  &
   location = 0.0, 0.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
defaults coordinate_system  &
   default_coordinate_system = .net_ball.vlnk_2_4
!
! ****** Markers for current part ******
!
marker create  &
   marker_name = .net_ball.vlnk_2_4.cntMar  &
   adams_id = 1178  &
   location = -125.0, 25.0, 0.0  &
   orientation = 0.0d, 90.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_2_4.cm  &
   adams_id = 1179  &
   location = -125.0, 0.0, 0.0  &
   orientation = 180.0d, 90.0d, 90.0d
!
marker create  &
   marker_name = .net_ball.vlnk_2_4.endMar  &
   adams_id = 1180  &
   location = -125.0, -25.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_2_4.cmMar  &
   adams_id = 1181  &
   location = -125.0, 0.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_2_4.MARKER_60  &
   adams_id = 60  &
   location = -150.0, 25.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_2_4.MARKER_98  &
   adams_id = 98  &
   location = -125.0, 25.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_2_4.MARKER_449  &
   adams_id = 449  &
   location = -125.0, 0.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_2_4.MARKER_451  &
   adams_id = 451  &
   location = -125.0, -25.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
part create rigid_body mass_properties  &
   part_name = .net_ball.vlnk_2_4  &
   material_type = .net_ball.aluminum
!
! ****** Graphics for current part ******
!
geometry create shape cylinder  &
   cylinder_name = .net_ball.vlnk_2_4.cyl  &
   adams_id = 300  &
   center_marker = .net_ball.vlnk_2_4.cntMar  &
   angle_extent = 360.0  &
   length = 50.0  &
   radius = 1.0  &
   side_count_for_body = 20  &
   segment_count_for_ends = 20
!
part attributes  &
   part_name = .net_ball.vlnk_2_4  &
   color = RED  &
   name_visibility = off
!
!---------------------------------- vlnk_2_5 ----------------------------------!
!
!
defaults coordinate_system  &
   default_coordinate_system = .net_ball.ground
!
part create rigid_body name_and_position  &
   part_name = .net_ball.vlnk_2_5  &
   adams_id = 116  &
   location = 0.0, 0.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
defaults coordinate_system  &
   default_coordinate_system = .net_ball.vlnk_2_5
!
! ****** Markers for current part ******
!
marker create  &
   marker_name = .net_ball.vlnk_2_5.cntMar  &
   adams_id = 1182  &
   location = -125.0, -25.0, 0.0  &
   orientation = 0.0d, 90.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_2_5.cm  &
   adams_id = 1183  &
   location = -125.0, -50.0, 0.0  &
   orientation = 180.0d, 90.0d, 90.0d
!
marker create  &
   marker_name = .net_ball.vlnk_2_5.endMar  &
   adams_id = 1184  &
   location = -125.0, -75.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_2_5.cmMar  &
   adams_id = 1185  &
   location = -125.0, -50.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_2_5.MARKER_64  &
   adams_id = 64  &
   location = -150.0, -25.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_2_5.MARKER_102  &
   adams_id = 102  &
   location = -125.0, -25.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_2_5.MARKER_453  &
   adams_id = 453  &
   location = -125.0, -50.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_2_5.MARKER_455  &
   adams_id = 455  &
   location = -125.0, -75.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
part create rigid_body mass_properties  &
   part_name = .net_ball.vlnk_2_5  &
   material_type = .net_ball.aluminum
!
! ****** Graphics for current part ******
!
geometry create shape cylinder  &
   cylinder_name = .net_ball.vlnk_2_5.cyl  &
   adams_id = 301  &
   center_marker = .net_ball.vlnk_2_5.cntMar  &
   angle_extent = 360.0  &
   length = 50.0  &
   radius = 1.0  &
   side_count_for_body = 20  &
   segment_count_for_ends = 20
!
part attributes  &
   part_name = .net_ball.vlnk_2_5  &
   color = RED  &
   name_visibility = off
!
!---------------------------------- vlnk_2_6 ----------------------------------!
!
!
defaults coordinate_system  &
   default_coordinate_system = .net_ball.ground
!
part create rigid_body name_and_position  &
   part_name = .net_ball.vlnk_2_6  &
   adams_id = 117  &
   location = 0.0, 0.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
defaults coordinate_system  &
   default_coordinate_system = .net_ball.vlnk_2_6
!
! ****** Markers for current part ******
!
marker create  &
   marker_name = .net_ball.vlnk_2_6.cntMar  &
   adams_id = 1186  &
   location = -125.0, -75.0, 0.0  &
   orientation = 0.0d, 90.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_2_6.cm  &
   adams_id = 1187  &
   location = -125.0, -100.0, 0.0  &
   orientation = 180.0d, 90.0d, 90.0d
!
marker create  &
   marker_name = .net_ball.vlnk_2_6.endMar  &
   adams_id = 1188  &
   location = -125.0, -125.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_2_6.cmMar  &
   adams_id = 1189  &
   location = -125.0, -100.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_2_6.MARKER_68  &
   adams_id = 68  &
   location = -150.0, -75.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_2_6.MARKER_106  &
   adams_id = 106  &
   location = -125.0, -75.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_2_6.MARKER_457  &
   adams_id = 457  &
   location = -125.0, -100.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_2_6.MARKER_459  &
   adams_id = 459  &
   location = -125.0, -125.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
part create rigid_body mass_properties  &
   part_name = .net_ball.vlnk_2_6  &
   material_type = .net_ball.aluminum
!
! ****** Graphics for current part ******
!
geometry create shape cylinder  &
   cylinder_name = .net_ball.vlnk_2_6.cyl  &
   adams_id = 302  &
   center_marker = .net_ball.vlnk_2_6.cntMar  &
   angle_extent = 360.0  &
   length = 50.0  &
   radius = 1.0  &
   side_count_for_body = 20  &
   segment_count_for_ends = 20
!
part attributes  &
   part_name = .net_ball.vlnk_2_6  &
   color = RED  &
   name_visibility = off
!
!---------------------------------- vlnk_2_7 ----------------------------------!
!
!
defaults coordinate_system  &
   default_coordinate_system = .net_ball.ground
!
part create rigid_body name_and_position  &
   part_name = .net_ball.vlnk_2_7  &
   adams_id = 118  &
   location = 0.0, 0.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
defaults coordinate_system  &
   default_coordinate_system = .net_ball.vlnk_2_7
!
! ****** Markers for current part ******
!
marker create  &
   marker_name = .net_ball.vlnk_2_7.cntMar  &
   adams_id = 1190  &
   location = -125.0, -125.0, 0.0  &
   orientation = 0.0d, 90.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_2_7.cm  &
   adams_id = 1191  &
   location = -125.0, -150.0, 0.0  &
   orientation = 180.0d, 90.0d, 90.0d
!
marker create  &
   marker_name = .net_ball.vlnk_2_7.endMar  &
   adams_id = 1192  &
   location = -125.0, -175.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_2_7.cmMar  &
   adams_id = 1193  &
   location = -125.0, -150.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_2_7.MARKER_72  &
   adams_id = 72  &
   location = -150.0, -125.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_2_7.MARKER_110  &
   adams_id = 110  &
   location = -125.0, -125.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_2_7.MARKER_461  &
   adams_id = 461  &
   location = -125.0, -150.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_2_7.MARKER_463  &
   adams_id = 463  &
   location = -125.0, -175.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
part create rigid_body mass_properties  &
   part_name = .net_ball.vlnk_2_7  &
   material_type = .net_ball.aluminum
!
! ****** Graphics for current part ******
!
geometry create shape cylinder  &
   cylinder_name = .net_ball.vlnk_2_7.cyl  &
   adams_id = 303  &
   center_marker = .net_ball.vlnk_2_7.cntMar  &
   angle_extent = 360.0  &
   length = 50.0  &
   radius = 1.0  &
   side_count_for_body = 20  &
   segment_count_for_ends = 20
!
part attributes  &
   part_name = .net_ball.vlnk_2_7  &
   color = RED  &
   name_visibility = off
!
!---------------------------------- vlnk_2_8 ----------------------------------!
!
!
defaults coordinate_system  &
   default_coordinate_system = .net_ball.ground
!
part create rigid_body name_and_position  &
   part_name = .net_ball.vlnk_2_8  &
   adams_id = 119  &
   location = 0.0, 0.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
defaults coordinate_system  &
   default_coordinate_system = .net_ball.vlnk_2_8
!
! ****** Markers for current part ******
!
marker create  &
   marker_name = .net_ball.vlnk_2_8.cntMar  &
   adams_id = 1194  &
   location = -125.0, -175.0, 0.0  &
   orientation = 0.0d, 90.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_2_8.cm  &
   adams_id = 1195  &
   location = -125.0, -200.0, 0.0  &
   orientation = 0.0d, 90.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_2_8.endMar  &
   adams_id = 1196  &
   location = -125.0, -225.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_2_8.cmMar  &
   adams_id = 1197  &
   location = -125.0, -200.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_2_8.MARKER_76  &
   adams_id = 76  &
   location = -150.0, -175.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_2_8.MARKER_80  &
   adams_id = 80  &
   location = -150.0, -225.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_2_8.MARKER_114  &
   adams_id = 114  &
   location = -125.0, -175.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_2_8.MARKER_118  &
   adams_id = 118  &
   location = -125.0, -225.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_2_8.MARKER_465  &
   adams_id = 465  &
   location = -125.0, -200.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_2_8.MARKER_467  &
   adams_id = 467  &
   location = -125.0, -225.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
part create rigid_body mass_properties  &
   part_name = .net_ball.vlnk_2_8  &
   material_type = .net_ball.aluminum
!
! ****** Graphics for current part ******
!
geometry create shape cylinder  &
   cylinder_name = .net_ball.vlnk_2_8.cyl  &
   adams_id = 304  &
   center_marker = .net_ball.vlnk_2_8.cntMar  &
   angle_extent = 360.0  &
   length = 50.0  &
   radius = 1.0  &
   side_count_for_body = 20  &
   segment_count_for_ends = 20
!
part attributes  &
   part_name = .net_ball.vlnk_2_8  &
   color = RED  &
   name_visibility = off
!
!---------------------------------- vlnk_3_0 ----------------------------------!
!
!
defaults coordinate_system  &
   default_coordinate_system = .net_ball.ground
!
part create rigid_body name_and_position  &
   part_name = .net_ball.vlnk_3_0  &
   adams_id = 120  &
   location = 0.0, 0.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
defaults coordinate_system  &
   default_coordinate_system = .net_ball.vlnk_3_0
!
! ****** Markers for current part ******
!
marker create  &
   marker_name = .net_ball.vlnk_3_0.cntMar  &
   adams_id = 1198  &
   location = -75.0, 225.0, 0.0  &
   orientation = 0.0d, 90.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_3_0.cm  &
   adams_id = 1199  &
   location = -75.0, 200.0, 0.0  &
   orientation = 180.0d, 90.0d, 90.0d
!
marker create  &
   marker_name = .net_ball.vlnk_3_0.endMar  &
   adams_id = 1200  &
   location = -75.0, 175.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_3_0.cmMar  &
   adams_id = 1201  &
   location = -75.0, 200.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_3_0.MARKER_84  &
   adams_id = 84  &
   location = -100.0, 225.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_3_0.MARKER_122  &
   adams_id = 122  &
   location = -75.0, 225.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_3_0.MARKER_469  &
   adams_id = 469  &
   location = -75.0, 200.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_3_0.MARKER_471  &
   adams_id = 471  &
   location = -75.0, 175.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
part create rigid_body mass_properties  &
   part_name = .net_ball.vlnk_3_0  &
   material_type = .net_ball.aluminum
!
! ****** Graphics for current part ******
!
geometry create shape cylinder  &
   cylinder_name = .net_ball.vlnk_3_0.cyl  &
   adams_id = 305  &
   center_marker = .net_ball.vlnk_3_0.cntMar  &
   angle_extent = 360.0  &
   length = 50.0  &
   radius = 1.0  &
   side_count_for_body = 20  &
   segment_count_for_ends = 20
!
part attributes  &
   part_name = .net_ball.vlnk_3_0  &
   color = RED  &
   name_visibility = off
!
!---------------------------------- vlnk_3_1 ----------------------------------!
!
!
defaults coordinate_system  &
   default_coordinate_system = .net_ball.ground
!
part create rigid_body name_and_position  &
   part_name = .net_ball.vlnk_3_1  &
   adams_id = 121  &
   location = 0.0, 0.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
defaults coordinate_system  &
   default_coordinate_system = .net_ball.vlnk_3_1
!
! ****** Markers for current part ******
!
marker create  &
   marker_name = .net_ball.vlnk_3_1.cntMar  &
   adams_id = 1202  &
   location = -75.0, 175.0, 0.0  &
   orientation = 0.0d, 90.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_3_1.cm  &
   adams_id = 1203  &
   location = -75.0, 150.0, 0.0  &
   orientation = 180.0d, 90.0d, 90.0d
!
marker create  &
   marker_name = .net_ball.vlnk_3_1.endMar  &
   adams_id = 1204  &
   location = -75.0, 125.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_3_1.cmMar  &
   adams_id = 1205  &
   location = -75.0, 150.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_3_1.MARKER_88  &
   adams_id = 88  &
   location = -100.0, 175.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_3_1.MARKER_126  &
   adams_id = 126  &
   location = -75.0, 175.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_3_1.MARKER_473  &
   adams_id = 473  &
   location = -75.0, 150.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_3_1.MARKER_475  &
   adams_id = 475  &
   location = -75.0, 125.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
part create rigid_body mass_properties  &
   part_name = .net_ball.vlnk_3_1  &
   material_type = .net_ball.aluminum
!
! ****** Graphics for current part ******
!
geometry create shape cylinder  &
   cylinder_name = .net_ball.vlnk_3_1.cyl  &
   adams_id = 306  &
   center_marker = .net_ball.vlnk_3_1.cntMar  &
   angle_extent = 360.0  &
   length = 50.0  &
   radius = 1.0  &
   side_count_for_body = 20  &
   segment_count_for_ends = 20
!
part attributes  &
   part_name = .net_ball.vlnk_3_1  &
   color = RED  &
   name_visibility = off
!
!---------------------------------- vlnk_3_2 ----------------------------------!
!
!
defaults coordinate_system  &
   default_coordinate_system = .net_ball.ground
!
part create rigid_body name_and_position  &
   part_name = .net_ball.vlnk_3_2  &
   adams_id = 122  &
   location = 0.0, 0.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
defaults coordinate_system  &
   default_coordinate_system = .net_ball.vlnk_3_2
!
! ****** Markers for current part ******
!
marker create  &
   marker_name = .net_ball.vlnk_3_2.cntMar  &
   adams_id = 1206  &
   location = -75.0, 125.0, 0.0  &
   orientation = 0.0d, 90.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_3_2.cm  &
   adams_id = 1207  &
   location = -75.0, 100.0, 0.0  &
   orientation = 180.0d, 90.0d, 90.0d
!
marker create  &
   marker_name = .net_ball.vlnk_3_2.endMar  &
   adams_id = 1208  &
   location = -75.0, 75.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_3_2.cmMar  &
   adams_id = 1209  &
   location = -75.0, 100.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_3_2.MARKER_92  &
   adams_id = 92  &
   location = -100.0, 125.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_3_2.MARKER_130  &
   adams_id = 130  &
   location = -75.0, 125.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_3_2.MARKER_477  &
   adams_id = 477  &
   location = -75.0, 100.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_3_2.MARKER_479  &
   adams_id = 479  &
   location = -75.0, 75.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
part create rigid_body mass_properties  &
   part_name = .net_ball.vlnk_3_2  &
   material_type = .net_ball.aluminum
!
! ****** Graphics for current part ******
!
geometry create shape cylinder  &
   cylinder_name = .net_ball.vlnk_3_2.cyl  &
   adams_id = 307  &
   center_marker = .net_ball.vlnk_3_2.cntMar  &
   angle_extent = 360.0  &
   length = 50.0  &
   radius = 1.0  &
   side_count_for_body = 20  &
   segment_count_for_ends = 20
!
part attributes  &
   part_name = .net_ball.vlnk_3_2  &
   color = RED  &
   name_visibility = off
!
!---------------------------------- vlnk_3_3 ----------------------------------!
!
!
defaults coordinate_system  &
   default_coordinate_system = .net_ball.ground
!
part create rigid_body name_and_position  &
   part_name = .net_ball.vlnk_3_3  &
   adams_id = 123  &
   location = 0.0, 0.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
defaults coordinate_system  &
   default_coordinate_system = .net_ball.vlnk_3_3
!
! ****** Markers for current part ******
!
marker create  &
   marker_name = .net_ball.vlnk_3_3.cntMar  &
   adams_id = 1210  &
   location = -75.0, 75.0, 0.0  &
   orientation = 0.0d, 90.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_3_3.cm  &
   adams_id = 1211  &
   location = -75.0, 50.0, 0.0  &
   orientation = 180.0d, 90.0d, 90.0d
!
marker create  &
   marker_name = .net_ball.vlnk_3_3.endMar  &
   adams_id = 1212  &
   location = -75.0, 25.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_3_3.cmMar  &
   adams_id = 1213  &
   location = -75.0, 50.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_3_3.MARKER_96  &
   adams_id = 96  &
   location = -100.0, 75.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_3_3.MARKER_134  &
   adams_id = 134  &
   location = -75.0, 75.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_3_3.MARKER_481  &
   adams_id = 481  &
   location = -75.0, 50.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_3_3.MARKER_483  &
   adams_id = 483  &
   location = -75.0, 25.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
part create rigid_body mass_properties  &
   part_name = .net_ball.vlnk_3_3  &
   material_type = .net_ball.aluminum
!
! ****** Graphics for current part ******
!
geometry create shape cylinder  &
   cylinder_name = .net_ball.vlnk_3_3.cyl  &
   adams_id = 308  &
   center_marker = .net_ball.vlnk_3_3.cntMar  &
   angle_extent = 360.0  &
   length = 50.0  &
   radius = 1.0  &
   side_count_for_body = 20  &
   segment_count_for_ends = 20
!
part attributes  &
   part_name = .net_ball.vlnk_3_3  &
   color = RED  &
   name_visibility = off
!
!---------------------------------- vlnk_3_4 ----------------------------------!
!
!
defaults coordinate_system  &
   default_coordinate_system = .net_ball.ground
!
part create rigid_body name_and_position  &
   part_name = .net_ball.vlnk_3_4  &
   adams_id = 124  &
   location = 0.0, 0.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
defaults coordinate_system  &
   default_coordinate_system = .net_ball.vlnk_3_4
!
! ****** Markers for current part ******
!
marker create  &
   marker_name = .net_ball.vlnk_3_4.cntMar  &
   adams_id = 1214  &
   location = -75.0, 25.0, 0.0  &
   orientation = 0.0d, 90.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_3_4.cm  &
   adams_id = 1215  &
   location = -75.0, 0.0, 0.0  &
   orientation = 180.0d, 90.0d, 90.0d
!
marker create  &
   marker_name = .net_ball.vlnk_3_4.endMar  &
   adams_id = 1216  &
   location = -75.0, -25.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_3_4.cmMar  &
   adams_id = 1217  &
   location = -75.0, 0.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_3_4.MARKER_100  &
   adams_id = 100  &
   location = -100.0, 25.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_3_4.MARKER_138  &
   adams_id = 138  &
   location = -75.0, 25.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_3_4.MARKER_485  &
   adams_id = 485  &
   location = -75.0, 0.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_3_4.MARKER_487  &
   adams_id = 487  &
   location = -75.0, -25.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
part create rigid_body mass_properties  &
   part_name = .net_ball.vlnk_3_4  &
   material_type = .net_ball.aluminum
!
! ****** Graphics for current part ******
!
geometry create shape cylinder  &
   cylinder_name = .net_ball.vlnk_3_4.cyl  &
   adams_id = 309  &
   center_marker = .net_ball.vlnk_3_4.cntMar  &
   angle_extent = 360.0  &
   length = 50.0  &
   radius = 1.0  &
   side_count_for_body = 20  &
   segment_count_for_ends = 20
!
part attributes  &
   part_name = .net_ball.vlnk_3_4  &
   color = RED  &
   name_visibility = off
!
!---------------------------------- vlnk_3_5 ----------------------------------!
!
!
defaults coordinate_system  &
   default_coordinate_system = .net_ball.ground
!
part create rigid_body name_and_position  &
   part_name = .net_ball.vlnk_3_5  &
   adams_id = 125  &
   location = 0.0, 0.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
defaults coordinate_system  &
   default_coordinate_system = .net_ball.vlnk_3_5
!
! ****** Markers for current part ******
!
marker create  &
   marker_name = .net_ball.vlnk_3_5.cntMar  &
   adams_id = 1218  &
   location = -75.0, -25.0, 0.0  &
   orientation = 0.0d, 90.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_3_5.cm  &
   adams_id = 1219  &
   location = -75.0, -50.0, 0.0  &
   orientation = 180.0d, 90.0d, 90.0d
!
marker create  &
   marker_name = .net_ball.vlnk_3_5.endMar  &
   adams_id = 1220  &
   location = -75.0, -75.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_3_5.cmMar  &
   adams_id = 1221  &
   location = -75.0, -50.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_3_5.MARKER_104  &
   adams_id = 104  &
   location = -100.0, -25.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_3_5.MARKER_142  &
   adams_id = 142  &
   location = -75.0, -25.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_3_5.MARKER_489  &
   adams_id = 489  &
   location = -75.0, -50.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_3_5.MARKER_491  &
   adams_id = 491  &
   location = -75.0, -75.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
part create rigid_body mass_properties  &
   part_name = .net_ball.vlnk_3_5  &
   material_type = .net_ball.aluminum
!
! ****** Graphics for current part ******
!
geometry create shape cylinder  &
   cylinder_name = .net_ball.vlnk_3_5.cyl  &
   adams_id = 310  &
   center_marker = .net_ball.vlnk_3_5.cntMar  &
   angle_extent = 360.0  &
   length = 50.0  &
   radius = 1.0  &
   side_count_for_body = 20  &
   segment_count_for_ends = 20
!
part attributes  &
   part_name = .net_ball.vlnk_3_5  &
   color = RED  &
   name_visibility = off
!
!---------------------------------- vlnk_3_6 ----------------------------------!
!
!
defaults coordinate_system  &
   default_coordinate_system = .net_ball.ground
!
part create rigid_body name_and_position  &
   part_name = .net_ball.vlnk_3_6  &
   adams_id = 126  &
   location = 0.0, 0.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
defaults coordinate_system  &
   default_coordinate_system = .net_ball.vlnk_3_6
!
! ****** Markers for current part ******
!
marker create  &
   marker_name = .net_ball.vlnk_3_6.cntMar  &
   adams_id = 1222  &
   location = -75.0, -75.0, 0.0  &
   orientation = 0.0d, 90.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_3_6.cm  &
   adams_id = 1223  &
   location = -75.0, -100.0, 0.0  &
   orientation = 0.0d, 90.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_3_6.endMar  &
   adams_id = 1224  &
   location = -75.0, -125.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_3_6.cmMar  &
   adams_id = 1225  &
   location = -75.0, -100.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_3_6.MARKER_108  &
   adams_id = 108  &
   location = -100.0, -75.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_3_6.MARKER_146  &
   adams_id = 146  &
   location = -75.0, -75.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_3_6.MARKER_493  &
   adams_id = 493  &
   location = -75.0, -100.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_3_6.MARKER_495  &
   adams_id = 495  &
   location = -75.0, -125.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
part create rigid_body mass_properties  &
   part_name = .net_ball.vlnk_3_6  &
   material_type = .net_ball.aluminum
!
! ****** Graphics for current part ******
!
geometry create shape cylinder  &
   cylinder_name = .net_ball.vlnk_3_6.cyl  &
   adams_id = 311  &
   center_marker = .net_ball.vlnk_3_6.cntMar  &
   angle_extent = 360.0  &
   length = 50.0  &
   radius = 1.0  &
   side_count_for_body = 20  &
   segment_count_for_ends = 20
!
part attributes  &
   part_name = .net_ball.vlnk_3_6  &
   color = RED  &
   name_visibility = off
!
!---------------------------------- vlnk_3_7 ----------------------------------!
!
!
defaults coordinate_system  &
   default_coordinate_system = .net_ball.ground
!
part create rigid_body name_and_position  &
   part_name = .net_ball.vlnk_3_7  &
   adams_id = 127  &
   location = 0.0, 0.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
defaults coordinate_system  &
   default_coordinate_system = .net_ball.vlnk_3_7
!
! ****** Markers for current part ******
!
marker create  &
   marker_name = .net_ball.vlnk_3_7.cntMar  &
   adams_id = 1226  &
   location = -75.0, -125.0, 0.0  &
   orientation = 0.0d, 90.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_3_7.cm  &
   adams_id = 1227  &
   location = -75.0, -150.0, 0.0  &
   orientation = 180.0d, 90.0d, 90.0d
!
marker create  &
   marker_name = .net_ball.vlnk_3_7.endMar  &
   adams_id = 1228  &
   location = -75.0, -175.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_3_7.cmMar  &
   adams_id = 1229  &
   location = -75.0, -150.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_3_7.MARKER_112  &
   adams_id = 112  &
   location = -100.0, -125.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_3_7.MARKER_150  &
   adams_id = 150  &
   location = -75.0, -125.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_3_7.MARKER_497  &
   adams_id = 497  &
   location = -75.0, -150.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_3_7.MARKER_499  &
   adams_id = 499  &
   location = -75.0, -175.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
part create rigid_body mass_properties  &
   part_name = .net_ball.vlnk_3_7  &
   material_type = .net_ball.aluminum
!
! ****** Graphics for current part ******
!
geometry create shape cylinder  &
   cylinder_name = .net_ball.vlnk_3_7.cyl  &
   adams_id = 312  &
   center_marker = .net_ball.vlnk_3_7.cntMar  &
   angle_extent = 360.0  &
   length = 50.0  &
   radius = 1.0  &
   side_count_for_body = 20  &
   segment_count_for_ends = 20
!
part attributes  &
   part_name = .net_ball.vlnk_3_7  &
   color = RED  &
   name_visibility = off
!
!---------------------------------- vlnk_3_8 ----------------------------------!
!
!
defaults coordinate_system  &
   default_coordinate_system = .net_ball.ground
!
part create rigid_body name_and_position  &
   part_name = .net_ball.vlnk_3_8  &
   adams_id = 128  &
   location = 0.0, 0.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
defaults coordinate_system  &
   default_coordinate_system = .net_ball.vlnk_3_8
!
! ****** Markers for current part ******
!
marker create  &
   marker_name = .net_ball.vlnk_3_8.cntMar  &
   adams_id = 1230  &
   location = -75.0, -175.0, 0.0  &
   orientation = 0.0d, 90.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_3_8.cm  &
   adams_id = 1231  &
   location = -75.0, -200.0, 0.0  &
   orientation = 0.0d, 90.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_3_8.endMar  &
   adams_id = 1232  &
   location = -75.0, -225.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_3_8.cmMar  &
   adams_id = 1233  &
   location = -75.0, -200.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_3_8.MARKER_116  &
   adams_id = 116  &
   location = -100.0, -175.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_3_8.MARKER_120  &
   adams_id = 120  &
   location = -100.0, -225.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_3_8.MARKER_154  &
   adams_id = 154  &
   location = -75.0, -175.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_3_8.MARKER_158  &
   adams_id = 158  &
   location = -75.0, -225.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_3_8.MARKER_501  &
   adams_id = 501  &
   location = -75.0, -200.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_3_8.MARKER_503  &
   adams_id = 503  &
   location = -75.0, -225.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
part create rigid_body mass_properties  &
   part_name = .net_ball.vlnk_3_8  &
   material_type = .net_ball.aluminum
!
! ****** Graphics for current part ******
!
geometry create shape cylinder  &
   cylinder_name = .net_ball.vlnk_3_8.cyl  &
   adams_id = 313  &
   center_marker = .net_ball.vlnk_3_8.cntMar  &
   angle_extent = 360.0  &
   length = 50.0  &
   radius = 1.0  &
   side_count_for_body = 20  &
   segment_count_for_ends = 20
!
part attributes  &
   part_name = .net_ball.vlnk_3_8  &
   color = RED  &
   name_visibility = off
!
!---------------------------------- vlnk_4_0 ----------------------------------!
!
!
defaults coordinate_system  &
   default_coordinate_system = .net_ball.ground
!
part create rigid_body name_and_position  &
   part_name = .net_ball.vlnk_4_0  &
   adams_id = 129  &
   location = 0.0, 0.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
defaults coordinate_system  &
   default_coordinate_system = .net_ball.vlnk_4_0
!
! ****** Markers for current part ******
!
marker create  &
   marker_name = .net_ball.vlnk_4_0.cntMar  &
   adams_id = 1234  &
   location = -25.0, 225.0, 0.0  &
   orientation = 0.0d, 90.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_4_0.cm  &
   adams_id = 1235  &
   location = -25.0, 200.0, 0.0  &
   orientation = 180.0d, 90.0d, 90.0d
!
marker create  &
   marker_name = .net_ball.vlnk_4_0.endMar  &
   adams_id = 1236  &
   location = -25.0, 175.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_4_0.cmMar  &
   adams_id = 1237  &
   location = -25.0, 200.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_4_0.MARKER_124  &
   adams_id = 124  &
   location = -50.0, 225.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_4_0.MARKER_162  &
   adams_id = 162  &
   location = -25.0, 225.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_4_0.MARKER_505  &
   adams_id = 505  &
   location = -25.0, 200.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_4_0.MARKER_507  &
   adams_id = 507  &
   location = -25.0, 175.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
part create rigid_body mass_properties  &
   part_name = .net_ball.vlnk_4_0  &
   material_type = .net_ball.aluminum
!
! ****** Graphics for current part ******
!
geometry create shape cylinder  &
   cylinder_name = .net_ball.vlnk_4_0.cyl  &
   adams_id = 314  &
   center_marker = .net_ball.vlnk_4_0.cntMar  &
   angle_extent = 360.0  &
   length = 50.0  &
   radius = 1.0  &
   side_count_for_body = 20  &
   segment_count_for_ends = 20
!
part attributes  &
   part_name = .net_ball.vlnk_4_0  &
   color = RED  &
   name_visibility = off
!
!---------------------------------- vlnk_4_1 ----------------------------------!
!
!
defaults coordinate_system  &
   default_coordinate_system = .net_ball.ground
!
part create rigid_body name_and_position  &
   part_name = .net_ball.vlnk_4_1  &
   adams_id = 130  &
   location = 0.0, 0.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
defaults coordinate_system  &
   default_coordinate_system = .net_ball.vlnk_4_1
!
! ****** Markers for current part ******
!
marker create  &
   marker_name = .net_ball.vlnk_4_1.cntMar  &
   adams_id = 1238  &
   location = -25.0, 175.0, 0.0  &
   orientation = 0.0d, 90.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_4_1.cm  &
   adams_id = 1239  &
   location = -25.0, 150.0, 0.0  &
   orientation = 0.0d, 90.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_4_1.endMar  &
   adams_id = 1240  &
   location = -25.0, 125.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_4_1.cmMar  &
   adams_id = 1241  &
   location = -25.0, 150.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_4_1.MARKER_128  &
   adams_id = 128  &
   location = -50.0, 175.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_4_1.MARKER_166  &
   adams_id = 166  &
   location = -25.0, 175.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_4_1.MARKER_509  &
   adams_id = 509  &
   location = -25.0, 150.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_4_1.MARKER_511  &
   adams_id = 511  &
   location = -25.0, 125.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
part create rigid_body mass_properties  &
   part_name = .net_ball.vlnk_4_1  &
   material_type = .net_ball.aluminum
!
! ****** Graphics for current part ******
!
geometry create shape cylinder  &
   cylinder_name = .net_ball.vlnk_4_1.cyl  &
   adams_id = 315  &
   center_marker = .net_ball.vlnk_4_1.cntMar  &
   angle_extent = 360.0  &
   length = 50.0  &
   radius = 1.0  &
   side_count_for_body = 20  &
   segment_count_for_ends = 20
!
part attributes  &
   part_name = .net_ball.vlnk_4_1  &
   color = RED  &
   name_visibility = off
!
!---------------------------------- vlnk_4_2 ----------------------------------!
!
!
defaults coordinate_system  &
   default_coordinate_system = .net_ball.ground
!
part create rigid_body name_and_position  &
   part_name = .net_ball.vlnk_4_2  &
   adams_id = 131  &
   location = 0.0, 0.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
defaults coordinate_system  &
   default_coordinate_system = .net_ball.vlnk_4_2
!
! ****** Markers for current part ******
!
marker create  &
   marker_name = .net_ball.vlnk_4_2.cntMar  &
   adams_id = 1242  &
   location = -25.0, 125.0, 0.0  &
   orientation = 0.0d, 90.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_4_2.cm  &
   adams_id = 1243  &
   location = -25.0, 100.0, 0.0  &
   orientation = 0.0d, 90.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_4_2.endMar  &
   adams_id = 1244  &
   location = -25.0, 75.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_4_2.cmMar  &
   adams_id = 1245  &
   location = -25.0, 100.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_4_2.MARKER_132  &
   adams_id = 132  &
   location = -50.0, 125.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_4_2.MARKER_170  &
   adams_id = 170  &
   location = -25.0, 125.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_4_2.MARKER_513  &
   adams_id = 513  &
   location = -25.0, 100.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_4_2.MARKER_515  &
   adams_id = 515  &
   location = -25.0, 75.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
part create rigid_body mass_properties  &
   part_name = .net_ball.vlnk_4_2  &
   material_type = .net_ball.aluminum
!
! ****** Graphics for current part ******
!
geometry create shape cylinder  &
   cylinder_name = .net_ball.vlnk_4_2.cyl  &
   adams_id = 316  &
   center_marker = .net_ball.vlnk_4_2.cntMar  &
   angle_extent = 360.0  &
   length = 50.0  &
   radius = 1.0  &
   side_count_for_body = 20  &
   segment_count_for_ends = 20
!
part attributes  &
   part_name = .net_ball.vlnk_4_2  &
   color = RED  &
   name_visibility = off
!
!---------------------------------- vlnk_4_3 ----------------------------------!
!
!
defaults coordinate_system  &
   default_coordinate_system = .net_ball.ground
!
part create rigid_body name_and_position  &
   part_name = .net_ball.vlnk_4_3  &
   adams_id = 132  &
   location = 0.0, 0.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
defaults coordinate_system  &
   default_coordinate_system = .net_ball.vlnk_4_3
!
! ****** Markers for current part ******
!
marker create  &
   marker_name = .net_ball.vlnk_4_3.cntMar  &
   adams_id = 1246  &
   location = -25.0, 75.0, 0.0  &
   orientation = 0.0d, 90.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_4_3.cm  &
   adams_id = 1247  &
   location = -25.0, 50.0, 0.0  &
   orientation = 180.0d, 90.0d, 90.0d
!
marker create  &
   marker_name = .net_ball.vlnk_4_3.endMar  &
   adams_id = 1248  &
   location = -25.0, 25.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_4_3.cmMar  &
   adams_id = 1249  &
   location = -25.0, 50.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_4_3.MARKER_136  &
   adams_id = 136  &
   location = -50.0, 75.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_4_3.MARKER_174  &
   adams_id = 174  &
   location = -25.0, 75.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_4_3.MARKER_517  &
   adams_id = 517  &
   location = -25.0, 50.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_4_3.MARKER_519  &
   adams_id = 519  &
   location = -25.0, 25.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
part create rigid_body mass_properties  &
   part_name = .net_ball.vlnk_4_3  &
   material_type = .net_ball.aluminum
!
! ****** Graphics for current part ******
!
geometry create shape cylinder  &
   cylinder_name = .net_ball.vlnk_4_3.cyl  &
   adams_id = 317  &
   center_marker = .net_ball.vlnk_4_3.cntMar  &
   angle_extent = 360.0  &
   length = 50.0  &
   radius = 1.0  &
   side_count_for_body = 20  &
   segment_count_for_ends = 20
!
part attributes  &
   part_name = .net_ball.vlnk_4_3  &
   color = RED  &
   name_visibility = off
!
!---------------------------------- vlnk_4_4 ----------------------------------!
!
!
defaults coordinate_system  &
   default_coordinate_system = .net_ball.ground
!
part create rigid_body name_and_position  &
   part_name = .net_ball.vlnk_4_4  &
   adams_id = 133  &
   location = 0.0, 0.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
defaults coordinate_system  &
   default_coordinate_system = .net_ball.vlnk_4_4
!
! ****** Markers for current part ******
!
marker create  &
   marker_name = .net_ball.vlnk_4_4.cntMar  &
   adams_id = 1250  &
   location = -25.0, 25.0, 0.0  &
   orientation = 0.0d, 90.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_4_4.cm  &
   adams_id = 1251  &
   location = -25.0, 0.0, 0.0  &
   orientation = 180.0d, 90.0d, 90.0d
!
marker create  &
   marker_name = .net_ball.vlnk_4_4.endMar  &
   adams_id = 1252  &
   location = -25.0, -25.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_4_4.cmMar  &
   adams_id = 1253  &
   location = -25.0, 0.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_4_4.MARKER_140  &
   adams_id = 140  &
   location = -50.0, 25.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_4_4.MARKER_178  &
   adams_id = 178  &
   location = -25.0, 25.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_4_4.MARKER_521  &
   adams_id = 521  &
   location = -25.0, 0.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_4_4.MARKER_523  &
   adams_id = 523  &
   location = -25.0, -25.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
part create rigid_body mass_properties  &
   part_name = .net_ball.vlnk_4_4  &
   material_type = .net_ball.aluminum
!
! ****** Graphics for current part ******
!
geometry create shape cylinder  &
   cylinder_name = .net_ball.vlnk_4_4.cyl  &
   adams_id = 318  &
   center_marker = .net_ball.vlnk_4_4.cntMar  &
   angle_extent = 360.0  &
   length = 50.0  &
   radius = 1.0  &
   side_count_for_body = 20  &
   segment_count_for_ends = 20
!
part attributes  &
   part_name = .net_ball.vlnk_4_4  &
   color = RED  &
   name_visibility = off
!
!---------------------------------- vlnk_4_5 ----------------------------------!
!
!
defaults coordinate_system  &
   default_coordinate_system = .net_ball.ground
!
part create rigid_body name_and_position  &
   part_name = .net_ball.vlnk_4_5  &
   adams_id = 134  &
   location = 0.0, 0.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
defaults coordinate_system  &
   default_coordinate_system = .net_ball.vlnk_4_5
!
! ****** Markers for current part ******
!
marker create  &
   marker_name = .net_ball.vlnk_4_5.cntMar  &
   adams_id = 1254  &
   location = -25.0, -25.0, 0.0  &
   orientation = 0.0d, 90.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_4_5.cm  &
   adams_id = 1255  &
   location = -25.0, -50.0, 0.0  &
   orientation = 180.0d, 90.0d, 90.0d
!
marker create  &
   marker_name = .net_ball.vlnk_4_5.endMar  &
   adams_id = 1256  &
   location = -25.0, -75.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_4_5.cmMar  &
   adams_id = 1257  &
   location = -25.0, -50.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_4_5.MARKER_144  &
   adams_id = 144  &
   location = -50.0, -25.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_4_5.MARKER_182  &
   adams_id = 182  &
   location = -25.0, -25.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_4_5.MARKER_525  &
   adams_id = 525  &
   location = -25.0, -50.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_4_5.MARKER_527  &
   adams_id = 527  &
   location = -25.0, -75.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
part create rigid_body mass_properties  &
   part_name = .net_ball.vlnk_4_5  &
   material_type = .net_ball.aluminum
!
! ****** Graphics for current part ******
!
geometry create shape cylinder  &
   cylinder_name = .net_ball.vlnk_4_5.cyl  &
   adams_id = 319  &
   center_marker = .net_ball.vlnk_4_5.cntMar  &
   angle_extent = 360.0  &
   length = 50.0  &
   radius = 1.0  &
   side_count_for_body = 20  &
   segment_count_for_ends = 20
!
part attributes  &
   part_name = .net_ball.vlnk_4_5  &
   color = RED  &
   name_visibility = off
!
!---------------------------------- vlnk_4_6 ----------------------------------!
!
!
defaults coordinate_system  &
   default_coordinate_system = .net_ball.ground
!
part create rigid_body name_and_position  &
   part_name = .net_ball.vlnk_4_6  &
   adams_id = 135  &
   location = 0.0, 0.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
defaults coordinate_system  &
   default_coordinate_system = .net_ball.vlnk_4_6
!
! ****** Markers for current part ******
!
marker create  &
   marker_name = .net_ball.vlnk_4_6.cntMar  &
   adams_id = 1258  &
   location = -25.0, -75.0, 0.0  &
   orientation = 0.0d, 90.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_4_6.cm  &
   adams_id = 1259  &
   location = -25.0, -100.0, 0.0  &
   orientation = 180.0d, 90.0d, 90.0d
!
marker create  &
   marker_name = .net_ball.vlnk_4_6.endMar  &
   adams_id = 1260  &
   location = -25.0, -125.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_4_6.cmMar  &
   adams_id = 1261  &
   location = -25.0, -100.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_4_6.MARKER_148  &
   adams_id = 148  &
   location = -50.0, -75.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_4_6.MARKER_186  &
   adams_id = 186  &
   location = -25.0, -75.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_4_6.MARKER_529  &
   adams_id = 529  &
   location = -25.0, -100.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_4_6.MARKER_531  &
   adams_id = 531  &
   location = -25.0, -125.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
part create rigid_body mass_properties  &
   part_name = .net_ball.vlnk_4_6  &
   material_type = .net_ball.aluminum
!
! ****** Graphics for current part ******
!
geometry create shape cylinder  &
   cylinder_name = .net_ball.vlnk_4_6.cyl  &
   adams_id = 320  &
   center_marker = .net_ball.vlnk_4_6.cntMar  &
   angle_extent = 360.0  &
   length = 50.0  &
   radius = 1.0  &
   side_count_for_body = 20  &
   segment_count_for_ends = 20
!
part attributes  &
   part_name = .net_ball.vlnk_4_6  &
   color = RED  &
   name_visibility = off
!
!---------------------------------- vlnk_4_7 ----------------------------------!
!
!
defaults coordinate_system  &
   default_coordinate_system = .net_ball.ground
!
part create rigid_body name_and_position  &
   part_name = .net_ball.vlnk_4_7  &
   adams_id = 136  &
   location = 0.0, 0.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
defaults coordinate_system  &
   default_coordinate_system = .net_ball.vlnk_4_7
!
! ****** Markers for current part ******
!
marker create  &
   marker_name = .net_ball.vlnk_4_7.cntMar  &
   adams_id = 1262  &
   location = -25.0, -125.0, 0.0  &
   orientation = 0.0d, 90.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_4_7.cm  &
   adams_id = 1263  &
   location = -25.0, -150.0, 0.0  &
   orientation = 0.0d, 90.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_4_7.endMar  &
   adams_id = 1264  &
   location = -25.0, -175.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_4_7.cmMar  &
   adams_id = 1265  &
   location = -25.0, -150.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_4_7.MARKER_152  &
   adams_id = 152  &
   location = -50.0, -125.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_4_7.MARKER_190  &
   adams_id = 190  &
   location = -25.0, -125.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_4_7.MARKER_533  &
   adams_id = 533  &
   location = -25.0, -150.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_4_7.MARKER_535  &
   adams_id = 535  &
   location = -25.0, -175.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
part create rigid_body mass_properties  &
   part_name = .net_ball.vlnk_4_7  &
   material_type = .net_ball.aluminum
!
! ****** Graphics for current part ******
!
geometry create shape cylinder  &
   cylinder_name = .net_ball.vlnk_4_7.cyl  &
   adams_id = 321  &
   center_marker = .net_ball.vlnk_4_7.cntMar  &
   angle_extent = 360.0  &
   length = 50.0  &
   radius = 1.0  &
   side_count_for_body = 20  &
   segment_count_for_ends = 20
!
part attributes  &
   part_name = .net_ball.vlnk_4_7  &
   color = RED  &
   name_visibility = off
!
!---------------------------------- vlnk_4_8 ----------------------------------!
!
!
defaults coordinate_system  &
   default_coordinate_system = .net_ball.ground
!
part create rigid_body name_and_position  &
   part_name = .net_ball.vlnk_4_8  &
   adams_id = 137  &
   location = 0.0, 0.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
defaults coordinate_system  &
   default_coordinate_system = .net_ball.vlnk_4_8
!
! ****** Markers for current part ******
!
marker create  &
   marker_name = .net_ball.vlnk_4_8.cntMar  &
   adams_id = 1266  &
   location = -25.0, -175.0, 0.0  &
   orientation = 0.0d, 90.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_4_8.cm  &
   adams_id = 1267  &
   location = -25.0, -200.0, 0.0  &
   orientation = 0.0d, 90.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_4_8.endMar  &
   adams_id = 1268  &
   location = -25.0, -225.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_4_8.cmMar  &
   adams_id = 1269  &
   location = -25.0, -200.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_4_8.MARKER_156  &
   adams_id = 156  &
   location = -50.0, -175.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_4_8.MARKER_160  &
   adams_id = 160  &
   location = -50.0, -225.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_4_8.MARKER_194  &
   adams_id = 194  &
   location = -25.0, -175.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_4_8.MARKER_198  &
   adams_id = 198  &
   location = -25.0, -225.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_4_8.MARKER_537  &
   adams_id = 537  &
   location = -25.0, -200.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_4_8.MARKER_539  &
   adams_id = 539  &
   location = -25.0, -225.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
part create rigid_body mass_properties  &
   part_name = .net_ball.vlnk_4_8  &
   material_type = .net_ball.aluminum
!
! ****** Graphics for current part ******
!
geometry create shape cylinder  &
   cylinder_name = .net_ball.vlnk_4_8.cyl  &
   adams_id = 322  &
   center_marker = .net_ball.vlnk_4_8.cntMar  &
   angle_extent = 360.0  &
   length = 50.0  &
   radius = 1.0  &
   side_count_for_body = 20  &
   segment_count_for_ends = 20
!
part attributes  &
   part_name = .net_ball.vlnk_4_8  &
   color = RED  &
   name_visibility = off
!
!---------------------------------- vlnk_5_0 ----------------------------------!
!
!
defaults coordinate_system  &
   default_coordinate_system = .net_ball.ground
!
part create rigid_body name_and_position  &
   part_name = .net_ball.vlnk_5_0  &
   adams_id = 138  &
   location = 0.0, 0.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
defaults coordinate_system  &
   default_coordinate_system = .net_ball.vlnk_5_0
!
! ****** Markers for current part ******
!
marker create  &
   marker_name = .net_ball.vlnk_5_0.cntMar  &
   adams_id = 1270  &
   location = 25.0, 225.0, 0.0  &
   orientation = 0.0d, 90.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_5_0.cm  &
   adams_id = 1271  &
   location = 25.0, 200.0, 0.0  &
   orientation = 180.0d, 90.0d, 90.0d
!
marker create  &
   marker_name = .net_ball.vlnk_5_0.endMar  &
   adams_id = 1272  &
   location = 25.0, 175.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_5_0.cmMar  &
   adams_id = 1273  &
   location = 25.0, 200.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_5_0.MARKER_164  &
   adams_id = 164  &
   location = 0.0, 225.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_5_0.MARKER_202  &
   adams_id = 202  &
   location = 25.0, 225.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_5_0.MARKER_541  &
   adams_id = 541  &
   location = 25.0, 200.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_5_0.MARKER_543  &
   adams_id = 543  &
   location = 25.0, 175.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
part create rigid_body mass_properties  &
   part_name = .net_ball.vlnk_5_0  &
   material_type = .net_ball.aluminum
!
! ****** Graphics for current part ******
!
geometry create shape cylinder  &
   cylinder_name = .net_ball.vlnk_5_0.cyl  &
   adams_id = 323  &
   center_marker = .net_ball.vlnk_5_0.cntMar  &
   angle_extent = 360.0  &
   length = 50.0  &
   radius = 1.0  &
   side_count_for_body = 20  &
   segment_count_for_ends = 20
!
part attributes  &
   part_name = .net_ball.vlnk_5_0  &
   color = RED  &
   name_visibility = off
!
!---------------------------------- vlnk_5_1 ----------------------------------!
!
!
defaults coordinate_system  &
   default_coordinate_system = .net_ball.ground
!
part create rigid_body name_and_position  &
   part_name = .net_ball.vlnk_5_1  &
   adams_id = 139  &
   location = 0.0, 0.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
defaults coordinate_system  &
   default_coordinate_system = .net_ball.vlnk_5_1
!
! ****** Markers for current part ******
!
marker create  &
   marker_name = .net_ball.vlnk_5_1.cntMar  &
   adams_id = 1274  &
   location = 25.0, 175.0, 0.0  &
   orientation = 0.0d, 90.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_5_1.cm  &
   adams_id = 1275  &
   location = 25.0, 150.0, 0.0  &
   orientation = 0.0d, 90.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_5_1.endMar  &
   adams_id = 1276  &
   location = 25.0, 125.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_5_1.cmMar  &
   adams_id = 1277  &
   location = 25.0, 150.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_5_1.MARKER_168  &
   adams_id = 168  &
   location = 0.0, 175.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_5_1.MARKER_206  &
   adams_id = 206  &
   location = 25.0, 175.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_5_1.MARKER_545  &
   adams_id = 545  &
   location = 25.0, 150.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_5_1.MARKER_547  &
   adams_id = 547  &
   location = 25.0, 125.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
part create rigid_body mass_properties  &
   part_name = .net_ball.vlnk_5_1  &
   material_type = .net_ball.aluminum
!
! ****** Graphics for current part ******
!
geometry create shape cylinder  &
   cylinder_name = .net_ball.vlnk_5_1.cyl  &
   adams_id = 324  &
   center_marker = .net_ball.vlnk_5_1.cntMar  &
   angle_extent = 360.0  &
   length = 50.0  &
   radius = 1.0  &
   side_count_for_body = 20  &
   segment_count_for_ends = 20
!
part attributes  &
   part_name = .net_ball.vlnk_5_1  &
   color = RED  &
   name_visibility = off
!
!---------------------------------- vlnk_5_2 ----------------------------------!
!
!
defaults coordinate_system  &
   default_coordinate_system = .net_ball.ground
!
part create rigid_body name_and_position  &
   part_name = .net_ball.vlnk_5_2  &
   adams_id = 140  &
   location = 0.0, 0.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
defaults coordinate_system  &
   default_coordinate_system = .net_ball.vlnk_5_2
!
! ****** Markers for current part ******
!
marker create  &
   marker_name = .net_ball.vlnk_5_2.cntMar  &
   adams_id = 1278  &
   location = 25.0, 125.0, 0.0  &
   orientation = 0.0d, 90.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_5_2.cm  &
   adams_id = 1279  &
   location = 25.0, 100.0, 0.0  &
   orientation = 0.0d, 90.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_5_2.endMar  &
   adams_id = 1280  &
   location = 25.0, 75.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_5_2.cmMar  &
   adams_id = 1281  &
   location = 25.0, 100.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_5_2.MARKER_172  &
   adams_id = 172  &
   location = 0.0, 125.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_5_2.MARKER_210  &
   adams_id = 210  &
   location = 25.0, 125.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_5_2.MARKER_549  &
   adams_id = 549  &
   location = 25.0, 100.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_5_2.MARKER_551  &
   adams_id = 551  &
   location = 25.0, 75.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
part create rigid_body mass_properties  &
   part_name = .net_ball.vlnk_5_2  &
   material_type = .net_ball.aluminum
!
! ****** Graphics for current part ******
!
geometry create shape cylinder  &
   cylinder_name = .net_ball.vlnk_5_2.cyl  &
   adams_id = 325  &
   center_marker = .net_ball.vlnk_5_2.cntMar  &
   angle_extent = 360.0  &
   length = 50.0  &
   radius = 1.0  &
   side_count_for_body = 20  &
   segment_count_for_ends = 20
!
part attributes  &
   part_name = .net_ball.vlnk_5_2  &
   color = RED  &
   name_visibility = off
!
!---------------------------------- vlnk_5_3 ----------------------------------!
!
!
defaults coordinate_system  &
   default_coordinate_system = .net_ball.ground
!
part create rigid_body name_and_position  &
   part_name = .net_ball.vlnk_5_3  &
   adams_id = 141  &
   location = 0.0, 0.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
defaults coordinate_system  &
   default_coordinate_system = .net_ball.vlnk_5_3
!
! ****** Markers for current part ******
!
marker create  &
   marker_name = .net_ball.vlnk_5_3.cntMar  &
   adams_id = 1282  &
   location = 25.0, 75.0, 0.0  &
   orientation = 0.0d, 90.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_5_3.cm  &
   adams_id = 1283  &
   location = 25.0, 50.0, 0.0  &
   orientation = 180.0d, 90.0d, 90.0d
!
marker create  &
   marker_name = .net_ball.vlnk_5_3.endMar  &
   adams_id = 1284  &
   location = 25.0, 25.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_5_3.cmMar  &
   adams_id = 1285  &
   location = 25.0, 50.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_5_3.MARKER_176  &
   adams_id = 176  &
   location = 0.0, 75.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_5_3.MARKER_214  &
   adams_id = 214  &
   location = 25.0, 75.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_5_3.MARKER_553  &
   adams_id = 553  &
   location = 25.0, 50.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_5_3.MARKER_555  &
   adams_id = 555  &
   location = 25.0, 25.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
part create rigid_body mass_properties  &
   part_name = .net_ball.vlnk_5_3  &
   material_type = .net_ball.aluminum
!
! ****** Graphics for current part ******
!
geometry create shape cylinder  &
   cylinder_name = .net_ball.vlnk_5_3.cyl  &
   adams_id = 326  &
   center_marker = .net_ball.vlnk_5_3.cntMar  &
   angle_extent = 360.0  &
   length = 50.0  &
   radius = 1.0  &
   side_count_for_body = 20  &
   segment_count_for_ends = 20
!
part attributes  &
   part_name = .net_ball.vlnk_5_3  &
   color = RED  &
   name_visibility = off
!
!---------------------------------- vlnk_5_4 ----------------------------------!
!
!
defaults coordinate_system  &
   default_coordinate_system = .net_ball.ground
!
part create rigid_body name_and_position  &
   part_name = .net_ball.vlnk_5_4  &
   adams_id = 142  &
   location = 0.0, 0.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
defaults coordinate_system  &
   default_coordinate_system = .net_ball.vlnk_5_4
!
! ****** Markers for current part ******
!
marker create  &
   marker_name = .net_ball.vlnk_5_4.cntMar  &
   adams_id = 1286  &
   location = 25.0, 25.0, 0.0  &
   orientation = 0.0d, 90.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_5_4.cm  &
   adams_id = 1287  &
   location = 25.0, 0.0, 0.0  &
   orientation = 180.0d, 90.0d, 90.0d
!
marker create  &
   marker_name = .net_ball.vlnk_5_4.endMar  &
   adams_id = 1288  &
   location = 25.0, -25.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_5_4.cmMar  &
   adams_id = 1289  &
   location = 25.0, 0.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_5_4.MARKER_180  &
   adams_id = 180  &
   location = 0.0, 25.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_5_4.MARKER_218  &
   adams_id = 218  &
   location = 25.0, 25.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_5_4.MARKER_557  &
   adams_id = 557  &
   location = 25.0, 0.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_5_4.MARKER_559  &
   adams_id = 559  &
   location = 25.0, -25.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
part create rigid_body mass_properties  &
   part_name = .net_ball.vlnk_5_4  &
   material_type = .net_ball.aluminum
!
! ****** Graphics for current part ******
!
geometry create shape cylinder  &
   cylinder_name = .net_ball.vlnk_5_4.cyl  &
   adams_id = 327  &
   center_marker = .net_ball.vlnk_5_4.cntMar  &
   angle_extent = 360.0  &
   length = 50.0  &
   radius = 1.0  &
   side_count_for_body = 20  &
   segment_count_for_ends = 20
!
part attributes  &
   part_name = .net_ball.vlnk_5_4  &
   color = RED  &
   name_visibility = off
!
!---------------------------------- vlnk_5_5 ----------------------------------!
!
!
defaults coordinate_system  &
   default_coordinate_system = .net_ball.ground
!
part create rigid_body name_and_position  &
   part_name = .net_ball.vlnk_5_5  &
   adams_id = 143  &
   location = 0.0, 0.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
defaults coordinate_system  &
   default_coordinate_system = .net_ball.vlnk_5_5
!
! ****** Markers for current part ******
!
marker create  &
   marker_name = .net_ball.vlnk_5_5.cntMar  &
   adams_id = 1290  &
   location = 25.0, -25.0, 0.0  &
   orientation = 0.0d, 90.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_5_5.cm  &
   adams_id = 1291  &
   location = 25.0, -50.0, 0.0  &
   orientation = 180.0d, 90.0d, 90.0d
!
marker create  &
   marker_name = .net_ball.vlnk_5_5.endMar  &
   adams_id = 1292  &
   location = 25.0, -75.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_5_5.cmMar  &
   adams_id = 1293  &
   location = 25.0, -50.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_5_5.MARKER_184  &
   adams_id = 184  &
   location = 0.0, -25.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_5_5.MARKER_222  &
   adams_id = 222  &
   location = 25.0, -25.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_5_5.MARKER_561  &
   adams_id = 561  &
   location = 25.0, -50.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_5_5.MARKER_563  &
   adams_id = 563  &
   location = 25.0, -75.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
part create rigid_body mass_properties  &
   part_name = .net_ball.vlnk_5_5  &
   material_type = .net_ball.aluminum
!
! ****** Graphics for current part ******
!
geometry create shape cylinder  &
   cylinder_name = .net_ball.vlnk_5_5.cyl  &
   adams_id = 328  &
   center_marker = .net_ball.vlnk_5_5.cntMar  &
   angle_extent = 360.0  &
   length = 50.0  &
   radius = 1.0  &
   side_count_for_body = 20  &
   segment_count_for_ends = 20
!
part attributes  &
   part_name = .net_ball.vlnk_5_5  &
   color = RED  &
   name_visibility = off
!
!---------------------------------- vlnk_5_6 ----------------------------------!
!
!
defaults coordinate_system  &
   default_coordinate_system = .net_ball.ground
!
part create rigid_body name_and_position  &
   part_name = .net_ball.vlnk_5_6  &
   adams_id = 144  &
   location = 0.0, 0.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
defaults coordinate_system  &
   default_coordinate_system = .net_ball.vlnk_5_6
!
! ****** Markers for current part ******
!
marker create  &
   marker_name = .net_ball.vlnk_5_6.cntMar  &
   adams_id = 1294  &
   location = 25.0, -75.0, 0.0  &
   orientation = 0.0d, 90.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_5_6.cm  &
   adams_id = 1295  &
   location = 25.0, -100.0, 0.0  &
   orientation = 180.0d, 90.0d, 90.0d
!
marker create  &
   marker_name = .net_ball.vlnk_5_6.endMar  &
   adams_id = 1296  &
   location = 25.0, -125.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_5_6.cmMar  &
   adams_id = 1297  &
   location = 25.0, -100.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_5_6.MARKER_188  &
   adams_id = 188  &
   location = 0.0, -75.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_5_6.MARKER_226  &
   adams_id = 226  &
   location = 25.0, -75.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_5_6.MARKER_565  &
   adams_id = 565  &
   location = 25.0, -100.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_5_6.MARKER_567  &
   adams_id = 567  &
   location = 25.0, -125.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
part create rigid_body mass_properties  &
   part_name = .net_ball.vlnk_5_6  &
   material_type = .net_ball.aluminum
!
! ****** Graphics for current part ******
!
geometry create shape cylinder  &
   cylinder_name = .net_ball.vlnk_5_6.cyl  &
   adams_id = 329  &
   center_marker = .net_ball.vlnk_5_6.cntMar  &
   angle_extent = 360.0  &
   length = 50.0  &
   radius = 1.0  &
   side_count_for_body = 20  &
   segment_count_for_ends = 20
!
part attributes  &
   part_name = .net_ball.vlnk_5_6  &
   color = RED  &
   name_visibility = off
!
!---------------------------------- vlnk_5_7 ----------------------------------!
!
!
defaults coordinate_system  &
   default_coordinate_system = .net_ball.ground
!
part create rigid_body name_and_position  &
   part_name = .net_ball.vlnk_5_7  &
   adams_id = 145  &
   location = 0.0, 0.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
defaults coordinate_system  &
   default_coordinate_system = .net_ball.vlnk_5_7
!
! ****** Markers for current part ******
!
marker create  &
   marker_name = .net_ball.vlnk_5_7.cntMar  &
   adams_id = 1298  &
   location = 25.0, -125.0, 0.0  &
   orientation = 0.0d, 90.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_5_7.cm  &
   adams_id = 1299  &
   location = 25.0, -150.0, 0.0  &
   orientation = 0.0d, 90.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_5_7.endMar  &
   adams_id = 1300  &
   location = 25.0, -175.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_5_7.cmMar  &
   adams_id = 1301  &
   location = 25.0, -150.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_5_7.MARKER_192  &
   adams_id = 192  &
   location = 0.0, -125.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_5_7.MARKER_230  &
   adams_id = 230  &
   location = 25.0, -125.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_5_7.MARKER_569  &
   adams_id = 569  &
   location = 25.0, -150.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_5_7.MARKER_571  &
   adams_id = 571  &
   location = 25.0, -175.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
part create rigid_body mass_properties  &
   part_name = .net_ball.vlnk_5_7  &
   material_type = .net_ball.aluminum
!
! ****** Graphics for current part ******
!
geometry create shape cylinder  &
   cylinder_name = .net_ball.vlnk_5_7.cyl  &
   adams_id = 330  &
   center_marker = .net_ball.vlnk_5_7.cntMar  &
   angle_extent = 360.0  &
   length = 50.0  &
   radius = 1.0  &
   side_count_for_body = 20  &
   segment_count_for_ends = 20
!
part attributes  &
   part_name = .net_ball.vlnk_5_7  &
   color = RED  &
   name_visibility = off
!
!---------------------------------- vlnk_5_8 ----------------------------------!
!
!
defaults coordinate_system  &
   default_coordinate_system = .net_ball.ground
!
part create rigid_body name_and_position  &
   part_name = .net_ball.vlnk_5_8  &
   adams_id = 146  &
   location = 0.0, 0.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
defaults coordinate_system  &
   default_coordinate_system = .net_ball.vlnk_5_8
!
! ****** Markers for current part ******
!
marker create  &
   marker_name = .net_ball.vlnk_5_8.cntMar  &
   adams_id = 1302  &
   location = 25.0, -175.0, 0.0  &
   orientation = 0.0d, 90.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_5_8.cm  &
   adams_id = 1303  &
   location = 25.0, -200.0, 0.0  &
   orientation = 0.0d, 90.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_5_8.endMar  &
   adams_id = 1304  &
   location = 25.0, -225.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_5_8.cmMar  &
   adams_id = 1305  &
   location = 25.0, -200.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_5_8.MARKER_196  &
   adams_id = 196  &
   location = 0.0, -175.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_5_8.MARKER_200  &
   adams_id = 200  &
   location = 0.0, -225.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_5_8.MARKER_234  &
   adams_id = 234  &
   location = 25.0, -175.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_5_8.MARKER_238  &
   adams_id = 238  &
   location = 25.0, -225.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_5_8.MARKER_573  &
   adams_id = 573  &
   location = 25.0, -200.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_5_8.MARKER_575  &
   adams_id = 575  &
   location = 25.0, -225.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
part create rigid_body mass_properties  &
   part_name = .net_ball.vlnk_5_8  &
   material_type = .net_ball.aluminum
!
! ****** Graphics for current part ******
!
geometry create shape cylinder  &
   cylinder_name = .net_ball.vlnk_5_8.cyl  &
   adams_id = 331  &
   center_marker = .net_ball.vlnk_5_8.cntMar  &
   angle_extent = 360.0  &
   length = 50.0  &
   radius = 1.0  &
   side_count_for_body = 20  &
   segment_count_for_ends = 20
!
part attributes  &
   part_name = .net_ball.vlnk_5_8  &
   color = RED  &
   name_visibility = off
!
!---------------------------------- vlnk_6_0 ----------------------------------!
!
!
defaults coordinate_system  &
   default_coordinate_system = .net_ball.ground
!
part create rigid_body name_and_position  &
   part_name = .net_ball.vlnk_6_0  &
   adams_id = 147  &
   location = 0.0, 0.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
defaults coordinate_system  &
   default_coordinate_system = .net_ball.vlnk_6_0
!
! ****** Markers for current part ******
!
marker create  &
   marker_name = .net_ball.vlnk_6_0.cntMar  &
   adams_id = 1306  &
   location = 75.0, 225.0, 0.0  &
   orientation = 0.0d, 90.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_6_0.cm  &
   adams_id = 1307  &
   location = 75.0, 200.0, 0.0  &
   orientation = 180.0d, 90.0d, 90.0d
!
marker create  &
   marker_name = .net_ball.vlnk_6_0.endMar  &
   adams_id = 1308  &
   location = 75.0, 175.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_6_0.cmMar  &
   adams_id = 1309  &
   location = 75.0, 200.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_6_0.MARKER_204  &
   adams_id = 204  &
   location = 50.0, 225.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_6_0.MARKER_242  &
   adams_id = 242  &
   location = 75.0, 225.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_6_0.MARKER_577  &
   adams_id = 577  &
   location = 75.0, 200.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_6_0.MARKER_579  &
   adams_id = 579  &
   location = 75.0, 175.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
part create rigid_body mass_properties  &
   part_name = .net_ball.vlnk_6_0  &
   material_type = .net_ball.aluminum
!
! ****** Graphics for current part ******
!
geometry create shape cylinder  &
   cylinder_name = .net_ball.vlnk_6_0.cyl  &
   adams_id = 332  &
   center_marker = .net_ball.vlnk_6_0.cntMar  &
   angle_extent = 360.0  &
   length = 50.0  &
   radius = 1.0  &
   side_count_for_body = 20  &
   segment_count_for_ends = 20
!
part attributes  &
   part_name = .net_ball.vlnk_6_0  &
   color = RED  &
   name_visibility = off
!
!---------------------------------- vlnk_6_1 ----------------------------------!
!
!
defaults coordinate_system  &
   default_coordinate_system = .net_ball.ground
!
part create rigid_body name_and_position  &
   part_name = .net_ball.vlnk_6_1  &
   adams_id = 148  &
   location = 0.0, 0.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
defaults coordinate_system  &
   default_coordinate_system = .net_ball.vlnk_6_1
!
! ****** Markers for current part ******
!
marker create  &
   marker_name = .net_ball.vlnk_6_1.cntMar  &
   adams_id = 1310  &
   location = 75.0, 175.0, 0.0  &
   orientation = 0.0d, 90.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_6_1.cm  &
   adams_id = 1311  &
   location = 75.0, 150.0, 0.0  &
   orientation = 180.0d, 90.0d, 90.0d
!
marker create  &
   marker_name = .net_ball.vlnk_6_1.endMar  &
   adams_id = 1312  &
   location = 75.0, 125.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_6_1.cmMar  &
   adams_id = 1313  &
   location = 75.0, 150.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_6_1.MARKER_208  &
   adams_id = 208  &
   location = 50.0, 175.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_6_1.MARKER_246  &
   adams_id = 246  &
   location = 75.0, 175.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_6_1.MARKER_581  &
   adams_id = 581  &
   location = 75.0, 150.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_6_1.MARKER_583  &
   adams_id = 583  &
   location = 75.0, 125.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
part create rigid_body mass_properties  &
   part_name = .net_ball.vlnk_6_1  &
   material_type = .net_ball.aluminum
!
! ****** Graphics for current part ******
!
geometry create shape cylinder  &
   cylinder_name = .net_ball.vlnk_6_1.cyl  &
   adams_id = 333  &
   center_marker = .net_ball.vlnk_6_1.cntMar  &
   angle_extent = 360.0  &
   length = 50.0  &
   radius = 1.0  &
   side_count_for_body = 20  &
   segment_count_for_ends = 20
!
part attributes  &
   part_name = .net_ball.vlnk_6_1  &
   color = RED  &
   name_visibility = off
!
!---------------------------------- vlnk_6_2 ----------------------------------!
!
!
defaults coordinate_system  &
   default_coordinate_system = .net_ball.ground
!
part create rigid_body name_and_position  &
   part_name = .net_ball.vlnk_6_2  &
   adams_id = 149  &
   location = 0.0, 0.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
defaults coordinate_system  &
   default_coordinate_system = .net_ball.vlnk_6_2
!
! ****** Markers for current part ******
!
marker create  &
   marker_name = .net_ball.vlnk_6_2.cntMar  &
   adams_id = 1314  &
   location = 75.0, 125.0, 0.0  &
   orientation = 0.0d, 90.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_6_2.cm  &
   adams_id = 1315  &
   location = 75.0, 100.0, 0.0  &
   orientation = 180.0d, 90.0d, 90.0d
!
marker create  &
   marker_name = .net_ball.vlnk_6_2.endMar  &
   adams_id = 1316  &
   location = 75.0, 75.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_6_2.cmMar  &
   adams_id = 1317  &
   location = 75.0, 100.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_6_2.MARKER_212  &
   adams_id = 212  &
   location = 50.0, 125.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_6_2.MARKER_250  &
   adams_id = 250  &
   location = 75.0, 125.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_6_2.MARKER_585  &
   adams_id = 585  &
   location = 75.0, 100.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_6_2.MARKER_587  &
   adams_id = 587  &
   location = 75.0, 75.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
part create rigid_body mass_properties  &
   part_name = .net_ball.vlnk_6_2  &
   material_type = .net_ball.aluminum
!
! ****** Graphics for current part ******
!
geometry create shape cylinder  &
   cylinder_name = .net_ball.vlnk_6_2.cyl  &
   adams_id = 334  &
   center_marker = .net_ball.vlnk_6_2.cntMar  &
   angle_extent = 360.0  &
   length = 50.0  &
   radius = 1.0  &
   side_count_for_body = 20  &
   segment_count_for_ends = 20
!
part attributes  &
   part_name = .net_ball.vlnk_6_2  &
   color = RED  &
   name_visibility = off
!
!---------------------------------- vlnk_6_3 ----------------------------------!
!
!
defaults coordinate_system  &
   default_coordinate_system = .net_ball.ground
!
part create rigid_body name_and_position  &
   part_name = .net_ball.vlnk_6_3  &
   adams_id = 150  &
   location = 0.0, 0.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
defaults coordinate_system  &
   default_coordinate_system = .net_ball.vlnk_6_3
!
! ****** Markers for current part ******
!
marker create  &
   marker_name = .net_ball.vlnk_6_3.cntMar  &
   adams_id = 1318  &
   location = 75.0, 75.0, 0.0  &
   orientation = 0.0d, 90.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_6_3.cm  &
   adams_id = 1319  &
   location = 75.0, 50.0, 0.0  &
   orientation = 180.0d, 90.0d, 90.0d
!
marker create  &
   marker_name = .net_ball.vlnk_6_3.endMar  &
   adams_id = 1320  &
   location = 75.0, 25.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_6_3.cmMar  &
   adams_id = 1321  &
   location = 75.0, 50.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_6_3.MARKER_216  &
   adams_id = 216  &
   location = 50.0, 75.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_6_3.MARKER_254  &
   adams_id = 254  &
   location = 75.0, 75.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_6_3.MARKER_589  &
   adams_id = 589  &
   location = 75.0, 50.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_6_3.MARKER_591  &
   adams_id = 591  &
   location = 75.0, 25.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
part create rigid_body mass_properties  &
   part_name = .net_ball.vlnk_6_3  &
   material_type = .net_ball.aluminum
!
! ****** Graphics for current part ******
!
geometry create shape cylinder  &
   cylinder_name = .net_ball.vlnk_6_3.cyl  &
   adams_id = 335  &
   center_marker = .net_ball.vlnk_6_3.cntMar  &
   angle_extent = 360.0  &
   length = 50.0  &
   radius = 1.0  &
   side_count_for_body = 20  &
   segment_count_for_ends = 20
!
part attributes  &
   part_name = .net_ball.vlnk_6_3  &
   color = RED  &
   name_visibility = off
!
!---------------------------------- vlnk_6_4 ----------------------------------!
!
!
defaults coordinate_system  &
   default_coordinate_system = .net_ball.ground
!
part create rigid_body name_and_position  &
   part_name = .net_ball.vlnk_6_4  &
   adams_id = 151  &
   location = 0.0, 0.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
defaults coordinate_system  &
   default_coordinate_system = .net_ball.vlnk_6_4
!
! ****** Markers for current part ******
!
marker create  &
   marker_name = .net_ball.vlnk_6_4.cntMar  &
   adams_id = 1322  &
   location = 75.0, 25.0, 0.0  &
   orientation = 0.0d, 90.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_6_4.cm  &
   adams_id = 1323  &
   location = 75.0, 0.0, 0.0  &
   orientation = 180.0d, 90.0d, 90.0d
!
marker create  &
   marker_name = .net_ball.vlnk_6_4.endMar  &
   adams_id = 1324  &
   location = 75.0, -25.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_6_4.cmMar  &
   adams_id = 1325  &
   location = 75.0, 0.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_6_4.MARKER_220  &
   adams_id = 220  &
   location = 50.0, 25.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_6_4.MARKER_258  &
   adams_id = 258  &
   location = 75.0, 25.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_6_4.MARKER_593  &
   adams_id = 593  &
   location = 75.0, 0.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_6_4.MARKER_595  &
   adams_id = 595  &
   location = 75.0, -25.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
part create rigid_body mass_properties  &
   part_name = .net_ball.vlnk_6_4  &
   material_type = .net_ball.aluminum
!
! ****** Graphics for current part ******
!
geometry create shape cylinder  &
   cylinder_name = .net_ball.vlnk_6_4.cyl  &
   adams_id = 336  &
   center_marker = .net_ball.vlnk_6_4.cntMar  &
   angle_extent = 360.0  &
   length = 50.0  &
   radius = 1.0  &
   side_count_for_body = 20  &
   segment_count_for_ends = 20
!
part attributes  &
   part_name = .net_ball.vlnk_6_4  &
   color = RED  &
   name_visibility = off
!
!---------------------------------- vlnk_6_5 ----------------------------------!
!
!
defaults coordinate_system  &
   default_coordinate_system = .net_ball.ground
!
part create rigid_body name_and_position  &
   part_name = .net_ball.vlnk_6_5  &
   adams_id = 152  &
   location = 0.0, 0.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
defaults coordinate_system  &
   default_coordinate_system = .net_ball.vlnk_6_5
!
! ****** Markers for current part ******
!
marker create  &
   marker_name = .net_ball.vlnk_6_5.cntMar  &
   adams_id = 1326  &
   location = 75.0, -25.0, 0.0  &
   orientation = 0.0d, 90.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_6_5.cm  &
   adams_id = 1327  &
   location = 75.0, -50.0, 0.0  &
   orientation = 180.0d, 90.0d, 90.0d
!
marker create  &
   marker_name = .net_ball.vlnk_6_5.endMar  &
   adams_id = 1328  &
   location = 75.0, -75.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_6_5.cmMar  &
   adams_id = 1329  &
   location = 75.0, -50.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_6_5.MARKER_224  &
   adams_id = 224  &
   location = 50.0, -25.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_6_5.MARKER_262  &
   adams_id = 262  &
   location = 75.0, -25.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_6_5.MARKER_597  &
   adams_id = 597  &
   location = 75.0, -50.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_6_5.MARKER_599  &
   adams_id = 599  &
   location = 75.0, -75.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
part create rigid_body mass_properties  &
   part_name = .net_ball.vlnk_6_5  &
   material_type = .net_ball.aluminum
!
! ****** Graphics for current part ******
!
geometry create shape cylinder  &
   cylinder_name = .net_ball.vlnk_6_5.cyl  &
   adams_id = 337  &
   center_marker = .net_ball.vlnk_6_5.cntMar  &
   angle_extent = 360.0  &
   length = 50.0  &
   radius = 1.0  &
   side_count_for_body = 20  &
   segment_count_for_ends = 20
!
part attributes  &
   part_name = .net_ball.vlnk_6_5  &
   color = RED  &
   name_visibility = off
!
!---------------------------------- vlnk_6_6 ----------------------------------!
!
!
defaults coordinate_system  &
   default_coordinate_system = .net_ball.ground
!
part create rigid_body name_and_position  &
   part_name = .net_ball.vlnk_6_6  &
   adams_id = 153  &
   location = 0.0, 0.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
defaults coordinate_system  &
   default_coordinate_system = .net_ball.vlnk_6_6
!
! ****** Markers for current part ******
!
marker create  &
   marker_name = .net_ball.vlnk_6_6.cntMar  &
   adams_id = 1330  &
   location = 75.0, -75.0, 0.0  &
   orientation = 0.0d, 90.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_6_6.cm  &
   adams_id = 1331  &
   location = 75.0, -100.0, 0.0  &
   orientation = 0.0d, 90.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_6_6.endMar  &
   adams_id = 1332  &
   location = 75.0, -125.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_6_6.cmMar  &
   adams_id = 1333  &
   location = 75.0, -100.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_6_6.MARKER_228  &
   adams_id = 228  &
   location = 50.0, -75.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_6_6.MARKER_266  &
   adams_id = 266  &
   location = 75.0, -75.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_6_6.MARKER_601  &
   adams_id = 601  &
   location = 75.0, -100.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_6_6.MARKER_603  &
   adams_id = 603  &
   location = 75.0, -125.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
part create rigid_body mass_properties  &
   part_name = .net_ball.vlnk_6_6  &
   material_type = .net_ball.aluminum
!
! ****** Graphics for current part ******
!
geometry create shape cylinder  &
   cylinder_name = .net_ball.vlnk_6_6.cyl  &
   adams_id = 338  &
   center_marker = .net_ball.vlnk_6_6.cntMar  &
   angle_extent = 360.0  &
   length = 50.0  &
   radius = 1.0  &
   side_count_for_body = 20  &
   segment_count_for_ends = 20
!
part attributes  &
   part_name = .net_ball.vlnk_6_6  &
   color = RED  &
   name_visibility = off
!
!---------------------------------- vlnk_6_7 ----------------------------------!
!
!
defaults coordinate_system  &
   default_coordinate_system = .net_ball.ground
!
part create rigid_body name_and_position  &
   part_name = .net_ball.vlnk_6_7  &
   adams_id = 154  &
   location = 0.0, 0.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
defaults coordinate_system  &
   default_coordinate_system = .net_ball.vlnk_6_7
!
! ****** Markers for current part ******
!
marker create  &
   marker_name = .net_ball.vlnk_6_7.cntMar  &
   adams_id = 1334  &
   location = 75.0, -125.0, 0.0  &
   orientation = 0.0d, 90.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_6_7.cm  &
   adams_id = 1335  &
   location = 75.0, -150.0, 0.0  &
   orientation = 180.0d, 90.0d, 90.0d
!
marker create  &
   marker_name = .net_ball.vlnk_6_7.endMar  &
   adams_id = 1336  &
   location = 75.0, -175.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_6_7.cmMar  &
   adams_id = 1337  &
   location = 75.0, -150.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_6_7.MARKER_232  &
   adams_id = 232  &
   location = 50.0, -125.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_6_7.MARKER_270  &
   adams_id = 270  &
   location = 75.0, -125.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_6_7.MARKER_605  &
   adams_id = 605  &
   location = 75.0, -150.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_6_7.MARKER_607  &
   adams_id = 607  &
   location = 75.0, -175.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
part create rigid_body mass_properties  &
   part_name = .net_ball.vlnk_6_7  &
   material_type = .net_ball.aluminum
!
! ****** Graphics for current part ******
!
geometry create shape cylinder  &
   cylinder_name = .net_ball.vlnk_6_7.cyl  &
   adams_id = 339  &
   center_marker = .net_ball.vlnk_6_7.cntMar  &
   angle_extent = 360.0  &
   length = 50.0  &
   radius = 1.0  &
   side_count_for_body = 20  &
   segment_count_for_ends = 20
!
part attributes  &
   part_name = .net_ball.vlnk_6_7  &
   color = RED  &
   name_visibility = off
!
!---------------------------------- vlnk_6_8 ----------------------------------!
!
!
defaults coordinate_system  &
   default_coordinate_system = .net_ball.ground
!
part create rigid_body name_and_position  &
   part_name = .net_ball.vlnk_6_8  &
   adams_id = 155  &
   location = 0.0, 0.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
defaults coordinate_system  &
   default_coordinate_system = .net_ball.vlnk_6_8
!
! ****** Markers for current part ******
!
marker create  &
   marker_name = .net_ball.vlnk_6_8.cntMar  &
   adams_id = 1338  &
   location = 75.0, -175.0, 0.0  &
   orientation = 0.0d, 90.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_6_8.cm  &
   adams_id = 1339  &
   location = 75.0, -200.0, 0.0  &
   orientation = 0.0d, 90.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_6_8.endMar  &
   adams_id = 1340  &
   location = 75.0, -225.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_6_8.cmMar  &
   adams_id = 1341  &
   location = 75.0, -200.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_6_8.MARKER_236  &
   adams_id = 236  &
   location = 50.0, -175.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_6_8.MARKER_240  &
   adams_id = 240  &
   location = 50.0, -225.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_6_8.MARKER_274  &
   adams_id = 274  &
   location = 75.0, -175.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_6_8.MARKER_278  &
   adams_id = 278  &
   location = 75.0, -225.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_6_8.MARKER_609  &
   adams_id = 609  &
   location = 75.0, -200.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_6_8.MARKER_611  &
   adams_id = 611  &
   location = 75.0, -225.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
part create rigid_body mass_properties  &
   part_name = .net_ball.vlnk_6_8  &
   material_type = .net_ball.aluminum
!
! ****** Graphics for current part ******
!
geometry create shape cylinder  &
   cylinder_name = .net_ball.vlnk_6_8.cyl  &
   adams_id = 340  &
   center_marker = .net_ball.vlnk_6_8.cntMar  &
   angle_extent = 360.0  &
   length = 50.0  &
   radius = 1.0  &
   side_count_for_body = 20  &
   segment_count_for_ends = 20
!
part attributes  &
   part_name = .net_ball.vlnk_6_8  &
   color = RED  &
   name_visibility = off
!
!---------------------------------- vlnk_7_0 ----------------------------------!
!
!
defaults coordinate_system  &
   default_coordinate_system = .net_ball.ground
!
part create rigid_body name_and_position  &
   part_name = .net_ball.vlnk_7_0  &
   adams_id = 156  &
   location = 0.0, 0.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
defaults coordinate_system  &
   default_coordinate_system = .net_ball.vlnk_7_0
!
! ****** Markers for current part ******
!
marker create  &
   marker_name = .net_ball.vlnk_7_0.cntMar  &
   adams_id = 1342  &
   location = 125.0, 225.0, 0.0  &
   orientation = 0.0d, 90.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_7_0.cm  &
   adams_id = 1343  &
   location = 125.0, 200.0, 0.0  &
   orientation = 180.0d, 90.0d, 90.0d
!
marker create  &
   marker_name = .net_ball.vlnk_7_0.endMar  &
   adams_id = 1344  &
   location = 125.0, 175.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_7_0.cmMar  &
   adams_id = 1345  &
   location = 125.0, 200.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_7_0.MARKER_244  &
   adams_id = 244  &
   location = 100.0, 225.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_7_0.MARKER_282  &
   adams_id = 282  &
   location = 125.0, 225.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_7_0.MARKER_613  &
   adams_id = 613  &
   location = 125.0, 200.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_7_0.MARKER_615  &
   adams_id = 615  &
   location = 125.0, 175.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
part create rigid_body mass_properties  &
   part_name = .net_ball.vlnk_7_0  &
   material_type = .net_ball.aluminum
!
! ****** Graphics for current part ******
!
geometry create shape cylinder  &
   cylinder_name = .net_ball.vlnk_7_0.cyl  &
   adams_id = 341  &
   center_marker = .net_ball.vlnk_7_0.cntMar  &
   angle_extent = 360.0  &
   length = 50.0  &
   radius = 1.0  &
   side_count_for_body = 20  &
   segment_count_for_ends = 20
!
part attributes  &
   part_name = .net_ball.vlnk_7_0  &
   color = RED  &
   name_visibility = off
!
!---------------------------------- vlnk_7_1 ----------------------------------!
!
!
defaults coordinate_system  &
   default_coordinate_system = .net_ball.ground
!
part create rigid_body name_and_position  &
   part_name = .net_ball.vlnk_7_1  &
   adams_id = 157  &
   location = 0.0, 0.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
defaults coordinate_system  &
   default_coordinate_system = .net_ball.vlnk_7_1
!
! ****** Markers for current part ******
!
marker create  &
   marker_name = .net_ball.vlnk_7_1.cntMar  &
   adams_id = 1346  &
   location = 125.0, 175.0, 0.0  &
   orientation = 0.0d, 90.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_7_1.cm  &
   adams_id = 1347  &
   location = 125.0, 150.0, 0.0  &
   orientation = 180.0d, 90.0d, 90.0d
!
marker create  &
   marker_name = .net_ball.vlnk_7_1.endMar  &
   adams_id = 1348  &
   location = 125.0, 125.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_7_1.cmMar  &
   adams_id = 1349  &
   location = 125.0, 150.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_7_1.MARKER_248  &
   adams_id = 248  &
   location = 100.0, 175.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_7_1.MARKER_286  &
   adams_id = 286  &
   location = 125.0, 175.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_7_1.MARKER_617  &
   adams_id = 617  &
   location = 125.0, 150.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_7_1.MARKER_619  &
   adams_id = 619  &
   location = 125.0, 125.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
part create rigid_body mass_properties  &
   part_name = .net_ball.vlnk_7_1  &
   material_type = .net_ball.aluminum
!
! ****** Graphics for current part ******
!
geometry create shape cylinder  &
   cylinder_name = .net_ball.vlnk_7_1.cyl  &
   adams_id = 342  &
   center_marker = .net_ball.vlnk_7_1.cntMar  &
   angle_extent = 360.0  &
   length = 50.0  &
   radius = 1.0  &
   side_count_for_body = 20  &
   segment_count_for_ends = 20
!
part attributes  &
   part_name = .net_ball.vlnk_7_1  &
   color = RED  &
   name_visibility = off
!
!---------------------------------- vlnk_7_2 ----------------------------------!
!
!
defaults coordinate_system  &
   default_coordinate_system = .net_ball.ground
!
part create rigid_body name_and_position  &
   part_name = .net_ball.vlnk_7_2  &
   adams_id = 158  &
   location = 0.0, 0.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
defaults coordinate_system  &
   default_coordinate_system = .net_ball.vlnk_7_2
!
! ****** Markers for current part ******
!
marker create  &
   marker_name = .net_ball.vlnk_7_2.cntMar  &
   adams_id = 1350  &
   location = 125.0, 125.0, 0.0  &
   orientation = 0.0d, 90.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_7_2.cm  &
   adams_id = 1351  &
   location = 125.0, 100.0, 0.0  &
   orientation = 0.0d, 90.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_7_2.endMar  &
   adams_id = 1352  &
   location = 125.0, 75.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_7_2.cmMar  &
   adams_id = 1353  &
   location = 125.0, 100.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_7_2.MARKER_252  &
   adams_id = 252  &
   location = 100.0, 125.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_7_2.MARKER_290  &
   adams_id = 290  &
   location = 125.0, 125.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_7_2.MARKER_621  &
   adams_id = 621  &
   location = 125.0, 100.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_7_2.MARKER_623  &
   adams_id = 623  &
   location = 125.0, 75.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
part create rigid_body mass_properties  &
   part_name = .net_ball.vlnk_7_2  &
   material_type = .net_ball.aluminum
!
! ****** Graphics for current part ******
!
geometry create shape cylinder  &
   cylinder_name = .net_ball.vlnk_7_2.cyl  &
   adams_id = 343  &
   center_marker = .net_ball.vlnk_7_2.cntMar  &
   angle_extent = 360.0  &
   length = 50.0  &
   radius = 1.0  &
   side_count_for_body = 20  &
   segment_count_for_ends = 20
!
part attributes  &
   part_name = .net_ball.vlnk_7_2  &
   color = RED  &
   name_visibility = off
!
!---------------------------------- vlnk_7_3 ----------------------------------!
!
!
defaults coordinate_system  &
   default_coordinate_system = .net_ball.ground
!
part create rigid_body name_and_position  &
   part_name = .net_ball.vlnk_7_3  &
   adams_id = 159  &
   location = 0.0, 0.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
defaults coordinate_system  &
   default_coordinate_system = .net_ball.vlnk_7_3
!
! ****** Markers for current part ******
!
marker create  &
   marker_name = .net_ball.vlnk_7_3.cntMar  &
   adams_id = 1354  &
   location = 125.0, 75.0, 0.0  &
   orientation = 0.0d, 90.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_7_3.cm  &
   adams_id = 1355  &
   location = 125.0, 50.0, 0.0  &
   orientation = 180.0d, 90.0d, 90.0d
!
marker create  &
   marker_name = .net_ball.vlnk_7_3.endMar  &
   adams_id = 1356  &
   location = 125.0, 25.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_7_3.cmMar  &
   adams_id = 1357  &
   location = 125.0, 50.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_7_3.MARKER_256  &
   adams_id = 256  &
   location = 100.0, 75.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_7_3.MARKER_294  &
   adams_id = 294  &
   location = 125.0, 75.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_7_3.MARKER_625  &
   adams_id = 625  &
   location = 125.0, 50.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_7_3.MARKER_627  &
   adams_id = 627  &
   location = 125.0, 25.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
part create rigid_body mass_properties  &
   part_name = .net_ball.vlnk_7_3  &
   material_type = .net_ball.aluminum
!
! ****** Graphics for current part ******
!
geometry create shape cylinder  &
   cylinder_name = .net_ball.vlnk_7_3.cyl  &
   adams_id = 344  &
   center_marker = .net_ball.vlnk_7_3.cntMar  &
   angle_extent = 360.0  &
   length = 50.0  &
   radius = 1.0  &
   side_count_for_body = 20  &
   segment_count_for_ends = 20
!
part attributes  &
   part_name = .net_ball.vlnk_7_3  &
   color = RED  &
   name_visibility = off
!
!---------------------------------- vlnk_7_4 ----------------------------------!
!
!
defaults coordinate_system  &
   default_coordinate_system = .net_ball.ground
!
part create rigid_body name_and_position  &
   part_name = .net_ball.vlnk_7_4  &
   adams_id = 160  &
   location = 0.0, 0.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
defaults coordinate_system  &
   default_coordinate_system = .net_ball.vlnk_7_4
!
! ****** Markers for current part ******
!
marker create  &
   marker_name = .net_ball.vlnk_7_4.cntMar  &
   adams_id = 1358  &
   location = 125.0, 25.0, 0.0  &
   orientation = 0.0d, 90.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_7_4.cm  &
   adams_id = 1359  &
   location = 125.0, 0.0, 0.0  &
   orientation = 180.0d, 90.0d, 90.0d
!
marker create  &
   marker_name = .net_ball.vlnk_7_4.endMar  &
   adams_id = 1360  &
   location = 125.0, -25.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_7_4.cmMar  &
   adams_id = 1361  &
   location = 125.0, 0.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_7_4.MARKER_260  &
   adams_id = 260  &
   location = 100.0, 25.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_7_4.MARKER_298  &
   adams_id = 298  &
   location = 125.0, 25.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_7_4.MARKER_629  &
   adams_id = 629  &
   location = 125.0, 0.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_7_4.MARKER_631  &
   adams_id = 631  &
   location = 125.0, -25.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
part create rigid_body mass_properties  &
   part_name = .net_ball.vlnk_7_4  &
   material_type = .net_ball.aluminum
!
! ****** Graphics for current part ******
!
geometry create shape cylinder  &
   cylinder_name = .net_ball.vlnk_7_4.cyl  &
   adams_id = 345  &
   center_marker = .net_ball.vlnk_7_4.cntMar  &
   angle_extent = 360.0  &
   length = 50.0  &
   radius = 1.0  &
   side_count_for_body = 20  &
   segment_count_for_ends = 20
!
part attributes  &
   part_name = .net_ball.vlnk_7_4  &
   color = RED  &
   name_visibility = off
!
!---------------------------------- vlnk_7_5 ----------------------------------!
!
!
defaults coordinate_system  &
   default_coordinate_system = .net_ball.ground
!
part create rigid_body name_and_position  &
   part_name = .net_ball.vlnk_7_5  &
   adams_id = 161  &
   location = 0.0, 0.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
defaults coordinate_system  &
   default_coordinate_system = .net_ball.vlnk_7_5
!
! ****** Markers for current part ******
!
marker create  &
   marker_name = .net_ball.vlnk_7_5.cntMar  &
   adams_id = 1362  &
   location = 125.0, -25.0, 0.0  &
   orientation = 0.0d, 90.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_7_5.cm  &
   adams_id = 1363  &
   location = 125.0, -50.0, 0.0  &
   orientation = 180.0d, 90.0d, 90.0d
!
marker create  &
   marker_name = .net_ball.vlnk_7_5.endMar  &
   adams_id = 1364  &
   location = 125.0, -75.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_7_5.cmMar  &
   adams_id = 1365  &
   location = 125.0, -50.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_7_5.MARKER_264  &
   adams_id = 264  &
   location = 100.0, -25.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_7_5.MARKER_302  &
   adams_id = 302  &
   location = 125.0, -25.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_7_5.MARKER_633  &
   adams_id = 633  &
   location = 125.0, -50.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_7_5.MARKER_635  &
   adams_id = 635  &
   location = 125.0, -75.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
part create rigid_body mass_properties  &
   part_name = .net_ball.vlnk_7_5  &
   material_type = .net_ball.aluminum
!
! ****** Graphics for current part ******
!
geometry create shape cylinder  &
   cylinder_name = .net_ball.vlnk_7_5.cyl  &
   adams_id = 346  &
   center_marker = .net_ball.vlnk_7_5.cntMar  &
   angle_extent = 360.0  &
   length = 50.0  &
   radius = 1.0  &
   side_count_for_body = 20  &
   segment_count_for_ends = 20
!
part attributes  &
   part_name = .net_ball.vlnk_7_5  &
   color = RED  &
   name_visibility = off
!
!---------------------------------- vlnk_7_6 ----------------------------------!
!
!
defaults coordinate_system  &
   default_coordinate_system = .net_ball.ground
!
part create rigid_body name_and_position  &
   part_name = .net_ball.vlnk_7_6  &
   adams_id = 162  &
   location = 0.0, 0.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
defaults coordinate_system  &
   default_coordinate_system = .net_ball.vlnk_7_6
!
! ****** Markers for current part ******
!
marker create  &
   marker_name = .net_ball.vlnk_7_6.cntMar  &
   adams_id = 1366  &
   location = 125.0, -75.0, 0.0  &
   orientation = 0.0d, 90.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_7_6.cm  &
   adams_id = 1367  &
   location = 125.0, -100.0, 0.0  &
   orientation = 180.0d, 90.0d, 90.0d
!
marker create  &
   marker_name = .net_ball.vlnk_7_6.endMar  &
   adams_id = 1368  &
   location = 125.0, -125.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_7_6.cmMar  &
   adams_id = 1369  &
   location = 125.0, -100.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_7_6.MARKER_268  &
   adams_id = 268  &
   location = 100.0, -75.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_7_6.MARKER_306  &
   adams_id = 306  &
   location = 125.0, -75.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_7_6.MARKER_637  &
   adams_id = 637  &
   location = 125.0, -100.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_7_6.MARKER_639  &
   adams_id = 639  &
   location = 125.0, -125.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
part create rigid_body mass_properties  &
   part_name = .net_ball.vlnk_7_6  &
   material_type = .net_ball.aluminum
!
! ****** Graphics for current part ******
!
geometry create shape cylinder  &
   cylinder_name = .net_ball.vlnk_7_6.cyl  &
   adams_id = 347  &
   center_marker = .net_ball.vlnk_7_6.cntMar  &
   angle_extent = 360.0  &
   length = 50.0  &
   radius = 1.0  &
   side_count_for_body = 20  &
   segment_count_for_ends = 20
!
part attributes  &
   part_name = .net_ball.vlnk_7_6  &
   color = RED  &
   name_visibility = off
!
!---------------------------------- vlnk_7_7 ----------------------------------!
!
!
defaults coordinate_system  &
   default_coordinate_system = .net_ball.ground
!
part create rigid_body name_and_position  &
   part_name = .net_ball.vlnk_7_7  &
   adams_id = 163  &
   location = 0.0, 0.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
defaults coordinate_system  &
   default_coordinate_system = .net_ball.vlnk_7_7
!
! ****** Markers for current part ******
!
marker create  &
   marker_name = .net_ball.vlnk_7_7.cntMar  &
   adams_id = 1370  &
   location = 125.0, -125.0, 0.0  &
   orientation = 0.0d, 90.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_7_7.cm  &
   adams_id = 1371  &
   location = 125.0, -150.0, 0.0  &
   orientation = 180.0d, 90.0d, 90.0d
!
marker create  &
   marker_name = .net_ball.vlnk_7_7.endMar  &
   adams_id = 1372  &
   location = 125.0, -175.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_7_7.cmMar  &
   adams_id = 1373  &
   location = 125.0, -150.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_7_7.MARKER_272  &
   adams_id = 272  &
   location = 100.0, -125.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_7_7.MARKER_310  &
   adams_id = 310  &
   location = 125.0, -125.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_7_7.MARKER_641  &
   adams_id = 641  &
   location = 125.0, -150.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_7_7.MARKER_643  &
   adams_id = 643  &
   location = 125.0, -175.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
part create rigid_body mass_properties  &
   part_name = .net_ball.vlnk_7_7  &
   material_type = .net_ball.aluminum
!
! ****** Graphics for current part ******
!
geometry create shape cylinder  &
   cylinder_name = .net_ball.vlnk_7_7.cyl  &
   adams_id = 348  &
   center_marker = .net_ball.vlnk_7_7.cntMar  &
   angle_extent = 360.0  &
   length = 50.0  &
   radius = 1.0  &
   side_count_for_body = 20  &
   segment_count_for_ends = 20
!
part attributes  &
   part_name = .net_ball.vlnk_7_7  &
   color = RED  &
   name_visibility = off
!
!---------------------------------- vlnk_7_8 ----------------------------------!
!
!
defaults coordinate_system  &
   default_coordinate_system = .net_ball.ground
!
part create rigid_body name_and_position  &
   part_name = .net_ball.vlnk_7_8  &
   adams_id = 164  &
   location = 0.0, 0.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
defaults coordinate_system  &
   default_coordinate_system = .net_ball.vlnk_7_8
!
! ****** Markers for current part ******
!
marker create  &
   marker_name = .net_ball.vlnk_7_8.cntMar  &
   adams_id = 1374  &
   location = 125.0, -175.0, 0.0  &
   orientation = 0.0d, 90.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_7_8.cm  &
   adams_id = 1375  &
   location = 125.0, -200.0, 0.0  &
   orientation = 0.0d, 90.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_7_8.endMar  &
   adams_id = 1376  &
   location = 125.0, -225.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_7_8.cmMar  &
   adams_id = 1377  &
   location = 125.0, -200.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_7_8.MARKER_276  &
   adams_id = 276  &
   location = 100.0, -175.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_7_8.MARKER_280  &
   adams_id = 280  &
   location = 100.0, -225.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_7_8.MARKER_314  &
   adams_id = 314  &
   location = 125.0, -175.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_7_8.MARKER_318  &
   adams_id = 318  &
   location = 125.0, -225.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_7_8.MARKER_645  &
   adams_id = 645  &
   location = 125.0, -200.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_7_8.MARKER_647  &
   adams_id = 647  &
   location = 125.0, -225.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
part create rigid_body mass_properties  &
   part_name = .net_ball.vlnk_7_8  &
   material_type = .net_ball.aluminum
!
! ****** Graphics for current part ******
!
geometry create shape cylinder  &
   cylinder_name = .net_ball.vlnk_7_8.cyl  &
   adams_id = 349  &
   center_marker = .net_ball.vlnk_7_8.cntMar  &
   angle_extent = 360.0  &
   length = 50.0  &
   radius = 1.0  &
   side_count_for_body = 20  &
   segment_count_for_ends = 20
!
part attributes  &
   part_name = .net_ball.vlnk_7_8  &
   color = RED  &
   name_visibility = off
!
!---------------------------------- vlnk_8_0 ----------------------------------!
!
!
defaults coordinate_system  &
   default_coordinate_system = .net_ball.ground
!
part create rigid_body name_and_position  &
   part_name = .net_ball.vlnk_8_0  &
   adams_id = 165  &
   location = 0.0, 0.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
defaults coordinate_system  &
   default_coordinate_system = .net_ball.vlnk_8_0
!
! ****** Markers for current part ******
!
marker create  &
   marker_name = .net_ball.vlnk_8_0.cntMar  &
   adams_id = 1378  &
   location = 175.0, 225.0, 0.0  &
   orientation = 0.0d, 90.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_8_0.cm  &
   adams_id = 1379  &
   location = 175.0, 200.0, 0.0  &
   orientation = 180.0d, 90.0d, 90.0d
!
marker create  &
   marker_name = .net_ball.vlnk_8_0.endMar  &
   adams_id = 1380  &
   location = 175.0, 175.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_8_0.cmMar  &
   adams_id = 1381  &
   location = 175.0, 200.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_8_0.MARKER_284  &
   adams_id = 284  &
   location = 150.0, 225.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_8_0.MARKER_322  &
   adams_id = 322  &
   location = 175.0, 225.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_8_0.MARKER_649  &
   adams_id = 649  &
   location = 175.0, 200.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_8_0.MARKER_651  &
   adams_id = 651  &
   location = 175.0, 175.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_8_0.MARKER_685  &
   adams_id = 685  &
   location = 225.0, 200.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_8_0.MARKER_687  &
   adams_id = 687  &
   location = 225.0, 175.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
part create rigid_body mass_properties  &
   part_name = .net_ball.vlnk_8_0  &
   material_type = .net_ball.aluminum
!
! ****** Graphics for current part ******
!
geometry create shape cylinder  &
   cylinder_name = .net_ball.vlnk_8_0.cyl  &
   adams_id = 350  &
   center_marker = .net_ball.vlnk_8_0.cntMar  &
   angle_extent = 360.0  &
   length = 50.0  &
   radius = 1.0  &
   side_count_for_body = 20  &
   segment_count_for_ends = 20
!
part attributes  &
   part_name = .net_ball.vlnk_8_0  &
   color = RED  &
   name_visibility = off
!
!---------------------------------- vlnk_8_1 ----------------------------------!
!
!
defaults coordinate_system  &
   default_coordinate_system = .net_ball.ground
!
part create rigid_body name_and_position  &
   part_name = .net_ball.vlnk_8_1  &
   adams_id = 166  &
   location = 0.0, 0.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
defaults coordinate_system  &
   default_coordinate_system = .net_ball.vlnk_8_1
!
! ****** Markers for current part ******
!
marker create  &
   marker_name = .net_ball.vlnk_8_1.cntMar  &
   adams_id = 1382  &
   location = 175.0, 175.0, 0.0  &
   orientation = 0.0d, 90.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_8_1.cm  &
   adams_id = 1383  &
   location = 175.0, 150.0, 0.0  &
   orientation = 180.0d, 90.0d, 90.0d
!
marker create  &
   marker_name = .net_ball.vlnk_8_1.endMar  &
   adams_id = 1384  &
   location = 175.0, 125.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_8_1.cmMar  &
   adams_id = 1385  &
   location = 175.0, 150.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_8_1.MARKER_288  &
   adams_id = 288  &
   location = 150.0, 175.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_8_1.MARKER_326  &
   adams_id = 326  &
   location = 175.0, 175.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_8_1.MARKER_653  &
   adams_id = 653  &
   location = 175.0, 150.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_8_1.MARKER_655  &
   adams_id = 655  &
   location = 175.0, 125.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_8_1.MARKER_689  &
   adams_id = 689  &
   location = 225.0, 150.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_8_1.MARKER_691  &
   adams_id = 691  &
   location = 225.0, 125.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
part create rigid_body mass_properties  &
   part_name = .net_ball.vlnk_8_1  &
   material_type = .net_ball.aluminum
!
! ****** Graphics for current part ******
!
geometry create shape cylinder  &
   cylinder_name = .net_ball.vlnk_8_1.cyl  &
   adams_id = 351  &
   center_marker = .net_ball.vlnk_8_1.cntMar  &
   angle_extent = 360.0  &
   length = 50.0  &
   radius = 1.0  &
   side_count_for_body = 20  &
   segment_count_for_ends = 20
!
part attributes  &
   part_name = .net_ball.vlnk_8_1  &
   color = RED  &
   name_visibility = off
!
!---------------------------------- vlnk_8_2 ----------------------------------!
!
!
defaults coordinate_system  &
   default_coordinate_system = .net_ball.ground
!
part create rigid_body name_and_position  &
   part_name = .net_ball.vlnk_8_2  &
   adams_id = 167  &
   location = 0.0, 0.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
defaults coordinate_system  &
   default_coordinate_system = .net_ball.vlnk_8_2
!
! ****** Markers for current part ******
!
marker create  &
   marker_name = .net_ball.vlnk_8_2.cntMar  &
   adams_id = 1386  &
   location = 175.0, 125.0, 0.0  &
   orientation = 0.0d, 90.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_8_2.cm  &
   adams_id = 1387  &
   location = 175.0, 100.0, 0.0  &
   orientation = 180.0d, 90.0d, 90.0d
!
marker create  &
   marker_name = .net_ball.vlnk_8_2.endMar  &
   adams_id = 1388  &
   location = 175.0, 75.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_8_2.cmMar  &
   adams_id = 1389  &
   location = 175.0, 100.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_8_2.MARKER_292  &
   adams_id = 292  &
   location = 150.0, 125.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_8_2.MARKER_330  &
   adams_id = 330  &
   location = 175.0, 125.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_8_2.MARKER_657  &
   adams_id = 657  &
   location = 175.0, 100.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_8_2.MARKER_659  &
   adams_id = 659  &
   location = 175.0, 75.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_8_2.MARKER_693  &
   adams_id = 693  &
   location = 225.0, 100.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_8_2.MARKER_695  &
   adams_id = 695  &
   location = 225.0, 75.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
part create rigid_body mass_properties  &
   part_name = .net_ball.vlnk_8_2  &
   material_type = .net_ball.aluminum
!
! ****** Graphics for current part ******
!
geometry create shape cylinder  &
   cylinder_name = .net_ball.vlnk_8_2.cyl  &
   adams_id = 352  &
   center_marker = .net_ball.vlnk_8_2.cntMar  &
   angle_extent = 360.0  &
   length = 50.0  &
   radius = 1.0  &
   side_count_for_body = 20  &
   segment_count_for_ends = 20
!
part attributes  &
   part_name = .net_ball.vlnk_8_2  &
   color = RED  &
   name_visibility = off
!
!---------------------------------- vlnk_8_3 ----------------------------------!
!
!
defaults coordinate_system  &
   default_coordinate_system = .net_ball.ground
!
part create rigid_body name_and_position  &
   part_name = .net_ball.vlnk_8_3  &
   adams_id = 168  &
   location = 0.0, 0.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
defaults coordinate_system  &
   default_coordinate_system = .net_ball.vlnk_8_3
!
! ****** Markers for current part ******
!
marker create  &
   marker_name = .net_ball.vlnk_8_3.cntMar  &
   adams_id = 1390  &
   location = 175.0, 75.0, 0.0  &
   orientation = 0.0d, 90.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_8_3.cm  &
   adams_id = 1391  &
   location = 175.0, 50.0, 0.0  &
   orientation = 180.0d, 90.0d, 90.0d
!
marker create  &
   marker_name = .net_ball.vlnk_8_3.endMar  &
   adams_id = 1392  &
   location = 175.0, 25.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_8_3.cmMar  &
   adams_id = 1393  &
   location = 175.0, 50.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_8_3.MARKER_296  &
   adams_id = 296  &
   location = 150.0, 75.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_8_3.MARKER_334  &
   adams_id = 334  &
   location = 175.0, 75.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_8_3.MARKER_661  &
   adams_id = 661  &
   location = 175.0, 50.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_8_3.MARKER_663  &
   adams_id = 663  &
   location = 175.0, 25.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_8_3.MARKER_697  &
   adams_id = 697  &
   location = 225.0, 50.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_8_3.MARKER_699  &
   adams_id = 699  &
   location = 225.0, 25.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
part create rigid_body mass_properties  &
   part_name = .net_ball.vlnk_8_3  &
   material_type = .net_ball.aluminum
!
! ****** Graphics for current part ******
!
geometry create shape cylinder  &
   cylinder_name = .net_ball.vlnk_8_3.cyl  &
   adams_id = 353  &
   center_marker = .net_ball.vlnk_8_3.cntMar  &
   angle_extent = 360.0  &
   length = 50.0  &
   radius = 1.0  &
   side_count_for_body = 20  &
   segment_count_for_ends = 20
!
part attributes  &
   part_name = .net_ball.vlnk_8_3  &
   color = RED  &
   name_visibility = off
!
!---------------------------------- vlnk_8_4 ----------------------------------!
!
!
defaults coordinate_system  &
   default_coordinate_system = .net_ball.ground
!
part create rigid_body name_and_position  &
   part_name = .net_ball.vlnk_8_4  &
   adams_id = 169  &
   location = 0.0, 0.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
defaults coordinate_system  &
   default_coordinate_system = .net_ball.vlnk_8_4
!
! ****** Markers for current part ******
!
marker create  &
   marker_name = .net_ball.vlnk_8_4.cntMar  &
   adams_id = 1394  &
   location = 175.0, 25.0, 0.0  &
   orientation = 0.0d, 90.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_8_4.cm  &
   adams_id = 1395  &
   location = 175.0, 0.0, 0.0  &
   orientation = 180.0d, 90.0d, 90.0d
!
marker create  &
   marker_name = .net_ball.vlnk_8_4.endMar  &
   adams_id = 1396  &
   location = 175.0, -25.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_8_4.cmMar  &
   adams_id = 1397  &
   location = 175.0, 0.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_8_4.MARKER_300  &
   adams_id = 300  &
   location = 150.0, 25.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_8_4.MARKER_338  &
   adams_id = 338  &
   location = 175.0, 25.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_8_4.MARKER_665  &
   adams_id = 665  &
   location = 175.0, 0.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_8_4.MARKER_667  &
   adams_id = 667  &
   location = 175.0, -25.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_8_4.MARKER_701  &
   adams_id = 701  &
   location = 225.0, 0.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_8_4.MARKER_703  &
   adams_id = 703  &
   location = 225.0, -25.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
part create rigid_body mass_properties  &
   part_name = .net_ball.vlnk_8_4  &
   material_type = .net_ball.aluminum
!
! ****** Graphics for current part ******
!
geometry create shape cylinder  &
   cylinder_name = .net_ball.vlnk_8_4.cyl  &
   adams_id = 354  &
   center_marker = .net_ball.vlnk_8_4.cntMar  &
   angle_extent = 360.0  &
   length = 50.0  &
   radius = 1.0  &
   side_count_for_body = 20  &
   segment_count_for_ends = 20
!
part attributes  &
   part_name = .net_ball.vlnk_8_4  &
   color = RED  &
   name_visibility = off
!
!---------------------------------- vlnk_8_5 ----------------------------------!
!
!
defaults coordinate_system  &
   default_coordinate_system = .net_ball.ground
!
part create rigid_body name_and_position  &
   part_name = .net_ball.vlnk_8_5  &
   adams_id = 170  &
   location = 0.0, 0.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
defaults coordinate_system  &
   default_coordinate_system = .net_ball.vlnk_8_5
!
! ****** Markers for current part ******
!
marker create  &
   marker_name = .net_ball.vlnk_8_5.cntMar  &
   adams_id = 1398  &
   location = 175.0, -25.0, 0.0  &
   orientation = 0.0d, 90.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_8_5.cm  &
   adams_id = 1399  &
   location = 175.0, -50.0, 0.0  &
   orientation = 180.0d, 90.0d, 90.0d
!
marker create  &
   marker_name = .net_ball.vlnk_8_5.endMar  &
   adams_id = 1400  &
   location = 175.0, -75.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_8_5.cmMar  &
   adams_id = 1401  &
   location = 175.0, -50.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_8_5.MARKER_304  &
   adams_id = 304  &
   location = 150.0, -25.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_8_5.MARKER_342  &
   adams_id = 342  &
   location = 175.0, -25.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_8_5.MARKER_669  &
   adams_id = 669  &
   location = 175.0, -50.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_8_5.MARKER_671  &
   adams_id = 671  &
   location = 175.0, -75.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_8_5.MARKER_705  &
   adams_id = 705  &
   location = 225.0, -50.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_8_5.MARKER_707  &
   adams_id = 707  &
   location = 225.0, -75.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
part create rigid_body mass_properties  &
   part_name = .net_ball.vlnk_8_5  &
   material_type = .net_ball.aluminum
!
! ****** Graphics for current part ******
!
geometry create shape cylinder  &
   cylinder_name = .net_ball.vlnk_8_5.cyl  &
   adams_id = 355  &
   center_marker = .net_ball.vlnk_8_5.cntMar  &
   angle_extent = 360.0  &
   length = 50.0  &
   radius = 1.0  &
   side_count_for_body = 20  &
   segment_count_for_ends = 20
!
part attributes  &
   part_name = .net_ball.vlnk_8_5  &
   color = RED  &
   name_visibility = off
!
!---------------------------------- vlnk_8_6 ----------------------------------!
!
!
defaults coordinate_system  &
   default_coordinate_system = .net_ball.ground
!
part create rigid_body name_and_position  &
   part_name = .net_ball.vlnk_8_6  &
   adams_id = 171  &
   location = 0.0, 0.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
defaults coordinate_system  &
   default_coordinate_system = .net_ball.vlnk_8_6
!
! ****** Markers for current part ******
!
marker create  &
   marker_name = .net_ball.vlnk_8_6.cntMar  &
   adams_id = 1402  &
   location = 175.0, -75.0, 0.0  &
   orientation = 0.0d, 90.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_8_6.cm  &
   adams_id = 1403  &
   location = 175.0, -100.0, 0.0  &
   orientation = 180.0d, 90.0d, 90.0d
!
marker create  &
   marker_name = .net_ball.vlnk_8_6.endMar  &
   adams_id = 1404  &
   location = 175.0, -125.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_8_6.cmMar  &
   adams_id = 1405  &
   location = 175.0, -100.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_8_6.MARKER_308  &
   adams_id = 308  &
   location = 150.0, -75.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_8_6.MARKER_346  &
   adams_id = 346  &
   location = 175.0, -75.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_8_6.MARKER_673  &
   adams_id = 673  &
   location = 175.0, -100.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_8_6.MARKER_675  &
   adams_id = 675  &
   location = 175.0, -125.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_8_6.MARKER_709  &
   adams_id = 709  &
   location = 225.0, -100.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_8_6.MARKER_711  &
   adams_id = 711  &
   location = 225.0, -125.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
part create rigid_body mass_properties  &
   part_name = .net_ball.vlnk_8_6  &
   material_type = .net_ball.aluminum
!
! ****** Graphics for current part ******
!
geometry create shape cylinder  &
   cylinder_name = .net_ball.vlnk_8_6.cyl  &
   adams_id = 356  &
   center_marker = .net_ball.vlnk_8_6.cntMar  &
   angle_extent = 360.0  &
   length = 50.0  &
   radius = 1.0  &
   side_count_for_body = 20  &
   segment_count_for_ends = 20
!
part attributes  &
   part_name = .net_ball.vlnk_8_6  &
   color = RED  &
   name_visibility = off
!
!---------------------------------- vlnk_8_7 ----------------------------------!
!
!
defaults coordinate_system  &
   default_coordinate_system = .net_ball.ground
!
part create rigid_body name_and_position  &
   part_name = .net_ball.vlnk_8_7  &
   adams_id = 172  &
   location = 0.0, 0.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
defaults coordinate_system  &
   default_coordinate_system = .net_ball.vlnk_8_7
!
! ****** Markers for current part ******
!
marker create  &
   marker_name = .net_ball.vlnk_8_7.cntMar  &
   adams_id = 1406  &
   location = 175.0, -125.0, 0.0  &
   orientation = 0.0d, 90.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_8_7.cm  &
   adams_id = 1407  &
   location = 175.0, -150.0, 0.0  &
   orientation = 180.0d, 90.0d, 90.0d
!
marker create  &
   marker_name = .net_ball.vlnk_8_7.endMar  &
   adams_id = 1408  &
   location = 175.0, -175.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_8_7.cmMar  &
   adams_id = 1409  &
   location = 175.0, -150.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_8_7.MARKER_312  &
   adams_id = 312  &
   location = 150.0, -125.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_8_7.MARKER_350  &
   adams_id = 350  &
   location = 175.0, -125.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_8_7.MARKER_677  &
   adams_id = 677  &
   location = 175.0, -150.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_8_7.MARKER_679  &
   adams_id = 679  &
   location = 175.0, -175.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_8_7.MARKER_713  &
   adams_id = 713  &
   location = 225.0, -150.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_8_7.MARKER_715  &
   adams_id = 715  &
   location = 225.0, -175.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
part create rigid_body mass_properties  &
   part_name = .net_ball.vlnk_8_7  &
   material_type = .net_ball.aluminum
!
! ****** Graphics for current part ******
!
geometry create shape cylinder  &
   cylinder_name = .net_ball.vlnk_8_7.cyl  &
   adams_id = 357  &
   center_marker = .net_ball.vlnk_8_7.cntMar  &
   angle_extent = 360.0  &
   length = 50.0  &
   radius = 1.0  &
   side_count_for_body = 20  &
   segment_count_for_ends = 20
!
part attributes  &
   part_name = .net_ball.vlnk_8_7  &
   color = RED  &
   name_visibility = off
!
!---------------------------------- vlnk_8_8 ----------------------------------!
!
!
defaults coordinate_system  &
   default_coordinate_system = .net_ball.ground
!
part create rigid_body name_and_position  &
   part_name = .net_ball.vlnk_8_8  &
   adams_id = 173  &
   location = 0.0, 0.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
defaults coordinate_system  &
   default_coordinate_system = .net_ball.vlnk_8_8
!
! ****** Markers for current part ******
!
marker create  &
   marker_name = .net_ball.vlnk_8_8.cntMar  &
   adams_id = 1410  &
   location = 175.0, -175.0, 0.0  &
   orientation = 0.0d, 90.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_8_8.cm  &
   adams_id = 1411  &
   location = 175.0, -200.0, 0.0  &
   orientation = 0.0d, 90.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_8_8.endMar  &
   adams_id = 1412  &
   location = 175.0, -225.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_8_8.cmMar  &
   adams_id = 1413  &
   location = 175.0, -200.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_8_8.MARKER_316  &
   adams_id = 316  &
   location = 150.0, -175.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_8_8.MARKER_320  &
   adams_id = 320  &
   location = 150.0, -225.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_8_8.MARKER_354  &
   adams_id = 354  &
   location = 175.0, -175.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_8_8.MARKER_358  &
   adams_id = 358  &
   location = 175.0, -225.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_8_8.MARKER_681  &
   adams_id = 681  &
   location = 175.0, -200.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_8_8.MARKER_683  &
   adams_id = 683  &
   location = 175.0, -225.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_8_8.MARKER_717  &
   adams_id = 717  &
   location = 225.0, -200.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_8_8.MARKER_719  &
   adams_id = 719  &
   location = 225.0, -225.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
part create rigid_body mass_properties  &
   part_name = .net_ball.vlnk_8_8  &
   material_type = .net_ball.aluminum
!
! ****** Graphics for current part ******
!
geometry create shape cylinder  &
   cylinder_name = .net_ball.vlnk_8_8.cyl  &
   adams_id = 358  &
   center_marker = .net_ball.vlnk_8_8.cntMar  &
   angle_extent = 360.0  &
   length = 50.0  &
   radius = 1.0  &
   side_count_for_body = 20  &
   segment_count_for_ends = 20
!
part attributes  &
   part_name = .net_ball.vlnk_8_8  &
   color = RED  &
   name_visibility = off
!
!---------------------------------- vlnk_9_0 ----------------------------------!
!
!
defaults coordinate_system  &
   default_coordinate_system = .net_ball.ground
!
part create rigid_body name_and_position  &
   part_name = .net_ball.vlnk_9_0  &
   adams_id = 174  &
   location = 0.0, 0.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
defaults coordinate_system  &
   default_coordinate_system = .net_ball.vlnk_9_0
!
! ****** Markers for current part ******
!
marker create  &
   marker_name = .net_ball.vlnk_9_0.cntMar  &
   adams_id = 1414  &
   location = 225.0, 225.0, 0.0  &
   orientation = 0.0d, 90.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_9_0.cm  &
   adams_id = 1415  &
   location = 225.0, 200.0, 0.0  &
   orientation = 180.0d, 90.0d, 90.0d
!
marker create  &
   marker_name = .net_ball.vlnk_9_0.endMar  &
   adams_id = 1416  &
   location = 225.0, 175.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_9_0.cmMar  &
   adams_id = 1417  &
   location = 225.0, 200.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_9_0.MARKER_324  &
   adams_id = 324  &
   location = 200.0, 225.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
part create rigid_body mass_properties  &
   part_name = .net_ball.vlnk_9_0  &
   material_type = .net_ball.aluminum
!
! ****** Graphics for current part ******
!
geometry create shape cylinder  &
   cylinder_name = .net_ball.vlnk_9_0.cyl  &
   adams_id = 359  &
   center_marker = .net_ball.vlnk_9_0.cntMar  &
   angle_extent = 360.0  &
   length = 50.0  &
   radius = 1.0  &
   side_count_for_body = 20  &
   segment_count_for_ends = 20
!
part attributes  &
   part_name = .net_ball.vlnk_9_0  &
   color = RED  &
   name_visibility = off
!
!---------------------------------- vlnk_9_1 ----------------------------------!
!
!
defaults coordinate_system  &
   default_coordinate_system = .net_ball.ground
!
part create rigid_body name_and_position  &
   part_name = .net_ball.vlnk_9_1  &
   adams_id = 175  &
   location = 0.0, 0.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
defaults coordinate_system  &
   default_coordinate_system = .net_ball.vlnk_9_1
!
! ****** Markers for current part ******
!
marker create  &
   marker_name = .net_ball.vlnk_9_1.cntMar  &
   adams_id = 1418  &
   location = 225.0, 175.0, 0.0  &
   orientation = 0.0d, 90.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_9_1.cm  &
   adams_id = 1419  &
   location = 225.0, 150.0, 0.0  &
   orientation = 180.0d, 90.0d, 90.0d
!
marker create  &
   marker_name = .net_ball.vlnk_9_1.endMar  &
   adams_id = 1420  &
   location = 225.0, 125.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_9_1.cmMar  &
   adams_id = 1421  &
   location = 225.0, 150.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_9_1.MARKER_328  &
   adams_id = 328  &
   location = 200.0, 175.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
part create rigid_body mass_properties  &
   part_name = .net_ball.vlnk_9_1  &
   material_type = .net_ball.aluminum
!
! ****** Graphics for current part ******
!
geometry create shape cylinder  &
   cylinder_name = .net_ball.vlnk_9_1.cyl  &
   adams_id = 360  &
   center_marker = .net_ball.vlnk_9_1.cntMar  &
   angle_extent = 360.0  &
   length = 50.0  &
   radius = 1.0  &
   side_count_for_body = 20  &
   segment_count_for_ends = 20
!
part attributes  &
   part_name = .net_ball.vlnk_9_1  &
   color = RED  &
   name_visibility = off
!
!---------------------------------- vlnk_9_2 ----------------------------------!
!
!
defaults coordinate_system  &
   default_coordinate_system = .net_ball.ground
!
part create rigid_body name_and_position  &
   part_name = .net_ball.vlnk_9_2  &
   adams_id = 176  &
   location = 0.0, 0.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
defaults coordinate_system  &
   default_coordinate_system = .net_ball.vlnk_9_2
!
! ****** Markers for current part ******
!
marker create  &
   marker_name = .net_ball.vlnk_9_2.cntMar  &
   adams_id = 1422  &
   location = 225.0, 125.0, 0.0  &
   orientation = 0.0d, 90.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_9_2.cm  &
   adams_id = 1423  &
   location = 225.0, 100.0, 0.0  &
   orientation = 180.0d, 90.0d, 90.0d
!
marker create  &
   marker_name = .net_ball.vlnk_9_2.endMar  &
   adams_id = 1424  &
   location = 225.0, 75.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_9_2.cmMar  &
   adams_id = 1425  &
   location = 225.0, 100.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_9_2.MARKER_332  &
   adams_id = 332  &
   location = 200.0, 125.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
part create rigid_body mass_properties  &
   part_name = .net_ball.vlnk_9_2  &
   material_type = .net_ball.aluminum
!
! ****** Graphics for current part ******
!
geometry create shape cylinder  &
   cylinder_name = .net_ball.vlnk_9_2.cyl  &
   adams_id = 361  &
   center_marker = .net_ball.vlnk_9_2.cntMar  &
   angle_extent = 360.0  &
   length = 50.0  &
   radius = 1.0  &
   side_count_for_body = 20  &
   segment_count_for_ends = 20
!
part attributes  &
   part_name = .net_ball.vlnk_9_2  &
   color = RED  &
   name_visibility = off
!
!---------------------------------- vlnk_9_3 ----------------------------------!
!
!
defaults coordinate_system  &
   default_coordinate_system = .net_ball.ground
!
part create rigid_body name_and_position  &
   part_name = .net_ball.vlnk_9_3  &
   adams_id = 177  &
   location = 0.0, 0.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
defaults coordinate_system  &
   default_coordinate_system = .net_ball.vlnk_9_3
!
! ****** Markers for current part ******
!
marker create  &
   marker_name = .net_ball.vlnk_9_3.cntMar  &
   adams_id = 1426  &
   location = 225.0, 75.0, 0.0  &
   orientation = 0.0d, 90.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_9_3.cm  &
   adams_id = 1427  &
   location = 225.0, 50.0, 0.0  &
   orientation = 180.0d, 90.0d, 90.0d
!
marker create  &
   marker_name = .net_ball.vlnk_9_3.endMar  &
   adams_id = 1428  &
   location = 225.0, 25.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_9_3.cmMar  &
   adams_id = 1429  &
   location = 225.0, 50.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_9_3.MARKER_336  &
   adams_id = 336  &
   location = 200.0, 75.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
part create rigid_body mass_properties  &
   part_name = .net_ball.vlnk_9_3  &
   material_type = .net_ball.aluminum
!
! ****** Graphics for current part ******
!
geometry create shape cylinder  &
   cylinder_name = .net_ball.vlnk_9_3.cyl  &
   adams_id = 362  &
   center_marker = .net_ball.vlnk_9_3.cntMar  &
   angle_extent = 360.0  &
   length = 50.0  &
   radius = 1.0  &
   side_count_for_body = 20  &
   segment_count_for_ends = 20
!
part attributes  &
   part_name = .net_ball.vlnk_9_3  &
   color = RED  &
   name_visibility = off
!
!---------------------------------- vlnk_9_4 ----------------------------------!
!
!
defaults coordinate_system  &
   default_coordinate_system = .net_ball.ground
!
part create rigid_body name_and_position  &
   part_name = .net_ball.vlnk_9_4  &
   adams_id = 178  &
   location = 0.0, 0.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
defaults coordinate_system  &
   default_coordinate_system = .net_ball.vlnk_9_4
!
! ****** Markers for current part ******
!
marker create  &
   marker_name = .net_ball.vlnk_9_4.cntMar  &
   adams_id = 1430  &
   location = 225.0, 25.0, 0.0  &
   orientation = 0.0d, 90.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_9_4.cm  &
   adams_id = 1431  &
   location = 225.0, 0.0, 0.0  &
   orientation = 180.0d, 90.0d, 90.0d
!
marker create  &
   marker_name = .net_ball.vlnk_9_4.endMar  &
   adams_id = 1432  &
   location = 225.0, -25.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_9_4.cmMar  &
   adams_id = 1433  &
   location = 225.0, 0.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_9_4.MARKER_340  &
   adams_id = 340  &
   location = 200.0, 25.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
part create rigid_body mass_properties  &
   part_name = .net_ball.vlnk_9_4  &
   material_type = .net_ball.aluminum
!
! ****** Graphics for current part ******
!
geometry create shape cylinder  &
   cylinder_name = .net_ball.vlnk_9_4.cyl  &
   adams_id = 363  &
   center_marker = .net_ball.vlnk_9_4.cntMar  &
   angle_extent = 360.0  &
   length = 50.0  &
   radius = 1.0  &
   side_count_for_body = 20  &
   segment_count_for_ends = 20
!
part attributes  &
   part_name = .net_ball.vlnk_9_4  &
   color = RED  &
   name_visibility = off
!
!---------------------------------- vlnk_9_5 ----------------------------------!
!
!
defaults coordinate_system  &
   default_coordinate_system = .net_ball.ground
!
part create rigid_body name_and_position  &
   part_name = .net_ball.vlnk_9_5  &
   adams_id = 179  &
   location = 0.0, 0.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
defaults coordinate_system  &
   default_coordinate_system = .net_ball.vlnk_9_5
!
! ****** Markers for current part ******
!
marker create  &
   marker_name = .net_ball.vlnk_9_5.cntMar  &
   adams_id = 1434  &
   location = 225.0, -25.0, 0.0  &
   orientation = 0.0d, 90.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_9_5.cm  &
   adams_id = 1435  &
   location = 225.0, -50.0, 0.0  &
   orientation = 180.0d, 90.0d, 90.0d
!
marker create  &
   marker_name = .net_ball.vlnk_9_5.endMar  &
   adams_id = 1436  &
   location = 225.0, -75.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_9_5.cmMar  &
   adams_id = 1437  &
   location = 225.0, -50.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_9_5.MARKER_344  &
   adams_id = 344  &
   location = 200.0, -25.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
part create rigid_body mass_properties  &
   part_name = .net_ball.vlnk_9_5  &
   material_type = .net_ball.aluminum
!
! ****** Graphics for current part ******
!
geometry create shape cylinder  &
   cylinder_name = .net_ball.vlnk_9_5.cyl  &
   adams_id = 364  &
   center_marker = .net_ball.vlnk_9_5.cntMar  &
   angle_extent = 360.0  &
   length = 50.0  &
   radius = 1.0  &
   side_count_for_body = 20  &
   segment_count_for_ends = 20
!
part attributes  &
   part_name = .net_ball.vlnk_9_5  &
   color = RED  &
   name_visibility = off
!
!---------------------------------- vlnk_9_6 ----------------------------------!
!
!
defaults coordinate_system  &
   default_coordinate_system = .net_ball.ground
!
part create rigid_body name_and_position  &
   part_name = .net_ball.vlnk_9_6  &
   adams_id = 180  &
   location = 0.0, 0.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
defaults coordinate_system  &
   default_coordinate_system = .net_ball.vlnk_9_6
!
! ****** Markers for current part ******
!
marker create  &
   marker_name = .net_ball.vlnk_9_6.cntMar  &
   adams_id = 1438  &
   location = 225.0, -75.0, 0.0  &
   orientation = 0.0d, 90.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_9_6.cm  &
   adams_id = 1439  &
   location = 225.0, -100.0, 0.0  &
   orientation = 180.0d, 90.0d, 90.0d
!
marker create  &
   marker_name = .net_ball.vlnk_9_6.endMar  &
   adams_id = 1440  &
   location = 225.0, -125.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_9_6.cmMar  &
   adams_id = 1441  &
   location = 225.0, -100.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_9_6.MARKER_348  &
   adams_id = 348  &
   location = 200.0, -75.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
part create rigid_body mass_properties  &
   part_name = .net_ball.vlnk_9_6  &
   material_type = .net_ball.aluminum
!
! ****** Graphics for current part ******
!
geometry create shape cylinder  &
   cylinder_name = .net_ball.vlnk_9_6.cyl  &
   adams_id = 365  &
   center_marker = .net_ball.vlnk_9_6.cntMar  &
   angle_extent = 360.0  &
   length = 50.0  &
   radius = 1.0  &
   side_count_for_body = 20  &
   segment_count_for_ends = 20
!
part attributes  &
   part_name = .net_ball.vlnk_9_6  &
   color = RED  &
   name_visibility = off
!
!---------------------------------- vlnk_9_7 ----------------------------------!
!
!
defaults coordinate_system  &
   default_coordinate_system = .net_ball.ground
!
part create rigid_body name_and_position  &
   part_name = .net_ball.vlnk_9_7  &
   adams_id = 181  &
   location = 0.0, 0.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
defaults coordinate_system  &
   default_coordinate_system = .net_ball.vlnk_9_7
!
! ****** Markers for current part ******
!
marker create  &
   marker_name = .net_ball.vlnk_9_7.cntMar  &
   adams_id = 1442  &
   location = 225.0, -125.0, 0.0  &
   orientation = 0.0d, 90.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_9_7.cm  &
   adams_id = 1443  &
   location = 225.0, -150.0, 0.0  &
   orientation = 180.0d, 90.0d, 90.0d
!
marker create  &
   marker_name = .net_ball.vlnk_9_7.endMar  &
   adams_id = 1444  &
   location = 225.0, -175.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_9_7.cmMar  &
   adams_id = 1445  &
   location = 225.0, -150.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_9_7.MARKER_352  &
   adams_id = 352  &
   location = 200.0, -125.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
part create rigid_body mass_properties  &
   part_name = .net_ball.vlnk_9_7  &
   material_type = .net_ball.aluminum
!
! ****** Graphics for current part ******
!
geometry create shape cylinder  &
   cylinder_name = .net_ball.vlnk_9_7.cyl  &
   adams_id = 366  &
   center_marker = .net_ball.vlnk_9_7.cntMar  &
   angle_extent = 360.0  &
   length = 50.0  &
   radius = 1.0  &
   side_count_for_body = 20  &
   segment_count_for_ends = 20
!
part attributes  &
   part_name = .net_ball.vlnk_9_7  &
   color = RED  &
   name_visibility = off
!
!---------------------------------- vlnk_9_8 ----------------------------------!
!
!
defaults coordinate_system  &
   default_coordinate_system = .net_ball.ground
!
part create rigid_body name_and_position  &
   part_name = .net_ball.vlnk_9_8  &
   adams_id = 182  &
   location = 0.0, 0.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
defaults coordinate_system  &
   default_coordinate_system = .net_ball.vlnk_9_8
!
! ****** Markers for current part ******
!
marker create  &
   marker_name = .net_ball.vlnk_9_8.cntMar  &
   adams_id = 1446  &
   location = 225.0, -175.0, 0.0  &
   orientation = 0.0d, 90.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_9_8.cm  &
   adams_id = 1447  &
   location = 225.0, -200.0, 0.0  &
   orientation = 180.0d, 90.0d, 90.0d
!
marker create  &
   marker_name = .net_ball.vlnk_9_8.endMar  &
   adams_id = 1448  &
   location = 225.0, -225.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_9_8.cmMar  &
   adams_id = 1449  &
   location = 225.0, -200.0, 0.0  &
   orientation = 270.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_9_8.MARKER_356  &
   adams_id = 356  &
   location = 200.0, -175.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.vlnk_9_8.MARKER_360  &
   adams_id = 360  &
   location = 200.0, -225.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
part create rigid_body mass_properties  &
   part_name = .net_ball.vlnk_9_8  &
   material_type = .net_ball.aluminum
!
! ****** Graphics for current part ******
!
geometry create shape cylinder  &
   cylinder_name = .net_ball.vlnk_9_8.cyl  &
   adams_id = 367  &
   center_marker = .net_ball.vlnk_9_8.cntMar  &
   angle_extent = 360.0  &
   length = 50.0  &
   radius = 1.0  &
   side_count_for_body = 20  &
   segment_count_for_ends = 20
!
part attributes  &
   part_name = .net_ball.vlnk_9_8  &
   color = RED  &
   name_visibility = off
!
!------------------------------------ ball ------------------------------------!
!
!
defaults coordinate_system  &
   default_coordinate_system = .net_ball.ground
!
part create rigid_body name_and_position  &
   part_name = .net_ball.ball  &
   adams_id = 2  &
   location = 0.0, 0.0, 0.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
defaults coordinate_system  &
   default_coordinate_system = .net_ball.ball
!
! ****** Markers for current part ******
!
marker create  &
   marker_name = .net_ball.ball.MARKER_729  &
   adams_id = 729  &
   location = 0.0, 0.0, 500.0  &
   orientation = 0.0d, 0.0d, 0.0d
!
marker create  &
   marker_name = .net_ball.ball.cm  &
   adams_id = 1450  &
   location = 0.0, 0.0, 500.0  &
   orientation = 270.0d, 90.0d, 90.0d
!
marker create  &
   marker_name = .net_ball.ball.MARKER_1451  &
   adams_id = 1451  &
   location = 0.0, 0.0, 500.0  &
   orientation = 16.9657251287d, 80.1558210195d, 359.5068548178d
!
part create rigid_body mass_properties  &
   part_name = .net_ball.ball  &
   material_type = .net_ball.steel
!
! ****** Graphics for current part ******
!
geometry create shape ellipsoid  &
   ellipsoid_name = .net_ball.ball.ELLIPSOID_181  &
   adams_id = 368  &
   center_marker = .net_ball.ball.MARKER_729  &
   x_scale_factor = 60.0  &
   y_scale_factor = 60.0  &
   z_scale_factor = 60.0
!
part attributes  &
   part_name = .net_ball.ball  &
   color = GREEN  &
   name_visibility = off
!
!---------------------------------- Contacts ----------------------------------!
!
!
contact create  &
   contact_name = .net_ball.CONTACT_1  &
   adams_id = 1  &
   type = solid_to_solid  &
   i_geometry_name = .net_ball.ball.ELLIPSOID_181  &
   j_geometry_name = .net_ball.hlnk_4_4.cyl  &
   stiffness = 1.0E+06  &
   damping = 5.0  &
   exponent = 1.5  &
   dmax = 0.1
!
force attributes  &
   force_name = .net_ball.CONTACT_1  &
   visibility = on
!
contact create  &
   contact_name = .net_ball.CONTACT_2  &
   adams_id = 2  &
   type = solid_to_solid  &
   i_geometry_name = .net_ball.ball.ELLIPSOID_181  &
   j_geometry_name = .net_ball.hlnk_4_5.cyl  &
   stiffness = 1.0E+06  &
   damping = 5.0  &
   exponent = 1.5  &
   dmax = 0.1
!
force attributes  &
   force_name = .net_ball.CONTACT_2  &
   visibility = on
!
contact create  &
   contact_name = .net_ball.CONTACT_3  &
   adams_id = 3  &
   type = solid_to_solid  &
   i_geometry_name = .net_ball.ball.ELLIPSOID_181  &
   j_geometry_name = .net_ball.vlnk_4_4.cyl  &
   stiffness = 1.0E+06  &
   damping = 5.0  &
   exponent = 1.5  &
   dmax = 0.1
!
force attributes  &
   force_name = .net_ball.CONTACT_3  &
   visibility = on
!
contact create  &
   contact_name = .net_ball.CONTACT_4  &
   adams_id = 4  &
   type = solid_to_solid  &
   i_geometry_name = .net_ball.ball.ELLIPSOID_181  &
   j_geometry_name = .net_ball.vlnk_5_4.cyl  &
   stiffness = 1.0E+06  &
   damping = 5.0  &
   exponent = 1.5  &
   dmax = 0.1
!
force attributes  &
   force_name = .net_ball.CONTACT_4  &
   visibility = on
!
!----------------------------------- Joints -----------------------------------!
!
!
constraint create joint spherical  &
   joint_name = .net_ball.JOINT_1  &
   adams_id = 1  &
   i_marker_name = .net_ball.hlnk_0_0.MARKER_721  &
   j_marker_name = .net_ball.ground.MARKER_722
!
constraint attributes  &
   constraint_name = .net_ball.JOINT_1  &
   visibility = on
!
constraint create joint spherical  &
   joint_name = .net_ball.JOINT_2  &
   adams_id = 2  &
   i_marker_name = .net_ball.hlnk_8_0.MARKER_723  &
   j_marker_name = .net_ball.ground.MARKER_724
!
constraint attributes  &
   constraint_name = .net_ball.JOINT_2  &
   visibility = on
!
constraint create joint spherical  &
   joint_name = .net_ball.JOINT_3  &
   adams_id = 3  &
   i_marker_name = .net_ball.hlnk_0_9.MARKER_725  &
   j_marker_name = .net_ball.ground.MARKER_726
!
constraint attributes  &
   constraint_name = .net_ball.JOINT_3  &
   visibility = on
!
constraint create joint spherical  &
   joint_name = .net_ball.JOINT_4  &
   adams_id = 4  &
   i_marker_name = .net_ball.hlnk_8_9.MARKER_727  &
   j_marker_name = .net_ball.ground.MARKER_728
!
constraint attributes  &
   constraint_name = .net_ball.JOINT_4  &
   visibility = on
!
constraint create joint fixed  &
   joint_name = .net_ball.JOINT_5  &
   adams_id = 5  &
   i_marker_name = .net_ball.ball.MARKER_1451  &
   j_marker_name = .net_ball.ground.MARKER_1452
!
constraint attributes  &
   constraint_name = .net_ball.JOINT_5  &
   visibility = on
!
!----------------------------------- Forces -----------------------------------!
!
!
force create element_like beam  &
   beam_name = .net_ball.hBeam_0_0_L  &
   adams_id = 1  &
   i_marker_name = .net_ball.hlnk_0_0.MARKER_1  &
   j_marker_name = .net_ball.vlnk_0_0.MARKER_2  &
   length = 25.0  &
   area_of_cross_section = 3.1415926536  &
   y_shear_area_ratio = 1.0  &
   z_shear_area_ratio = 1.0  &
   youngs_modulus = 7.1705E+04  &
   shear_modulus = 2.6956766917E+04  &
   ixx = 1.5707963268  &
   iyy = 0.7853981634  &
   izz = 0.7853981634  &
   damping_ratio = 1.0E-05  &
   formulation = linear
!
force create element_like beam  &
   beam_name = .net_ball.hBeam_0_0_R  &
   adams_id = 2  &
   i_marker_name = .net_ball.hlnk_0_0.MARKER_3  &
   j_marker_name = .net_ball.vlnk_1_0.MARKER_4  &
   length = 25.0  &
   area_of_cross_section = 3.1415926536  &
   y_shear_area_ratio = 1.0  &
   z_shear_area_ratio = 1.0  &
   youngs_modulus = 7.1705E+04  &
   shear_modulus = 2.6956766917E+04  &
   ixx = 1.5707963268  &
   iyy = 0.7853981634  &
   izz = 0.7853981634  &
   damping_ratio = 1.0E-05  &
   formulation = linear
!
force create element_like beam  &
   beam_name = .net_ball.hBeam_0_1_L  &
   adams_id = 3  &
   i_marker_name = .net_ball.hlnk_0_1.MARKER_5  &
   j_marker_name = .net_ball.vlnk_0_1.MARKER_6  &
   length = 25.0  &
   area_of_cross_section = 3.1415926536  &
   y_shear_area_ratio = 1.0  &
   z_shear_area_ratio = 1.0  &
   youngs_modulus = 7.1705E+04  &
   shear_modulus = 2.6956766917E+04  &
   ixx = 1.5707963268  &
   iyy = 0.7853981634  &
   izz = 0.7853981634  &
   damping_ratio = 1.0E-05  &
   formulation = linear
!
force create element_like beam  &
   beam_name = .net_ball.hBeam_0_1_R  &
   adams_id = 4  &
   i_marker_name = .net_ball.hlnk_0_1.MARKER_7  &
   j_marker_name = .net_ball.vlnk_1_1.MARKER_8  &
   length = 25.0  &
   area_of_cross_section = 3.1415926536  &
   y_shear_area_ratio = 1.0  &
   z_shear_area_ratio = 1.0  &
   youngs_modulus = 7.1705E+04  &
   shear_modulus = 2.6956766917E+04  &
   ixx = 1.5707963268  &
   iyy = 0.7853981634  &
   izz = 0.7853981634  &
   damping_ratio = 1.0E-05  &
   formulation = linear
!
force create element_like beam  &
   beam_name = .net_ball.hBeam_0_2_L  &
   adams_id = 5  &
   i_marker_name = .net_ball.hlnk_0_2.MARKER_9  &
   j_marker_name = .net_ball.vlnk_0_2.MARKER_10  &
   length = 25.0  &
   area_of_cross_section = 3.1415926536  &
   y_shear_area_ratio = 1.0  &
   z_shear_area_ratio = 1.0  &
   youngs_modulus = 7.1705E+04  &
   shear_modulus = 2.6956766917E+04  &
   ixx = 1.5707963268  &
   iyy = 0.7853981634  &
   izz = 0.7853981634  &
   damping_ratio = 1.0E-05  &
   formulation = linear
!
force create element_like beam  &
   beam_name = .net_ball.hBeam_0_2_R  &
   adams_id = 6  &
   i_marker_name = .net_ball.hlnk_0_2.MARKER_11  &
   j_marker_name = .net_ball.vlnk_1_2.MARKER_12  &
   length = 25.0  &
   area_of_cross_section = 3.1415926536  &
   y_shear_area_ratio = 1.0  &
   z_shear_area_ratio = 1.0  &
   youngs_modulus = 7.1705E+04  &
   shear_modulus = 2.6956766917E+04  &
   ixx = 1.5707963268  &
   iyy = 0.7853981634  &
   izz = 0.7853981634  &
   damping_ratio = 1.0E-05  &
   formulation = linear
!
force create element_like beam  &
   beam_name = .net_ball.hBeam_0_3_L  &
   adams_id = 7  &
   i_marker_name = .net_ball.hlnk_0_3.MARKER_13  &
   j_marker_name = .net_ball.vlnk_0_3.MARKER_14  &
   length = 25.0  &
   area_of_cross_section = 3.1415926536  &
   y_shear_area_ratio = 1.0  &
   z_shear_area_ratio = 1.0  &
   youngs_modulus = 7.1705E+04  &
   shear_modulus = 2.6956766917E+04  &
   ixx = 1.5707963268  &
   iyy = 0.7853981634  &
   izz = 0.7853981634  &
   damping_ratio = 1.0E-05  &
   formulation = linear
!
force create element_like beam  &
   beam_name = .net_ball.hBeam_0_3_R  &
   adams_id = 8  &
   i_marker_name = .net_ball.hlnk_0_3.MARKER_15  &
   j_marker_name = .net_ball.vlnk_1_3.MARKER_16  &
   length = 25.0  &
   area_of_cross_section = 3.1415926536  &
   y_shear_area_ratio = 1.0  &
   z_shear_area_ratio = 1.0  &
   youngs_modulus = 7.1705E+04  &
   shear_modulus = 2.6956766917E+04  &
   ixx = 1.5707963268  &
   iyy = 0.7853981634  &
   izz = 0.7853981634  &
   damping_ratio = 1.0E-05  &
   formulation = linear
!
force create element_like beam  &
   beam_name = .net_ball.hBeam_0_4_L  &
   adams_id = 9  &
   i_marker_name = .net_ball.hlnk_0_4.MARKER_17  &
   j_marker_name = .net_ball.vlnk_0_4.MARKER_18  &
   length = 25.0  &
   area_of_cross_section = 3.1415926536  &
   y_shear_area_ratio = 1.0  &
   z_shear_area_ratio = 1.0  &
   youngs_modulus = 7.1705E+04  &
   shear_modulus = 2.6956766917E+04  &
   ixx = 1.5707963268  &
   iyy = 0.7853981634  &
   izz = 0.7853981634  &
   damping_ratio = 1.0E-05  &
   formulation = linear
!
force create element_like beam  &
   beam_name = .net_ball.hBeam_0_4_R  &
   adams_id = 10  &
   i_marker_name = .net_ball.hlnk_0_4.MARKER_19  &
   j_marker_name = .net_ball.vlnk_1_4.MARKER_20  &
   length = 25.0  &
   area_of_cross_section = 3.1415926536  &
   y_shear_area_ratio = 1.0  &
   z_shear_area_ratio = 1.0  &
   youngs_modulus = 7.1705E+04  &
   shear_modulus = 2.6956766917E+04  &
   ixx = 1.5707963268  &
   iyy = 0.7853981634  &
   izz = 0.7853981634  &
   damping_ratio = 1.0E-05  &
   formulation = linear
!
force create element_like beam  &
   beam_name = .net_ball.hBeam_0_5_L  &
   adams_id = 11  &
   i_marker_name = .net_ball.hlnk_0_5.MARKER_21  &
   j_marker_name = .net_ball.vlnk_0_5.MARKER_22  &
   length = 25.0  &
   area_of_cross_section = 3.1415926536  &
   y_shear_area_ratio = 1.0  &
   z_shear_area_ratio = 1.0  &
   youngs_modulus = 7.1705E+04  &
   shear_modulus = 2.6956766917E+04  &
   ixx = 1.5707963268  &
   iyy = 0.7853981634  &
   izz = 0.7853981634  &
   damping_ratio = 1.0E-05  &
   formulation = linear
!
force create element_like beam  &
   beam_name = .net_ball.hBeam_0_5_R  &
   adams_id = 12  &
   i_marker_name = .net_ball.hlnk_0_5.MARKER_23  &
   j_marker_name = .net_ball.vlnk_1_5.MARKER_24  &
   length = 25.0  &
   area_of_cross_section = 3.1415926536  &
   y_shear_area_ratio = 1.0  &
   z_shear_area_ratio = 1.0  &
   youngs_modulus = 7.1705E+04  &
   shear_modulus = 2.6956766917E+04  &
   ixx = 1.5707963268  &
   iyy = 0.7853981634  &
   izz = 0.7853981634  &
   damping_ratio = 1.0E-05  &
   formulation = linear
!
force create element_like beam  &
   beam_name = .net_ball.hBeam_0_6_L  &
   adams_id = 13  &
   i_marker_name = .net_ball.hlnk_0_6.MARKER_25  &
   j_marker_name = .net_ball.vlnk_0_6.MARKER_26  &
   length = 25.0  &
   area_of_cross_section = 3.1415926536  &
   y_shear_area_ratio = 1.0  &
   z_shear_area_ratio = 1.0  &
   youngs_modulus = 7.1705E+04  &
   shear_modulus = 2.6956766917E+04  &
   ixx = 1.5707963268  &
   iyy = 0.7853981634  &
   izz = 0.7853981634  &
   damping_ratio = 1.0E-05  &
   formulation = linear
!
force create element_like beam  &
   beam_name = .net_ball.hBeam_0_6_R  &
   adams_id = 14  &
   i_marker_name = .net_ball.hlnk_0_6.MARKER_27  &
   j_marker_name = .net_ball.vlnk_1_6.MARKER_28  &
   length = 25.0  &
   area_of_cross_section = 3.1415926536  &
   y_shear_area_ratio = 1.0  &
   z_shear_area_ratio = 1.0  &
   youngs_modulus = 7.1705E+04  &
   shear_modulus = 2.6956766917E+04  &
   ixx = 1.5707963268  &
   iyy = 0.7853981634  &
   izz = 0.7853981634  &
   damping_ratio = 1.0E-05  &
   formulation = linear
!
force create element_like beam  &
   beam_name = .net_ball.hBeam_0_7_L  &
   adams_id = 15  &
   i_marker_name = .net_ball.hlnk_0_7.MARKER_29  &
   j_marker_name = .net_ball.vlnk_0_7.MARKER_30  &
   length = 25.0  &
   area_of_cross_section = 3.1415926536  &
   y_shear_area_ratio = 1.0  &
   z_shear_area_ratio = 1.0  &
   youngs_modulus = 7.1705E+04  &
   shear_modulus = 2.6956766917E+04  &
   ixx = 1.5707963268  &
   iyy = 0.7853981634  &
   izz = 0.7853981634  &
   damping_ratio = 1.0E-05  &
   formulation = linear
!
force create element_like beam  &
   beam_name = .net_ball.hBeam_0_7_R  &
   adams_id = 16  &
   i_marker_name = .net_ball.hlnk_0_7.MARKER_31  &
   j_marker_name = .net_ball.vlnk_1_7.MARKER_32  &
   length = 25.0  &
   area_of_cross_section = 3.1415926536  &
   y_shear_area_ratio = 1.0  &
   z_shear_area_ratio = 1.0  &
   youngs_modulus = 7.1705E+04  &
   shear_modulus = 2.6956766917E+04  &
   ixx = 1.5707963268  &
   iyy = 0.7853981634  &
   izz = 0.7853981634  &
   damping_ratio = 1.0E-05  &
   formulation = linear
!
force create element_like beam  &
   beam_name = .net_ball.hBeam_0_8_L  &
   adams_id = 17  &
   i_marker_name = .net_ball.hlnk_0_8.MARKER_33  &
   j_marker_name = .net_ball.vlnk_0_8.MARKER_34  &
   length = 25.0  &
   area_of_cross_section = 3.1415926536  &
   y_shear_area_ratio = 1.0  &
   z_shear_area_ratio = 1.0  &
   youngs_modulus = 7.1705E+04  &
   shear_modulus = 2.6956766917E+04  &
   ixx = 1.5707963268  &
   iyy = 0.7853981634  &
   izz = 0.7853981634  &
   damping_ratio = 1.0E-05  &
   formulation = linear
!
force create element_like beam  &
   beam_name = .net_ball.hBeam_0_8_R  &
   adams_id = 18  &
   i_marker_name = .net_ball.hlnk_0_8.MARKER_35  &
   j_marker_name = .net_ball.vlnk_1_8.MARKER_36  &
   length = 25.0  &
   area_of_cross_section = 3.1415926536  &
   y_shear_area_ratio = 1.0  &
   z_shear_area_ratio = 1.0  &
   youngs_modulus = 7.1705E+04  &
   shear_modulus = 2.6956766917E+04  &
   ixx = 1.5707963268  &
   iyy = 0.7853981634  &
   izz = 0.7853981634  &
   damping_ratio = 1.0E-05  &
   formulation = linear
!
force create element_like beam  &
   beam_name = .net_ball.hBeam_0_9_L  &
   adams_id = 19  &
   i_marker_name = .net_ball.hlnk_0_8.MARKER_37  &
   j_marker_name = .net_ball.vlnk_0_8.MARKER_38  &
   length = 25.0  &
   area_of_cross_section = 3.1415926536  &
   y_shear_area_ratio = 1.0  &
   z_shear_area_ratio = 1.0  &
   youngs_modulus = 7.1705E+04  &
   shear_modulus = 2.6956766917E+04  &
   ixx = 1.5707963268  &
   iyy = 0.7853981634  &
   izz = 0.7853981634  &
   damping_ratio = 1.0E-05  &
   formulation = linear
!
force create element_like beam  &
   beam_name = .net_ball.hBeam_0_9_R  &
   adams_id = 20  &
   i_marker_name = .net_ball.hlnk_0_8.MARKER_39  &
   j_marker_name = .net_ball.vlnk_1_8.MARKER_40  &
   length = 25.0  &
   area_of_cross_section = 3.1415926536  &
   y_shear_area_ratio = 1.0  &
   z_shear_area_ratio = 1.0  &
   youngs_modulus = 7.1705E+04  &
   shear_modulus = 2.6956766917E+04  &
   ixx = 1.5707963268  &
   iyy = 0.7853981634  &
   izz = 0.7853981634  &
   damping_ratio = 1.0E-05  &
   formulation = linear
!
force create element_like beam  &
   beam_name = .net_ball.hBeam_1_0_L  &
   adams_id = 21  &
   i_marker_name = .net_ball.hlnk_1_0.MARKER_41  &
   j_marker_name = .net_ball.vlnk_1_0.MARKER_42  &
   length = 25.0  &
   area_of_cross_section = 3.1415926536  &
   y_shear_area_ratio = 1.0  &
   z_shear_area_ratio = 1.0  &
   youngs_modulus = 7.1705E+04  &
   shear_modulus = 2.6956766917E+04  &
   ixx = 1.5707963268  &
   iyy = 0.7853981634  &
   izz = 0.7853981634  &
   damping_ratio = 1.0E-05  &
   formulation = linear
!
force create element_like beam  &
   beam_name = .net_ball.hBeam_1_0_R  &
   adams_id = 22  &
   i_marker_name = .net_ball.hlnk_1_0.MARKER_43  &
   j_marker_name = .net_ball.vlnk_2_0.MARKER_44  &
   length = 25.0  &
   area_of_cross_section = 3.1415926536  &
   y_shear_area_ratio = 1.0  &
   z_shear_area_ratio = 1.0  &
   youngs_modulus = 7.1705E+04  &
   shear_modulus = 2.6956766917E+04  &
   ixx = 1.5707963268  &
   iyy = 0.7853981634  &
   izz = 0.7853981634  &
   damping_ratio = 1.0E-05  &
   formulation = linear
!
force create element_like beam  &
   beam_name = .net_ball.hBeam_1_1_L  &
   adams_id = 23  &
   i_marker_name = .net_ball.hlnk_1_1.MARKER_45  &
   j_marker_name = .net_ball.vlnk_1_1.MARKER_46  &
   length = 25.0  &
   area_of_cross_section = 3.1415926536  &
   y_shear_area_ratio = 1.0  &
   z_shear_area_ratio = 1.0  &
   youngs_modulus = 7.1705E+04  &
   shear_modulus = 2.6956766917E+04  &
   ixx = 1.5707963268  &
   iyy = 0.7853981634  &
   izz = 0.7853981634  &
   damping_ratio = 1.0E-05  &
   formulation = linear
!
force create element_like beam  &
   beam_name = .net_ball.hBeam_1_1_R  &
   adams_id = 24  &
   i_marker_name = .net_ball.hlnk_1_1.MARKER_47  &
   j_marker_name = .net_ball.vlnk_2_1.MARKER_48  &
   length = 25.0  &
   area_of_cross_section = 3.1415926536  &
   y_shear_area_ratio = 1.0  &
   z_shear_area_ratio = 1.0  &
   youngs_modulus = 7.1705E+04  &
   shear_modulus = 2.6956766917E+04  &
   ixx = 1.5707963268  &
   iyy = 0.7853981634  &
   izz = 0.7853981634  &
   damping_ratio = 1.0E-05  &
   formulation = linear
!
force create element_like beam  &
   beam_name = .net_ball.hBeam_1_2_L  &
   adams_id = 25  &
   i_marker_name = .net_ball.hlnk_1_2.MARKER_49  &
   j_marker_name = .net_ball.vlnk_1_2.MARKER_50  &
   length = 25.0  &
   area_of_cross_section = 3.1415926536  &
   y_shear_area_ratio = 1.0  &
   z_shear_area_ratio = 1.0  &
   youngs_modulus = 7.1705E+04  &
   shear_modulus = 2.6956766917E+04  &
   ixx = 1.5707963268  &
   iyy = 0.7853981634  &
   izz = 0.7853981634  &
   damping_ratio = 1.0E-05  &
   formulation = linear
!
force create element_like beam  &
   beam_name = .net_ball.hBeam_1_2_R  &
   adams_id = 26  &
   i_marker_name = .net_ball.hlnk_1_2.MARKER_51  &
   j_marker_name = .net_ball.vlnk_2_2.MARKER_52  &
   length = 25.0  &
   area_of_cross_section = 3.1415926536  &
   y_shear_area_ratio = 1.0  &
   z_shear_area_ratio = 1.0  &
   youngs_modulus = 7.1705E+04  &
   shear_modulus = 2.6956766917E+04  &
   ixx = 1.5707963268  &
   iyy = 0.7853981634  &
   izz = 0.7853981634  &
   damping_ratio = 1.0E-05  &
   formulation = linear
!
force create element_like beam  &
   beam_name = .net_ball.hBeam_1_3_L  &
   adams_id = 27  &
   i_marker_name = .net_ball.hlnk_1_3.MARKER_53  &
   j_marker_name = .net_ball.vlnk_1_3.MARKER_54  &
   length = 25.0  &
   area_of_cross_section = 3.1415926536  &
   y_shear_area_ratio = 1.0  &
   z_shear_area_ratio = 1.0  &
   youngs_modulus = 7.1705E+04  &
   shear_modulus = 2.6956766917E+04  &
   ixx = 1.5707963268  &
   iyy = 0.7853981634  &
   izz = 0.7853981634  &
   damping_ratio = 1.0E-05  &
   formulation = linear
!
force create element_like beam  &
   beam_name = .net_ball.hBeam_1_3_R  &
   adams_id = 28  &
   i_marker_name = .net_ball.hlnk_1_3.MARKER_55  &
   j_marker_name = .net_ball.vlnk_2_3.MARKER_56  &
   length = 25.0  &
   area_of_cross_section = 3.1415926536  &
   y_shear_area_ratio = 1.0  &
   z_shear_area_ratio = 1.0  &
   youngs_modulus = 7.1705E+04  &
   shear_modulus = 2.6956766917E+04  &
   ixx = 1.5707963268  &
   iyy = 0.7853981634  &
   izz = 0.7853981634  &
   damping_ratio = 1.0E-05  &
   formulation = linear
!
force create element_like beam  &
   beam_name = .net_ball.hBeam_1_4_L  &
   adams_id = 29  &
   i_marker_name = .net_ball.hlnk_1_4.MARKER_57  &
   j_marker_name = .net_ball.vlnk_1_4.MARKER_58  &
   length = 25.0  &
   area_of_cross_section = 3.1415926536  &
   y_shear_area_ratio = 1.0  &
   z_shear_area_ratio = 1.0  &
   youngs_modulus = 7.1705E+04  &
   shear_modulus = 2.6956766917E+04  &
   ixx = 1.5707963268  &
   iyy = 0.7853981634  &
   izz = 0.7853981634  &
   damping_ratio = 1.0E-05  &
   formulation = linear
!
force create element_like beam  &
   beam_name = .net_ball.hBeam_1_4_R  &
   adams_id = 30  &
   i_marker_name = .net_ball.hlnk_1_4.MARKER_59  &
   j_marker_name = .net_ball.vlnk_2_4.MARKER_60  &
   length = 25.0  &
   area_of_cross_section = 3.1415926536  &
   y_shear_area_ratio = 1.0  &
   z_shear_area_ratio = 1.0  &
   youngs_modulus = 7.1705E+04  &
   shear_modulus = 2.6956766917E+04  &
   ixx = 1.5707963268  &
   iyy = 0.7853981634  &
   izz = 0.7853981634  &
   damping_ratio = 1.0E-05  &
   formulation = linear
!
force create element_like beam  &
   beam_name = .net_ball.hBeam_1_5_L  &
   adams_id = 31  &
   i_marker_name = .net_ball.hlnk_1_5.MARKER_61  &
   j_marker_name = .net_ball.vlnk_1_5.MARKER_62  &
   length = 25.0  &
   area_of_cross_section = 3.1415926536  &
   y_shear_area_ratio = 1.0  &
   z_shear_area_ratio = 1.0  &
   youngs_modulus = 7.1705E+04  &
   shear_modulus = 2.6956766917E+04  &
   ixx = 1.5707963268  &
   iyy = 0.7853981634  &
   izz = 0.7853981634  &
   damping_ratio = 1.0E-05  &
   formulation = linear
!
force create element_like beam  &
   beam_name = .net_ball.hBeam_1_5_R  &
   adams_id = 32  &
   i_marker_name = .net_ball.hlnk_1_5.MARKER_63  &
   j_marker_name = .net_ball.vlnk_2_5.MARKER_64  &
   length = 25.0  &
   area_of_cross_section = 3.1415926536  &
   y_shear_area_ratio = 1.0  &
   z_shear_area_ratio = 1.0  &
   youngs_modulus = 7.1705E+04  &
   shear_modulus = 2.6956766917E+04  &
   ixx = 1.5707963268  &
   iyy = 0.7853981634  &
   izz = 0.7853981634  &
   damping_ratio = 1.0E-05  &
   formulation = linear
!
force create element_like beam  &
   beam_name = .net_ball.hBeam_1_6_L  &
   adams_id = 33  &
   i_marker_name = .net_ball.hlnk_1_6.MARKER_65  &
   j_marker_name = .net_ball.vlnk_1_6.MARKER_66  &
   length = 25.0  &
   area_of_cross_section = 3.1415926536  &
   y_shear_area_ratio = 1.0  &
   z_shear_area_ratio = 1.0  &
   youngs_modulus = 7.1705E+04  &
   shear_modulus = 2.6956766917E+04  &
   ixx = 1.5707963268  &
   iyy = 0.7853981634  &
   izz = 0.7853981634  &
   damping_ratio = 1.0E-05  &
   formulation = linear
!
force create element_like beam  &
   beam_name = .net_ball.hBeam_1_6_R  &
   adams_id = 34  &
   i_marker_name = .net_ball.hlnk_1_6.MARKER_67  &
   j_marker_name = .net_ball.vlnk_2_6.MARKER_68  &
   length = 25.0  &
   area_of_cross_section = 3.1415926536  &
   y_shear_area_ratio = 1.0  &
   z_shear_area_ratio = 1.0  &
   youngs_modulus = 7.1705E+04  &
   shear_modulus = 2.6956766917E+04  &
   ixx = 1.5707963268  &
   iyy = 0.7853981634  &
   izz = 0.7853981634  &
   damping_ratio = 1.0E-05  &
   formulation = linear
!
force create element_like beam  &
   beam_name = .net_ball.hBeam_1_7_L  &
   adams_id = 35  &
   i_marker_name = .net_ball.hlnk_1_7.MARKER_69  &
   j_marker_name = .net_ball.vlnk_1_7.MARKER_70  &
   length = 25.0  &
   area_of_cross_section = 3.1415926536  &
   y_shear_area_ratio = 1.0  &
   z_shear_area_ratio = 1.0  &
   youngs_modulus = 7.1705E+04  &
   shear_modulus = 2.6956766917E+04  &
   ixx = 1.5707963268  &
   iyy = 0.7853981634  &
   izz = 0.7853981634  &
   damping_ratio = 1.0E-05  &
   formulation = linear
!
force create element_like beam  &
   beam_name = .net_ball.hBeam_1_7_R  &
   adams_id = 36  &
   i_marker_name = .net_ball.hlnk_1_7.MARKER_71  &
   j_marker_name = .net_ball.vlnk_2_7.MARKER_72  &
   length = 25.0  &
   area_of_cross_section = 3.1415926536  &
   y_shear_area_ratio = 1.0  &
   z_shear_area_ratio = 1.0  &
   youngs_modulus = 7.1705E+04  &
   shear_modulus = 2.6956766917E+04  &
   ixx = 1.5707963268  &
   iyy = 0.7853981634  &
   izz = 0.7853981634  &
   damping_ratio = 1.0E-05  &
   formulation = linear
!
force create element_like beam  &
   beam_name = .net_ball.hBeam_1_8_L  &
   adams_id = 37  &
   i_marker_name = .net_ball.hlnk_1_8.MARKER_73  &
   j_marker_name = .net_ball.vlnk_1_8.MARKER_74  &
   length = 25.0  &
   area_of_cross_section = 3.1415926536  &
   y_shear_area_ratio = 1.0  &
   z_shear_area_ratio = 1.0  &
   youngs_modulus = 7.1705E+04  &
   shear_modulus = 2.6956766917E+04  &
   ixx = 1.5707963268  &
   iyy = 0.7853981634  &
   izz = 0.7853981634  &
   damping_ratio = 1.0E-05  &
   formulation = linear
!
force create element_like beam  &
   beam_name = .net_ball.hBeam_1_8_R  &
   adams_id = 38  &
   i_marker_name = .net_ball.hlnk_1_8.MARKER_75  &
   j_marker_name = .net_ball.vlnk_2_8.MARKER_76  &
   length = 25.0  &
   area_of_cross_section = 3.1415926536  &
   y_shear_area_ratio = 1.0  &
   z_shear_area_ratio = 1.0  &
   youngs_modulus = 7.1705E+04  &
   shear_modulus = 2.6956766917E+04  &
   ixx = 1.5707963268  &
   iyy = 0.7853981634  &
   izz = 0.7853981634  &
   damping_ratio = 1.0E-05  &
   formulation = linear
!
force create element_like beam  &
   beam_name = .net_ball.hBeam_1_9_L  &
   adams_id = 39  &
   i_marker_name = .net_ball.hlnk_1_8.MARKER_77  &
   j_marker_name = .net_ball.vlnk_1_8.MARKER_78  &
   length = 25.0  &
   area_of_cross_section = 3.1415926536  &
   y_shear_area_ratio = 1.0  &
   z_shear_area_ratio = 1.0  &
   youngs_modulus = 7.1705E+04  &
   shear_modulus = 2.6956766917E+04  &
   ixx = 1.5707963268  &
   iyy = 0.7853981634  &
   izz = 0.7853981634  &
   damping_ratio = 1.0E-05  &
   formulation = linear
!
force create element_like beam  &
   beam_name = .net_ball.hBeam_1_9_R  &
   adams_id = 40  &
   i_marker_name = .net_ball.hlnk_1_8.MARKER_79  &
   j_marker_name = .net_ball.vlnk_2_8.MARKER_80  &
   length = 25.0  &
   area_of_cross_section = 3.1415926536  &
   y_shear_area_ratio = 1.0  &
   z_shear_area_ratio = 1.0  &
   youngs_modulus = 7.1705E+04  &
   shear_modulus = 2.6956766917E+04  &
   ixx = 1.5707963268  &
   iyy = 0.7853981634  &
   izz = 0.7853981634  &
   damping_ratio = 1.0E-05  &
   formulation = linear
!
force create element_like beam  &
   beam_name = .net_ball.hBeam_2_0_L  &
   adams_id = 41  &
   i_marker_name = .net_ball.hlnk_2_0.MARKER_81  &
   j_marker_name = .net_ball.vlnk_2_0.MARKER_82  &
   length = 25.0  &
   area_of_cross_section = 3.1415926536  &
   y_shear_area_ratio = 1.0  &
   z_shear_area_ratio = 1.0  &
   youngs_modulus = 7.1705E+04  &
   shear_modulus = 2.6956766917E+04  &
   ixx = 1.5707963268  &
   iyy = 0.7853981634  &
   izz = 0.7853981634  &
   damping_ratio = 1.0E-05  &
   formulation = linear
!
force create element_like beam  &
   beam_name = .net_ball.hBeam_2_0_R  &
   adams_id = 42  &
   i_marker_name = .net_ball.hlnk_2_0.MARKER_83  &
   j_marker_name = .net_ball.vlnk_3_0.MARKER_84  &
   length = 25.0  &
   area_of_cross_section = 3.1415926536  &
   y_shear_area_ratio = 1.0  &
   z_shear_area_ratio = 1.0  &
   youngs_modulus = 7.1705E+04  &
   shear_modulus = 2.6956766917E+04  &
   ixx = 1.5707963268  &
   iyy = 0.7853981634  &
   izz = 0.7853981634  &
   damping_ratio = 1.0E-05  &
   formulation = linear
!
force create element_like beam  &
   beam_name = .net_ball.hBeam_2_1_L  &
   adams_id = 43  &
   i_marker_name = .net_ball.hlnk_2_1.MARKER_85  &
   j_marker_name = .net_ball.vlnk_2_1.MARKER_86  &
   length = 25.0  &
   area_of_cross_section = 3.1415926536  &
   y_shear_area_ratio = 1.0  &
   z_shear_area_ratio = 1.0  &
   youngs_modulus = 7.1705E+04  &
   shear_modulus = 2.6956766917E+04  &
   ixx = 1.5707963268  &
   iyy = 0.7853981634  &
   izz = 0.7853981634  &
   damping_ratio = 1.0E-05  &
   formulation = linear
!
force create element_like beam  &
   beam_name = .net_ball.hBeam_2_1_R  &
   adams_id = 44  &
   i_marker_name = .net_ball.hlnk_2_1.MARKER_87  &
   j_marker_name = .net_ball.vlnk_3_1.MARKER_88  &
   length = 25.0  &
   area_of_cross_section = 3.1415926536  &
   y_shear_area_ratio = 1.0  &
   z_shear_area_ratio = 1.0  &
   youngs_modulus = 7.1705E+04  &
   shear_modulus = 2.6956766917E+04  &
   ixx = 1.5707963268  &
   iyy = 0.7853981634  &
   izz = 0.7853981634  &
   damping_ratio = 1.0E-05  &
   formulation = linear
!
force create element_like beam  &
   beam_name = .net_ball.hBeam_2_2_L  &
   adams_id = 45  &
   i_marker_name = .net_ball.hlnk_2_2.MARKER_89  &
   j_marker_name = .net_ball.vlnk_2_2.MARKER_90  &
   length = 25.0  &
   area_of_cross_section = 3.1415926536  &
   y_shear_area_ratio = 1.0  &
   z_shear_area_ratio = 1.0  &
   youngs_modulus = 7.1705E+04  &
   shear_modulus = 2.6956766917E+04  &
   ixx = 1.5707963268  &
   iyy = 0.7853981634  &
   izz = 0.7853981634  &
   damping_ratio = 1.0E-05  &
   formulation = linear
!
force create element_like beam  &
   beam_name = .net_ball.hBeam_2_2_R  &
   adams_id = 46  &
   i_marker_name = .net_ball.hlnk_2_2.MARKER_91  &
   j_marker_name = .net_ball.vlnk_3_2.MARKER_92  &
   length = 25.0  &
   area_of_cross_section = 3.1415926536  &
   y_shear_area_ratio = 1.0  &
   z_shear_area_ratio = 1.0  &
   youngs_modulus = 7.1705E+04  &
   shear_modulus = 2.6956766917E+04  &
   ixx = 1.5707963268  &
   iyy = 0.7853981634  &
   izz = 0.7853981634  &
   damping_ratio = 1.0E-05  &
   formulation = linear
!
force create element_like beam  &
   beam_name = .net_ball.hBeam_2_3_L  &
   adams_id = 47  &
   i_marker_name = .net_ball.hlnk_2_3.MARKER_93  &
   j_marker_name = .net_ball.vlnk_2_3.MARKER_94  &
   length = 25.0  &
   area_of_cross_section = 3.1415926536  &
   y_shear_area_ratio = 1.0  &
   z_shear_area_ratio = 1.0  &
   youngs_modulus = 7.1705E+04  &
   shear_modulus = 2.6956766917E+04  &
   ixx = 1.5707963268  &
   iyy = 0.7853981634  &
   izz = 0.7853981634  &
   damping_ratio = 1.0E-05  &
   formulation = linear
!
force create element_like beam  &
   beam_name = .net_ball.hBeam_2_3_R  &
   adams_id = 48  &
   i_marker_name = .net_ball.hlnk_2_3.MARKER_95  &
   j_marker_name = .net_ball.vlnk_3_3.MARKER_96  &
   length = 25.0  &
   area_of_cross_section = 3.1415926536  &
   y_shear_area_ratio = 1.0  &
   z_shear_area_ratio = 1.0  &
   youngs_modulus = 7.1705E+04  &
   shear_modulus = 2.6956766917E+04  &
   ixx = 1.5707963268  &
   iyy = 0.7853981634  &
   izz = 0.7853981634  &
   damping_ratio = 1.0E-05  &
   formulation = linear
!
force create element_like beam  &
   beam_name = .net_ball.hBeam_2_4_L  &
   adams_id = 49  &
   i_marker_name = .net_ball.hlnk_2_4.MARKER_97  &
   j_marker_name = .net_ball.vlnk_2_4.MARKER_98  &
   length = 25.0  &
   area_of_cross_section = 3.1415926536  &
   y_shear_area_ratio = 1.0  &
   z_shear_area_ratio = 1.0  &
   youngs_modulus = 7.1705E+04  &
   shear_modulus = 2.6956766917E+04  &
   ixx = 1.5707963268  &
   iyy = 0.7853981634  &
   izz = 0.7853981634  &
   damping_ratio = 1.0E-05  &
   formulation = linear
!
force create element_like beam  &
   beam_name = .net_ball.hBeam_2_4_R  &
   adams_id = 50  &
   i_marker_name = .net_ball.hlnk_2_4.MARKER_99  &
   j_marker_name = .net_ball.vlnk_3_4.MARKER_100  &
   length = 25.0  &
   area_of_cross_section = 3.1415926536  &
   y_shear_area_ratio = 1.0  &
   z_shear_area_ratio = 1.0  &
   youngs_modulus = 7.1705E+04  &
   shear_modulus = 2.6956766917E+04  &
   ixx = 1.5707963268  &
   iyy = 0.7853981634  &
   izz = 0.7853981634  &
   damping_ratio = 1.0E-05  &
   formulation = linear
!
force create element_like beam  &
   beam_name = .net_ball.hBeam_2_5_L  &
   adams_id = 51  &
   i_marker_name = .net_ball.hlnk_2_5.MARKER_101  &
   j_marker_name = .net_ball.vlnk_2_5.MARKER_102  &
   length = 25.0  &
   area_of_cross_section = 3.1415926536  &
   y_shear_area_ratio = 1.0  &
   z_shear_area_ratio = 1.0  &
   youngs_modulus = 7.1705E+04  &
   shear_modulus = 2.6956766917E+04  &
   ixx = 1.5707963268  &
   iyy = 0.7853981634  &
   izz = 0.7853981634  &
   damping_ratio = 1.0E-05  &
   formulation = linear
!
force create element_like beam  &
   beam_name = .net_ball.hBeam_2_5_R  &
   adams_id = 52  &
   i_marker_name = .net_ball.hlnk_2_5.MARKER_103  &
   j_marker_name = .net_ball.vlnk_3_5.MARKER_104  &
   length = 25.0  &
   area_of_cross_section = 3.1415926536  &
   y_shear_area_ratio = 1.0  &
   z_shear_area_ratio = 1.0  &
   youngs_modulus = 7.1705E+04  &
   shear_modulus = 2.6956766917E+04  &
   ixx = 1.5707963268  &
   iyy = 0.7853981634  &
   izz = 0.7853981634  &
   damping_ratio = 1.0E-05  &
   formulation = linear
!
force create element_like beam  &
   beam_name = .net_ball.hBeam_2_6_L  &
   adams_id = 53  &
   i_marker_name = .net_ball.hlnk_2_6.MARKER_105  &
   j_marker_name = .net_ball.vlnk_2_6.MARKER_106  &
   length = 25.0  &
   area_of_cross_section = 3.1415926536  &
   y_shear_area_ratio = 1.0  &
   z_shear_area_ratio = 1.0  &
   youngs_modulus = 7.1705E+04  &
   shear_modulus = 2.6956766917E+04  &
   ixx = 1.5707963268  &
   iyy = 0.7853981634  &
   izz = 0.7853981634  &
   damping_ratio = 1.0E-05  &
   formulation = linear
!
force create element_like beam  &
   beam_name = .net_ball.hBeam_2_6_R  &
   adams_id = 54  &
   i_marker_name = .net_ball.hlnk_2_6.MARKER_107  &
   j_marker_name = .net_ball.vlnk_3_6.MARKER_108  &
   length = 25.0  &
   area_of_cross_section = 3.1415926536  &
   y_shear_area_ratio = 1.0  &
   z_shear_area_ratio = 1.0  &
   youngs_modulus = 7.1705E+04  &
   shear_modulus = 2.6956766917E+04  &
   ixx = 1.5707963268  &
   iyy = 0.7853981634  &
   izz = 0.7853981634  &
   damping_ratio = 1.0E-05  &
   formulation = linear
!
force create element_like beam  &
   beam_name = .net_ball.hBeam_2_7_L  &
   adams_id = 55  &
   i_marker_name = .net_ball.hlnk_2_7.MARKER_109  &
   j_marker_name = .net_ball.vlnk_2_7.MARKER_110  &
   length = 25.0  &
   area_of_cross_section = 3.1415926536  &
   y_shear_area_ratio = 1.0  &
   z_shear_area_ratio = 1.0  &
   youngs_modulus = 7.1705E+04  &
   shear_modulus = 2.6956766917E+04  &
   ixx = 1.5707963268  &
   iyy = 0.7853981634  &
   izz = 0.7853981634  &
   damping_ratio = 1.0E-05  &
   formulation = linear
!
force create element_like beam  &
   beam_name = .net_ball.hBeam_2_7_R  &
   adams_id = 56  &
   i_marker_name = .net_ball.hlnk_2_7.MARKER_111  &
   j_marker_name = .net_ball.vlnk_3_7.MARKER_112  &
   length = 25.0  &
   area_of_cross_section = 3.1415926536  &
   y_shear_area_ratio = 1.0  &
   z_shear_area_ratio = 1.0  &
   youngs_modulus = 7.1705E+04  &
   shear_modulus = 2.6956766917E+04  &
   ixx = 1.5707963268  &
   iyy = 0.7853981634  &
   izz = 0.7853981634  &
   damping_ratio = 1.0E-05  &
   formulation = linear
!
force create element_like beam  &
   beam_name = .net_ball.hBeam_2_8_L  &
   adams_id = 57  &
   i_marker_name = .net_ball.hlnk_2_8.MARKER_113  &
   j_marker_name = .net_ball.vlnk_2_8.MARKER_114  &
   length = 25.0  &
   area_of_cross_section = 3.1415926536  &
   y_shear_area_ratio = 1.0  &
   z_shear_area_ratio = 1.0  &
   youngs_modulus = 7.1705E+04  &
   shear_modulus = 2.6956766917E+04  &
   ixx = 1.5707963268  &
   iyy = 0.7853981634  &
   izz = 0.7853981634  &
   damping_ratio = 1.0E-05  &
   formulation = linear
!
force create element_like beam  &
   beam_name = .net_ball.hBeam_2_8_R  &
   adams_id = 58  &
   i_marker_name = .net_ball.hlnk_2_8.MARKER_115  &
   j_marker_name = .net_ball.vlnk_3_8.MARKER_116  &
   length = 25.0  &
   area_of_cross_section = 3.1415926536  &
   y_shear_area_ratio = 1.0  &
   z_shear_area_ratio = 1.0  &
   youngs_modulus = 7.1705E+04  &
   shear_modulus = 2.6956766917E+04  &
   ixx = 1.5707963268  &
   iyy = 0.7853981634  &
   izz = 0.7853981634  &
   damping_ratio = 1.0E-05  &
   formulation = linear
!
force create element_like beam  &
   beam_name = .net_ball.hBeam_2_9_L  &
   adams_id = 59  &
   i_marker_name = .net_ball.hlnk_2_8.MARKER_117  &
   j_marker_name = .net_ball.vlnk_2_8.MARKER_118  &
   length = 25.0  &
   area_of_cross_section = 3.1415926536  &
   y_shear_area_ratio = 1.0  &
   z_shear_area_ratio = 1.0  &
   youngs_modulus = 7.1705E+04  &
   shear_modulus = 2.6956766917E+04  &
   ixx = 1.5707963268  &
   iyy = 0.7853981634  &
   izz = 0.7853981634  &
   damping_ratio = 1.0E-05  &
   formulation = linear
!
force create element_like beam  &
   beam_name = .net_ball.hBeam_2_9_R  &
   adams_id = 60  &
   i_marker_name = .net_ball.hlnk_2_8.MARKER_119  &
   j_marker_name = .net_ball.vlnk_3_8.MARKER_120  &
   length = 25.0  &
   area_of_cross_section = 3.1415926536  &
   y_shear_area_ratio = 1.0  &
   z_shear_area_ratio = 1.0  &
   youngs_modulus = 7.1705E+04  &
   shear_modulus = 2.6956766917E+04  &
   ixx = 1.5707963268  &
   iyy = 0.7853981634  &
   izz = 0.7853981634  &
   damping_ratio = 1.0E-05  &
   formulation = linear
!
force create element_like beam  &
   beam_name = .net_ball.hBeam_3_0_L  &
   adams_id = 61  &
   i_marker_name = .net_ball.hlnk_3_0.MARKER_121  &
   j_marker_name = .net_ball.vlnk_3_0.MARKER_122  &
   length = 25.0  &
   area_of_cross_section = 3.1415926536  &
   y_shear_area_ratio = 1.0  &
   z_shear_area_ratio = 1.0  &
   youngs_modulus = 7.1705E+04  &
   shear_modulus = 2.6956766917E+04  &
   ixx = 1.5707963268  &
   iyy = 0.7853981634  &
   izz = 0.7853981634  &
   damping_ratio = 1.0E-05  &
   formulation = linear
!
force create element_like beam  &
   beam_name = .net_ball.hBeam_3_0_R  &
   adams_id = 62  &
   i_marker_name = .net_ball.hlnk_3_0.MARKER_123  &
   j_marker_name = .net_ball.vlnk_4_0.MARKER_124  &
   length = 25.0  &
   area_of_cross_section = 3.1415926536  &
   y_shear_area_ratio = 1.0  &
   z_shear_area_ratio = 1.0  &
   youngs_modulus = 7.1705E+04  &
   shear_modulus = 2.6956766917E+04  &
   ixx = 1.5707963268  &
   iyy = 0.7853981634  &
   izz = 0.7853981634  &
   damping_ratio = 1.0E-05  &
   formulation = linear
!
force create element_like beam  &
   beam_name = .net_ball.hBeam_3_1_L  &
   adams_id = 63  &
   i_marker_name = .net_ball.hlnk_3_1.MARKER_125  &
   j_marker_name = .net_ball.vlnk_3_1.MARKER_126  &
   length = 25.0  &
   area_of_cross_section = 3.1415926536  &
   y_shear_area_ratio = 1.0  &
   z_shear_area_ratio = 1.0  &
   youngs_modulus = 7.1705E+04  &
   shear_modulus = 2.6956766917E+04  &
   ixx = 1.5707963268  &
   iyy = 0.7853981634  &
   izz = 0.7853981634  &
   damping_ratio = 1.0E-05  &
   formulation = linear
!
force create element_like beam  &
   beam_name = .net_ball.hBeam_3_1_R  &
   adams_id = 64  &
   i_marker_name = .net_ball.hlnk_3_1.MARKER_127  &
   j_marker_name = .net_ball.vlnk_4_1.MARKER_128  &
   length = 25.0  &
   area_of_cross_section = 3.1415926536  &
   y_shear_area_ratio = 1.0  &
   z_shear_area_ratio = 1.0  &
   youngs_modulus = 7.1705E+04  &
   shear_modulus = 2.6956766917E+04  &
   ixx = 1.5707963268  &
   iyy = 0.7853981634  &
   izz = 0.7853981634  &
   damping_ratio = 1.0E-05  &
   formulation = linear
!
force create element_like beam  &
   beam_name = .net_ball.hBeam_3_2_L  &
   adams_id = 65  &
   i_marker_name = .net_ball.hlnk_3_2.MARKER_129  &
   j_marker_name = .net_ball.vlnk_3_2.MARKER_130  &
   length = 25.0  &
   area_of_cross_section = 3.1415926536  &
   y_shear_area_ratio = 1.0  &
   z_shear_area_ratio = 1.0  &
   youngs_modulus = 7.1705E+04  &
   shear_modulus = 2.6956766917E+04  &
   ixx = 1.5707963268  &
   iyy = 0.7853981634  &
   izz = 0.7853981634  &
   damping_ratio = 1.0E-05  &
   formulation = linear
!
force create element_like beam  &
   beam_name = .net_ball.hBeam_3_2_R  &
   adams_id = 66  &
   i_marker_name = .net_ball.hlnk_3_2.MARKER_131  &
   j_marker_name = .net_ball.vlnk_4_2.MARKER_132  &
   length = 25.0  &
   area_of_cross_section = 3.1415926536  &
   y_shear_area_ratio = 1.0  &
   z_shear_area_ratio = 1.0  &
   youngs_modulus = 7.1705E+04  &
   shear_modulus = 2.6956766917E+04  &
   ixx = 1.5707963268  &
   iyy = 0.7853981634  &
   izz = 0.7853981634  &
   damping_ratio = 1.0E-05  &
   formulation = linear
!
force create element_like beam  &
   beam_name = .net_ball.hBeam_3_3_L  &
   adams_id = 67  &
   i_marker_name = .net_ball.hlnk_3_3.MARKER_133  &
   j_marker_name = .net_ball.vlnk_3_3.MARKER_134  &
   length = 25.0  &
   area_of_cross_section = 3.1415926536  &
   y_shear_area_ratio = 1.0  &
   z_shear_area_ratio = 1.0  &
   youngs_modulus = 7.1705E+04  &
   shear_modulus = 2.6956766917E+04  &
   ixx = 1.5707963268  &
   iyy = 0.7853981634  &
   izz = 0.7853981634  &
   damping_ratio = 1.0E-05  &
   formulation = linear
!
force create element_like beam  &
   beam_name = .net_ball.hBeam_3_3_R  &
   adams_id = 68  &
   i_marker_name = .net_ball.hlnk_3_3.MARKER_135  &
   j_marker_name = .net_ball.vlnk_4_3.MARKER_136  &
   length = 25.0  &
   area_of_cross_section = 3.1415926536  &
   y_shear_area_ratio = 1.0  &
   z_shear_area_ratio = 1.0  &
   youngs_modulus = 7.1705E+04  &
   shear_modulus = 2.6956766917E+04  &
   ixx = 1.5707963268  &
   iyy = 0.7853981634  &
   izz = 0.7853981634  &
   damping_ratio = 1.0E-05  &
   formulation = linear
!
force create element_like beam  &
   beam_name = .net_ball.hBeam_3_4_L  &
   adams_id = 69  &
   i_marker_name = .net_ball.hlnk_3_4.MARKER_137  &
   j_marker_name = .net_ball.vlnk_3_4.MARKER_138  &
   length = 25.0  &
   area_of_cross_section = 3.1415926536  &
   y_shear_area_ratio = 1.0  &
   z_shear_area_ratio = 1.0  &
   youngs_modulus = 7.1705E+04  &
   shear_modulus = 2.6956766917E+04  &
   ixx = 1.5707963268  &
   iyy = 0.7853981634  &
   izz = 0.7853981634  &
   damping_ratio = 1.0E-05  &
   formulation = linear
!
force create element_like beam  &
   beam_name = .net_ball.hBeam_3_4_R  &
   adams_id = 70  &
   i_marker_name = .net_ball.hlnk_3_4.MARKER_139  &
   j_marker_name = .net_ball.vlnk_4_4.MARKER_140  &
   length = 25.0  &
   area_of_cross_section = 3.1415926536  &
   y_shear_area_ratio = 1.0  &
   z_shear_area_ratio = 1.0  &
   youngs_modulus = 7.1705E+04  &
   shear_modulus = 2.6956766917E+04  &
   ixx = 1.5707963268  &
   iyy = 0.7853981634  &
   izz = 0.7853981634  &
   damping_ratio = 1.0E-05  &
   formulation = linear
!
force create element_like beam  &
   beam_name = .net_ball.hBeam_3_5_L  &
   adams_id = 71  &
   i_marker_name = .net_ball.hlnk_3_5.MARKER_141  &
   j_marker_name = .net_ball.vlnk_3_5.MARKER_142  &
   length = 25.0  &
   area_of_cross_section = 3.1415926536  &
   y_shear_area_ratio = 1.0  &
   z_shear_area_ratio = 1.0  &
   youngs_modulus = 7.1705E+04  &
   shear_modulus = 2.6956766917E+04  &
   ixx = 1.5707963268  &
   iyy = 0.7853981634  &
   izz = 0.7853981634  &
   damping_ratio = 1.0E-05  &
   formulation = linear
!
force create element_like beam  &
   beam_name = .net_ball.hBeam_3_5_R  &
   adams_id = 72  &
   i_marker_name = .net_ball.hlnk_3_5.MARKER_143  &
   j_marker_name = .net_ball.vlnk_4_5.MARKER_144  &
   length = 25.0  &
   area_of_cross_section = 3.1415926536  &
   y_shear_area_ratio = 1.0  &
   z_shear_area_ratio = 1.0  &
   youngs_modulus = 7.1705E+04  &
   shear_modulus = 2.6956766917E+04  &
   ixx = 1.5707963268  &
   iyy = 0.7853981634  &
   izz = 0.7853981634  &
   damping_ratio = 1.0E-05  &
   formulation = linear
!
force create element_like beam  &
   beam_name = .net_ball.hBeam_3_6_L  &
   adams_id = 73  &
   i_marker_name = .net_ball.hlnk_3_6.MARKER_145  &
   j_marker_name = .net_ball.vlnk_3_6.MARKER_146  &
   length = 25.0  &
   area_of_cross_section = 3.1415926536  &
   y_shear_area_ratio = 1.0  &
   z_shear_area_ratio = 1.0  &
   youngs_modulus = 7.1705E+04  &
   shear_modulus = 2.6956766917E+04  &
   ixx = 1.5707963268  &
   iyy = 0.7853981634  &
   izz = 0.7853981634  &
   damping_ratio = 1.0E-05  &
   formulation = linear
!
force create element_like beam  &
   beam_name = .net_ball.hBeam_3_6_R  &
   adams_id = 74  &
   i_marker_name = .net_ball.hlnk_3_6.MARKER_147  &
   j_marker_name = .net_ball.vlnk_4_6.MARKER_148  &
   length = 25.0  &
   area_of_cross_section = 3.1415926536  &
   y_shear_area_ratio = 1.0  &
   z_shear_area_ratio = 1.0  &
   youngs_modulus = 7.1705E+04  &
   shear_modulus = 2.6956766917E+04  &
   ixx = 1.5707963268  &
   iyy = 0.7853981634  &
   izz = 0.7853981634  &
   damping_ratio = 1.0E-05  &
   formulation = linear
!
force create element_like beam  &
   beam_name = .net_ball.hBeam_3_7_L  &
   adams_id = 75  &
   i_marker_name = .net_ball.hlnk_3_7.MARKER_149  &
   j_marker_name = .net_ball.vlnk_3_7.MARKER_150  &
   length = 25.0  &
   area_of_cross_section = 3.1415926536  &
   y_shear_area_ratio = 1.0  &
   z_shear_area_ratio = 1.0  &
   youngs_modulus = 7.1705E+04  &
   shear_modulus = 2.6956766917E+04  &
   ixx = 1.5707963268  &
   iyy = 0.7853981634  &
   izz = 0.7853981634  &
   damping_ratio = 1.0E-05  &
   formulation = linear
!
force create element_like beam  &
   beam_name = .net_ball.hBeam_3_7_R  &
   adams_id = 76  &
   i_marker_name = .net_ball.hlnk_3_7.MARKER_151  &
   j_marker_name = .net_ball.vlnk_4_7.MARKER_152  &
   length = 25.0  &
   area_of_cross_section = 3.1415926536  &
   y_shear_area_ratio = 1.0  &
   z_shear_area_ratio = 1.0  &
   youngs_modulus = 7.1705E+04  &
   shear_modulus = 2.6956766917E+04  &
   ixx = 1.5707963268  &
   iyy = 0.7853981634  &
   izz = 0.7853981634  &
   damping_ratio = 1.0E-05  &
   formulation = linear
!
force create element_like beam  &
   beam_name = .net_ball.hBeam_3_8_L  &
   adams_id = 77  &
   i_marker_name = .net_ball.hlnk_3_8.MARKER_153  &
   j_marker_name = .net_ball.vlnk_3_8.MARKER_154  &
   length = 25.0  &
   area_of_cross_section = 3.1415926536  &
   y_shear_area_ratio = 1.0  &
   z_shear_area_ratio = 1.0  &
   youngs_modulus = 7.1705E+04  &
   shear_modulus = 2.6956766917E+04  &
   ixx = 1.5707963268  &
   iyy = 0.7853981634  &
   izz = 0.7853981634  &
   damping_ratio = 1.0E-05  &
   formulation = linear
!
force create element_like beam  &
   beam_name = .net_ball.hBeam_3_8_R  &
   adams_id = 78  &
   i_marker_name = .net_ball.hlnk_3_8.MARKER_155  &
   j_marker_name = .net_ball.vlnk_4_8.MARKER_156  &
   length = 25.0  &
   area_of_cross_section = 3.1415926536  &
   y_shear_area_ratio = 1.0  &
   z_shear_area_ratio = 1.0  &
   youngs_modulus = 7.1705E+04  &
   shear_modulus = 2.6956766917E+04  &
   ixx = 1.5707963268  &
   iyy = 0.7853981634  &
   izz = 0.7853981634  &
   damping_ratio = 1.0E-05  &
   formulation = linear
!
force create element_like beam  &
   beam_name = .net_ball.hBeam_3_9_L  &
   adams_id = 79  &
   i_marker_name = .net_ball.hlnk_3_8.MARKER_157  &
   j_marker_name = .net_ball.vlnk_3_8.MARKER_158  &
   length = 25.0  &
   area_of_cross_section = 3.1415926536  &
   y_shear_area_ratio = 1.0  &
   z_shear_area_ratio = 1.0  &
   youngs_modulus = 7.1705E+04  &
   shear_modulus = 2.6956766917E+04  &
   ixx = 1.5707963268  &
   iyy = 0.7853981634  &
   izz = 0.7853981634  &
   damping_ratio = 1.0E-05  &
   formulation = linear
!
force create element_like beam  &
   beam_name = .net_ball.hBeam_3_9_R  &
   adams_id = 80  &
   i_marker_name = .net_ball.hlnk_3_8.MARKER_159  &
   j_marker_name = .net_ball.vlnk_4_8.MARKER_160  &
   length = 25.0  &
   area_of_cross_section = 3.1415926536  &
   y_shear_area_ratio = 1.0  &
   z_shear_area_ratio = 1.0  &
   youngs_modulus = 7.1705E+04  &
   shear_modulus = 2.6956766917E+04  &
   ixx = 1.5707963268  &
   iyy = 0.7853981634  &
   izz = 0.7853981634  &
   damping_ratio = 1.0E-05  &
   formulation = linear
!
force create element_like beam  &
   beam_name = .net_ball.hBeam_4_0_L  &
   adams_id = 81  &
   i_marker_name = .net_ball.hlnk_4_0.MARKER_161  &
   j_marker_name = .net_ball.vlnk_4_0.MARKER_162  &
   length = 25.0  &
   area_of_cross_section = 3.1415926536  &
   y_shear_area_ratio = 1.0  &
   z_shear_area_ratio = 1.0  &
   youngs_modulus = 7.1705E+04  &
   shear_modulus = 2.6956766917E+04  &
   ixx = 1.5707963268  &
   iyy = 0.7853981634  &
   izz = 0.7853981634  &
   damping_ratio = 1.0E-05  &
   formulation = linear
!
force create element_like beam  &
   beam_name = .net_ball.hBeam_4_0_R  &
   adams_id = 82  &
   i_marker_name = .net_ball.hlnk_4_0.MARKER_163  &
   j_marker_name = .net_ball.vlnk_5_0.MARKER_164  &
   length = 25.0  &
   area_of_cross_section = 3.1415926536  &
   y_shear_area_ratio = 1.0  &
   z_shear_area_ratio = 1.0  &
   youngs_modulus = 7.1705E+04  &
   shear_modulus = 2.6956766917E+04  &
   ixx = 1.5707963268  &
   iyy = 0.7853981634  &
   izz = 0.7853981634  &
   damping_ratio = 1.0E-05  &
   formulation = linear
!
force create element_like beam  &
   beam_name = .net_ball.hBeam_4_1_L  &
   adams_id = 83  &
   i_marker_name = .net_ball.hlnk_4_1.MARKER_165  &
   j_marker_name = .net_ball.vlnk_4_1.MARKER_166  &
   length = 25.0  &
   area_of_cross_section = 3.1415926536  &
   y_shear_area_ratio = 1.0  &
   z_shear_area_ratio = 1.0  &
   youngs_modulus = 7.1705E+04  &
   shear_modulus = 2.6956766917E+04  &
   ixx = 1.5707963268  &
   iyy = 0.7853981634  &
   izz = 0.7853981634  &
   damping_ratio = 1.0E-05  &
   formulation = linear
!
force create element_like beam  &
   beam_name = .net_ball.hBeam_4_1_R  &
   adams_id = 84  &
   i_marker_name = .net_ball.hlnk_4_1.MARKER_167  &
   j_marker_name = .net_ball.vlnk_5_1.MARKER_168  &
   length = 25.0  &
   area_of_cross_section = 3.1415926536  &
   y_shear_area_ratio = 1.0  &
   z_shear_area_ratio = 1.0  &
   youngs_modulus = 7.1705E+04  &
   shear_modulus = 2.6956766917E+04  &
   ixx = 1.5707963268  &
   iyy = 0.7853981634  &
   izz = 0.7853981634  &
   damping_ratio = 1.0E-05  &
   formulation = linear
!
force create element_like beam  &
   beam_name = .net_ball.hBeam_4_2_L  &
   adams_id = 85  &
   i_marker_name = .net_ball.hlnk_4_2.MARKER_169  &
   j_marker_name = .net_ball.vlnk_4_2.MARKER_170  &
   length = 25.0  &
   area_of_cross_section = 3.1415926536  &
   y_shear_area_ratio = 1.0  &
   z_shear_area_ratio = 1.0  &
   youngs_modulus = 7.1705E+04  &
   shear_modulus = 2.6956766917E+04  &
   ixx = 1.5707963268  &
   iyy = 0.7853981634  &
   izz = 0.7853981634  &
   damping_ratio = 1.0E-05  &
   formulation = linear
!
force create element_like beam  &
   beam_name = .net_ball.hBeam_4_2_R  &
   adams_id = 86  &
   i_marker_name = .net_ball.hlnk_4_2.MARKER_171  &
   j_marker_name = .net_ball.vlnk_5_2.MARKER_172  &
   length = 25.0  &
   area_of_cross_section = 3.1415926536  &
   y_shear_area_ratio = 1.0  &
   z_shear_area_ratio = 1.0  &
   youngs_modulus = 7.1705E+04  &
   shear_modulus = 2.6956766917E+04  &
   ixx = 1.5707963268  &
   iyy = 0.7853981634  &
   izz = 0.7853981634  &
   damping_ratio = 1.0E-05  &
   formulation = linear
!
force create element_like beam  &
   beam_name = .net_ball.hBeam_4_3_L  &
   adams_id = 87  &
   i_marker_name = .net_ball.hlnk_4_3.MARKER_173  &
   j_marker_name = .net_ball.vlnk_4_3.MARKER_174  &
   length = 25.0  &
   area_of_cross_section = 3.1415926536  &
   y_shear_area_ratio = 1.0  &
   z_shear_area_ratio = 1.0  &
   youngs_modulus = 7.1705E+04  &
   shear_modulus = 2.6956766917E+04  &
   ixx = 1.5707963268  &
   iyy = 0.7853981634  &
   izz = 0.7853981634  &
   damping_ratio = 1.0E-05  &
   formulation = linear
!
force create element_like beam  &
   beam_name = .net_ball.hBeam_4_3_R  &
   adams_id = 88  &
   i_marker_name = .net_ball.hlnk_4_3.MARKER_175  &
   j_marker_name = .net_ball.vlnk_5_3.MARKER_176  &
   length = 25.0  &
   area_of_cross_section = 3.1415926536  &
   y_shear_area_ratio = 1.0  &
   z_shear_area_ratio = 1.0  &
   youngs_modulus = 7.1705E+04  &
   shear_modulus = 2.6956766917E+04  &
   ixx = 1.5707963268  &
   iyy = 0.7853981634  &
   izz = 0.7853981634  &
   damping_ratio = 1.0E-05  &
   formulation = linear
!
force create element_like beam  &
   beam_name = .net_ball.hBeam_4_4_L  &
   adams_id = 89  &
   i_marker_name = .net_ball.hlnk_4_4.MARKER_177  &
   j_marker_name = .net_ball.vlnk_4_4.MARKER_178  &
   length = 25.0  &
   area_of_cross_section = 3.1415926536  &
   y_shear_area_ratio = 1.0  &
   z_shear_area_ratio = 1.0  &
   youngs_modulus = 7.1705E+04  &
   shear_modulus = 2.6956766917E+04  &
   ixx = 1.5707963268  &
   iyy = 0.7853981634  &
   izz = 0.7853981634  &
   damping_ratio = 1.0E-05  &
   formulation = linear
!
force create element_like beam  &
   beam_name = .net_ball.hBeam_4_4_R  &
   adams_id = 90  &
   i_marker_name = .net_ball.hlnk_4_4.MARKER_179  &
   j_marker_name = .net_ball.vlnk_5_4.MARKER_180  &
   length = 25.0  &
   area_of_cross_section = 3.1415926536  &
   y_shear_area_ratio = 1.0  &
   z_shear_area_ratio = 1.0  &
   youngs_modulus = 7.1705E+04  &
   shear_modulus = 2.6956766917E+04  &
   ixx = 1.5707963268  &
   iyy = 0.7853981634  &
   izz = 0.7853981634  &
   damping_ratio = 1.0E-05  &
   formulation = linear
!
force create element_like beam  &
   beam_name = .net_ball.hBeam_4_5_L  &
   adams_id = 91  &
   i_marker_name = .net_ball.hlnk_4_5.MARKER_181  &
   j_marker_name = .net_ball.vlnk_4_5.MARKER_182  &
   length = 25.0  &
   area_of_cross_section = 3.1415926536  &
   y_shear_area_ratio = 1.0  &
   z_shear_area_ratio = 1.0  &
   youngs_modulus = 7.1705E+04  &
   shear_modulus = 2.6956766917E+04  &
   ixx = 1.5707963268  &
   iyy = 0.7853981634  &
   izz = 0.7853981634  &
   damping_ratio = 1.0E-05  &
   formulation = linear
!
force create element_like beam  &
   beam_name = .net_ball.hBeam_4_5_R  &
   adams_id = 92  &
   i_marker_name = .net_ball.hlnk_4_5.MARKER_183  &
   j_marker_name = .net_ball.vlnk_5_5.MARKER_184  &
   length = 25.0  &
   area_of_cross_section = 3.1415926536  &
   y_shear_area_ratio = 1.0  &
   z_shear_area_ratio = 1.0  &
   youngs_modulus = 7.1705E+04  &
   shear_modulus = 2.6956766917E+04  &
   ixx = 1.5707963268  &
   iyy = 0.7853981634  &
   izz = 0.7853981634  &
   damping_ratio = 1.0E-05  &
   formulation = linear
!
force create element_like beam  &
   beam_name = .net_ball.hBeam_4_6_L  &
   adams_id = 93  &
   i_marker_name = .net_ball.hlnk_4_6.MARKER_185  &
   j_marker_name = .net_ball.vlnk_4_6.MARKER_186  &
   length = 25.0  &
   area_of_cross_section = 3.1415926536  &
   y_shear_area_ratio = 1.0  &
   z_shear_area_ratio = 1.0  &
   youngs_modulus = 7.1705E+04  &
   shear_modulus = 2.6956766917E+04  &
   ixx = 1.5707963268  &
   iyy = 0.7853981634  &
   izz = 0.7853981634  &
   damping_ratio = 1.0E-05  &
   formulation = linear
!
force create element_like beam  &
   beam_name = .net_ball.hBeam_4_6_R  &
   adams_id = 94  &
   i_marker_name = .net_ball.hlnk_4_6.MARKER_187  &
   j_marker_name = .net_ball.vlnk_5_6.MARKER_188  &
   length = 25.0  &
   area_of_cross_section = 3.1415926536  &
   y_shear_area_ratio = 1.0  &
   z_shear_area_ratio = 1.0  &
   youngs_modulus = 7.1705E+04  &
   shear_modulus = 2.6956766917E+04  &
   ixx = 1.5707963268  &
   iyy = 0.7853981634  &
   izz = 0.7853981634  &
   damping_ratio = 1.0E-05  &
   formulation = linear
!
force create element_like beam  &
   beam_name = .net_ball.hBeam_4_7_L  &
   adams_id = 95  &
   i_marker_name = .net_ball.hlnk_4_7.MARKER_189  &
   j_marker_name = .net_ball.vlnk_4_7.MARKER_190  &
   length = 25.0  &
   area_of_cross_section = 3.1415926536  &
   y_shear_area_ratio = 1.0  &
   z_shear_area_ratio = 1.0  &
   youngs_modulus = 7.1705E+04  &
   shear_modulus = 2.6956766917E+04  &
   ixx = 1.5707963268  &
   iyy = 0.7853981634  &
   izz = 0.7853981634  &
   damping_ratio = 1.0E-05  &
   formulation = linear
!
force create element_like beam  &
   beam_name = .net_ball.hBeam_4_7_R  &
   adams_id = 96  &
   i_marker_name = .net_ball.hlnk_4_7.MARKER_191  &
   j_marker_name = .net_ball.vlnk_5_7.MARKER_192  &
   length = 25.0  &
   area_of_cross_section = 3.1415926536  &
   y_shear_area_ratio = 1.0  &
   z_shear_area_ratio = 1.0  &
   youngs_modulus = 7.1705E+04  &
   shear_modulus = 2.6956766917E+04  &
   ixx = 1.5707963268  &
   iyy = 0.7853981634  &
   izz = 0.7853981634  &
   damping_ratio = 1.0E-05  &
   formulation = linear
!
force create element_like beam  &
   beam_name = .net_ball.hBeam_4_8_L  &
   adams_id = 97  &
   i_marker_name = .net_ball.hlnk_4_8.MARKER_193  &
   j_marker_name = .net_ball.vlnk_4_8.MARKER_194  &
   length = 25.0  &
   area_of_cross_section = 3.1415926536  &
   y_shear_area_ratio = 1.0  &
   z_shear_area_ratio = 1.0  &
   youngs_modulus = 7.1705E+04  &
   shear_modulus = 2.6956766917E+04  &
   ixx = 1.5707963268  &
   iyy = 0.7853981634  &
   izz = 0.7853981634  &
   damping_ratio = 1.0E-05  &
   formulation = linear
!
force create element_like beam  &
   beam_name = .net_ball.hBeam_4_8_R  &
   adams_id = 98  &
   i_marker_name = .net_ball.hlnk_4_8.MARKER_195  &
   j_marker_name = .net_ball.vlnk_5_8.MARKER_196  &
   length = 25.0  &
   area_of_cross_section = 3.1415926536  &
   y_shear_area_ratio = 1.0  &
   z_shear_area_ratio = 1.0  &
   youngs_modulus = 7.1705E+04  &
   shear_modulus = 2.6956766917E+04  &
   ixx = 1.5707963268  &
   iyy = 0.7853981634  &
   izz = 0.7853981634  &
   damping_ratio = 1.0E-05  &
   formulation = linear
!
force create element_like beam  &
   beam_name = .net_ball.hBeam_4_9_L  &
   adams_id = 99  &
   i_marker_name = .net_ball.hlnk_4_8.MARKER_197  &
   j_marker_name = .net_ball.vlnk_4_8.MARKER_198  &
   length = 25.0  &
   area_of_cross_section = 3.1415926536  &
   y_shear_area_ratio = 1.0  &
   z_shear_area_ratio = 1.0  &
   youngs_modulus = 7.1705E+04  &
   shear_modulus = 2.6956766917E+04  &
   ixx = 1.5707963268  &
   iyy = 0.7853981634  &
   izz = 0.7853981634  &
   damping_ratio = 1.0E-05  &
   formulation = linear
!
force create element_like beam  &
   beam_name = .net_ball.hBeam_4_9_R  &
   adams_id = 100  &
   i_marker_name = .net_ball.hlnk_4_8.MARKER_199  &
   j_marker_name = .net_ball.vlnk_5_8.MARKER_200  &
   length = 25.0  &
   area_of_cross_section = 3.1415926536  &
   y_shear_area_ratio = 1.0  &
   z_shear_area_ratio = 1.0  &
   youngs_modulus = 7.1705E+04  &
   shear_modulus = 2.6956766917E+04  &
   ixx = 1.5707963268  &
   iyy = 0.7853981634  &
   izz = 0.7853981634  &
   damping_ratio = 1.0E-05  &
   formulation = linear
!
force create element_like beam  &
   beam_name = .net_ball.hBeam_5_0_L  &
   adams_id = 101  &
   i_marker_name = .net_ball.hlnk_5_0.MARKER_201  &
   j_marker_name = .net_ball.vlnk_5_0.MARKER_202  &
   length = 25.0  &
   area_of_cross_section = 3.1415926536  &
   y_shear_area_ratio = 1.0  &
   z_shear_area_ratio = 1.0  &
   youngs_modulus = 7.1705E+04  &
   shear_modulus = 2.6956766917E+04  &
   ixx = 1.5707963268  &
   iyy = 0.7853981634  &
   izz = 0.7853981634  &
   damping_ratio = 1.0E-05  &
   formulation = linear
!
force create element_like beam  &
   beam_name = .net_ball.hBeam_5_0_R  &
   adams_id = 102  &
   i_marker_name = .net_ball.hlnk_5_0.MARKER_203  &
   j_marker_name = .net_ball.vlnk_6_0.MARKER_204  &
   length = 25.0  &
   area_of_cross_section = 3.1415926536  &
   y_shear_area_ratio = 1.0  &
   z_shear_area_ratio = 1.0  &
   youngs_modulus = 7.1705E+04  &
   shear_modulus = 2.6956766917E+04  &
   ixx = 1.5707963268  &
   iyy = 0.7853981634  &
   izz = 0.7853981634  &
   damping_ratio = 1.0E-05  &
   formulation = linear
!
force create element_like beam  &
   beam_name = .net_ball.hBeam_5_1_L  &
   adams_id = 103  &
   i_marker_name = .net_ball.hlnk_5_1.MARKER_205  &
   j_marker_name = .net_ball.vlnk_5_1.MARKER_206  &
   length = 25.0  &
   area_of_cross_section = 3.1415926536  &
   y_shear_area_ratio = 1.0  &
   z_shear_area_ratio = 1.0  &
   youngs_modulus = 7.1705E+04  &
   shear_modulus = 2.6956766917E+04  &
   ixx = 1.5707963268  &
   iyy = 0.7853981634  &
   izz = 0.7853981634  &
   damping_ratio = 1.0E-05  &
   formulation = linear
!
force create element_like beam  &
   beam_name = .net_ball.hBeam_5_1_R  &
   adams_id = 104  &
   i_marker_name = .net_ball.hlnk_5_1.MARKER_207  &
   j_marker_name = .net_ball.vlnk_6_1.MARKER_208  &
   length = 25.0  &
   area_of_cross_section = 3.1415926536  &
   y_shear_area_ratio = 1.0  &
   z_shear_area_ratio = 1.0  &
   youngs_modulus = 7.1705E+04  &
   shear_modulus = 2.6956766917E+04  &
   ixx = 1.5707963268  &
   iyy = 0.7853981634  &
   izz = 0.7853981634  &
   damping_ratio = 1.0E-05  &
   formulation = linear
!
force create element_like beam  &
   beam_name = .net_ball.hBeam_5_2_L  &
   adams_id = 105  &
   i_marker_name = .net_ball.hlnk_5_2.MARKER_209  &
   j_marker_name = .net_ball.vlnk_5_2.MARKER_210  &
   length = 25.0  &
   area_of_cross_section = 3.1415926536  &
   y_shear_area_ratio = 1.0  &
   z_shear_area_ratio = 1.0  &
   youngs_modulus = 7.1705E+04  &
   shear_modulus = 2.6956766917E+04  &
   ixx = 1.5707963268  &
   iyy = 0.7853981634  &
   izz = 0.7853981634  &
   damping_ratio = 1.0E-05  &
   formulation = linear
!
force create element_like beam  &
   beam_name = .net_ball.hBeam_5_2_R  &
   adams_id = 106  &
   i_marker_name = .net_ball.hlnk_5_2.MARKER_211  &
   j_marker_name = .net_ball.vlnk_6_2.MARKER_212  &
   length = 25.0  &
   area_of_cross_section = 3.1415926536  &
   y_shear_area_ratio = 1.0  &
   z_shear_area_ratio = 1.0  &
   youngs_modulus = 7.1705E+04  &
   shear_modulus = 2.6956766917E+04  &
   ixx = 1.5707963268  &
   iyy = 0.7853981634  &
   izz = 0.7853981634  &
   damping_ratio = 1.0E-05  &
   formulation = linear
!
force create element_like beam  &
   beam_name = .net_ball.hBeam_5_3_L  &
   adams_id = 107  &
   i_marker_name = .net_ball.hlnk_5_3.MARKER_213  &
   j_marker_name = .net_ball.vlnk_5_3.MARKER_214  &
   length = 25.0  &
   area_of_cross_section = 3.1415926536  &
   y_shear_area_ratio = 1.0  &
   z_shear_area_ratio = 1.0  &
   youngs_modulus = 7.1705E+04  &
   shear_modulus = 2.6956766917E+04  &
   ixx = 1.5707963268  &
   iyy = 0.7853981634  &
   izz = 0.7853981634  &
   damping_ratio = 1.0E-05  &
   formulation = linear
!
force create element_like beam  &
   beam_name = .net_ball.hBeam_5_3_R  &
   adams_id = 108  &
   i_marker_name = .net_ball.hlnk_5_3.MARKER_215  &
   j_marker_name = .net_ball.vlnk_6_3.MARKER_216  &
   length = 25.0  &
   area_of_cross_section = 3.1415926536  &
   y_shear_area_ratio = 1.0  &
   z_shear_area_ratio = 1.0  &
   youngs_modulus = 7.1705E+04  &
   shear_modulus = 2.6956766917E+04  &
   ixx = 1.5707963268  &
   iyy = 0.7853981634  &
   izz = 0.7853981634  &
   damping_ratio = 1.0E-05  &
   formulation = linear
!
force create element_like beam  &
   beam_name = .net_ball.hBeam_5_4_L  &
   adams_id = 109  &
   i_marker_name = .net_ball.hlnk_5_4.MARKER_217  &
   j_marker_name = .net_ball.vlnk_5_4.MARKER_218  &
   length = 25.0  &
   area_of_cross_section = 3.1415926536  &
   y_shear_area_ratio = 1.0  &
   z_shear_area_ratio = 1.0  &
   youngs_modulus = 7.1705E+04  &
   shear_modulus = 2.6956766917E+04  &
   ixx = 1.5707963268  &
   iyy = 0.7853981634  &
   izz = 0.7853981634  &
   damping_ratio = 1.0E-05  &
   formulation = linear
!
force create element_like beam  &
   beam_name = .net_ball.hBeam_5_4_R  &
   adams_id = 110  &
   i_marker_name = .net_ball.hlnk_5_4.MARKER_219  &
   j_marker_name = .net_ball.vlnk_6_4.MARKER_220  &
   length = 25.0  &
   area_of_cross_section = 3.1415926536  &
   y_shear_area_ratio = 1.0  &
   z_shear_area_ratio = 1.0  &
   youngs_modulus = 7.1705E+04  &
   shear_modulus = 2.6956766917E+04  &
   ixx = 1.5707963268  &
   iyy = 0.7853981634  &
   izz = 0.7853981634  &
   damping_ratio = 1.0E-05  &
   formulation = linear
!
force create element_like beam  &
   beam_name = .net_ball.hBeam_5_5_L  &
   adams_id = 111  &
   i_marker_name = .net_ball.hlnk_5_5.MARKER_221  &
   j_marker_name = .net_ball.vlnk_5_5.MARKER_222  &
   length = 25.0  &
   area_of_cross_section = 3.1415926536  &
   y_shear_area_ratio = 1.0  &
   z_shear_area_ratio = 1.0  &
   youngs_modulus = 7.1705E+04  &
   shear_modulus = 2.6956766917E+04  &
   ixx = 1.5707963268  &
   iyy = 0.7853981634  &
   izz = 0.7853981634  &
   damping_ratio = 1.0E-05  &
   formulation = linear
!
force create element_like beam  &
   beam_name = .net_ball.hBeam_5_5_R  &
   adams_id = 112  &
   i_marker_name = .net_ball.hlnk_5_5.MARKER_223  &
   j_marker_name = .net_ball.vlnk_6_5.MARKER_224  &
   length = 25.0  &
   area_of_cross_section = 3.1415926536  &
   y_shear_area_ratio = 1.0  &
   z_shear_area_ratio = 1.0  &
   youngs_modulus = 7.1705E+04  &
   shear_modulus = 2.6956766917E+04  &
   ixx = 1.5707963268  &
   iyy = 0.7853981634  &
   izz = 0.7853981634  &
   damping_ratio = 1.0E-05  &
   formulation = linear
!
force create element_like beam  &
   beam_name = .net_ball.hBeam_5_6_L  &
   adams_id = 113  &
   i_marker_name = .net_ball.hlnk_5_6.MARKER_225  &
   j_marker_name = .net_ball.vlnk_5_6.MARKER_226  &
   length = 25.0  &
   area_of_cross_section = 3.1415926536  &
   y_shear_area_ratio = 1.0  &
   z_shear_area_ratio = 1.0  &
   youngs_modulus = 7.1705E+04  &
   shear_modulus = 2.6956766917E+04  &
   ixx = 1.5707963268  &
   iyy = 0.7853981634  &
   izz = 0.7853981634  &
   damping_ratio = 1.0E-05  &
   formulation = linear
!
force create element_like beam  &
   beam_name = .net_ball.hBeam_5_6_R  &
   adams_id = 114  &
   i_marker_name = .net_ball.hlnk_5_6.MARKER_227  &
   j_marker_name = .net_ball.vlnk_6_6.MARKER_228  &
   length = 25.0  &
   area_of_cross_section = 3.1415926536  &
   y_shear_area_ratio = 1.0  &
   z_shear_area_ratio = 1.0  &
   youngs_modulus = 7.1705E+04  &
   shear_modulus = 2.6956766917E+04  &
   ixx = 1.5707963268  &
   iyy = 0.7853981634  &
   izz = 0.7853981634  &
   damping_ratio = 1.0E-05  &
   formulation = linear
!
force create element_like beam  &
   beam_name = .net_ball.hBeam_5_7_L  &
   adams_id = 115  &
   i_marker_name = .net_ball.hlnk_5_7.MARKER_229  &
   j_marker_name = .net_ball.vlnk_5_7.MARKER_230  &
   length = 25.0  &
   area_of_cross_section = 3.1415926536  &
   y_shear_area_ratio = 1.0  &
   z_shear_area_ratio = 1.0  &
   youngs_modulus = 7.1705E+04  &
   shear_modulus = 2.6956766917E+04  &
   ixx = 1.5707963268  &
   iyy = 0.7853981634  &
   izz = 0.7853981634  &
   damping_ratio = 1.0E-05  &
   formulation = linear
!
force create element_like beam  &
   beam_name = .net_ball.hBeam_5_7_R  &
   adams_id = 116  &
   i_marker_name = .net_ball.hlnk_5_7.MARKER_231  &
   j_marker_name = .net_ball.vlnk_6_7.MARKER_232  &
   length = 25.0  &
   area_of_cross_section = 3.1415926536  &
   y_shear_area_ratio = 1.0  &
   z_shear_area_ratio = 1.0  &
   youngs_modulus = 7.1705E+04  &
   shear_modulus = 2.6956766917E+04  &
   ixx = 1.5707963268  &
   iyy = 0.7853981634  &
   izz = 0.7853981634  &
   damping_ratio = 1.0E-05  &
   formulation = linear
!
force create element_like beam  &
   beam_name = .net_ball.hBeam_5_8_L  &
   adams_id = 117  &
   i_marker_name = .net_ball.hlnk_5_8.MARKER_233  &
   j_marker_name = .net_ball.vlnk_5_8.MARKER_234  &
   length = 25.0  &
   area_of_cross_section = 3.1415926536  &
   y_shear_area_ratio = 1.0  &
   z_shear_area_ratio = 1.0  &
   youngs_modulus = 7.1705E+04  &
   shear_modulus = 2.6956766917E+04  &
   ixx = 1.5707963268  &
   iyy = 0.7853981634  &
   izz = 0.7853981634  &
   damping_ratio = 1.0E-05  &
   formulation = linear
!
force create element_like beam  &
   beam_name = .net_ball.hBeam_5_8_R  &
   adams_id = 118  &
   i_marker_name = .net_ball.hlnk_5_8.MARKER_235  &
   j_marker_name = .net_ball.vlnk_6_8.MARKER_236  &
   length = 25.0  &
   area_of_cross_section = 3.1415926536  &
   y_shear_area_ratio = 1.0  &
   z_shear_area_ratio = 1.0  &
   youngs_modulus = 7.1705E+04  &
   shear_modulus = 2.6956766917E+04  &
   ixx = 1.5707963268  &
   iyy = 0.7853981634  &
   izz = 0.7853981634  &
   damping_ratio = 1.0E-05  &
   formulation = linear
!
force create element_like beam  &
   beam_name = .net_ball.hBeam_5_9_L  &
   adams_id = 119  &
   i_marker_name = .net_ball.hlnk_5_8.MARKER_237  &
   j_marker_name = .net_ball.vlnk_5_8.MARKER_238  &
   length = 25.0  &
   area_of_cross_section = 3.1415926536  &
   y_shear_area_ratio = 1.0  &
   z_shear_area_ratio = 1.0  &
   youngs_modulus = 7.1705E+04  &
   shear_modulus = 2.6956766917E+04  &
   ixx = 1.5707963268  &
   iyy = 0.7853981634  &
   izz = 0.7853981634  &
   damping_ratio = 1.0E-05  &
   formulation = linear
!
force create element_like beam  &
   beam_name = .net_ball.hBeam_5_9_R  &
   adams_id = 120  &
   i_marker_name = .net_ball.hlnk_5_8.MARKER_239  &
   j_marker_name = .net_ball.vlnk_6_8.MARKER_240  &
   length = 25.0  &
   area_of_cross_section = 3.1415926536  &
   y_shear_area_ratio = 1.0  &
   z_shear_area_ratio = 1.0  &
   youngs_modulus = 7.1705E+04  &
   shear_modulus = 2.6956766917E+04  &
   ixx = 1.5707963268  &
   iyy = 0.7853981634  &
   izz = 0.7853981634  &
   damping_ratio = 1.0E-05  &
   formulation = linear
!
force create element_like beam  &
   beam_name = .net_ball.hBeam_6_0_L  &
   adams_id = 121  &
   i_marker_name = .net_ball.hlnk_6_0.MARKER_241  &
   j_marker_name = .net_ball.vlnk_6_0.MARKER_242  &
   length = 25.0  &
   area_of_cross_section = 3.1415926536  &
   y_shear_area_ratio = 1.0  &
   z_shear_area_ratio = 1.0  &
   youngs_modulus = 7.1705E+04  &
   shear_modulus = 2.6956766917E+04  &
   ixx = 1.5707963268  &
   iyy = 0.7853981634  &
   izz = 0.7853981634  &
   damping_ratio = 1.0E-05  &
   formulation = linear
!
force create element_like beam  &
   beam_name = .net_ball.hBeam_6_0_R  &
   adams_id = 122  &
   i_marker_name = .net_ball.hlnk_6_0.MARKER_243  &
   j_marker_name = .net_ball.vlnk_7_0.MARKER_244  &
   length = 25.0  &
   area_of_cross_section = 3.1415926536  &
   y_shear_area_ratio = 1.0  &
   z_shear_area_ratio = 1.0  &
   youngs_modulus = 7.1705E+04  &
   shear_modulus = 2.6956766917E+04  &
   ixx = 1.5707963268  &
   iyy = 0.7853981634  &
   izz = 0.7853981634  &
   damping_ratio = 1.0E-05  &
   formulation = linear
!
force create element_like beam  &
   beam_name = .net_ball.hBeam_6_1_L  &
   adams_id = 123  &
   i_marker_name = .net_ball.hlnk_6_1.MARKER_245  &
   j_marker_name = .net_ball.vlnk_6_1.MARKER_246  &
   length = 25.0  &
   area_of_cross_section = 3.1415926536  &
   y_shear_area_ratio = 1.0  &
   z_shear_area_ratio = 1.0  &
   youngs_modulus = 7.1705E+04  &
   shear_modulus = 2.6956766917E+04  &
   ixx = 1.5707963268  &
   iyy = 0.7853981634  &
   izz = 0.7853981634  &
   damping_ratio = 1.0E-05  &
   formulation = linear
!
force create element_like beam  &
   beam_name = .net_ball.hBeam_6_1_R  &
   adams_id = 124  &
   i_marker_name = .net_ball.hlnk_6_1.MARKER_247  &
   j_marker_name = .net_ball.vlnk_7_1.MARKER_248  &
   length = 25.0  &
   area_of_cross_section = 3.1415926536  &
   y_shear_area_ratio = 1.0  &
   z_shear_area_ratio = 1.0  &
   youngs_modulus = 7.1705E+04  &
   shear_modulus = 2.6956766917E+04  &
   ixx = 1.5707963268  &
   iyy = 0.7853981634  &
   izz = 0.7853981634  &
   damping_ratio = 1.0E-05  &
   formulation = linear
!
force create element_like beam  &
   beam_name = .net_ball.hBeam_6_2_L  &
   adams_id = 125  &
   i_marker_name = .net_ball.hlnk_6_2.MARKER_249  &
   j_marker_name = .net_ball.vlnk_6_2.MARKER_250  &
   length = 25.0  &
   area_of_cross_section = 3.1415926536  &
   y_shear_area_ratio = 1.0  &
   z_shear_area_ratio = 1.0  &
   youngs_modulus = 7.1705E+04  &
   shear_modulus = 2.6956766917E+04  &
   ixx = 1.5707963268  &
   iyy = 0.7853981634  &
   izz = 0.7853981634  &
   damping_ratio = 1.0E-05  &
   formulation = linear
!
force create element_like beam  &
   beam_name = .net_ball.hBeam_6_2_R  &
   adams_id = 126  &
   i_marker_name = .net_ball.hlnk_6_2.MARKER_251  &
   j_marker_name = .net_ball.vlnk_7_2.MARKER_252  &
   length = 25.0  &
   area_of_cross_section = 3.1415926536  &
   y_shear_area_ratio = 1.0  &
   z_shear_area_ratio = 1.0  &
   youngs_modulus = 7.1705E+04  &
   shear_modulus = 2.6956766917E+04  &
   ixx = 1.5707963268  &
   iyy = 0.7853981634  &
   izz = 0.7853981634  &
   damping_ratio = 1.0E-05  &
   formulation = linear
!
force create element_like beam  &
   beam_name = .net_ball.hBeam_6_3_L  &
   adams_id = 127  &
   i_marker_name = .net_ball.hlnk_6_3.MARKER_253  &
   j_marker_name = .net_ball.vlnk_6_3.MARKER_254  &
   length = 25.0  &
   area_of_cross_section = 3.1415926536  &
   y_shear_area_ratio = 1.0  &
   z_shear_area_ratio = 1.0  &
   youngs_modulus = 7.1705E+04  &
   shear_modulus = 2.6956766917E+04  &
   ixx = 1.5707963268  &
   iyy = 0.7853981634  &
   izz = 0.7853981634  &
   damping_ratio = 1.0E-05  &
   formulation = linear
!
force create element_like beam  &
   beam_name = .net_ball.hBeam_6_3_R  &
   adams_id = 128  &
   i_marker_name = .net_ball.hlnk_6_3.MARKER_255  &
   j_marker_name = .net_ball.vlnk_7_3.MARKER_256  &
   length = 25.0  &
   area_of_cross_section = 3.1415926536  &
   y_shear_area_ratio = 1.0  &
   z_shear_area_ratio = 1.0  &
   youngs_modulus = 7.1705E+04  &
   shear_modulus = 2.6956766917E+04  &
   ixx = 1.5707963268  &
   iyy = 0.7853981634  &
   izz = 0.7853981634  &
   damping_ratio = 1.0E-05  &
   formulation = linear
!
force create element_like beam  &
   beam_name = .net_ball.hBeam_6_4_L  &
   adams_id = 129  &
   i_marker_name = .net_ball.hlnk_6_4.MARKER_257  &
   j_marker_name = .net_ball.vlnk_6_4.MARKER_258  &
   length = 25.0  &
   area_of_cross_section = 3.1415926536  &
   y_shear_area_ratio = 1.0  &
   z_shear_area_ratio = 1.0  &
   youngs_modulus = 7.1705E+04  &
   shear_modulus = 2.6956766917E+04  &
   ixx = 1.5707963268  &
   iyy = 0.7853981634  &
   izz = 0.7853981634  &
   damping_ratio = 1.0E-05  &
   formulation = linear
!
force create element_like beam  &
   beam_name = .net_ball.hBeam_6_4_R  &
   adams_id = 130  &
   i_marker_name = .net_ball.hlnk_6_4.MARKER_259  &
   j_marker_name = .net_ball.vlnk_7_4.MARKER_260  &
   length = 25.0  &
   area_of_cross_section = 3.1415926536  &
   y_shear_area_ratio = 1.0  &
   z_shear_area_ratio = 1.0  &
   youngs_modulus = 7.1705E+04  &
   shear_modulus = 2.6956766917E+04  &
   ixx = 1.5707963268  &
   iyy = 0.7853981634  &
   izz = 0.7853981634  &
   damping_ratio = 1.0E-05  &
   formulation = linear
!
force create element_like beam  &
   beam_name = .net_ball.hBeam_6_5_L  &
   adams_id = 131  &
   i_marker_name = .net_ball.hlnk_6_5.MARKER_261  &
   j_marker_name = .net_ball.vlnk_6_5.MARKER_262  &
   length = 25.0  &
   area_of_cross_section = 3.1415926536  &
   y_shear_area_ratio = 1.0  &
   z_shear_area_ratio = 1.0  &
   youngs_modulus = 7.1705E+04  &
   shear_modulus = 2.6956766917E+04  &
   ixx = 1.5707963268  &
   iyy = 0.7853981634  &
   izz = 0.7853981634  &
   damping_ratio = 1.0E-05  &
   formulation = linear
!
force create element_like beam  &
   beam_name = .net_ball.hBeam_6_5_R  &
   adams_id = 132  &
   i_marker_name = .net_ball.hlnk_6_5.MARKER_263  &
   j_marker_name = .net_ball.vlnk_7_5.MARKER_264  &
   length = 25.0  &
   area_of_cross_section = 3.1415926536  &
   y_shear_area_ratio = 1.0  &
   z_shear_area_ratio = 1.0  &
   youngs_modulus = 7.1705E+04  &
   shear_modulus = 2.6956766917E+04  &
   ixx = 1.5707963268  &
   iyy = 0.7853981634  &
   izz = 0.7853981634  &
   damping_ratio = 1.0E-05  &
   formulation = linear
!
force create element_like beam  &
   beam_name = .net_ball.hBeam_6_6_L  &
   adams_id = 133  &
   i_marker_name = .net_ball.hlnk_6_6.MARKER_265  &
   j_marker_name = .net_ball.vlnk_6_6.MARKER_266  &
   length = 25.0  &
   area_of_cross_section = 3.1415926536  &
   y_shear_area_ratio = 1.0  &
   z_shear_area_ratio = 1.0  &
   youngs_modulus = 7.1705E+04  &
   shear_modulus = 2.6956766917E+04  &
   ixx = 1.5707963268  &
   iyy = 0.7853981634  &
   izz = 0.7853981634  &
   damping_ratio = 1.0E-05  &
   formulation = linear
!
force create element_like beam  &
   beam_name = .net_ball.hBeam_6_6_R  &
   adams_id = 134  &
   i_marker_name = .net_ball.hlnk_6_6.MARKER_267  &
   j_marker_name = .net_ball.vlnk_7_6.MARKER_268  &
   length = 25.0  &
   area_of_cross_section = 3.1415926536  &
   y_shear_area_ratio = 1.0  &
   z_shear_area_ratio = 1.0  &
   youngs_modulus = 7.1705E+04  &
   shear_modulus = 2.6956766917E+04  &
   ixx = 1.5707963268  &
   iyy = 0.7853981634  &
   izz = 0.7853981634  &
   damping_ratio = 1.0E-05  &
   formulation = linear
!
force create element_like beam  &
   beam_name = .net_ball.hBeam_6_7_L  &
   adams_id = 135  &
   i_marker_name = .net_ball.hlnk_6_7.MARKER_269  &
   j_marker_name = .net_ball.vlnk_6_7.MARKER_270  &
   length = 25.0  &
   area_of_cross_section = 3.1415926536  &
   y_shear_area_ratio = 1.0  &
   z_shear_area_ratio = 1.0  &
   youngs_modulus = 7.1705E+04  &
   shear_modulus = 2.6956766917E+04  &
   ixx = 1.5707963268  &
   iyy = 0.7853981634  &
   izz = 0.7853981634  &
   damping_ratio = 1.0E-05  &
   formulation = linear
!
force create element_like beam  &
   beam_name = .net_ball.hBeam_6_7_R  &
   adams_id = 136  &
   i_marker_name = .net_ball.hlnk_6_7.MARKER_271  &
   j_marker_name = .net_ball.vlnk_7_7.MARKER_272  &
   length = 25.0  &
   area_of_cross_section = 3.1415926536  &
   y_shear_area_ratio = 1.0  &
   z_shear_area_ratio = 1.0  &
   youngs_modulus = 7.1705E+04  &
   shear_modulus = 2.6956766917E+04  &
   ixx = 1.5707963268  &
   iyy = 0.7853981634  &
   izz = 0.7853981634  &
   damping_ratio = 1.0E-05  &
   formulation = linear
!
force create element_like beam  &
   beam_name = .net_ball.hBeam_6_8_L  &
   adams_id = 137  &
   i_marker_name = .net_ball.hlnk_6_8.MARKER_273  &
   j_marker_name = .net_ball.vlnk_6_8.MARKER_274  &
   length = 25.0  &
   area_of_cross_section = 3.1415926536  &
   y_shear_area_ratio = 1.0  &
   z_shear_area_ratio = 1.0  &
   youngs_modulus = 7.1705E+04  &
   shear_modulus = 2.6956766917E+04  &
   ixx = 1.5707963268  &
   iyy = 0.7853981634  &
   izz = 0.7853981634  &
   damping_ratio = 1.0E-05  &
   formulation = linear
!
force create element_like beam  &
   beam_name = .net_ball.hBeam_6_8_R  &
   adams_id = 138  &
   i_marker_name = .net_ball.hlnk_6_8.MARKER_275  &
   j_marker_name = .net_ball.vlnk_7_8.MARKER_276  &
   length = 25.0  &
   area_of_cross_section = 3.1415926536  &
   y_shear_area_ratio = 1.0  &
   z_shear_area_ratio = 1.0  &
   youngs_modulus = 7.1705E+04  &
   shear_modulus = 2.6956766917E+04  &
   ixx = 1.5707963268  &
   iyy = 0.7853981634  &
   izz = 0.7853981634  &
   damping_ratio = 1.0E-05  &
   formulation = linear
!
force create element_like beam  &
   beam_name = .net_ball.hBeam_6_9_L  &
   adams_id = 139  &
   i_marker_name = .net_ball.hlnk_6_8.MARKER_277  &
   j_marker_name = .net_ball.vlnk_6_8.MARKER_278  &
   length = 25.0  &
   area_of_cross_section = 3.1415926536  &
   y_shear_area_ratio = 1.0  &
   z_shear_area_ratio = 1.0  &
   youngs_modulus = 7.1705E+04  &
   shear_modulus = 2.6956766917E+04  &
   ixx = 1.5707963268  &
   iyy = 0.7853981634  &
   izz = 0.7853981634  &
   damping_ratio = 1.0E-05  &
   formulation = linear
!
force create element_like beam  &
   beam_name = .net_ball.hBeam_6_9_R  &
   adams_id = 140  &
   i_marker_name = .net_ball.hlnk_6_8.MARKER_279  &
   j_marker_name = .net_ball.vlnk_7_8.MARKER_280  &
   length = 25.0  &
   area_of_cross_section = 3.1415926536  &
   y_shear_area_ratio = 1.0  &
   z_shear_area_ratio = 1.0  &
   youngs_modulus = 7.1705E+04  &
   shear_modulus = 2.6956766917E+04  &
   ixx = 1.5707963268  &
   iyy = 0.7853981634  &
   izz = 0.7853981634  &
   damping_ratio = 1.0E-05  &
   formulation = linear
!
force create element_like beam  &
   beam_name = .net_ball.hBeam_7_0_L  &
   adams_id = 141  &
   i_marker_name = .net_ball.hlnk_7_0.MARKER_281  &
   j_marker_name = .net_ball.vlnk_7_0.MARKER_282  &
   length = 25.0  &
   area_of_cross_section = 3.1415926536  &
   y_shear_area_ratio = 1.0  &
   z_shear_area_ratio = 1.0  &
   youngs_modulus = 7.1705E+04  &
   shear_modulus = 2.6956766917E+04  &
   ixx = 1.5707963268  &
   iyy = 0.7853981634  &
   izz = 0.7853981634  &
   damping_ratio = 1.0E-05  &
   formulation = linear
!
force create element_like beam  &
   beam_name = .net_ball.hBeam_7_0_R  &
   adams_id = 142  &
   i_marker_name = .net_ball.hlnk_7_0.MARKER_283  &
   j_marker_name = .net_ball.vlnk_8_0.MARKER_284  &
   length = 25.0  &
   area_of_cross_section = 3.1415926536  &
   y_shear_area_ratio = 1.0  &
   z_shear_area_ratio = 1.0  &
   youngs_modulus = 7.1705E+04  &
   shear_modulus = 2.6956766917E+04  &
   ixx = 1.5707963268  &
   iyy = 0.7853981634  &
   izz = 0.7853981634  &
   damping_ratio = 1.0E-05  &
   formulation = linear
!
force create element_like beam  &
   beam_name = .net_ball.hBeam_7_1_L  &
   adams_id = 143  &
   i_marker_name = .net_ball.hlnk_7_1.MARKER_285  &
   j_marker_name = .net_ball.vlnk_7_1.MARKER_286  &
   length = 25.0  &
   area_of_cross_section = 3.1415926536  &
   y_shear_area_ratio = 1.0  &
   z_shear_area_ratio = 1.0  &
   youngs_modulus = 7.1705E+04  &
   shear_modulus = 2.6956766917E+04  &
   ixx = 1.5707963268  &
   iyy = 0.7853981634  &
   izz = 0.7853981634  &
   damping_ratio = 1.0E-05  &
   formulation = linear
!
force create element_like beam  &
   beam_name = .net_ball.hBeam_7_1_R  &
   adams_id = 144  &
   i_marker_name = .net_ball.hlnk_7_1.MARKER_287  &
   j_marker_name = .net_ball.vlnk_8_1.MARKER_288  &
   length = 25.0  &
   area_of_cross_section = 3.1415926536  &
   y_shear_area_ratio = 1.0  &
   z_shear_area_ratio = 1.0  &
   youngs_modulus = 7.1705E+04  &
   shear_modulus = 2.6956766917E+04  &
   ixx = 1.5707963268  &
   iyy = 0.7853981634  &
   izz = 0.7853981634  &
   damping_ratio = 1.0E-05  &
   formulation = linear
!
force create element_like beam  &
   beam_name = .net_ball.hBeam_7_2_L  &
   adams_id = 145  &
   i_marker_name = .net_ball.hlnk_7_2.MARKER_289  &
   j_marker_name = .net_ball.vlnk_7_2.MARKER_290  &
   length = 25.0  &
   area_of_cross_section = 3.1415926536  &
   y_shear_area_ratio = 1.0  &
   z_shear_area_ratio = 1.0  &
   youngs_modulus = 7.1705E+04  &
   shear_modulus = 2.6956766917E+04  &
   ixx = 1.5707963268  &
   iyy = 0.7853981634  &
   izz = 0.7853981634  &
   damping_ratio = 1.0E-05  &
   formulation = linear
!
force create element_like beam  &
   beam_name = .net_ball.hBeam_7_2_R  &
   adams_id = 146  &
   i_marker_name = .net_ball.hlnk_7_2.MARKER_291  &
   j_marker_name = .net_ball.vlnk_8_2.MARKER_292  &
   length = 25.0  &
   area_of_cross_section = 3.1415926536  &
   y_shear_area_ratio = 1.0  &
   z_shear_area_ratio = 1.0  &
   youngs_modulus = 7.1705E+04  &
   shear_modulus = 2.6956766917E+04  &
   ixx = 1.5707963268  &
   iyy = 0.7853981634  &
   izz = 0.7853981634  &
   damping_ratio = 1.0E-05  &
   formulation = linear
!
force create element_like beam  &
   beam_name = .net_ball.hBeam_7_3_L  &
   adams_id = 147  &
   i_marker_name = .net_ball.hlnk_7_3.MARKER_293  &
   j_marker_name = .net_ball.vlnk_7_3.MARKER_294  &
   length = 25.0  &
   area_of_cross_section = 3.1415926536  &
   y_shear_area_ratio = 1.0  &
   z_shear_area_ratio = 1.0  &
   youngs_modulus = 7.1705E+04  &
   shear_modulus = 2.6956766917E+04  &
   ixx = 1.5707963268  &
   iyy = 0.7853981634  &
   izz = 0.7853981634  &
   damping_ratio = 1.0E-05  &
   formulation = linear
!
force create element_like beam  &
   beam_name = .net_ball.hBeam_7_3_R  &
   adams_id = 148  &
   i_marker_name = .net_ball.hlnk_7_3.MARKER_295  &
   j_marker_name = .net_ball.vlnk_8_3.MARKER_296  &
   length = 25.0  &
   area_of_cross_section = 3.1415926536  &
   y_shear_area_ratio = 1.0  &
   z_shear_area_ratio = 1.0  &
   youngs_modulus = 7.1705E+04  &
   shear_modulus = 2.6956766917E+04  &
   ixx = 1.5707963268  &
   iyy = 0.7853981634  &
   izz = 0.7853981634  &
   damping_ratio = 1.0E-05  &
   formulation = linear
!
force create element_like beam  &
   beam_name = .net_ball.hBeam_7_4_L  &
   adams_id = 149  &
   i_marker_name = .net_ball.hlnk_7_4.MARKER_297  &
   j_marker_name = .net_ball.vlnk_7_4.MARKER_298  &
   length = 25.0  &
   area_of_cross_section = 3.1415926536  &
   y_shear_area_ratio = 1.0  &
   z_shear_area_ratio = 1.0  &
   youngs_modulus = 7.1705E+04  &
   shear_modulus = 2.6956766917E+04  &
   ixx = 1.5707963268  &
   iyy = 0.7853981634  &
   izz = 0.7853981634  &
   damping_ratio = 1.0E-05  &
   formulation = linear
!
force create element_like beam  &
   beam_name = .net_ball.hBeam_7_4_R  &
   adams_id = 150  &
   i_marker_name = .net_ball.hlnk_7_4.MARKER_299  &
   j_marker_name = .net_ball.vlnk_8_4.MARKER_300  &
   length = 25.0  &
   area_of_cross_section = 3.1415926536  &
   y_shear_area_ratio = 1.0  &
   z_shear_area_ratio = 1.0  &
   youngs_modulus = 7.1705E+04  &
   shear_modulus = 2.6956766917E+04  &
   ixx = 1.5707963268  &
   iyy = 0.7853981634  &
   izz = 0.7853981634  &
   damping_ratio = 1.0E-05  &
   formulation = linear
!
force create element_like beam  &
   beam_name = .net_ball.hBeam_7_5_L  &
   adams_id = 151  &
   i_marker_name = .net_ball.hlnk_7_5.MARKER_301  &
   j_marker_name = .net_ball.vlnk_7_5.MARKER_302  &
   length = 25.0  &
   area_of_cross_section = 3.1415926536  &
   y_shear_area_ratio = 1.0  &
   z_shear_area_ratio = 1.0  &
   youngs_modulus = 7.1705E+04  &
   shear_modulus = 2.6956766917E+04  &
   ixx = 1.5707963268  &
   iyy = 0.7853981634  &
   izz = 0.7853981634  &
   damping_ratio = 1.0E-05  &
   formulation = linear
!
force create element_like beam  &
   beam_name = .net_ball.hBeam_7_5_R  &
   adams_id = 152  &
   i_marker_name = .net_ball.hlnk_7_5.MARKER_303  &
   j_marker_name = .net_ball.vlnk_8_5.MARKER_304  &
   length = 25.0  &
   area_of_cross_section = 3.1415926536  &
   y_shear_area_ratio = 1.0  &
   z_shear_area_ratio = 1.0  &
   youngs_modulus = 7.1705E+04  &
   shear_modulus = 2.6956766917E+04  &
   ixx = 1.5707963268  &
   iyy = 0.7853981634  &
   izz = 0.7853981634  &
   damping_ratio = 1.0E-05  &
   formulation = linear
!
force create element_like beam  &
   beam_name = .net_ball.hBeam_7_6_L  &
   adams_id = 153  &
   i_marker_name = .net_ball.hlnk_7_6.MARKER_305  &
   j_marker_name = .net_ball.vlnk_7_6.MARKER_306  &
   length = 25.0  &
   area_of_cross_section = 3.1415926536  &
   y_shear_area_ratio = 1.0  &
   z_shear_area_ratio = 1.0  &
   youngs_modulus = 7.1705E+04  &
   shear_modulus = 2.6956766917E+04  &
   ixx = 1.5707963268  &
   iyy = 0.7853981634  &
   izz = 0.7853981634  &
   damping_ratio = 1.0E-05  &
   formulation = linear
!
force create element_like beam  &
   beam_name = .net_ball.hBeam_7_6_R  &
   adams_id = 154  &
   i_marker_name = .net_ball.hlnk_7_6.MARKER_307  &
   j_marker_name = .net_ball.vlnk_8_6.MARKER_308  &
   length = 25.0  &
   area_of_cross_section = 3.1415926536  &
   y_shear_area_ratio = 1.0  &
   z_shear_area_ratio = 1.0  &
   youngs_modulus = 7.1705E+04  &
   shear_modulus = 2.6956766917E+04  &
   ixx = 1.5707963268  &
   iyy = 0.7853981634  &
   izz = 0.7853981634  &
   damping_ratio = 1.0E-05  &
   formulation = linear
!
force create element_like beam  &
   beam_name = .net_ball.hBeam_7_7_L  &
   adams_id = 155  &
   i_marker_name = .net_ball.hlnk_7_7.MARKER_309  &
   j_marker_name = .net_ball.vlnk_7_7.MARKER_310  &
   length = 25.0  &
   area_of_cross_section = 3.1415926536  &
   y_shear_area_ratio = 1.0  &
   z_shear_area_ratio = 1.0  &
   youngs_modulus = 7.1705E+04  &
   shear_modulus = 2.6956766917E+04  &
   ixx = 1.5707963268  &
   iyy = 0.7853981634  &
   izz = 0.7853981634  &
   damping_ratio = 1.0E-05  &
   formulation = linear
!
force create element_like beam  &
   beam_name = .net_ball.hBeam_7_7_R  &
   adams_id = 156  &
   i_marker_name = .net_ball.hlnk_7_7.MARKER_311  &
   j_marker_name = .net_ball.vlnk_8_7.MARKER_312  &
   length = 25.0  &
   area_of_cross_section = 3.1415926536  &
   y_shear_area_ratio = 1.0  &
   z_shear_area_ratio = 1.0  &
   youngs_modulus = 7.1705E+04  &
   shear_modulus = 2.6956766917E+04  &
   ixx = 1.5707963268  &
   iyy = 0.7853981634  &
   izz = 0.7853981634  &
   damping_ratio = 1.0E-05  &
   formulation = linear
!
force create element_like beam  &
   beam_name = .net_ball.hBeam_7_8_L  &
   adams_id = 157  &
   i_marker_name = .net_ball.hlnk_7_8.MARKER_313  &
   j_marker_name = .net_ball.vlnk_7_8.MARKER_314  &
   length = 25.0  &
   area_of_cross_section = 3.1415926536  &
   y_shear_area_ratio = 1.0  &
   z_shear_area_ratio = 1.0  &
   youngs_modulus = 7.1705E+04  &
   shear_modulus = 2.6956766917E+04  &
   ixx = 1.5707963268  &
   iyy = 0.7853981634  &
   izz = 0.7853981634  &
   damping_ratio = 1.0E-05  &
   formulation = linear
!
force create element_like beam  &
   beam_name = .net_ball.hBeam_7_8_R  &
   adams_id = 158  &
   i_marker_name = .net_ball.hlnk_7_8.MARKER_315  &
   j_marker_name = .net_ball.vlnk_8_8.MARKER_316  &
   length = 25.0  &
   area_of_cross_section = 3.1415926536  &
   y_shear_area_ratio = 1.0  &
   z_shear_area_ratio = 1.0  &
   youngs_modulus = 7.1705E+04  &
   shear_modulus = 2.6956766917E+04  &
   ixx = 1.5707963268  &
   iyy = 0.7853981634  &
   izz = 0.7853981634  &
   damping_ratio = 1.0E-05  &
   formulation = linear
!
force create element_like beam  &
   beam_name = .net_ball.hBeam_7_9_L  &
   adams_id = 159  &
   i_marker_name = .net_ball.hlnk_7_8.MARKER_317  &
   j_marker_name = .net_ball.vlnk_7_8.MARKER_318  &
   length = 25.0  &
   area_of_cross_section = 3.1415926536  &
   y_shear_area_ratio = 1.0  &
   z_shear_area_ratio = 1.0  &
   youngs_modulus = 7.1705E+04  &
   shear_modulus = 2.6956766917E+04  &
   ixx = 1.5707963268  &
   iyy = 0.7853981634  &
   izz = 0.7853981634  &
   damping_ratio = 1.0E-05  &
   formulation = linear
!
force create element_like beam  &
   beam_name = .net_ball.hBeam_7_9_R  &
   adams_id = 160  &
   i_marker_name = .net_ball.hlnk_7_8.MARKER_319  &
   j_marker_name = .net_ball.vlnk_8_8.MARKER_320  &
   length = 25.0  &
   area_of_cross_section = 3.1415926536  &
   y_shear_area_ratio = 1.0  &
   z_shear_area_ratio = 1.0  &
   youngs_modulus = 7.1705E+04  &
   shear_modulus = 2.6956766917E+04  &
   ixx = 1.5707963268  &
   iyy = 0.7853981634  &
   izz = 0.7853981634  &
   damping_ratio = 1.0E-05  &
   formulation = linear
!
force create element_like beam  &
   beam_name = .net_ball.hBeam_8_0_L  &
   adams_id = 161  &
   i_marker_name = .net_ball.hlnk_8_0.MARKER_321  &
   j_marker_name = .net_ball.vlnk_8_0.MARKER_322  &
   length = 25.0  &
   area_of_cross_section = 3.1415926536  &
   y_shear_area_ratio = 1.0  &
   z_shear_area_ratio = 1.0  &
   youngs_modulus = 7.1705E+04  &
   shear_modulus = 2.6956766917E+04  &
   ixx = 1.5707963268  &
   iyy = 0.7853981634  &
   izz = 0.7853981634  &
   damping_ratio = 1.0E-05  &
   formulation = linear
!
force create element_like beam  &
   beam_name = .net_ball.hBeam_8_0_R  &
   adams_id = 162  &
   i_marker_name = .net_ball.hlnk_8_0.MARKER_323  &
   j_marker_name = .net_ball.vlnk_9_0.MARKER_324  &
   length = 25.0  &
   area_of_cross_section = 3.1415926536  &
   y_shear_area_ratio = 1.0  &
   z_shear_area_ratio = 1.0  &
   youngs_modulus = 7.1705E+04  &
   shear_modulus = 2.6956766917E+04  &
   ixx = 1.5707963268  &
   iyy = 0.7853981634  &
   izz = 0.7853981634  &
   damping_ratio = 1.0E-05  &
   formulation = linear
!
force create element_like beam  &
   beam_name = .net_ball.hBeam_8_1_L  &
   adams_id = 163  &
   i_marker_name = .net_ball.hlnk_8_1.MARKER_325  &
   j_marker_name = .net_ball.vlnk_8_1.MARKER_326  &
   length = 25.0  &
   area_of_cross_section = 3.1415926536  &
   y_shear_area_ratio = 1.0  &
   z_shear_area_ratio = 1.0  &
   youngs_modulus = 7.1705E+04  &
   shear_modulus = 2.6956766917E+04  &
   ixx = 1.5707963268  &
   iyy = 0.7853981634  &
   izz = 0.7853981634  &
   damping_ratio = 1.0E-05  &
   formulation = linear
!
force create element_like beam  &
   beam_name = .net_ball.hBeam_8_1_R  &
   adams_id = 164  &
   i_marker_name = .net_ball.hlnk_8_1.MARKER_327  &
   j_marker_name = .net_ball.vlnk_9_1.MARKER_328  &
   length = 25.0  &
   area_of_cross_section = 3.1415926536  &
   y_shear_area_ratio = 1.0  &
   z_shear_area_ratio = 1.0  &
   youngs_modulus = 7.1705E+04  &
   shear_modulus = 2.6956766917E+04  &
   ixx = 1.5707963268  &
   iyy = 0.7853981634  &
   izz = 0.7853981634  &
   damping_ratio = 1.0E-05  &
   formulation = linear
!
force create element_like beam  &
   beam_name = .net_ball.hBeam_8_2_L  &
   adams_id = 165  &
   i_marker_name = .net_ball.hlnk_8_2.MARKER_329  &
   j_marker_name = .net_ball.vlnk_8_2.MARKER_330  &
   length = 25.0  &
   area_of_cross_section = 3.1415926536  &
   y_shear_area_ratio = 1.0  &
   z_shear_area_ratio = 1.0  &
   youngs_modulus = 7.1705E+04  &
   shear_modulus = 2.6956766917E+04  &
   ixx = 1.5707963268  &
   iyy = 0.7853981634  &
   izz = 0.7853981634  &
   damping_ratio = 1.0E-05  &
   formulation = linear
!
force create element_like beam  &
   beam_name = .net_ball.hBeam_8_2_R  &
   adams_id = 166  &
   i_marker_name = .net_ball.hlnk_8_2.MARKER_331  &
   j_marker_name = .net_ball.vlnk_9_2.MARKER_332  &
   length = 25.0  &
   area_of_cross_section = 3.1415926536  &
   y_shear_area_ratio = 1.0  &
   z_shear_area_ratio = 1.0  &
   youngs_modulus = 7.1705E+04  &
   shear_modulus = 2.6956766917E+04  &
   ixx = 1.5707963268  &
   iyy = 0.7853981634  &
   izz = 0.7853981634  &
   damping_ratio = 1.0E-05  &
   formulation = linear
!
force create element_like beam  &
   beam_name = .net_ball.hBeam_8_3_L  &
   adams_id = 167  &
   i_marker_name = .net_ball.hlnk_8_3.MARKER_333  &
   j_marker_name = .net_ball.vlnk_8_3.MARKER_334  &
   length = 25.0  &
   area_of_cross_section = 3.1415926536  &
   y_shear_area_ratio = 1.0  &
   z_shear_area_ratio = 1.0  &
   youngs_modulus = 7.1705E+04  &
   shear_modulus = 2.6956766917E+04  &
   ixx = 1.5707963268  &
   iyy = 0.7853981634  &
   izz = 0.7853981634  &
   damping_ratio = 1.0E-05  &
   formulation = linear
!
force create element_like beam  &
   beam_name = .net_ball.hBeam_8_3_R  &
   adams_id = 168  &
   i_marker_name = .net_ball.hlnk_8_3.MARKER_335  &
   j_marker_name = .net_ball.vlnk_9_3.MARKER_336  &
   length = 25.0  &
   area_of_cross_section = 3.1415926536  &
   y_shear_area_ratio = 1.0  &
   z_shear_area_ratio = 1.0  &
   youngs_modulus = 7.1705E+04  &
   shear_modulus = 2.6956766917E+04  &
   ixx = 1.5707963268  &
   iyy = 0.7853981634  &
   izz = 0.7853981634  &
   damping_ratio = 1.0E-05  &
   formulation = linear
!
force create element_like beam  &
   beam_name = .net_ball.hBeam_8_4_L  &
   adams_id = 169  &
   i_marker_name = .net_ball.hlnk_8_4.MARKER_337  &
   j_marker_name = .net_ball.vlnk_8_4.MARKER_338  &
   length = 25.0  &
   area_of_cross_section = 3.1415926536  &
   y_shear_area_ratio = 1.0  &
   z_shear_area_ratio = 1.0  &
   youngs_modulus = 7.1705E+04  &
   shear_modulus = 2.6956766917E+04  &
   ixx = 1.5707963268  &
   iyy = 0.7853981634  &
   izz = 0.7853981634  &
   damping_ratio = 1.0E-05  &
   formulation = linear
!
force create element_like beam  &
   beam_name = .net_ball.hBeam_8_4_R  &
   adams_id = 170  &
   i_marker_name = .net_ball.hlnk_8_4.MARKER_339  &
   j_marker_name = .net_ball.vlnk_9_4.MARKER_340  &
   length = 25.0  &
   area_of_cross_section = 3.1415926536  &
   y_shear_area_ratio = 1.0  &
   z_shear_area_ratio = 1.0  &
   youngs_modulus = 7.1705E+04  &
   shear_modulus = 2.6956766917E+04  &
   ixx = 1.5707963268  &
   iyy = 0.7853981634  &
   izz = 0.7853981634  &
   damping_ratio = 1.0E-05  &
   formulation = linear
!
force create element_like beam  &
   beam_name = .net_ball.hBeam_8_5_L  &
   adams_id = 171  &
   i_marker_name = .net_ball.hlnk_8_5.MARKER_341  &
   j_marker_name = .net_ball.vlnk_8_5.MARKER_342  &
   length = 25.0  &
   area_of_cross_section = 3.1415926536  &
   y_shear_area_ratio = 1.0  &
   z_shear_area_ratio = 1.0  &
   youngs_modulus = 7.1705E+04  &
   shear_modulus = 2.6956766917E+04  &
   ixx = 1.5707963268  &
   iyy = 0.7853981634  &
   izz = 0.7853981634  &
   damping_ratio = 1.0E-05  &
   formulation = linear
!
force create element_like beam  &
   beam_name = .net_ball.hBeam_8_5_R  &
   adams_id = 172  &
   i_marker_name = .net_ball.hlnk_8_5.MARKER_343  &
   j_marker_name = .net_ball.vlnk_9_5.MARKER_344  &
   length = 25.0  &
   area_of_cross_section = 3.1415926536  &
   y_shear_area_ratio = 1.0  &
   z_shear_area_ratio = 1.0  &
   youngs_modulus = 7.1705E+04  &
   shear_modulus = 2.6956766917E+04  &
   ixx = 1.5707963268  &
   iyy = 0.7853981634  &
   izz = 0.7853981634  &
   damping_ratio = 1.0E-05  &
   formulation = linear
!
force create element_like beam  &
   beam_name = .net_ball.hBeam_8_6_L  &
   adams_id = 173  &
   i_marker_name = .net_ball.hlnk_8_6.MARKER_345  &
   j_marker_name = .net_ball.vlnk_8_6.MARKER_346  &
   length = 25.0  &
   area_of_cross_section = 3.1415926536  &
   y_shear_area_ratio = 1.0  &
   z_shear_area_ratio = 1.0  &
   youngs_modulus = 7.1705E+04  &
   shear_modulus = 2.6956766917E+04  &
   ixx = 1.5707963268  &
   iyy = 0.7853981634  &
   izz = 0.7853981634  &
   damping_ratio = 1.0E-05  &
   formulation = linear
!
force create element_like beam  &
   beam_name = .net_ball.hBeam_8_6_R  &
   adams_id = 174  &
   i_marker_name = .net_ball.hlnk_8_6.MARKER_347  &
   j_marker_name = .net_ball.vlnk_9_6.MARKER_348  &
   length = 25.0  &
   area_of_cross_section = 3.1415926536  &
   y_shear_area_ratio = 1.0  &
   z_shear_area_ratio = 1.0  &
   youngs_modulus = 7.1705E+04  &
   shear_modulus = 2.6956766917E+04  &
   ixx = 1.5707963268  &
   iyy = 0.7853981634  &
   izz = 0.7853981634  &
   damping_ratio = 1.0E-05  &
   formulation = linear
!
force create element_like beam  &
   beam_name = .net_ball.hBeam_8_7_L  &
   adams_id = 175  &
   i_marker_name = .net_ball.hlnk_8_7.MARKER_349  &
   j_marker_name = .net_ball.vlnk_8_7.MARKER_350  &
   length = 25.0  &
   area_of_cross_section = 3.1415926536  &
   y_shear_area_ratio = 1.0  &
   z_shear_area_ratio = 1.0  &
   youngs_modulus = 7.1705E+04  &
   shear_modulus = 2.6956766917E+04  &
   ixx = 1.5707963268  &
   iyy = 0.7853981634  &
   izz = 0.7853981634  &
   damping_ratio = 1.0E-05  &
   formulation = linear
!
force create element_like beam  &
   beam_name = .net_ball.hBeam_8_7_R  &
   adams_id = 176  &
   i_marker_name = .net_ball.hlnk_8_7.MARKER_351  &
   j_marker_name = .net_ball.vlnk_9_7.MARKER_352  &
   length = 25.0  &
   area_of_cross_section = 3.1415926536  &
   y_shear_area_ratio = 1.0  &
   z_shear_area_ratio = 1.0  &
   youngs_modulus = 7.1705E+04  &
   shear_modulus = 2.6956766917E+04  &
   ixx = 1.5707963268  &
   iyy = 0.7853981634  &
   izz = 0.7853981634  &
   damping_ratio = 1.0E-05  &
   formulation = linear
!
force create element_like beam  &
   beam_name = .net_ball.hBeam_8_8_L  &
   adams_id = 177  &
   i_marker_name = .net_ball.hlnk_8_8.MARKER_353  &
   j_marker_name = .net_ball.vlnk_8_8.MARKER_354  &
   length = 25.0  &
   area_of_cross_section = 3.1415926536  &
   y_shear_area_ratio = 1.0  &
   z_shear_area_ratio = 1.0  &
   youngs_modulus = 7.1705E+04  &
   shear_modulus = 2.6956766917E+04  &
   ixx = 1.5707963268  &
   iyy = 0.7853981634  &
   izz = 0.7853981634  &
   damping_ratio = 1.0E-05  &
   formulation = linear
!
force create element_like beam  &
   beam_name = .net_ball.hBeam_8_8_R  &
   adams_id = 178  &
   i_marker_name = .net_ball.hlnk_8_8.MARKER_355  &
   j_marker_name = .net_ball.vlnk_9_8.MARKER_356  &
   length = 25.0  &
   area_of_cross_section = 3.1415926536  &
   y_shear_area_ratio = 1.0  &
   z_shear_area_ratio = 1.0  &
   youngs_modulus = 7.1705E+04  &
   shear_modulus = 2.6956766917E+04  &
   ixx = 1.5707963268  &
   iyy = 0.7853981634  &
   izz = 0.7853981634  &
   damping_ratio = 1.0E-05  &
   formulation = linear
!
force create element_like beam  &
   beam_name = .net_ball.hBeam_8_9_L  &
   adams_id = 179  &
   i_marker_name = .net_ball.hlnk_8_8.MARKER_357  &
   j_marker_name = .net_ball.vlnk_8_8.MARKER_358  &
   length = 25.0  &
   area_of_cross_section = 3.1415926536  &
   y_shear_area_ratio = 1.0  &
   z_shear_area_ratio = 1.0  &
   youngs_modulus = 7.1705E+04  &
   shear_modulus = 2.6956766917E+04  &
   ixx = 1.5707963268  &
   iyy = 0.7853981634  &
   izz = 0.7853981634  &
   damping_ratio = 1.0E-05  &
   formulation = linear
!
force create element_like beam  &
   beam_name = .net_ball.hBeam_8_9_R  &
   adams_id = 180  &
   i_marker_name = .net_ball.hlnk_8_8.MARKER_359  &
   j_marker_name = .net_ball.vlnk_9_8.MARKER_360  &
   length = 25.0  &
   area_of_cross_section = 3.1415926536  &
   y_shear_area_ratio = 1.0  &
   z_shear_area_ratio = 1.0  &
   youngs_modulus = 7.1705E+04  &
   shear_modulus = 2.6956766917E+04  &
   ixx = 1.5707963268  &
   iyy = 0.7853981634  &
   izz = 0.7853981634  &
   damping_ratio = 1.0E-05  &
   formulation = linear
!
force create element_like beam  &
   beam_name = .net_ball.vBeam_0_0_L  &
   adams_id = 181  &
   i_marker_name = .net_ball.vlnk_0_0.MARKER_361  &
   j_marker_name = .net_ball.hlnk_0_0.MARKER_362  &
   length = 25.0  &
   area_of_cross_section = 3.1415926536  &
   y_shear_area_ratio = 1.0  &
   z_shear_area_ratio = 1.0  &
   youngs_modulus = 7.1705E+04  &
   shear_modulus = 2.6956766917E+04  &
   ixx = 1.5707963268  &
   iyy = 0.7853981634  &
   izz = 0.7853981634  &
   damping_ratio = 1.0E-05  &
   formulation = linear
!
force create element_like beam  &
   beam_name = .net_ball.vBeam_0_0_R  &
   adams_id = 182  &
   i_marker_name = .net_ball.vlnk_0_0.MARKER_363  &
   j_marker_name = .net_ball.hlnk_0_1.MARKER_364  &
   length = 25.0  &
   area_of_cross_section = 3.1415926536  &
   y_shear_area_ratio = 1.0  &
   z_shear_area_ratio = 1.0  &
   youngs_modulus = 7.1705E+04  &
   shear_modulus = 2.6956766917E+04  &
   ixx = 1.5707963268  &
   iyy = 0.7853981634  &
   izz = 0.7853981634  &
   damping_ratio = 1.0E-05  &
   formulation = linear
!
force create element_like beam  &
   beam_name = .net_ball.vBeam_0_1_L  &
   adams_id = 183  &
   i_marker_name = .net_ball.vlnk_0_1.MARKER_365  &
   j_marker_name = .net_ball.hlnk_0_1.MARKER_366  &
   length = 25.0  &
   area_of_cross_section = 3.1415926536  &
   y_shear_area_ratio = 1.0  &
   z_shear_area_ratio = 1.0  &
   youngs_modulus = 7.1705E+04  &
   shear_modulus = 2.6956766917E+04  &
   ixx = 1.5707963268  &
   iyy = 0.7853981634  &
   izz = 0.7853981634  &
   damping_ratio = 1.0E-05  &
   formulation = linear
!
force create element_like beam  &
   beam_name = .net_ball.vBeam_0_1_R  &
   adams_id = 184  &
   i_marker_name = .net_ball.vlnk_0_1.MARKER_367  &
   j_marker_name = .net_ball.hlnk_0_2.MARKER_368  &
   length = 25.0  &
   area_of_cross_section = 3.1415926536  &
   y_shear_area_ratio = 1.0  &
   z_shear_area_ratio = 1.0  &
   youngs_modulus = 7.1705E+04  &
   shear_modulus = 2.6956766917E+04  &
   ixx = 1.5707963268  &
   iyy = 0.7853981634  &
   izz = 0.7853981634  &
   damping_ratio = 1.0E-05  &
   formulation = linear
!
force create element_like beam  &
   beam_name = .net_ball.vBeam_0_2_L  &
   adams_id = 185  &
   i_marker_name = .net_ball.vlnk_0_2.MARKER_369  &
   j_marker_name = .net_ball.hlnk_0_2.MARKER_370  &
   length = 25.0  &
   area_of_cross_section = 3.1415926536  &
   y_shear_area_ratio = 1.0  &
   z_shear_area_ratio = 1.0  &
   youngs_modulus = 7.1705E+04  &
   shear_modulus = 2.6956766917E+04  &
   ixx = 1.5707963268  &
   iyy = 0.7853981634  &
   izz = 0.7853981634  &
   damping_ratio = 1.0E-05  &
   formulation = linear
!
force create element_like beam  &
   beam_name = .net_ball.vBeam_0_2_R  &
   adams_id = 186  &
   i_marker_name = .net_ball.vlnk_0_2.MARKER_371  &
   j_marker_name = .net_ball.hlnk_0_3.MARKER_372  &
   length = 25.0  &
   area_of_cross_section = 3.1415926536  &
   y_shear_area_ratio = 1.0  &
   z_shear_area_ratio = 1.0  &
   youngs_modulus = 7.1705E+04  &
   shear_modulus = 2.6956766917E+04  &
   ixx = 1.5707963268  &
   iyy = 0.7853981634  &
   izz = 0.7853981634  &
   damping_ratio = 1.0E-05  &
   formulation = linear
!
force create element_like beam  &
   beam_name = .net_ball.vBeam_0_3_L  &
   adams_id = 187  &
   i_marker_name = .net_ball.vlnk_0_3.MARKER_373  &
   j_marker_name = .net_ball.hlnk_0_3.MARKER_374  &
   length = 25.0  &
   area_of_cross_section = 3.1415926536  &
   y_shear_area_ratio = 1.0  &
   z_shear_area_ratio = 1.0  &
   youngs_modulus = 7.1705E+04  &
   shear_modulus = 2.6956766917E+04  &
   ixx = 1.5707963268  &
   iyy = 0.7853981634  &
   izz = 0.7853981634  &
   damping_ratio = 1.0E-05  &
   formulation = linear
!
force create element_like beam  &
   beam_name = .net_ball.vBeam_0_3_R  &
   adams_id = 188  &
   i_marker_name = .net_ball.vlnk_0_3.MARKER_375  &
   j_marker_name = .net_ball.hlnk_0_4.MARKER_376  &
   length = 25.0  &
   area_of_cross_section = 3.1415926536  &
   y_shear_area_ratio = 1.0  &
   z_shear_area_ratio = 1.0  &
   youngs_modulus = 7.1705E+04  &
   shear_modulus = 2.6956766917E+04  &
   ixx = 1.5707963268  &
   iyy = 0.7853981634  &
   izz = 0.7853981634  &
   damping_ratio = 1.0E-05  &
   formulation = linear
!
force create element_like beam  &
   beam_name = .net_ball.vBeam_0_4_L  &
   adams_id = 189  &
   i_marker_name = .net_ball.vlnk_0_4.MARKER_377  &
   j_marker_name = .net_ball.hlnk_0_4.MARKER_378  &
   length = 25.0  &
   area_of_cross_section = 3.1415926536  &
   y_shear_area_ratio = 1.0  &
   z_shear_area_ratio = 1.0  &
   youngs_modulus = 7.1705E+04  &
   shear_modulus = 2.6956766917E+04  &
   ixx = 1.5707963268  &
   iyy = 0.7853981634  &
   izz = 0.7853981634  &
   damping_ratio = 1.0E-05  &
   formulation = linear
!
force create element_like beam  &
   beam_name = .net_ball.vBeam_0_4_R  &
   adams_id = 190  &
   i_marker_name = .net_ball.vlnk_0_4.MARKER_379  &
   j_marker_name = .net_ball.hlnk_0_5.MARKER_380  &
   length = 25.0  &
   area_of_cross_section = 3.1415926536  &
   y_shear_area_ratio = 1.0  &
   z_shear_area_ratio = 1.0  &
   youngs_modulus = 7.1705E+04  &
   shear_modulus = 2.6956766917E+04  &
   ixx = 1.5707963268  &
   iyy = 0.7853981634  &
   izz = 0.7853981634  &
   damping_ratio = 1.0E-05  &
   formulation = linear
!
force create element_like beam  &
   beam_name = .net_ball.vBeam_0_5_L  &
   adams_id = 191  &
   i_marker_name = .net_ball.vlnk_0_5.MARKER_381  &
   j_marker_name = .net_ball.hlnk_0_5.MARKER_382  &
   length = 25.0  &
   area_of_cross_section = 3.1415926536  &
   y_shear_area_ratio = 1.0  &
   z_shear_area_ratio = 1.0  &
   youngs_modulus = 7.1705E+04  &
   shear_modulus = 2.6956766917E+04  &
   ixx = 1.5707963268  &
   iyy = 0.7853981634  &
   izz = 0.7853981634  &
   damping_ratio = 1.0E-05  &
   formulation = linear
!
force create element_like beam  &
   beam_name = .net_ball.vBeam_0_5_R  &
   adams_id = 192  &
   i_marker_name = .net_ball.vlnk_0_5.MARKER_383  &
   j_marker_name = .net_ball.hlnk_0_6.MARKER_384  &
   length = 25.0  &
   area_of_cross_section = 3.1415926536  &
   y_shear_area_ratio = 1.0  &
   z_shear_area_ratio = 1.0  &
   youngs_modulus = 7.1705E+04  &
   shear_modulus = 2.6956766917E+04  &
   ixx = 1.5707963268  &
   iyy = 0.7853981634  &
   izz = 0.7853981634  &
   damping_ratio = 1.0E-05  &
   formulation = linear
!
force create element_like beam  &
   beam_name = .net_ball.vBeam_0_6_L  &
   adams_id = 193  &
   i_marker_name = .net_ball.vlnk_0_6.MARKER_385  &
   j_marker_name = .net_ball.hlnk_0_6.MARKER_386  &
   length = 25.0  &
   area_of_cross_section = 3.1415926536  &
   y_shear_area_ratio = 1.0  &
   z_shear_area_ratio = 1.0  &
   youngs_modulus = 7.1705E+04  &
   shear_modulus = 2.6956766917E+04  &
   ixx = 1.5707963268  &
   iyy = 0.7853981634  &
   izz = 0.7853981634  &
   damping_ratio = 1.0E-05  &
   formulation = linear
!
force create element_like beam  &
   beam_name = .net_ball.vBeam_0_6_R  &
   adams_id = 194  &
   i_marker_name = .net_ball.vlnk_0_6.MARKER_387  &
   j_marker_name = .net_ball.hlnk_0_7.MARKER_388  &
   length = 25.0  &
   area_of_cross_section = 3.1415926536  &
   y_shear_area_ratio = 1.0  &
   z_shear_area_ratio = 1.0  &
   youngs_modulus = 7.1705E+04  &
   shear_modulus = 2.6956766917E+04  &
   ixx = 1.5707963268  &
   iyy = 0.7853981634  &
   izz = 0.7853981634  &
   damping_ratio = 1.0E-05  &
   formulation = linear
!
force create element_like beam  &
   beam_name = .net_ball.vBeam_0_7_L  &
   adams_id = 195  &
   i_marker_name = .net_ball.vlnk_0_7.MARKER_389  &
   j_marker_name = .net_ball.hlnk_0_7.MARKER_390  &
   length = 25.0  &
   area_of_cross_section = 3.1415926536  &
   y_shear_area_ratio = 1.0  &
   z_shear_area_ratio = 1.0  &
   youngs_modulus = 7.1705E+04  &
   shear_modulus = 2.6956766917E+04  &
   ixx = 1.5707963268  &
   iyy = 0.7853981634  &
   izz = 0.7853981634  &
   damping_ratio = 1.0E-05  &
   formulation = linear
!
force create element_like beam  &
   beam_name = .net_ball.vBeam_0_7_R  &
   adams_id = 196  &
   i_marker_name = .net_ball.vlnk_0_7.MARKER_391  &
   j_marker_name = .net_ball.hlnk_0_8.MARKER_392  &
   length = 25.0  &
   area_of_cross_section = 3.1415926536  &
   y_shear_area_ratio = 1.0  &
   z_shear_area_ratio = 1.0  &
   youngs_modulus = 7.1705E+04  &
   shear_modulus = 2.6956766917E+04  &
   ixx = 1.5707963268  &
   iyy = 0.7853981634  &
   izz = 0.7853981634  &
   damping_ratio = 1.0E-05  &
   formulation = linear
!
force create element_like beam  &
   beam_name = .net_ball.vBeam_0_8_L  &
   adams_id = 197  &
   i_marker_name = .net_ball.vlnk_0_8.MARKER_393  &
   j_marker_name = .net_ball.hlnk_0_8.MARKER_394  &
   length = 25.0  &
   area_of_cross_section = 3.1415926536  &
   y_shear_area_ratio = 1.0  &
   z_shear_area_ratio = 1.0  &
   youngs_modulus = 7.1705E+04  &
   shear_modulus = 2.6956766917E+04  &
   ixx = 1.5707963268  &
   iyy = 0.7853981634  &
   izz = 0.7853981634  &
   damping_ratio = 1.0E-05  &
   formulation = linear
!
force create element_like beam  &
   beam_name = .net_ball.vBeam_0_8_R  &
   adams_id = 198  &
   i_marker_name = .net_ball.vlnk_0_8.MARKER_395  &
   j_marker_name = .net_ball.hlnk_0_9.MARKER_396  &
   length = 25.0  &
   area_of_cross_section = 3.1415926536  &
   y_shear_area_ratio = 1.0  &
   z_shear_area_ratio = 1.0  &
   youngs_modulus = 7.1705E+04  &
   shear_modulus = 2.6956766917E+04  &
   ixx = 1.5707963268  &
   iyy = 0.7853981634  &
   izz = 0.7853981634  &
   damping_ratio = 1.0E-05  &
   formulation = linear
!
force create element_like beam  &
   beam_name = .net_ball.vBeam_1_0_L  &
   adams_id = 199  &
   i_marker_name = .net_ball.vlnk_1_0.MARKER_397  &
   j_marker_name = .net_ball.hlnk_1_0.MARKER_398  &
   length = 25.0  &
   area_of_cross_section = 3.1415926536  &
   y_shear_area_ratio = 1.0  &
   z_shear_area_ratio = 1.0  &
   youngs_modulus = 7.1705E+04  &
   shear_modulus = 2.6956766917E+04  &
   ixx = 1.5707963268  &
   iyy = 0.7853981634  &
   izz = 0.7853981634  &
   damping_ratio = 1.0E-05  &
   formulation = linear
!
force create element_like beam  &
   beam_name = .net_ball.vBeam_1_0_R  &
   adams_id = 200  &
   i_marker_name = .net_ball.vlnk_1_0.MARKER_399  &
   j_marker_name = .net_ball.hlnk_1_1.MARKER_400  &
   length = 25.0  &
   area_of_cross_section = 3.1415926536  &
   y_shear_area_ratio = 1.0  &
   z_shear_area_ratio = 1.0  &
   youngs_modulus = 7.1705E+04  &
   shear_modulus = 2.6956766917E+04  &
   ixx = 1.5707963268  &
   iyy = 0.7853981634  &
   izz = 0.7853981634  &
   damping_ratio = 1.0E-05  &
   formulation = linear
!
force create element_like beam  &
   beam_name = .net_ball.vBeam_1_1_L  &
   adams_id = 201  &
   i_marker_name = .net_ball.vlnk_1_1.MARKER_401  &
   j_marker_name = .net_ball.hlnk_1_1.MARKER_402  &
   length = 25.0  &
   area_of_cross_section = 3.1415926536  &
   y_shear_area_ratio = 1.0  &
   z_shear_area_ratio = 1.0  &
   youngs_modulus = 7.1705E+04  &
   shear_modulus = 2.6956766917E+04  &
   ixx = 1.5707963268  &
   iyy = 0.7853981634  &
   izz = 0.7853981634  &
   damping_ratio = 1.0E-05  &
   formulation = linear
!
force create element_like beam  &
   beam_name = .net_ball.vBeam_1_1_R  &
   adams_id = 202  &
   i_marker_name = .net_ball.vlnk_1_1.MARKER_403  &
   j_marker_name = .net_ball.hlnk_1_2.MARKER_404  &
   length = 25.0  &
   area_of_cross_section = 3.1415926536  &
   y_shear_area_ratio = 1.0  &
   z_shear_area_ratio = 1.0  &
   youngs_modulus = 7.1705E+04  &
   shear_modulus = 2.6956766917E+04  &
   ixx = 1.5707963268  &
   iyy = 0.7853981634  &
   izz = 0.7853981634  &
   damping_ratio = 1.0E-05  &
   formulation = linear
!
force create element_like beam  &
   beam_name = .net_ball.vBeam_1_2_L  &
   adams_id = 203  &
   i_marker_name = .net_ball.vlnk_1_2.MARKER_405  &
   j_marker_name = .net_ball.hlnk_1_2.MARKER_406  &
   length = 25.0  &
   area_of_cross_section = 3.1415926536  &
   y_shear_area_ratio = 1.0  &
   z_shear_area_ratio = 1.0  &
   youngs_modulus = 7.1705E+04  &
   shear_modulus = 2.6956766917E+04  &
   ixx = 1.5707963268  &
   iyy = 0.7853981634  &
   izz = 0.7853981634  &
   damping_ratio = 1.0E-05  &
   formulation = linear
!
force create element_like beam  &
   beam_name = .net_ball.vBeam_1_2_R  &
   adams_id = 204  &
   i_marker_name = .net_ball.vlnk_1_2.MARKER_407  &
   j_marker_name = .net_ball.hlnk_1_3.MARKER_408  &
   length = 25.0  &
   area_of_cross_section = 3.1415926536  &
   y_shear_area_ratio = 1.0  &
   z_shear_area_ratio = 1.0  &
   youngs_modulus = 7.1705E+04  &
   shear_modulus = 2.6956766917E+04  &
   ixx = 1.5707963268  &
   iyy = 0.7853981634  &
   izz = 0.7853981634  &
   damping_ratio = 1.0E-05  &
   formulation = linear
!
force create element_like beam  &
   beam_name = .net_ball.vBeam_1_3_L  &
   adams_id = 205  &
   i_marker_name = .net_ball.vlnk_1_3.MARKER_409  &
   j_marker_name = .net_ball.hlnk_1_3.MARKER_410  &
   length = 25.0  &
   area_of_cross_section = 3.1415926536  &
   y_shear_area_ratio = 1.0  &
   z_shear_area_ratio = 1.0  &
   youngs_modulus = 7.1705E+04  &
   shear_modulus = 2.6956766917E+04  &
   ixx = 1.5707963268  &
   iyy = 0.7853981634  &
   izz = 0.7853981634  &
   damping_ratio = 1.0E-05  &
   formulation = linear
!
force create element_like beam  &
   beam_name = .net_ball.vBeam_1_3_R  &
   adams_id = 206  &
   i_marker_name = .net_ball.vlnk_1_3.MARKER_411  &
   j_marker_name = .net_ball.hlnk_1_4.MARKER_412  &
   length = 25.0  &
   area_of_cross_section = 3.1415926536  &
   y_shear_area_ratio = 1.0  &
   z_shear_area_ratio = 1.0  &
   youngs_modulus = 7.1705E+04  &
   shear_modulus = 2.6956766917E+04  &
   ixx = 1.5707963268  &
   iyy = 0.7853981634  &
   izz = 0.7853981634  &
   damping_ratio = 1.0E-05  &
   formulation = linear
!
force create element_like beam  &
   beam_name = .net_ball.vBeam_1_4_L  &
   adams_id = 207  &
   i_marker_name = .net_ball.vlnk_1_4.MARKER_413  &
   j_marker_name = .net_ball.hlnk_1_4.MARKER_414  &
   length = 25.0  &
   area_of_cross_section = 3.1415926536  &
   y_shear_area_ratio = 1.0  &
   z_shear_area_ratio = 1.0  &
   youngs_modulus = 7.1705E+04  &
   shear_modulus = 2.6956766917E+04  &
   ixx = 1.5707963268  &
   iyy = 0.7853981634  &
   izz = 0.7853981634  &
   damping_ratio = 1.0E-05  &
   formulation = linear
!
force create element_like beam  &
   beam_name = .net_ball.vBeam_1_4_R  &
   adams_id = 208  &
   i_marker_name = .net_ball.vlnk_1_4.MARKER_415  &
   j_marker_name = .net_ball.hlnk_1_5.MARKER_416  &
   length = 25.0  &
   area_of_cross_section = 3.1415926536  &
   y_shear_area_ratio = 1.0  &
   z_shear_area_ratio = 1.0  &
   youngs_modulus = 7.1705E+04  &
   shear_modulus = 2.6956766917E+04  &
   ixx = 1.5707963268  &
   iyy = 0.7853981634  &
   izz = 0.7853981634  &
   damping_ratio = 1.0E-05  &
   formulation = linear
!
force create element_like beam  &
   beam_name = .net_ball.vBeam_1_5_L  &
   adams_id = 209  &
   i_marker_name = .net_ball.vlnk_1_5.MARKER_417  &
   j_marker_name = .net_ball.hlnk_1_5.MARKER_418  &
   length = 25.0  &
   area_of_cross_section = 3.1415926536  &
   y_shear_area_ratio = 1.0  &
   z_shear_area_ratio = 1.0  &
   youngs_modulus = 7.1705E+04  &
   shear_modulus = 2.6956766917E+04  &
   ixx = 1.5707963268  &
   iyy = 0.7853981634  &
   izz = 0.7853981634  &
   damping_ratio = 1.0E-05  &
   formulation = linear
!
force create element_like beam  &
   beam_name = .net_ball.vBeam_1_5_R  &
   adams_id = 210  &
   i_marker_name = .net_ball.vlnk_1_5.MARKER_419  &
   j_marker_name = .net_ball.hlnk_1_6.MARKER_420  &
   length = 25.0  &
   area_of_cross_section = 3.1415926536  &
   y_shear_area_ratio = 1.0  &
   z_shear_area_ratio = 1.0  &
   youngs_modulus = 7.1705E+04  &
   shear_modulus = 2.6956766917E+04  &
   ixx = 1.5707963268  &
   iyy = 0.7853981634  &
   izz = 0.7853981634  &
   damping_ratio = 1.0E-05  &
   formulation = linear
!
force create element_like beam  &
   beam_name = .net_ball.vBeam_1_6_L  &
   adams_id = 211  &
   i_marker_name = .net_ball.vlnk_1_6.MARKER_421  &
   j_marker_name = .net_ball.hlnk_1_6.MARKER_422  &
   length = 25.0  &
   area_of_cross_section = 3.1415926536  &
   y_shear_area_ratio = 1.0  &
   z_shear_area_ratio = 1.0  &
   youngs_modulus = 7.1705E+04  &
   shear_modulus = 2.6956766917E+04  &
   ixx = 1.5707963268  &
   iyy = 0.7853981634  &
   izz = 0.7853981634  &
   damping_ratio = 1.0E-05  &
   formulation = linear
!
force create element_like beam  &
   beam_name = .net_ball.vBeam_1_6_R  &
   adams_id = 212  &
   i_marker_name = .net_ball.vlnk_1_6.MARKER_423  &
   j_marker_name = .net_ball.hlnk_1_7.MARKER_424  &
   length = 25.0  &
   area_of_cross_section = 3.1415926536  &
   y_shear_area_ratio = 1.0  &
   z_shear_area_ratio = 1.0  &
   youngs_modulus = 7.1705E+04  &
   shear_modulus = 2.6956766917E+04  &
   ixx = 1.5707963268  &
   iyy = 0.7853981634  &
   izz = 0.7853981634  &
   damping_ratio = 1.0E-05  &
   formulation = linear
!
force create element_like beam  &
   beam_name = .net_ball.vBeam_1_7_L  &
   adams_id = 213  &
   i_marker_name = .net_ball.vlnk_1_7.MARKER_425  &
   j_marker_name = .net_ball.hlnk_1_7.MARKER_426  &
   length = 25.0  &
   area_of_cross_section = 3.1415926536  &
   y_shear_area_ratio = 1.0  &
   z_shear_area_ratio = 1.0  &
   youngs_modulus = 7.1705E+04  &
   shear_modulus = 2.6956766917E+04  &
   ixx = 1.5707963268  &
   iyy = 0.7853981634  &
   izz = 0.7853981634  &
   damping_ratio = 1.0E-05  &
   formulation = linear
!
force create element_like beam  &
   beam_name = .net_ball.vBeam_1_7_R  &
   adams_id = 214  &
   i_marker_name = .net_ball.vlnk_1_7.MARKER_427  &
   j_marker_name = .net_ball.hlnk_1_8.MARKER_428  &
   length = 25.0  &
   area_of_cross_section = 3.1415926536  &
   y_shear_area_ratio = 1.0  &
   z_shear_area_ratio = 1.0  &
   youngs_modulus = 7.1705E+04  &
   shear_modulus = 2.6956766917E+04  &
   ixx = 1.5707963268  &
   iyy = 0.7853981634  &
   izz = 0.7853981634  &
   damping_ratio = 1.0E-05  &
   formulation = linear
!
force create element_like beam  &
   beam_name = .net_ball.vBeam_1_8_L  &
   adams_id = 215  &
   i_marker_name = .net_ball.vlnk_1_8.MARKER_429  &
   j_marker_name = .net_ball.hlnk_1_8.MARKER_430  &
   length = 25.0  &
   area_of_cross_section = 3.1415926536  &
   y_shear_area_ratio = 1.0  &
   z_shear_area_ratio = 1.0  &
   youngs_modulus = 7.1705E+04  &
   shear_modulus = 2.6956766917E+04  &
   ixx = 1.5707963268  &
   iyy = 0.7853981634  &
   izz = 0.7853981634  &
   damping_ratio = 1.0E-05  &
   formulation = linear
!
force create element_like beam  &
   beam_name = .net_ball.vBeam_1_8_R  &
   adams_id = 216  &
   i_marker_name = .net_ball.vlnk_1_8.MARKER_431  &
   j_marker_name = .net_ball.hlnk_1_9.MARKER_432  &
   length = 25.0  &
   area_of_cross_section = 3.1415926536  &
   y_shear_area_ratio = 1.0  &
   z_shear_area_ratio = 1.0  &
   youngs_modulus = 7.1705E+04  &
   shear_modulus = 2.6956766917E+04  &
   ixx = 1.5707963268  &
   iyy = 0.7853981634  &
   izz = 0.7853981634  &
   damping_ratio = 1.0E-05  &
   formulation = linear
!
force create element_like beam  &
   beam_name = .net_ball.vBeam_2_0_L  &
   adams_id = 217  &
   i_marker_name = .net_ball.vlnk_2_0.MARKER_433  &
   j_marker_name = .net_ball.hlnk_2_0.MARKER_434  &
   length = 25.0  &
   area_of_cross_section = 3.1415926536  &
   y_shear_area_ratio = 1.0  &
   z_shear_area_ratio = 1.0  &
   youngs_modulus = 7.1705E+04  &
   shear_modulus = 2.6956766917E+04  &
   ixx = 1.5707963268  &
   iyy = 0.7853981634  &
   izz = 0.7853981634  &
   damping_ratio = 1.0E-05  &
   formulation = linear
!
force create element_like beam  &
   beam_name = .net_ball.vBeam_2_0_R  &
   adams_id = 218  &
   i_marker_name = .net_ball.vlnk_2_0.MARKER_435  &
   j_marker_name = .net_ball.hlnk_2_1.MARKER_436  &
   length = 25.0  &
   area_of_cross_section = 3.1415926536  &
   y_shear_area_ratio = 1.0  &
   z_shear_area_ratio = 1.0  &
   youngs_modulus = 7.1705E+04  &
   shear_modulus = 2.6956766917E+04  &
   ixx = 1.5707963268  &
   iyy = 0.7853981634  &
   izz = 0.7853981634  &
   damping_ratio = 1.0E-05  &
   formulation = linear
!
force create element_like beam  &
   beam_name = .net_ball.vBeam_2_1_L  &
   adams_id = 219  &
   i_marker_name = .net_ball.vlnk_2_1.MARKER_437  &
   j_marker_name = .net_ball.hlnk_2_1.MARKER_438  &
   length = 25.0  &
   area_of_cross_section = 3.1415926536  &
   y_shear_area_ratio = 1.0  &
   z_shear_area_ratio = 1.0  &
   youngs_modulus = 7.1705E+04  &
   shear_modulus = 2.6956766917E+04  &
   ixx = 1.5707963268  &
   iyy = 0.7853981634  &
   izz = 0.7853981634  &
   damping_ratio = 1.0E-05  &
   formulation = linear
!
force create element_like beam  &
   beam_name = .net_ball.vBeam_2_1_R  &
   adams_id = 220  &
   i_marker_name = .net_ball.vlnk_2_1.MARKER_439  &
   j_marker_name = .net_ball.hlnk_2_2.MARKER_440  &
   length = 25.0  &
   area_of_cross_section = 3.1415926536  &
   y_shear_area_ratio = 1.0  &
   z_shear_area_ratio = 1.0  &
   youngs_modulus = 7.1705E+04  &
   shear_modulus = 2.6956766917E+04  &
   ixx = 1.5707963268  &
   iyy = 0.7853981634  &
   izz = 0.7853981634  &
   damping_ratio = 1.0E-05  &
   formulation = linear
!
force create element_like beam  &
   beam_name = .net_ball.vBeam_2_2_L  &
   adams_id = 221  &
   i_marker_name = .net_ball.vlnk_2_2.MARKER_441  &
   j_marker_name = .net_ball.hlnk_2_2.MARKER_442  &
   length = 25.0  &
   area_of_cross_section = 3.1415926536  &
   y_shear_area_ratio = 1.0  &
   z_shear_area_ratio = 1.0  &
   youngs_modulus = 7.1705E+04  &
   shear_modulus = 2.6956766917E+04  &
   ixx = 1.5707963268  &
   iyy = 0.7853981634  &
   izz = 0.7853981634  &
   damping_ratio = 1.0E-05  &
   formulation = linear
!
force create element_like beam  &
   beam_name = .net_ball.vBeam_2_2_R  &
   adams_id = 222  &
   i_marker_name = .net_ball.vlnk_2_2.MARKER_443  &
   j_marker_name = .net_ball.hlnk_2_3.MARKER_444  &
   length = 25.0  &
   area_of_cross_section = 3.1415926536  &
   y_shear_area_ratio = 1.0  &
   z_shear_area_ratio = 1.0  &
   youngs_modulus = 7.1705E+04  &
   shear_modulus = 2.6956766917E+04  &
   ixx = 1.5707963268  &
   iyy = 0.7853981634  &
   izz = 0.7853981634  &
   damping_ratio = 1.0E-05  &
   formulation = linear
!
force create element_like beam  &
   beam_name = .net_ball.vBeam_2_3_L  &
   adams_id = 223  &
   i_marker_name = .net_ball.vlnk_2_3.MARKER_445  &
   j_marker_name = .net_ball.hlnk_2_3.MARKER_446  &
   length = 25.0  &
   area_of_cross_section = 3.1415926536  &
   y_shear_area_ratio = 1.0  &
   z_shear_area_ratio = 1.0  &
   youngs_modulus = 7.1705E+04  &
   shear_modulus = 2.6956766917E+04  &
   ixx = 1.5707963268  &
   iyy = 0.7853981634  &
   izz = 0.7853981634  &
   damping_ratio = 1.0E-05  &
   formulation = linear
!
force create element_like beam  &
   beam_name = .net_ball.vBeam_2_3_R  &
   adams_id = 224  &
   i_marker_name = .net_ball.vlnk_2_3.MARKER_447  &
   j_marker_name = .net_ball.hlnk_2_4.MARKER_448  &
   length = 25.0  &
   area_of_cross_section = 3.1415926536  &
   y_shear_area_ratio = 1.0  &
   z_shear_area_ratio = 1.0  &
   youngs_modulus = 7.1705E+04  &
   shear_modulus = 2.6956766917E+04  &
   ixx = 1.5707963268  &
   iyy = 0.7853981634  &
   izz = 0.7853981634  &
   damping_ratio = 1.0E-05  &
   formulation = linear
!
force create element_like beam  &
   beam_name = .net_ball.vBeam_2_4_L  &
   adams_id = 225  &
   i_marker_name = .net_ball.vlnk_2_4.MARKER_449  &
   j_marker_name = .net_ball.hlnk_2_4.MARKER_450  &
   length = 25.0  &
   area_of_cross_section = 3.1415926536  &
   y_shear_area_ratio = 1.0  &
   z_shear_area_ratio = 1.0  &
   youngs_modulus = 7.1705E+04  &
   shear_modulus = 2.6956766917E+04  &
   ixx = 1.5707963268  &
   iyy = 0.7853981634  &
   izz = 0.7853981634  &
   damping_ratio = 1.0E-05  &
   formulation = linear
!
force create element_like beam  &
   beam_name = .net_ball.vBeam_2_4_R  &
   adams_id = 226  &
   i_marker_name = .net_ball.vlnk_2_4.MARKER_451  &
   j_marker_name = .net_ball.hlnk_2_5.MARKER_452  &
   length = 25.0  &
   area_of_cross_section = 3.1415926536  &
   y_shear_area_ratio = 1.0  &
   z_shear_area_ratio = 1.0  &
   youngs_modulus = 7.1705E+04  &
   shear_modulus = 2.6956766917E+04  &
   ixx = 1.5707963268  &
   iyy = 0.7853981634  &
   izz = 0.7853981634  &
   damping_ratio = 1.0E-05  &
   formulation = linear
!
force create element_like beam  &
   beam_name = .net_ball.vBeam_2_5_L  &
   adams_id = 227  &
   i_marker_name = .net_ball.vlnk_2_5.MARKER_453  &
   j_marker_name = .net_ball.hlnk_2_5.MARKER_454  &
   length = 25.0  &
   area_of_cross_section = 3.1415926536  &
   y_shear_area_ratio = 1.0  &
   z_shear_area_ratio = 1.0  &
   youngs_modulus = 7.1705E+04  &
   shear_modulus = 2.6956766917E+04  &
   ixx = 1.5707963268  &
   iyy = 0.7853981634  &
   izz = 0.7853981634  &
   damping_ratio = 1.0E-05  &
   formulation = linear
!
force create element_like beam  &
   beam_name = .net_ball.vBeam_2_5_R  &
   adams_id = 228  &
   i_marker_name = .net_ball.vlnk_2_5.MARKER_455  &
   j_marker_name = .net_ball.hlnk_2_6.MARKER_456  &
   length = 25.0  &
   area_of_cross_section = 3.1415926536  &
   y_shear_area_ratio = 1.0  &
   z_shear_area_ratio = 1.0  &
   youngs_modulus = 7.1705E+04  &
   shear_modulus = 2.6956766917E+04  &
   ixx = 1.5707963268  &
   iyy = 0.7853981634  &
   izz = 0.7853981634  &
   damping_ratio = 1.0E-05  &
   formulation = linear
!
force create element_like beam  &
   beam_name = .net_ball.vBeam_2_6_L  &
   adams_id = 229  &
   i_marker_name = .net_ball.vlnk_2_6.MARKER_457  &
   j_marker_name = .net_ball.hlnk_2_6.MARKER_458  &
   length = 25.0  &
   area_of_cross_section = 3.1415926536  &
   y_shear_area_ratio = 1.0  &
   z_shear_area_ratio = 1.0  &
   youngs_modulus = 7.1705E+04  &
   shear_modulus = 2.6956766917E+04  &
   ixx = 1.5707963268  &
   iyy = 0.7853981634  &
   izz = 0.7853981634  &
   damping_ratio = 1.0E-05  &
   formulation = linear
!
force create element_like beam  &
   beam_name = .net_ball.vBeam_2_6_R  &
   adams_id = 230  &
   i_marker_name = .net_ball.vlnk_2_6.MARKER_459  &
   j_marker_name = .net_ball.hlnk_2_7.MARKER_460  &
   length = 25.0  &
   area_of_cross_section = 3.1415926536  &
   y_shear_area_ratio = 1.0  &
   z_shear_area_ratio = 1.0  &
   youngs_modulus = 7.1705E+04  &
   shear_modulus = 2.6956766917E+04  &
   ixx = 1.5707963268  &
   iyy = 0.7853981634  &
   izz = 0.7853981634  &
   damping_ratio = 1.0E-05  &
   formulation = linear
!
force create element_like beam  &
   beam_name = .net_ball.vBeam_2_7_L  &
   adams_id = 231  &
   i_marker_name = .net_ball.vlnk_2_7.MARKER_461  &
   j_marker_name = .net_ball.hlnk_2_7.MARKER_462  &
   length = 25.0  &
   area_of_cross_section = 3.1415926536  &
   y_shear_area_ratio = 1.0  &
   z_shear_area_ratio = 1.0  &
   youngs_modulus = 7.1705E+04  &
   shear_modulus = 2.6956766917E+04  &
   ixx = 1.5707963268  &
   iyy = 0.7853981634  &
   izz = 0.7853981634  &
   damping_ratio = 1.0E-05  &
   formulation = linear
!
force create element_like beam  &
   beam_name = .net_ball.vBeam_2_7_R  &
   adams_id = 232  &
   i_marker_name = .net_ball.vlnk_2_7.MARKER_463  &
   j_marker_name = .net_ball.hlnk_2_8.MARKER_464  &
   length = 25.0  &
   area_of_cross_section = 3.1415926536  &
   y_shear_area_ratio = 1.0  &
   z_shear_area_ratio = 1.0  &
   youngs_modulus = 7.1705E+04  &
   shear_modulus = 2.6956766917E+04  &
   ixx = 1.5707963268  &
   iyy = 0.7853981634  &
   izz = 0.7853981634  &
   damping_ratio = 1.0E-05  &
   formulation = linear
!
force create element_like beam  &
   beam_name = .net_ball.vBeam_2_8_L  &
   adams_id = 233  &
   i_marker_name = .net_ball.vlnk_2_8.MARKER_465  &
   j_marker_name = .net_ball.hlnk_2_8.MARKER_466  &
   length = 25.0  &
   area_of_cross_section = 3.1415926536  &
   y_shear_area_ratio = 1.0  &
   z_shear_area_ratio = 1.0  &
   youngs_modulus = 7.1705E+04  &
   shear_modulus = 2.6956766917E+04  &
   ixx = 1.5707963268  &
   iyy = 0.7853981634  &
   izz = 0.7853981634  &
   damping_ratio = 1.0E-05  &
   formulation = linear
!
force create element_like beam  &
   beam_name = .net_ball.vBeam_2_8_R  &
   adams_id = 234  &
   i_marker_name = .net_ball.vlnk_2_8.MARKER_467  &
   j_marker_name = .net_ball.hlnk_2_9.MARKER_468  &
   length = 25.0  &
   area_of_cross_section = 3.1415926536  &
   y_shear_area_ratio = 1.0  &
   z_shear_area_ratio = 1.0  &
   youngs_modulus = 7.1705E+04  &
   shear_modulus = 2.6956766917E+04  &
   ixx = 1.5707963268  &
   iyy = 0.7853981634  &
   izz = 0.7853981634  &
   damping_ratio = 1.0E-05  &
   formulation = linear
!
force create element_like beam  &
   beam_name = .net_ball.vBeam_3_0_L  &
   adams_id = 235  &
   i_marker_name = .net_ball.vlnk_3_0.MARKER_469  &
   j_marker_name = .net_ball.hlnk_3_0.MARKER_470  &
   length = 25.0  &
   area_of_cross_section = 3.1415926536  &
   y_shear_area_ratio = 1.0  &
   z_shear_area_ratio = 1.0  &
   youngs_modulus = 7.1705E+04  &
   shear_modulus = 2.6956766917E+04  &
   ixx = 1.5707963268  &
   iyy = 0.7853981634  &
   izz = 0.7853981634  &
   damping_ratio = 1.0E-05  &
   formulation = linear
!
force create element_like beam  &
   beam_name = .net_ball.vBeam_3_0_R  &
   adams_id = 236  &
   i_marker_name = .net_ball.vlnk_3_0.MARKER_471  &
   j_marker_name = .net_ball.hlnk_3_1.MARKER_472  &
   length = 25.0  &
   area_of_cross_section = 3.1415926536  &
   y_shear_area_ratio = 1.0  &
   z_shear_area_ratio = 1.0  &
   youngs_modulus = 7.1705E+04  &
   shear_modulus = 2.6956766917E+04  &
   ixx = 1.5707963268  &
   iyy = 0.7853981634  &
   izz = 0.7853981634  &
   damping_ratio = 1.0E-05  &
   formulation = linear
!
force create element_like beam  &
   beam_name = .net_ball.vBeam_3_1_L  &
   adams_id = 237  &
   i_marker_name = .net_ball.vlnk_3_1.MARKER_473  &
   j_marker_name = .net_ball.hlnk_3_1.MARKER_474  &
   length = 25.0  &
   area_of_cross_section = 3.1415926536  &
   y_shear_area_ratio = 1.0  &
   z_shear_area_ratio = 1.0  &
   youngs_modulus = 7.1705E+04  &
   shear_modulus = 2.6956766917E+04  &
   ixx = 1.5707963268  &
   iyy = 0.7853981634  &
   izz = 0.7853981634  &
   damping_ratio = 1.0E-05  &
   formulation = linear
!
force create element_like beam  &
   beam_name = .net_ball.vBeam_3_1_R  &
   adams_id = 238  &
   i_marker_name = .net_ball.vlnk_3_1.MARKER_475  &
   j_marker_name = .net_ball.hlnk_3_2.MARKER_476  &
   length = 25.0  &
   area_of_cross_section = 3.1415926536  &
   y_shear_area_ratio = 1.0  &
   z_shear_area_ratio = 1.0  &
   youngs_modulus = 7.1705E+04  &
   shear_modulus = 2.6956766917E+04  &
   ixx = 1.5707963268  &
   iyy = 0.7853981634  &
   izz = 0.7853981634  &
   damping_ratio = 1.0E-05  &
   formulation = linear
!
force create element_like beam  &
   beam_name = .net_ball.vBeam_3_2_L  &
   adams_id = 239  &
   i_marker_name = .net_ball.vlnk_3_2.MARKER_477  &
   j_marker_name = .net_ball.hlnk_3_2.MARKER_478  &
   length = 25.0  &
   area_of_cross_section = 3.1415926536  &
   y_shear_area_ratio = 1.0  &
   z_shear_area_ratio = 1.0  &
   youngs_modulus = 7.1705E+04  &
   shear_modulus = 2.6956766917E+04  &
   ixx = 1.5707963268  &
   iyy = 0.7853981634  &
   izz = 0.7853981634  &
   damping_ratio = 1.0E-05  &
   formulation = linear
!
force create element_like beam  &
   beam_name = .net_ball.vBeam_3_2_R  &
   adams_id = 240  &
   i_marker_name = .net_ball.vlnk_3_2.MARKER_479  &
   j_marker_name = .net_ball.hlnk_3_3.MARKER_480  &
   length = 25.0  &
   area_of_cross_section = 3.1415926536  &
   y_shear_area_ratio = 1.0  &
   z_shear_area_ratio = 1.0  &
   youngs_modulus = 7.1705E+04  &
   shear_modulus = 2.6956766917E+04  &
   ixx = 1.5707963268  &
   iyy = 0.7853981634  &
   izz = 0.7853981634  &
   damping_ratio = 1.0E-05  &
   formulation = linear
!
force create element_like beam  &
   beam_name = .net_ball.vBeam_3_3_L  &
   adams_id = 241  &
   i_marker_name = .net_ball.vlnk_3_3.MARKER_481  &
   j_marker_name = .net_ball.hlnk_3_3.MARKER_482  &
   length = 25.0  &
   area_of_cross_section = 3.1415926536  &
   y_shear_area_ratio = 1.0  &
   z_shear_area_ratio = 1.0  &
   youngs_modulus = 7.1705E+04  &
   shear_modulus = 2.6956766917E+04  &
   ixx = 1.5707963268  &
   iyy = 0.7853981634  &
   izz = 0.7853981634  &
   damping_ratio = 1.0E-05  &
   formulation = linear
!
force create element_like beam  &
   beam_name = .net_ball.vBeam_3_3_R  &
   adams_id = 242  &
   i_marker_name = .net_ball.vlnk_3_3.MARKER_483  &
   j_marker_name = .net_ball.hlnk_3_4.MARKER_484  &
   length = 25.0  &
   area_of_cross_section = 3.1415926536  &
   y_shear_area_ratio = 1.0  &
   z_shear_area_ratio = 1.0  &
   youngs_modulus = 7.1705E+04  &
   shear_modulus = 2.6956766917E+04  &
   ixx = 1.5707963268  &
   iyy = 0.7853981634  &
   izz = 0.7853981634  &
   damping_ratio = 1.0E-05  &
   formulation = linear
!
force create element_like beam  &
   beam_name = .net_ball.vBeam_3_4_L  &
   adams_id = 243  &
   i_marker_name = .net_ball.vlnk_3_4.MARKER_485  &
   j_marker_name = .net_ball.hlnk_3_4.MARKER_486  &
   length = 25.0  &
   area_of_cross_section = 3.1415926536  &
   y_shear_area_ratio = 1.0  &
   z_shear_area_ratio = 1.0  &
   youngs_modulus = 7.1705E+04  &
   shear_modulus = 2.6956766917E+04  &
   ixx = 1.5707963268  &
   iyy = 0.7853981634  &
   izz = 0.7853981634  &
   damping_ratio = 1.0E-05  &
   formulation = linear
!
force create element_like beam  &
   beam_name = .net_ball.vBeam_3_4_R  &
   adams_id = 244  &
   i_marker_name = .net_ball.vlnk_3_4.MARKER_487  &
   j_marker_name = .net_ball.hlnk_3_5.MARKER_488  &
   length = 25.0  &
   area_of_cross_section = 3.1415926536  &
   y_shear_area_ratio = 1.0  &
   z_shear_area_ratio = 1.0  &
   youngs_modulus = 7.1705E+04  &
   shear_modulus = 2.6956766917E+04  &
   ixx = 1.5707963268  &
   iyy = 0.7853981634  &
   izz = 0.7853981634  &
   damping_ratio = 1.0E-05  &
   formulation = linear
!
force create element_like beam  &
   beam_name = .net_ball.vBeam_3_5_L  &
   adams_id = 245  &
   i_marker_name = .net_ball.vlnk_3_5.MARKER_489  &
   j_marker_name = .net_ball.hlnk_3_5.MARKER_490  &
   length = 25.0  &
   area_of_cross_section = 3.1415926536  &
   y_shear_area_ratio = 1.0  &
   z_shear_area_ratio = 1.0  &
   youngs_modulus = 7.1705E+04  &
   shear_modulus = 2.6956766917E+04  &
   ixx = 1.5707963268  &
   iyy = 0.7853981634  &
   izz = 0.7853981634  &
   damping_ratio = 1.0E-05  &
   formulation = linear
!
force create element_like beam  &
   beam_name = .net_ball.vBeam_3_5_R  &
   adams_id = 246  &
   i_marker_name = .net_ball.vlnk_3_5.MARKER_491  &
   j_marker_name = .net_ball.hlnk_3_6.MARKER_492  &
   length = 25.0  &
   area_of_cross_section = 3.1415926536  &
   y_shear_area_ratio = 1.0  &
   z_shear_area_ratio = 1.0  &
   youngs_modulus = 7.1705E+04  &
   shear_modulus = 2.6956766917E+04  &
   ixx = 1.5707963268  &
   iyy = 0.7853981634  &
   izz = 0.7853981634  &
   damping_ratio = 1.0E-05  &
   formulation = linear
!
force create element_like beam  &
   beam_name = .net_ball.vBeam_3_6_L  &
   adams_id = 247  &
   i_marker_name = .net_ball.vlnk_3_6.MARKER_493  &
   j_marker_name = .net_ball.hlnk_3_6.MARKER_494  &
   length = 25.0  &
   area_of_cross_section = 3.1415926536  &
   y_shear_area_ratio = 1.0  &
   z_shear_area_ratio = 1.0  &
   youngs_modulus = 7.1705E+04  &
   shear_modulus = 2.6956766917E+04  &
   ixx = 1.5707963268  &
   iyy = 0.7853981634  &
   izz = 0.7853981634  &
   damping_ratio = 1.0E-05  &
   formulation = linear
!
force create element_like beam  &
   beam_name = .net_ball.vBeam_3_6_R  &
   adams_id = 248  &
   i_marker_name = .net_ball.vlnk_3_6.MARKER_495  &
   j_marker_name = .net_ball.hlnk_3_7.MARKER_496  &
   length = 25.0  &
   area_of_cross_section = 3.1415926536  &
   y_shear_area_ratio = 1.0  &
   z_shear_area_ratio = 1.0  &
   youngs_modulus = 7.1705E+04  &
   shear_modulus = 2.6956766917E+04  &
   ixx = 1.5707963268  &
   iyy = 0.7853981634  &
   izz = 0.7853981634  &
   damping_ratio = 1.0E-05  &
   formulation = linear
!
force create element_like beam  &
   beam_name = .net_ball.vBeam_3_7_L  &
   adams_id = 249  &
   i_marker_name = .net_ball.vlnk_3_7.MARKER_497  &
   j_marker_name = .net_ball.hlnk_3_7.MARKER_498  &
   length = 25.0  &
   area_of_cross_section = 3.1415926536  &
   y_shear_area_ratio = 1.0  &
   z_shear_area_ratio = 1.0  &
   youngs_modulus = 7.1705E+04  &
   shear_modulus = 2.6956766917E+04  &
   ixx = 1.5707963268  &
   iyy = 0.7853981634  &
   izz = 0.7853981634  &
   damping_ratio = 1.0E-05  &
   formulation = linear
!
force create element_like beam  &
   beam_name = .net_ball.vBeam_3_7_R  &
   adams_id = 250  &
   i_marker_name = .net_ball.vlnk_3_7.MARKER_499  &
   j_marker_name = .net_ball.hlnk_3_8.MARKER_500  &
   length = 25.0  &
   area_of_cross_section = 3.1415926536  &
   y_shear_area_ratio = 1.0  &
   z_shear_area_ratio = 1.0  &
   youngs_modulus = 7.1705E+04  &
   shear_modulus = 2.6956766917E+04  &
   ixx = 1.5707963268  &
   iyy = 0.7853981634  &
   izz = 0.7853981634  &
   damping_ratio = 1.0E-05  &
   formulation = linear
!
force create element_like beam  &
   beam_name = .net_ball.vBeam_3_8_L  &
   adams_id = 251  &
   i_marker_name = .net_ball.vlnk_3_8.MARKER_501  &
   j_marker_name = .net_ball.hlnk_3_8.MARKER_502  &
   length = 25.0  &
   area_of_cross_section = 3.1415926536  &
   y_shear_area_ratio = 1.0  &
   z_shear_area_ratio = 1.0  &
   youngs_modulus = 7.1705E+04  &
   shear_modulus = 2.6956766917E+04  &
   ixx = 1.5707963268  &
   iyy = 0.7853981634  &
   izz = 0.7853981634  &
   damping_ratio = 1.0E-05  &
   formulation = linear
!
force create element_like beam  &
   beam_name = .net_ball.vBeam_3_8_R  &
   adams_id = 252  &
   i_marker_name = .net_ball.vlnk_3_8.MARKER_503  &
   j_marker_name = .net_ball.hlnk_3_9.MARKER_504  &
   length = 25.0  &
   area_of_cross_section = 3.1415926536  &
   y_shear_area_ratio = 1.0  &
   z_shear_area_ratio = 1.0  &
   youngs_modulus = 7.1705E+04  &
   shear_modulus = 2.6956766917E+04  &
   ixx = 1.5707963268  &
   iyy = 0.7853981634  &
   izz = 0.7853981634  &
   damping_ratio = 1.0E-05  &
   formulation = linear
!
force create element_like beam  &
   beam_name = .net_ball.vBeam_4_0_L  &
   adams_id = 253  &
   i_marker_name = .net_ball.vlnk_4_0.MARKER_505  &
   j_marker_name = .net_ball.hlnk_4_0.MARKER_506  &
   length = 25.0  &
   area_of_cross_section = 3.1415926536  &
   y_shear_area_ratio = 1.0  &
   z_shear_area_ratio = 1.0  &
   youngs_modulus = 7.1705E+04  &
   shear_modulus = 2.6956766917E+04  &
   ixx = 1.5707963268  &
   iyy = 0.7853981634  &
   izz = 0.7853981634  &
   damping_ratio = 1.0E-05  &
   formulation = linear
!
force create element_like beam  &
   beam_name = .net_ball.vBeam_4_0_R  &
   adams_id = 254  &
   i_marker_name = .net_ball.vlnk_4_0.MARKER_507  &
   j_marker_name = .net_ball.hlnk_4_1.MARKER_508  &
   length = 25.0  &
   area_of_cross_section = 3.1415926536  &
   y_shear_area_ratio = 1.0  &
   z_shear_area_ratio = 1.0  &
   youngs_modulus = 7.1705E+04  &
   shear_modulus = 2.6956766917E+04  &
   ixx = 1.5707963268  &
   iyy = 0.7853981634  &
   izz = 0.7853981634  &
   damping_ratio = 1.0E-05  &
   formulation = linear
!
force create element_like beam  &
   beam_name = .net_ball.vBeam_4_1_L  &
   adams_id = 255  &
   i_marker_name = .net_ball.vlnk_4_1.MARKER_509  &
   j_marker_name = .net_ball.hlnk_4_1.MARKER_510  &
   length = 25.0  &
   area_of_cross_section = 3.1415926536  &
   y_shear_area_ratio = 1.0  &
   z_shear_area_ratio = 1.0  &
   youngs_modulus = 7.1705E+04  &
   shear_modulus = 2.6956766917E+04  &
   ixx = 1.5707963268  &
   iyy = 0.7853981634  &
   izz = 0.7853981634  &
   damping_ratio = 1.0E-05  &
   formulation = linear
!
force create element_like beam  &
   beam_name = .net_ball.vBeam_4_1_R  &
   adams_id = 256  &
   i_marker_name = .net_ball.vlnk_4_1.MARKER_511  &
   j_marker_name = .net_ball.hlnk_4_2.MARKER_512  &
   length = 25.0  &
   area_of_cross_section = 3.1415926536  &
   y_shear_area_ratio = 1.0  &
   z_shear_area_ratio = 1.0  &
   youngs_modulus = 7.1705E+04  &
   shear_modulus = 2.6956766917E+04  &
   ixx = 1.5707963268  &
   iyy = 0.7853981634  &
   izz = 0.7853981634  &
   damping_ratio = 1.0E-05  &
   formulation = linear
!
force create element_like beam  &
   beam_name = .net_ball.vBeam_4_2_L  &
   adams_id = 257  &
   i_marker_name = .net_ball.vlnk_4_2.MARKER_513  &
   j_marker_name = .net_ball.hlnk_4_2.MARKER_514  &
   length = 25.0  &
   area_of_cross_section = 3.1415926536  &
   y_shear_area_ratio = 1.0  &
   z_shear_area_ratio = 1.0  &
   youngs_modulus = 7.1705E+04  &
   shear_modulus = 2.6956766917E+04  &
   ixx = 1.5707963268  &
   iyy = 0.7853981634  &
   izz = 0.7853981634  &
   damping_ratio = 1.0E-05  &
   formulation = linear
!
force create element_like beam  &
   beam_name = .net_ball.vBeam_4_2_R  &
   adams_id = 258  &
   i_marker_name = .net_ball.vlnk_4_2.MARKER_515  &
   j_marker_name = .net_ball.hlnk_4_3.MARKER_516  &
   length = 25.0  &
   area_of_cross_section = 3.1415926536  &
   y_shear_area_ratio = 1.0  &
   z_shear_area_ratio = 1.0  &
   youngs_modulus = 7.1705E+04  &
   shear_modulus = 2.6956766917E+04  &
   ixx = 1.5707963268  &
   iyy = 0.7853981634  &
   izz = 0.7853981634  &
   damping_ratio = 1.0E-05  &
   formulation = linear
!
force create element_like beam  &
   beam_name = .net_ball.vBeam_4_3_L  &
   adams_id = 259  &
   i_marker_name = .net_ball.vlnk_4_3.MARKER_517  &
   j_marker_name = .net_ball.hlnk_4_3.MARKER_518  &
   length = 25.0  &
   area_of_cross_section = 3.1415926536  &
   y_shear_area_ratio = 1.0  &
   z_shear_area_ratio = 1.0  &
   youngs_modulus = 7.1705E+04  &
   shear_modulus = 2.6956766917E+04  &
   ixx = 1.5707963268  &
   iyy = 0.7853981634  &
   izz = 0.7853981634  &
   damping_ratio = 1.0E-05  &
   formulation = linear
!
force create element_like beam  &
   beam_name = .net_ball.vBeam_4_3_R  &
   adams_id = 260  &
   i_marker_name = .net_ball.vlnk_4_3.MARKER_519  &
   j_marker_name = .net_ball.hlnk_4_4.MARKER_520  &
   length = 25.0  &
   area_of_cross_section = 3.1415926536  &
   y_shear_area_ratio = 1.0  &
   z_shear_area_ratio = 1.0  &
   youngs_modulus = 7.1705E+04  &
   shear_modulus = 2.6956766917E+04  &
   ixx = 1.5707963268  &
   iyy = 0.7853981634  &
   izz = 0.7853981634  &
   damping_ratio = 1.0E-05  &
   formulation = linear
!
force create element_like beam  &
   beam_name = .net_ball.vBeam_4_4_L  &
   adams_id = 261  &
   i_marker_name = .net_ball.vlnk_4_4.MARKER_521  &
   j_marker_name = .net_ball.hlnk_4_4.MARKER_522  &
   length = 25.0  &
   area_of_cross_section = 3.1415926536  &
   y_shear_area_ratio = 1.0  &
   z_shear_area_ratio = 1.0  &
   youngs_modulus = 7.1705E+04  &
   shear_modulus = 2.6956766917E+04  &
   ixx = 1.5707963268  &
   iyy = 0.7853981634  &
   izz = 0.7853981634  &
   damping_ratio = 1.0E-05  &
   formulation = linear
!
force create element_like beam  &
   beam_name = .net_ball.vBeam_4_4_R  &
   adams_id = 262  &
   i_marker_name = .net_ball.vlnk_4_4.MARKER_523  &
   j_marker_name = .net_ball.hlnk_4_5.MARKER_524  &
   length = 25.0  &
   area_of_cross_section = 3.1415926536  &
   y_shear_area_ratio = 1.0  &
   z_shear_area_ratio = 1.0  &
   youngs_modulus = 7.1705E+04  &
   shear_modulus = 2.6956766917E+04  &
   ixx = 1.5707963268  &
   iyy = 0.7853981634  &
   izz = 0.7853981634  &
   damping_ratio = 1.0E-05  &
   formulation = linear
!
force create element_like beam  &
   beam_name = .net_ball.vBeam_4_5_L  &
   adams_id = 263  &
   i_marker_name = .net_ball.vlnk_4_5.MARKER_525  &
   j_marker_name = .net_ball.hlnk_4_5.MARKER_526  &
   length = 25.0  &
   area_of_cross_section = 3.1415926536  &
   y_shear_area_ratio = 1.0  &
   z_shear_area_ratio = 1.0  &
   youngs_modulus = 7.1705E+04  &
   shear_modulus = 2.6956766917E+04  &
   ixx = 1.5707963268  &
   iyy = 0.7853981634  &
   izz = 0.7853981634  &
   damping_ratio = 1.0E-05  &
   formulation = linear
!
force create element_like beam  &
   beam_name = .net_ball.vBeam_4_5_R  &
   adams_id = 264  &
   i_marker_name = .net_ball.vlnk_4_5.MARKER_527  &
   j_marker_name = .net_ball.hlnk_4_6.MARKER_528  &
   length = 25.0  &
   area_of_cross_section = 3.1415926536  &
   y_shear_area_ratio = 1.0  &
   z_shear_area_ratio = 1.0  &
   youngs_modulus = 7.1705E+04  &
   shear_modulus = 2.6956766917E+04  &
   ixx = 1.5707963268  &
   iyy = 0.7853981634  &
   izz = 0.7853981634  &
   damping_ratio = 1.0E-05  &
   formulation = linear
!
force create element_like beam  &
   beam_name = .net_ball.vBeam_4_6_L  &
   adams_id = 265  &
   i_marker_name = .net_ball.vlnk_4_6.MARKER_529  &
   j_marker_name = .net_ball.hlnk_4_6.MARKER_530  &
   length = 25.0  &
   area_of_cross_section = 3.1415926536  &
   y_shear_area_ratio = 1.0  &
   z_shear_area_ratio = 1.0  &
   youngs_modulus = 7.1705E+04  &
   shear_modulus = 2.6956766917E+04  &
   ixx = 1.5707963268  &
   iyy = 0.7853981634  &
   izz = 0.7853981634  &
   damping_ratio = 1.0E-05  &
   formulation = linear
!
force create element_like beam  &
   beam_name = .net_ball.vBeam_4_6_R  &
   adams_id = 266  &
   i_marker_name = .net_ball.vlnk_4_6.MARKER_531  &
   j_marker_name = .net_ball.hlnk_4_7.MARKER_532  &
   length = 25.0  &
   area_of_cross_section = 3.1415926536  &
   y_shear_area_ratio = 1.0  &
   z_shear_area_ratio = 1.0  &
   youngs_modulus = 7.1705E+04  &
   shear_modulus = 2.6956766917E+04  &
   ixx = 1.5707963268  &
   iyy = 0.7853981634  &
   izz = 0.7853981634  &
   damping_ratio = 1.0E-05  &
   formulation = linear
!
force create element_like beam  &
   beam_name = .net_ball.vBeam_4_7_L  &
   adams_id = 267  &
   i_marker_name = .net_ball.vlnk_4_7.MARKER_533  &
   j_marker_name = .net_ball.hlnk_4_7.MARKER_534  &
   length = 25.0  &
   area_of_cross_section = 3.1415926536  &
   y_shear_area_ratio = 1.0  &
   z_shear_area_ratio = 1.0  &
   youngs_modulus = 7.1705E+04  &
   shear_modulus = 2.6956766917E+04  &
   ixx = 1.5707963268  &
   iyy = 0.7853981634  &
   izz = 0.7853981634  &
   damping_ratio = 1.0E-05  &
   formulation = linear
!
force create element_like beam  &
   beam_name = .net_ball.vBeam_4_7_R  &
   adams_id = 268  &
   i_marker_name = .net_ball.vlnk_4_7.MARKER_535  &
   j_marker_name = .net_ball.hlnk_4_8.MARKER_536  &
   length = 25.0  &
   area_of_cross_section = 3.1415926536  &
   y_shear_area_ratio = 1.0  &
   z_shear_area_ratio = 1.0  &
   youngs_modulus = 7.1705E+04  &
   shear_modulus = 2.6956766917E+04  &
   ixx = 1.5707963268  &
   iyy = 0.7853981634  &
   izz = 0.7853981634  &
   damping_ratio = 1.0E-05  &
   formulation = linear
!
force create element_like beam  &
   beam_name = .net_ball.vBeam_4_8_L  &
   adams_id = 269  &
   i_marker_name = .net_ball.vlnk_4_8.MARKER_537  &
   j_marker_name = .net_ball.hlnk_4_8.MARKER_538  &
   length = 25.0  &
   area_of_cross_section = 3.1415926536  &
   y_shear_area_ratio = 1.0  &
   z_shear_area_ratio = 1.0  &
   youngs_modulus = 7.1705E+04  &
   shear_modulus = 2.6956766917E+04  &
   ixx = 1.5707963268  &
   iyy = 0.7853981634  &
   izz = 0.7853981634  &
   damping_ratio = 1.0E-05  &
   formulation = linear
!
force create element_like beam  &
   beam_name = .net_ball.vBeam_4_8_R  &
   adams_id = 270  &
   i_marker_name = .net_ball.vlnk_4_8.MARKER_539  &
   j_marker_name = .net_ball.hlnk_4_9.MARKER_540  &
   length = 25.0  &
   area_of_cross_section = 3.1415926536  &
   y_shear_area_ratio = 1.0  &
   z_shear_area_ratio = 1.0  &
   youngs_modulus = 7.1705E+04  &
   shear_modulus = 2.6956766917E+04  &
   ixx = 1.5707963268  &
   iyy = 0.7853981634  &
   izz = 0.7853981634  &
   damping_ratio = 1.0E-05  &
   formulation = linear
!
force create element_like beam  &
   beam_name = .net_ball.vBeam_5_0_L  &
   adams_id = 271  &
   i_marker_name = .net_ball.vlnk_5_0.MARKER_541  &
   j_marker_name = .net_ball.hlnk_5_0.MARKER_542  &
   length = 25.0  &
   area_of_cross_section = 3.1415926536  &
   y_shear_area_ratio = 1.0  &
   z_shear_area_ratio = 1.0  &
   youngs_modulus = 7.1705E+04  &
   shear_modulus = 2.6956766917E+04  &
   ixx = 1.5707963268  &
   iyy = 0.7853981634  &
   izz = 0.7853981634  &
   damping_ratio = 1.0E-05  &
   formulation = linear
!
force create element_like beam  &
   beam_name = .net_ball.vBeam_5_0_R  &
   adams_id = 272  &
   i_marker_name = .net_ball.vlnk_5_0.MARKER_543  &
   j_marker_name = .net_ball.hlnk_5_1.MARKER_544  &
   length = 25.0  &
   area_of_cross_section = 3.1415926536  &
   y_shear_area_ratio = 1.0  &
   z_shear_area_ratio = 1.0  &
   youngs_modulus = 7.1705E+04  &
   shear_modulus = 2.6956766917E+04  &
   ixx = 1.5707963268  &
   iyy = 0.7853981634  &
   izz = 0.7853981634  &
   damping_ratio = 1.0E-05  &
   formulation = linear
!
force create element_like beam  &
   beam_name = .net_ball.vBeam_5_1_L  &
   adams_id = 273  &
   i_marker_name = .net_ball.vlnk_5_1.MARKER_545  &
   j_marker_name = .net_ball.hlnk_5_1.MARKER_546  &
   length = 25.0  &
   area_of_cross_section = 3.1415926536  &
   y_shear_area_ratio = 1.0  &
   z_shear_area_ratio = 1.0  &
   youngs_modulus = 7.1705E+04  &
   shear_modulus = 2.6956766917E+04  &
   ixx = 1.5707963268  &
   iyy = 0.7853981634  &
   izz = 0.7853981634  &
   damping_ratio = 1.0E-05  &
   formulation = linear
!
force create element_like beam  &
   beam_name = .net_ball.vBeam_5_1_R  &
   adams_id = 274  &
   i_marker_name = .net_ball.vlnk_5_1.MARKER_547  &
   j_marker_name = .net_ball.hlnk_5_2.MARKER_548  &
   length = 25.0  &
   area_of_cross_section = 3.1415926536  &
   y_shear_area_ratio = 1.0  &
   z_shear_area_ratio = 1.0  &
   youngs_modulus = 7.1705E+04  &
   shear_modulus = 2.6956766917E+04  &
   ixx = 1.5707963268  &
   iyy = 0.7853981634  &
   izz = 0.7853981634  &
   damping_ratio = 1.0E-05  &
   formulation = linear
!
force create element_like beam  &
   beam_name = .net_ball.vBeam_5_2_L  &
   adams_id = 275  &
   i_marker_name = .net_ball.vlnk_5_2.MARKER_549  &
   j_marker_name = .net_ball.hlnk_5_2.MARKER_550  &
   length = 25.0  &
   area_of_cross_section = 3.1415926536  &
   y_shear_area_ratio = 1.0  &
   z_shear_area_ratio = 1.0  &
   youngs_modulus = 7.1705E+04  &
   shear_modulus = 2.6956766917E+04  &
   ixx = 1.5707963268  &
   iyy = 0.7853981634  &
   izz = 0.7853981634  &
   damping_ratio = 1.0E-05  &
   formulation = linear
!
force create element_like beam  &
   beam_name = .net_ball.vBeam_5_2_R  &
   adams_id = 276  &
   i_marker_name = .net_ball.vlnk_5_2.MARKER_551  &
   j_marker_name = .net_ball.hlnk_5_3.MARKER_552  &
   length = 25.0  &
   area_of_cross_section = 3.1415926536  &
   y_shear_area_ratio = 1.0  &
   z_shear_area_ratio = 1.0  &
   youngs_modulus = 7.1705E+04  &
   shear_modulus = 2.6956766917E+04  &
   ixx = 1.5707963268  &
   iyy = 0.7853981634  &
   izz = 0.7853981634  &
   damping_ratio = 1.0E-05  &
   formulation = linear
!
force create element_like beam  &
   beam_name = .net_ball.vBeam_5_3_L  &
   adams_id = 277  &
   i_marker_name = .net_ball.vlnk_5_3.MARKER_553  &
   j_marker_name = .net_ball.hlnk_5_3.MARKER_554  &
   length = 25.0  &
   area_of_cross_section = 3.1415926536  &
   y_shear_area_ratio = 1.0  &
   z_shear_area_ratio = 1.0  &
   youngs_modulus = 7.1705E+04  &
   shear_modulus = 2.6956766917E+04  &
   ixx = 1.5707963268  &
   iyy = 0.7853981634  &
   izz = 0.7853981634  &
   damping_ratio = 1.0E-05  &
   formulation = linear
!
force create element_like beam  &
   beam_name = .net_ball.vBeam_5_3_R  &
   adams_id = 278  &
   i_marker_name = .net_ball.vlnk_5_3.MARKER_555  &
   j_marker_name = .net_ball.hlnk_5_4.MARKER_556  &
   length = 25.0  &
   area_of_cross_section = 3.1415926536  &
   y_shear_area_ratio = 1.0  &
   z_shear_area_ratio = 1.0  &
   youngs_modulus = 7.1705E+04  &
   shear_modulus = 2.6956766917E+04  &
   ixx = 1.5707963268  &
   iyy = 0.7853981634  &
   izz = 0.7853981634  &
   damping_ratio = 1.0E-05  &
   formulation = linear
!
force create element_like beam  &
   beam_name = .net_ball.vBeam_5_4_L  &
   adams_id = 279  &
   i_marker_name = .net_ball.vlnk_5_4.MARKER_557  &
   j_marker_name = .net_ball.hlnk_5_4.MARKER_558  &
   length = 25.0  &
   area_of_cross_section = 3.1415926536  &
   y_shear_area_ratio = 1.0  &
   z_shear_area_ratio = 1.0  &
   youngs_modulus = 7.1705E+04  &
   shear_modulus = 2.6956766917E+04  &
   ixx = 1.5707963268  &
   iyy = 0.7853981634  &
   izz = 0.7853981634  &
   damping_ratio = 1.0E-05  &
   formulation = linear
!
force create element_like beam  &
   beam_name = .net_ball.vBeam_5_4_R  &
   adams_id = 280  &
   i_marker_name = .net_ball.vlnk_5_4.MARKER_559  &
   j_marker_name = .net_ball.hlnk_5_5.MARKER_560  &
   length = 25.0  &
   area_of_cross_section = 3.1415926536  &
   y_shear_area_ratio = 1.0  &
   z_shear_area_ratio = 1.0  &
   youngs_modulus = 7.1705E+04  &
   shear_modulus = 2.6956766917E+04  &
   ixx = 1.5707963268  &
   iyy = 0.7853981634  &
   izz = 0.7853981634  &
   damping_ratio = 1.0E-05  &
   formulation = linear
!
force create element_like beam  &
   beam_name = .net_ball.vBeam_5_5_L  &
   adams_id = 281  &
   i_marker_name = .net_ball.vlnk_5_5.MARKER_561  &
   j_marker_name = .net_ball.hlnk_5_5.MARKER_562  &
   length = 25.0  &
   area_of_cross_section = 3.1415926536  &
   y_shear_area_ratio = 1.0  &
   z_shear_area_ratio = 1.0  &
   youngs_modulus = 7.1705E+04  &
   shear_modulus = 2.6956766917E+04  &
   ixx = 1.5707963268  &
   iyy = 0.7853981634  &
   izz = 0.7853981634  &
   damping_ratio = 1.0E-05  &
   formulation = linear
!
force create element_like beam  &
   beam_name = .net_ball.vBeam_5_5_R  &
   adams_id = 282  &
   i_marker_name = .net_ball.vlnk_5_5.MARKER_563  &
   j_marker_name = .net_ball.hlnk_5_6.MARKER_564  &
   length = 25.0  &
   area_of_cross_section = 3.1415926536  &
   y_shear_area_ratio = 1.0  &
   z_shear_area_ratio = 1.0  &
   youngs_modulus = 7.1705E+04  &
   shear_modulus = 2.6956766917E+04  &
   ixx = 1.5707963268  &
   iyy = 0.7853981634  &
   izz = 0.7853981634  &
   damping_ratio = 1.0E-05  &
   formulation = linear
!
force create element_like beam  &
   beam_name = .net_ball.vBeam_5_6_L  &
   adams_id = 283  &
   i_marker_name = .net_ball.vlnk_5_6.MARKER_565  &
   j_marker_name = .net_ball.hlnk_5_6.MARKER_566  &
   length = 25.0  &
   area_of_cross_section = 3.1415926536  &
   y_shear_area_ratio = 1.0  &
   z_shear_area_ratio = 1.0  &
   youngs_modulus = 7.1705E+04  &
   shear_modulus = 2.6956766917E+04  &
   ixx = 1.5707963268  &
   iyy = 0.7853981634  &
   izz = 0.7853981634  &
   damping_ratio = 1.0E-05  &
   formulation = linear
!
force create element_like beam  &
   beam_name = .net_ball.vBeam_5_6_R  &
   adams_id = 284  &
   i_marker_name = .net_ball.vlnk_5_6.MARKER_567  &
   j_marker_name = .net_ball.hlnk_5_7.MARKER_568  &
   length = 25.0  &
   area_of_cross_section = 3.1415926536  &
   y_shear_area_ratio = 1.0  &
   z_shear_area_ratio = 1.0  &
   youngs_modulus = 7.1705E+04  &
   shear_modulus = 2.6956766917E+04  &
   ixx = 1.5707963268  &
   iyy = 0.7853981634  &
   izz = 0.7853981634  &
   damping_ratio = 1.0E-05  &
   formulation = linear
!
force create element_like beam  &
   beam_name = .net_ball.vBeam_5_7_L  &
   adams_id = 285  &
   i_marker_name = .net_ball.vlnk_5_7.MARKER_569  &
   j_marker_name = .net_ball.hlnk_5_7.MARKER_570  &
   length = 25.0  &
   area_of_cross_section = 3.1415926536  &
   y_shear_area_ratio = 1.0  &
   z_shear_area_ratio = 1.0  &
   youngs_modulus = 7.1705E+04  &
   shear_modulus = 2.6956766917E+04  &
   ixx = 1.5707963268  &
   iyy = 0.7853981634  &
   izz = 0.7853981634  &
   damping_ratio = 1.0E-05  &
   formulation = linear
!
force create element_like beam  &
   beam_name = .net_ball.vBeam_5_7_R  &
   adams_id = 286  &
   i_marker_name = .net_ball.vlnk_5_7.MARKER_571  &
   j_marker_name = .net_ball.hlnk_5_8.MARKER_572  &
   length = 25.0  &
   area_of_cross_section = 3.1415926536  &
   y_shear_area_ratio = 1.0  &
   z_shear_area_ratio = 1.0  &
   youngs_modulus = 7.1705E+04  &
   shear_modulus = 2.6956766917E+04  &
   ixx = 1.5707963268  &
   iyy = 0.7853981634  &
   izz = 0.7853981634  &
   damping_ratio = 1.0E-05  &
   formulation = linear
!
force create element_like beam  &
   beam_name = .net_ball.vBeam_5_8_L  &
   adams_id = 287  &
   i_marker_name = .net_ball.vlnk_5_8.MARKER_573  &
   j_marker_name = .net_ball.hlnk_5_8.MARKER_574  &
   length = 25.0  &
   area_of_cross_section = 3.1415926536  &
   y_shear_area_ratio = 1.0  &
   z_shear_area_ratio = 1.0  &
   youngs_modulus = 7.1705E+04  &
   shear_modulus = 2.6956766917E+04  &
   ixx = 1.5707963268  &
   iyy = 0.7853981634  &
   izz = 0.7853981634  &
   damping_ratio = 1.0E-05  &
   formulation = linear
!
force create element_like beam  &
   beam_name = .net_ball.vBeam_5_8_R  &
   adams_id = 288  &
   i_marker_name = .net_ball.vlnk_5_8.MARKER_575  &
   j_marker_name = .net_ball.hlnk_5_9.MARKER_576  &
   length = 25.0  &
   area_of_cross_section = 3.1415926536  &
   y_shear_area_ratio = 1.0  &
   z_shear_area_ratio = 1.0  &
   youngs_modulus = 7.1705E+04  &
   shear_modulus = 2.6956766917E+04  &
   ixx = 1.5707963268  &
   iyy = 0.7853981634  &
   izz = 0.7853981634  &
   damping_ratio = 1.0E-05  &
   formulation = linear
!
force create element_like beam  &
   beam_name = .net_ball.vBeam_6_0_L  &
   adams_id = 289  &
   i_marker_name = .net_ball.vlnk_6_0.MARKER_577  &
   j_marker_name = .net_ball.hlnk_6_0.MARKER_578  &
   length = 25.0  &
   area_of_cross_section = 3.1415926536  &
   y_shear_area_ratio = 1.0  &
   z_shear_area_ratio = 1.0  &
   youngs_modulus = 7.1705E+04  &
   shear_modulus = 2.6956766917E+04  &
   ixx = 1.5707963268  &
   iyy = 0.7853981634  &
   izz = 0.7853981634  &
   damping_ratio = 1.0E-05  &
   formulation = linear
!
force create element_like beam  &
   beam_name = .net_ball.vBeam_6_0_R  &
   adams_id = 290  &
   i_marker_name = .net_ball.vlnk_6_0.MARKER_579  &
   j_marker_name = .net_ball.hlnk_6_1.MARKER_580  &
   length = 25.0  &
   area_of_cross_section = 3.1415926536  &
   y_shear_area_ratio = 1.0  &
   z_shear_area_ratio = 1.0  &
   youngs_modulus = 7.1705E+04  &
   shear_modulus = 2.6956766917E+04  &
   ixx = 1.5707963268  &
   iyy = 0.7853981634  &
   izz = 0.7853981634  &
   damping_ratio = 1.0E-05  &
   formulation = linear
!
force create element_like beam  &
   beam_name = .net_ball.vBeam_6_1_L  &
   adams_id = 291  &
   i_marker_name = .net_ball.vlnk_6_1.MARKER_581  &
   j_marker_name = .net_ball.hlnk_6_1.MARKER_582  &
   length = 25.0  &
   area_of_cross_section = 3.1415926536  &
   y_shear_area_ratio = 1.0  &
   z_shear_area_ratio = 1.0  &
   youngs_modulus = 7.1705E+04  &
   shear_modulus = 2.6956766917E+04  &
   ixx = 1.5707963268  &
   iyy = 0.7853981634  &
   izz = 0.7853981634  &
   damping_ratio = 1.0E-05  &
   formulation = linear
!
force create element_like beam  &
   beam_name = .net_ball.vBeam_6_1_R  &
   adams_id = 292  &
   i_marker_name = .net_ball.vlnk_6_1.MARKER_583  &
   j_marker_name = .net_ball.hlnk_6_2.MARKER_584  &
   length = 25.0  &
   area_of_cross_section = 3.1415926536  &
   y_shear_area_ratio = 1.0  &
   z_shear_area_ratio = 1.0  &
   youngs_modulus = 7.1705E+04  &
   shear_modulus = 2.6956766917E+04  &
   ixx = 1.5707963268  &
   iyy = 0.7853981634  &
   izz = 0.7853981634  &
   damping_ratio = 1.0E-05  &
   formulation = linear
!
force create element_like beam  &
   beam_name = .net_ball.vBeam_6_2_L  &
   adams_id = 293  &
   i_marker_name = .net_ball.vlnk_6_2.MARKER_585  &
   j_marker_name = .net_ball.hlnk_6_2.MARKER_586  &
   length = 25.0  &
   area_of_cross_section = 3.1415926536  &
   y_shear_area_ratio = 1.0  &
   z_shear_area_ratio = 1.0  &
   youngs_modulus = 7.1705E+04  &
   shear_modulus = 2.6956766917E+04  &
   ixx = 1.5707963268  &
   iyy = 0.7853981634  &
   izz = 0.7853981634  &
   damping_ratio = 1.0E-05  &
   formulation = linear
!
force create element_like beam  &
   beam_name = .net_ball.vBeam_6_2_R  &
   adams_id = 294  &
   i_marker_name = .net_ball.vlnk_6_2.MARKER_587  &
   j_marker_name = .net_ball.hlnk_6_3.MARKER_588  &
   length = 25.0  &
   area_of_cross_section = 3.1415926536  &
   y_shear_area_ratio = 1.0  &
   z_shear_area_ratio = 1.0  &
   youngs_modulus = 7.1705E+04  &
   shear_modulus = 2.6956766917E+04  &
   ixx = 1.5707963268  &
   iyy = 0.7853981634  &
   izz = 0.7853981634  &
   damping_ratio = 1.0E-05  &
   formulation = linear
!
force create element_like beam  &
   beam_name = .net_ball.vBeam_6_3_L  &
   adams_id = 295  &
   i_marker_name = .net_ball.vlnk_6_3.MARKER_589  &
   j_marker_name = .net_ball.hlnk_6_3.MARKER_590  &
   length = 25.0  &
   area_of_cross_section = 3.1415926536  &
   y_shear_area_ratio = 1.0  &
   z_shear_area_ratio = 1.0  &
   youngs_modulus = 7.1705E+04  &
   shear_modulus = 2.6956766917E+04  &
   ixx = 1.5707963268  &
   iyy = 0.7853981634  &
   izz = 0.7853981634  &
   damping_ratio = 1.0E-05  &
   formulation = linear
!
force create element_like beam  &
   beam_name = .net_ball.vBeam_6_3_R  &
   adams_id = 296  &
   i_marker_name = .net_ball.vlnk_6_3.MARKER_591  &
   j_marker_name = .net_ball.hlnk_6_4.MARKER_592  &
   length = 25.0  &
   area_of_cross_section = 3.1415926536  &
   y_shear_area_ratio = 1.0  &
   z_shear_area_ratio = 1.0  &
   youngs_modulus = 7.1705E+04  &
   shear_modulus = 2.6956766917E+04  &
   ixx = 1.5707963268  &
   iyy = 0.7853981634  &
   izz = 0.7853981634  &
   damping_ratio = 1.0E-05  &
   formulation = linear
!
force create element_like beam  &
   beam_name = .net_ball.vBeam_6_4_L  &
   adams_id = 297  &
   i_marker_name = .net_ball.vlnk_6_4.MARKER_593  &
   j_marker_name = .net_ball.hlnk_6_4.MARKER_594  &
   length = 25.0  &
   area_of_cross_section = 3.1415926536  &
   y_shear_area_ratio = 1.0  &
   z_shear_area_ratio = 1.0  &
   youngs_modulus = 7.1705E+04  &
   shear_modulus = 2.6956766917E+04  &
   ixx = 1.5707963268  &
   iyy = 0.7853981634  &
   izz = 0.7853981634  &
   damping_ratio = 1.0E-05  &
   formulation = linear
!
force create element_like beam  &
   beam_name = .net_ball.vBeam_6_4_R  &
   adams_id = 298  &
   i_marker_name = .net_ball.vlnk_6_4.MARKER_595  &
   j_marker_name = .net_ball.hlnk_6_5.MARKER_596  &
   length = 25.0  &
   area_of_cross_section = 3.1415926536  &
   y_shear_area_ratio = 1.0  &
   z_shear_area_ratio = 1.0  &
   youngs_modulus = 7.1705E+04  &
   shear_modulus = 2.6956766917E+04  &
   ixx = 1.5707963268  &
   iyy = 0.7853981634  &
   izz = 0.7853981634  &
   damping_ratio = 1.0E-05  &
   formulation = linear
!
force create element_like beam  &
   beam_name = .net_ball.vBeam_6_5_L  &
   adams_id = 299  &
   i_marker_name = .net_ball.vlnk_6_5.MARKER_597  &
   j_marker_name = .net_ball.hlnk_6_5.MARKER_598  &
   length = 25.0  &
   area_of_cross_section = 3.1415926536  &
   y_shear_area_ratio = 1.0  &
   z_shear_area_ratio = 1.0  &
   youngs_modulus = 7.1705E+04  &
   shear_modulus = 2.6956766917E+04  &
   ixx = 1.5707963268  &
   iyy = 0.7853981634  &
   izz = 0.7853981634  &
   damping_ratio = 1.0E-05  &
   formulation = linear
!
force create element_like beam  &
   beam_name = .net_ball.vBeam_6_5_R  &
   adams_id = 300  &
   i_marker_name = .net_ball.vlnk_6_5.MARKER_599  &
   j_marker_name = .net_ball.hlnk_6_6.MARKER_600  &
   length = 25.0  &
   area_of_cross_section = 3.1415926536  &
   y_shear_area_ratio = 1.0  &
   z_shear_area_ratio = 1.0  &
   youngs_modulus = 7.1705E+04  &
   shear_modulus = 2.6956766917E+04  &
   ixx = 1.5707963268  &
   iyy = 0.7853981634  &
   izz = 0.7853981634  &
   damping_ratio = 1.0E-05  &
   formulation = linear
!
force create element_like beam  &
   beam_name = .net_ball.vBeam_6_6_L  &
   adams_id = 301  &
   i_marker_name = .net_ball.vlnk_6_6.MARKER_601  &
   j_marker_name = .net_ball.hlnk_6_6.MARKER_602  &
   length = 25.0  &
   area_of_cross_section = 3.1415926536  &
   y_shear_area_ratio = 1.0  &
   z_shear_area_ratio = 1.0  &
   youngs_modulus = 7.1705E+04  &
   shear_modulus = 2.6956766917E+04  &
   ixx = 1.5707963268  &
   iyy = 0.7853981634  &
   izz = 0.7853981634  &
   damping_ratio = 1.0E-05  &
   formulation = linear
!
force create element_like beam  &
   beam_name = .net_ball.vBeam_6_6_R  &
   adams_id = 302  &
   i_marker_name = .net_ball.vlnk_6_6.MARKER_603  &
   j_marker_name = .net_ball.hlnk_6_7.MARKER_604  &
   length = 25.0  &
   area_of_cross_section = 3.1415926536  &
   y_shear_area_ratio = 1.0  &
   z_shear_area_ratio = 1.0  &
   youngs_modulus = 7.1705E+04  &
   shear_modulus = 2.6956766917E+04  &
   ixx = 1.5707963268  &
   iyy = 0.7853981634  &
   izz = 0.7853981634  &
   damping_ratio = 1.0E-05  &
   formulation = linear
!
force create element_like beam  &
   beam_name = .net_ball.vBeam_6_7_L  &
   adams_id = 303  &
   i_marker_name = .net_ball.vlnk_6_7.MARKER_605  &
   j_marker_name = .net_ball.hlnk_6_7.MARKER_606  &
   length = 25.0  &
   area_of_cross_section = 3.1415926536  &
   y_shear_area_ratio = 1.0  &
   z_shear_area_ratio = 1.0  &
   youngs_modulus = 7.1705E+04  &
   shear_modulus = 2.6956766917E+04  &
   ixx = 1.5707963268  &
   iyy = 0.7853981634  &
   izz = 0.7853981634  &
   damping_ratio = 1.0E-05  &
   formulation = linear
!
force create element_like beam  &
   beam_name = .net_ball.vBeam_6_7_R  &
   adams_id = 304  &
   i_marker_name = .net_ball.vlnk_6_7.MARKER_607  &
   j_marker_name = .net_ball.hlnk_6_8.MARKER_608  &
   length = 25.0  &
   area_of_cross_section = 3.1415926536  &
   y_shear_area_ratio = 1.0  &
   z_shear_area_ratio = 1.0  &
   youngs_modulus = 7.1705E+04  &
   shear_modulus = 2.6956766917E+04  &
   ixx = 1.5707963268  &
   iyy = 0.7853981634  &
   izz = 0.7853981634  &
   damping_ratio = 1.0E-05  &
   formulation = linear
!
force create element_like beam  &
   beam_name = .net_ball.vBeam_6_8_L  &
   adams_id = 305  &
   i_marker_name = .net_ball.vlnk_6_8.MARKER_609  &
   j_marker_name = .net_ball.hlnk_6_8.MARKER_610  &
   length = 25.0  &
   area_of_cross_section = 3.1415926536  &
   y_shear_area_ratio = 1.0  &
   z_shear_area_ratio = 1.0  &
   youngs_modulus = 7.1705E+04  &
   shear_modulus = 2.6956766917E+04  &
   ixx = 1.5707963268  &
   iyy = 0.7853981634  &
   izz = 0.7853981634  &
   damping_ratio = 1.0E-05  &
   formulation = linear
!
force create element_like beam  &
   beam_name = .net_ball.vBeam_6_8_R  &
   adams_id = 306  &
   i_marker_name = .net_ball.vlnk_6_8.MARKER_611  &
   j_marker_name = .net_ball.hlnk_6_9.MARKER_612  &
   length = 25.0  &
   area_of_cross_section = 3.1415926536  &
   y_shear_area_ratio = 1.0  &
   z_shear_area_ratio = 1.0  &
   youngs_modulus = 7.1705E+04  &
   shear_modulus = 2.6956766917E+04  &
   ixx = 1.5707963268  &
   iyy = 0.7853981634  &
   izz = 0.7853981634  &
   damping_ratio = 1.0E-05  &
   formulation = linear
!
force create element_like beam  &
   beam_name = .net_ball.vBeam_7_0_L  &
   adams_id = 307  &
   i_marker_name = .net_ball.vlnk_7_0.MARKER_613  &
   j_marker_name = .net_ball.hlnk_7_0.MARKER_614  &
   length = 25.0  &
   area_of_cross_section = 3.1415926536  &
   y_shear_area_ratio = 1.0  &
   z_shear_area_ratio = 1.0  &
   youngs_modulus = 7.1705E+04  &
   shear_modulus = 2.6956766917E+04  &
   ixx = 1.5707963268  &
   iyy = 0.7853981634  &
   izz = 0.7853981634  &
   damping_ratio = 1.0E-05  &
   formulation = linear
!
force create element_like beam  &
   beam_name = .net_ball.vBeam_7_0_R  &
   adams_id = 308  &
   i_marker_name = .net_ball.vlnk_7_0.MARKER_615  &
   j_marker_name = .net_ball.hlnk_7_1.MARKER_616  &
   length = 25.0  &
   area_of_cross_section = 3.1415926536  &
   y_shear_area_ratio = 1.0  &
   z_shear_area_ratio = 1.0  &
   youngs_modulus = 7.1705E+04  &
   shear_modulus = 2.6956766917E+04  &
   ixx = 1.5707963268  &
   iyy = 0.7853981634  &
   izz = 0.7853981634  &
   damping_ratio = 1.0E-05  &
   formulation = linear
!
force create element_like beam  &
   beam_name = .net_ball.vBeam_7_1_L  &
   adams_id = 309  &
   i_marker_name = .net_ball.vlnk_7_1.MARKER_617  &
   j_marker_name = .net_ball.hlnk_7_1.MARKER_618  &
   length = 25.0  &
   area_of_cross_section = 3.1415926536  &
   y_shear_area_ratio = 1.0  &
   z_shear_area_ratio = 1.0  &
   youngs_modulus = 7.1705E+04  &
   shear_modulus = 2.6956766917E+04  &
   ixx = 1.5707963268  &
   iyy = 0.7853981634  &
   izz = 0.7853981634  &
   damping_ratio = 1.0E-05  &
   formulation = linear
!
force create element_like beam  &
   beam_name = .net_ball.vBeam_7_1_R  &
   adams_id = 310  &
   i_marker_name = .net_ball.vlnk_7_1.MARKER_619  &
   j_marker_name = .net_ball.hlnk_7_2.MARKER_620  &
   length = 25.0  &
   area_of_cross_section = 3.1415926536  &
   y_shear_area_ratio = 1.0  &
   z_shear_area_ratio = 1.0  &
   youngs_modulus = 7.1705E+04  &
   shear_modulus = 2.6956766917E+04  &
   ixx = 1.5707963268  &
   iyy = 0.7853981634  &
   izz = 0.7853981634  &
   damping_ratio = 1.0E-05  &
   formulation = linear
!
force create element_like beam  &
   beam_name = .net_ball.vBeam_7_2_L  &
   adams_id = 311  &
   i_marker_name = .net_ball.vlnk_7_2.MARKER_621  &
   j_marker_name = .net_ball.hlnk_7_2.MARKER_622  &
   length = 25.0  &
   area_of_cross_section = 3.1415926536  &
   y_shear_area_ratio = 1.0  &
   z_shear_area_ratio = 1.0  &
   youngs_modulus = 7.1705E+04  &
   shear_modulus = 2.6956766917E+04  &
   ixx = 1.5707963268  &
   iyy = 0.7853981634  &
   izz = 0.7853981634  &
   damping_ratio = 1.0E-05  &
   formulation = linear
!
force create element_like beam  &
   beam_name = .net_ball.vBeam_7_2_R  &
   adams_id = 312  &
   i_marker_name = .net_ball.vlnk_7_2.MARKER_623  &
   j_marker_name = .net_ball.hlnk_7_3.MARKER_624  &
   length = 25.0  &
   area_of_cross_section = 3.1415926536  &
   y_shear_area_ratio = 1.0  &
   z_shear_area_ratio = 1.0  &
   youngs_modulus = 7.1705E+04  &
   shear_modulus = 2.6956766917E+04  &
   ixx = 1.5707963268  &
   iyy = 0.7853981634  &
   izz = 0.7853981634  &
   damping_ratio = 1.0E-05  &
   formulation = linear
!
force create element_like beam  &
   beam_name = .net_ball.vBeam_7_3_L  &
   adams_id = 313  &
   i_marker_name = .net_ball.vlnk_7_3.MARKER_625  &
   j_marker_name = .net_ball.hlnk_7_3.MARKER_626  &
   length = 25.0  &
   area_of_cross_section = 3.1415926536  &
   y_shear_area_ratio = 1.0  &
   z_shear_area_ratio = 1.0  &
   youngs_modulus = 7.1705E+04  &
   shear_modulus = 2.6956766917E+04  &
   ixx = 1.5707963268  &
   iyy = 0.7853981634  &
   izz = 0.7853981634  &
   damping_ratio = 1.0E-05  &
   formulation = linear
!
force create element_like beam  &
   beam_name = .net_ball.vBeam_7_3_R  &
   adams_id = 314  &
   i_marker_name = .net_ball.vlnk_7_3.MARKER_627  &
   j_marker_name = .net_ball.hlnk_7_4.MARKER_628  &
   length = 25.0  &
   area_of_cross_section = 3.1415926536  &
   y_shear_area_ratio = 1.0  &
   z_shear_area_ratio = 1.0  &
   youngs_modulus = 7.1705E+04  &
   shear_modulus = 2.6956766917E+04  &
   ixx = 1.5707963268  &
   iyy = 0.7853981634  &
   izz = 0.7853981634  &
   damping_ratio = 1.0E-05  &
   formulation = linear
!
force create element_like beam  &
   beam_name = .net_ball.vBeam_7_4_L  &
   adams_id = 315  &
   i_marker_name = .net_ball.vlnk_7_4.MARKER_629  &
   j_marker_name = .net_ball.hlnk_7_4.MARKER_630  &
   length = 25.0  &
   area_of_cross_section = 3.1415926536  &
   y_shear_area_ratio = 1.0  &
   z_shear_area_ratio = 1.0  &
   youngs_modulus = 7.1705E+04  &
   shear_modulus = 2.6956766917E+04  &
   ixx = 1.5707963268  &
   iyy = 0.7853981634  &
   izz = 0.7853981634  &
   damping_ratio = 1.0E-05  &
   formulation = linear
!
force create element_like beam  &
   beam_name = .net_ball.vBeam_7_4_R  &
   adams_id = 316  &
   i_marker_name = .net_ball.vlnk_7_4.MARKER_631  &
   j_marker_name = .net_ball.hlnk_7_5.MARKER_632  &
   length = 25.0  &
   area_of_cross_section = 3.1415926536  &
   y_shear_area_ratio = 1.0  &
   z_shear_area_ratio = 1.0  &
   youngs_modulus = 7.1705E+04  &
   shear_modulus = 2.6956766917E+04  &
   ixx = 1.5707963268  &
   iyy = 0.7853981634  &
   izz = 0.7853981634  &
   damping_ratio = 1.0E-05  &
   formulation = linear
!
force create element_like beam  &
   beam_name = .net_ball.vBeam_7_5_L  &
   adams_id = 317  &
   i_marker_name = .net_ball.vlnk_7_5.MARKER_633  &
   j_marker_name = .net_ball.hlnk_7_5.MARKER_634  &
   length = 25.0  &
   area_of_cross_section = 3.1415926536  &
   y_shear_area_ratio = 1.0  &
   z_shear_area_ratio = 1.0  &
   youngs_modulus = 7.1705E+04  &
   shear_modulus = 2.6956766917E+04  &
   ixx = 1.5707963268  &
   iyy = 0.7853981634  &
   izz = 0.7853981634  &
   damping_ratio = 1.0E-05  &
   formulation = linear
!
force create element_like beam  &
   beam_name = .net_ball.vBeam_7_5_R  &
   adams_id = 318  &
   i_marker_name = .net_ball.vlnk_7_5.MARKER_635  &
   j_marker_name = .net_ball.hlnk_7_6.MARKER_636  &
   length = 25.0  &
   area_of_cross_section = 3.1415926536  &
   y_shear_area_ratio = 1.0  &
   z_shear_area_ratio = 1.0  &
   youngs_modulus = 7.1705E+04  &
   shear_modulus = 2.6956766917E+04  &
   ixx = 1.5707963268  &
   iyy = 0.7853981634  &
   izz = 0.7853981634  &
   damping_ratio = 1.0E-05  &
   formulation = linear
!
force create element_like beam  &
   beam_name = .net_ball.vBeam_7_6_L  &
   adams_id = 319  &
   i_marker_name = .net_ball.vlnk_7_6.MARKER_637  &
   j_marker_name = .net_ball.hlnk_7_6.MARKER_638  &
   length = 25.0  &
   area_of_cross_section = 3.1415926536  &
   y_shear_area_ratio = 1.0  &
   z_shear_area_ratio = 1.0  &
   youngs_modulus = 7.1705E+04  &
   shear_modulus = 2.6956766917E+04  &
   ixx = 1.5707963268  &
   iyy = 0.7853981634  &
   izz = 0.7853981634  &
   damping_ratio = 1.0E-05  &
   formulation = linear
!
force create element_like beam  &
   beam_name = .net_ball.vBeam_7_6_R  &
   adams_id = 320  &
   i_marker_name = .net_ball.vlnk_7_6.MARKER_639  &
   j_marker_name = .net_ball.hlnk_7_7.MARKER_640  &
   length = 25.0  &
   area_of_cross_section = 3.1415926536  &
   y_shear_area_ratio = 1.0  &
   z_shear_area_ratio = 1.0  &
   youngs_modulus = 7.1705E+04  &
   shear_modulus = 2.6956766917E+04  &
   ixx = 1.5707963268  &
   iyy = 0.7853981634  &
   izz = 0.7853981634  &
   damping_ratio = 1.0E-05  &
   formulation = linear
!
force create element_like beam  &
   beam_name = .net_ball.vBeam_7_7_L  &
   adams_id = 321  &
   i_marker_name = .net_ball.vlnk_7_7.MARKER_641  &
   j_marker_name = .net_ball.hlnk_7_7.MARKER_642  &
   length = 25.0  &
   area_of_cross_section = 3.1415926536  &
   y_shear_area_ratio = 1.0  &
   z_shear_area_ratio = 1.0  &
   youngs_modulus = 7.1705E+04  &
   shear_modulus = 2.6956766917E+04  &
   ixx = 1.5707963268  &
   iyy = 0.7853981634  &
   izz = 0.7853981634  &
   damping_ratio = 1.0E-05  &
   formulation = linear
!
force create element_like beam  &
   beam_name = .net_ball.vBeam_7_7_R  &
   adams_id = 322  &
   i_marker_name = .net_ball.vlnk_7_7.MARKER_643  &
   j_marker_name = .net_ball.hlnk_7_8.MARKER_644  &
   length = 25.0  &
   area_of_cross_section = 3.1415926536  &
   y_shear_area_ratio = 1.0  &
   z_shear_area_ratio = 1.0  &
   youngs_modulus = 7.1705E+04  &
   shear_modulus = 2.6956766917E+04  &
   ixx = 1.5707963268  &
   iyy = 0.7853981634  &
   izz = 0.7853981634  &
   damping_ratio = 1.0E-05  &
   formulation = linear
!
force create element_like beam  &
   beam_name = .net_ball.vBeam_7_8_L  &
   adams_id = 323  &
   i_marker_name = .net_ball.vlnk_7_8.MARKER_645  &
   j_marker_name = .net_ball.hlnk_7_8.MARKER_646  &
   length = 25.0  &
   area_of_cross_section = 3.1415926536  &
   y_shear_area_ratio = 1.0  &
   z_shear_area_ratio = 1.0  &
   youngs_modulus = 7.1705E+04  &
   shear_modulus = 2.6956766917E+04  &
   ixx = 1.5707963268  &
   iyy = 0.7853981634  &
   izz = 0.7853981634  &
   damping_ratio = 1.0E-05  &
   formulation = linear
!
force create element_like beam  &
   beam_name = .net_ball.vBeam_7_8_R  &
   adams_id = 324  &
   i_marker_name = .net_ball.vlnk_7_8.MARKER_647  &
   j_marker_name = .net_ball.hlnk_7_9.MARKER_648  &
   length = 25.0  &
   area_of_cross_section = 3.1415926536  &
   y_shear_area_ratio = 1.0  &
   z_shear_area_ratio = 1.0  &
   youngs_modulus = 7.1705E+04  &
   shear_modulus = 2.6956766917E+04  &
   ixx = 1.5707963268  &
   iyy = 0.7853981634  &
   izz = 0.7853981634  &
   damping_ratio = 1.0E-05  &
   formulation = linear
!
force create element_like beam  &
   beam_name = .net_ball.vBeam_8_0_L  &
   adams_id = 325  &
   i_marker_name = .net_ball.vlnk_8_0.MARKER_649  &
   j_marker_name = .net_ball.hlnk_8_0.MARKER_650  &
   length = 25.0  &
   area_of_cross_section = 3.1415926536  &
   y_shear_area_ratio = 1.0  &
   z_shear_area_ratio = 1.0  &
   youngs_modulus = 7.1705E+04  &
   shear_modulus = 2.6956766917E+04  &
   ixx = 1.5707963268  &
   iyy = 0.7853981634  &
   izz = 0.7853981634  &
   damping_ratio = 1.0E-05  &
   formulation = linear
!
force create element_like beam  &
   beam_name = .net_ball.vBeam_8_0_R  &
   adams_id = 326  &
   i_marker_name = .net_ball.vlnk_8_0.MARKER_651  &
   j_marker_name = .net_ball.hlnk_8_1.MARKER_652  &
   length = 25.0  &
   area_of_cross_section = 3.1415926536  &
   y_shear_area_ratio = 1.0  &
   z_shear_area_ratio = 1.0  &
   youngs_modulus = 7.1705E+04  &
   shear_modulus = 2.6956766917E+04  &
   ixx = 1.5707963268  &
   iyy = 0.7853981634  &
   izz = 0.7853981634  &
   damping_ratio = 1.0E-05  &
   formulation = linear
!
force create element_like beam  &
   beam_name = .net_ball.vBeam_8_1_L  &
   adams_id = 327  &
   i_marker_name = .net_ball.vlnk_8_1.MARKER_653  &
   j_marker_name = .net_ball.hlnk_8_1.MARKER_654  &
   length = 25.0  &
   area_of_cross_section = 3.1415926536  &
   y_shear_area_ratio = 1.0  &
   z_shear_area_ratio = 1.0  &
   youngs_modulus = 7.1705E+04  &
   shear_modulus = 2.6956766917E+04  &
   ixx = 1.5707963268  &
   iyy = 0.7853981634  &
   izz = 0.7853981634  &
   damping_ratio = 1.0E-05  &
   formulation = linear
!
force create element_like beam  &
   beam_name = .net_ball.vBeam_8_1_R  &
   adams_id = 328  &
   i_marker_name = .net_ball.vlnk_8_1.MARKER_655  &
   j_marker_name = .net_ball.hlnk_8_2.MARKER_656  &
   length = 25.0  &
   area_of_cross_section = 3.1415926536  &
   y_shear_area_ratio = 1.0  &
   z_shear_area_ratio = 1.0  &
   youngs_modulus = 7.1705E+04  &
   shear_modulus = 2.6956766917E+04  &
   ixx = 1.5707963268  &
   iyy = 0.7853981634  &
   izz = 0.7853981634  &
   damping_ratio = 1.0E-05  &
   formulation = linear
!
force create element_like beam  &
   beam_name = .net_ball.vBeam_8_2_L  &
   adams_id = 329  &
   i_marker_name = .net_ball.vlnk_8_2.MARKER_657  &
   j_marker_name = .net_ball.hlnk_8_2.MARKER_658  &
   length = 25.0  &
   area_of_cross_section = 3.1415926536  &
   y_shear_area_ratio = 1.0  &
   z_shear_area_ratio = 1.0  &
   youngs_modulus = 7.1705E+04  &
   shear_modulus = 2.6956766917E+04  &
   ixx = 1.5707963268  &
   iyy = 0.7853981634  &
   izz = 0.7853981634  &
   damping_ratio = 1.0E-05  &
   formulation = linear
!
force create element_like beam  &
   beam_name = .net_ball.vBeam_8_2_R  &
   adams_id = 330  &
   i_marker_name = .net_ball.vlnk_8_2.MARKER_659  &
   j_marker_name = .net_ball.hlnk_8_3.MARKER_660  &
   length = 25.0  &
   area_of_cross_section = 3.1415926536  &
   y_shear_area_ratio = 1.0  &
   z_shear_area_ratio = 1.0  &
   youngs_modulus = 7.1705E+04  &
   shear_modulus = 2.6956766917E+04  &
   ixx = 1.5707963268  &
   iyy = 0.7853981634  &
   izz = 0.7853981634  &
   damping_ratio = 1.0E-05  &
   formulation = linear
!
force create element_like beam  &
   beam_name = .net_ball.vBeam_8_3_L  &
   adams_id = 331  &
   i_marker_name = .net_ball.vlnk_8_3.MARKER_661  &
   j_marker_name = .net_ball.hlnk_8_3.MARKER_662  &
   length = 25.0  &
   area_of_cross_section = 3.1415926536  &
   y_shear_area_ratio = 1.0  &
   z_shear_area_ratio = 1.0  &
   youngs_modulus = 7.1705E+04  &
   shear_modulus = 2.6956766917E+04  &
   ixx = 1.5707963268  &
   iyy = 0.7853981634  &
   izz = 0.7853981634  &
   damping_ratio = 1.0E-05  &
   formulation = linear
!
force create element_like beam  &
   beam_name = .net_ball.vBeam_8_3_R  &
   adams_id = 332  &
   i_marker_name = .net_ball.vlnk_8_3.MARKER_663  &
   j_marker_name = .net_ball.hlnk_8_4.MARKER_664  &
   length = 25.0  &
   area_of_cross_section = 3.1415926536  &
   y_shear_area_ratio = 1.0  &
   z_shear_area_ratio = 1.0  &
   youngs_modulus = 7.1705E+04  &
   shear_modulus = 2.6956766917E+04  &
   ixx = 1.5707963268  &
   iyy = 0.7853981634  &
   izz = 0.7853981634  &
   damping_ratio = 1.0E-05  &
   formulation = linear
!
force create element_like beam  &
   beam_name = .net_ball.vBeam_8_4_L  &
   adams_id = 333  &
   i_marker_name = .net_ball.vlnk_8_4.MARKER_665  &
   j_marker_name = .net_ball.hlnk_8_4.MARKER_666  &
   length = 25.0  &
   area_of_cross_section = 3.1415926536  &
   y_shear_area_ratio = 1.0  &
   z_shear_area_ratio = 1.0  &
   youngs_modulus = 7.1705E+04  &
   shear_modulus = 2.6956766917E+04  &
   ixx = 1.5707963268  &
   iyy = 0.7853981634  &
   izz = 0.7853981634  &
   damping_ratio = 1.0E-05  &
   formulation = linear
!
force create element_like beam  &
   beam_name = .net_ball.vBeam_8_4_R  &
   adams_id = 334  &
   i_marker_name = .net_ball.vlnk_8_4.MARKER_667  &
   j_marker_name = .net_ball.hlnk_8_5.MARKER_668  &
   length = 25.0  &
   area_of_cross_section = 3.1415926536  &
   y_shear_area_ratio = 1.0  &
   z_shear_area_ratio = 1.0  &
   youngs_modulus = 7.1705E+04  &
   shear_modulus = 2.6956766917E+04  &
   ixx = 1.5707963268  &
   iyy = 0.7853981634  &
   izz = 0.7853981634  &
   damping_ratio = 1.0E-05  &
   formulation = linear
!
force create element_like beam  &
   beam_name = .net_ball.vBeam_8_5_L  &
   adams_id = 335  &
   i_marker_name = .net_ball.vlnk_8_5.MARKER_669  &
   j_marker_name = .net_ball.hlnk_8_5.MARKER_670  &
   length = 25.0  &
   area_of_cross_section = 3.1415926536  &
   y_shear_area_ratio = 1.0  &
   z_shear_area_ratio = 1.0  &
   youngs_modulus = 7.1705E+04  &
   shear_modulus = 2.6956766917E+04  &
   ixx = 1.5707963268  &
   iyy = 0.7853981634  &
   izz = 0.7853981634  &
   damping_ratio = 1.0E-05  &
   formulation = linear
!
force create element_like beam  &
   beam_name = .net_ball.vBeam_8_5_R  &
   adams_id = 336  &
   i_marker_name = .net_ball.vlnk_8_5.MARKER_671  &
   j_marker_name = .net_ball.hlnk_8_6.MARKER_672  &
   length = 25.0  &
   area_of_cross_section = 3.1415926536  &
   y_shear_area_ratio = 1.0  &
   z_shear_area_ratio = 1.0  &
   youngs_modulus = 7.1705E+04  &
   shear_modulus = 2.6956766917E+04  &
   ixx = 1.5707963268  &
   iyy = 0.7853981634  &
   izz = 0.7853981634  &
   damping_ratio = 1.0E-05  &
   formulation = linear
!
force create element_like beam  &
   beam_name = .net_ball.vBeam_8_6_L  &
   adams_id = 337  &
   i_marker_name = .net_ball.vlnk_8_6.MARKER_673  &
   j_marker_name = .net_ball.hlnk_8_6.MARKER_674  &
   length = 25.0  &
   area_of_cross_section = 3.1415926536  &
   y_shear_area_ratio = 1.0  &
   z_shear_area_ratio = 1.0  &
   youngs_modulus = 7.1705E+04  &
   shear_modulus = 2.6956766917E+04  &
   ixx = 1.5707963268  &
   iyy = 0.7853981634  &
   izz = 0.7853981634  &
   damping_ratio = 1.0E-05  &
   formulation = linear
!
force create element_like beam  &
   beam_name = .net_ball.vBeam_8_6_R  &
   adams_id = 338  &
   i_marker_name = .net_ball.vlnk_8_6.MARKER_675  &
   j_marker_name = .net_ball.hlnk_8_7.MARKER_676  &
   length = 25.0  &
   area_of_cross_section = 3.1415926536  &
   y_shear_area_ratio = 1.0  &
   z_shear_area_ratio = 1.0  &
   youngs_modulus = 7.1705E+04  &
   shear_modulus = 2.6956766917E+04  &
   ixx = 1.5707963268  &
   iyy = 0.7853981634  &
   izz = 0.7853981634  &
   damping_ratio = 1.0E-05  &
   formulation = linear
!
force create element_like beam  &
   beam_name = .net_ball.vBeam_8_7_L  &
   adams_id = 339  &
   i_marker_name = .net_ball.vlnk_8_7.MARKER_677  &
   j_marker_name = .net_ball.hlnk_8_7.MARKER_678  &
   length = 25.0  &
   area_of_cross_section = 3.1415926536  &
   y_shear_area_ratio = 1.0  &
   z_shear_area_ratio = 1.0  &
   youngs_modulus = 7.1705E+04  &
   shear_modulus = 2.6956766917E+04  &
   ixx = 1.5707963268  &
   iyy = 0.7853981634  &
   izz = 0.7853981634  &
   damping_ratio = 1.0E-05  &
   formulation = linear
!
force create element_like beam  &
   beam_name = .net_ball.vBeam_8_7_R  &
   adams_id = 340  &
   i_marker_name = .net_ball.vlnk_8_7.MARKER_679  &
   j_marker_name = .net_ball.hlnk_8_8.MARKER_680  &
   length = 25.0  &
   area_of_cross_section = 3.1415926536  &
   y_shear_area_ratio = 1.0  &
   z_shear_area_ratio = 1.0  &
   youngs_modulus = 7.1705E+04  &
   shear_modulus = 2.6956766917E+04  &
   ixx = 1.5707963268  &
   iyy = 0.7853981634  &
   izz = 0.7853981634  &
   damping_ratio = 1.0E-05  &
   formulation = linear
!
force create element_like beam  &
   beam_name = .net_ball.vBeam_8_8_L  &
   adams_id = 341  &
   i_marker_name = .net_ball.vlnk_8_8.MARKER_681  &
   j_marker_name = .net_ball.hlnk_8_8.MARKER_682  &
   length = 25.0  &
   area_of_cross_section = 3.1415926536  &
   y_shear_area_ratio = 1.0  &
   z_shear_area_ratio = 1.0  &
   youngs_modulus = 7.1705E+04  &
   shear_modulus = 2.6956766917E+04  &
   ixx = 1.5707963268  &
   iyy = 0.7853981634  &
   izz = 0.7853981634  &
   damping_ratio = 1.0E-05  &
   formulation = linear
!
force create element_like beam  &
   beam_name = .net_ball.vBeam_8_8_R  &
   adams_id = 342  &
   i_marker_name = .net_ball.vlnk_8_8.MARKER_683  &
   j_marker_name = .net_ball.hlnk_8_9.MARKER_684  &
   length = 25.0  &
   area_of_cross_section = 3.1415926536  &
   y_shear_area_ratio = 1.0  &
   z_shear_area_ratio = 1.0  &
   youngs_modulus = 7.1705E+04  &
   shear_modulus = 2.6956766917E+04  &
   ixx = 1.5707963268  &
   iyy = 0.7853981634  &
   izz = 0.7853981634  &
   damping_ratio = 1.0E-05  &
   formulation = linear
!
force create element_like beam  &
   beam_name = .net_ball.vBeam_9_0_L  &
   adams_id = 343  &
   i_marker_name = .net_ball.vlnk_8_0.MARKER_685  &
   j_marker_name = .net_ball.hlnk_8_1.MARKER_686  &
   length = 25.0  &
   area_of_cross_section = 3.1415926536  &
   y_shear_area_ratio = 1.0  &
   z_shear_area_ratio = 1.0  &
   youngs_modulus = 7.1705E+04  &
   shear_modulus = 2.6956766917E+04  &
   ixx = 1.5707963268  &
   iyy = 0.7853981634  &
   izz = 0.7853981634  &
   damping_ratio = 1.0E-05  &
   formulation = linear
!
force create element_like beam  &
   beam_name = .net_ball.vBeam_9_0_R  &
   adams_id = 344  &
   i_marker_name = .net_ball.vlnk_8_0.MARKER_687  &
   j_marker_name = .net_ball.hlnk_8_1.MARKER_688  &
   length = 25.0  &
   area_of_cross_section = 3.1415926536  &
   y_shear_area_ratio = 1.0  &
   z_shear_area_ratio = 1.0  &
   youngs_modulus = 7.1705E+04  &
   shear_modulus = 2.6956766917E+04  &
   ixx = 1.5707963268  &
   iyy = 0.7853981634  &
   izz = 0.7853981634  &
   damping_ratio = 1.0E-05  &
   formulation = linear
!
force create element_like beam  &
   beam_name = .net_ball.vBeam_9_1_L  &
   adams_id = 345  &
   i_marker_name = .net_ball.vlnk_8_1.MARKER_689  &
   j_marker_name = .net_ball.hlnk_8_2.MARKER_690  &
   length = 25.0  &
   area_of_cross_section = 3.1415926536  &
   y_shear_area_ratio = 1.0  &
   z_shear_area_ratio = 1.0  &
   youngs_modulus = 7.1705E+04  &
   shear_modulus = 2.6956766917E+04  &
   ixx = 1.5707963268  &
   iyy = 0.7853981634  &
   izz = 0.7853981634  &
   damping_ratio = 1.0E-05  &
   formulation = linear
!
force create element_like beam  &
   beam_name = .net_ball.vBeam_9_1_R  &
   adams_id = 346  &
   i_marker_name = .net_ball.vlnk_8_1.MARKER_691  &
   j_marker_name = .net_ball.hlnk_8_2.MARKER_692  &
   length = 25.0  &
   area_of_cross_section = 3.1415926536  &
   y_shear_area_ratio = 1.0  &
   z_shear_area_ratio = 1.0  &
   youngs_modulus = 7.1705E+04  &
   shear_modulus = 2.6956766917E+04  &
   ixx = 1.5707963268  &
   iyy = 0.7853981634  &
   izz = 0.7853981634  &
   damping_ratio = 1.0E-05  &
   formulation = linear
!
force create element_like beam  &
   beam_name = .net_ball.vBeam_9_2_L  &
   adams_id = 347  &
   i_marker_name = .net_ball.vlnk_8_2.MARKER_693  &
   j_marker_name = .net_ball.hlnk_8_3.MARKER_694  &
   length = 25.0  &
   area_of_cross_section = 3.1415926536  &
   y_shear_area_ratio = 1.0  &
   z_shear_area_ratio = 1.0  &
   youngs_modulus = 7.1705E+04  &
   shear_modulus = 2.6956766917E+04  &
   ixx = 1.5707963268  &
   iyy = 0.7853981634  &
   izz = 0.7853981634  &
   damping_ratio = 1.0E-05  &
   formulation = linear
!
force create element_like beam  &
   beam_name = .net_ball.vBeam_9_2_R  &
   adams_id = 348  &
   i_marker_name = .net_ball.vlnk_8_2.MARKER_695  &
   j_marker_name = .net_ball.hlnk_8_3.MARKER_696  &
   length = 25.0  &
   area_of_cross_section = 3.1415926536  &
   y_shear_area_ratio = 1.0  &
   z_shear_area_ratio = 1.0  &
   youngs_modulus = 7.1705E+04  &
   shear_modulus = 2.6956766917E+04  &
   ixx = 1.5707963268  &
   iyy = 0.7853981634  &
   izz = 0.7853981634  &
   damping_ratio = 1.0E-05  &
   formulation = linear
!
force create element_like beam  &
   beam_name = .net_ball.vBeam_9_3_L  &
   adams_id = 349  &
   i_marker_name = .net_ball.vlnk_8_3.MARKER_697  &
   j_marker_name = .net_ball.hlnk_8_4.MARKER_698  &
   length = 25.0  &
   area_of_cross_section = 3.1415926536  &
   y_shear_area_ratio = 1.0  &
   z_shear_area_ratio = 1.0  &
   youngs_modulus = 7.1705E+04  &
   shear_modulus = 2.6956766917E+04  &
   ixx = 1.5707963268  &
   iyy = 0.7853981634  &
   izz = 0.7853981634  &
   damping_ratio = 1.0E-05  &
   formulation = linear
!
force create element_like beam  &
   beam_name = .net_ball.vBeam_9_3_R  &
   adams_id = 350  &
   i_marker_name = .net_ball.vlnk_8_3.MARKER_699  &
   j_marker_name = .net_ball.hlnk_8_4.MARKER_700  &
   length = 25.0  &
   area_of_cross_section = 3.1415926536  &
   y_shear_area_ratio = 1.0  &
   z_shear_area_ratio = 1.0  &
   youngs_modulus = 7.1705E+04  &
   shear_modulus = 2.6956766917E+04  &
   ixx = 1.5707963268  &
   iyy = 0.7853981634  &
   izz = 0.7853981634  &
   damping_ratio = 1.0E-05  &
   formulation = linear
!
force create element_like beam  &
   beam_name = .net_ball.vBeam_9_4_L  &
   adams_id = 351  &
   i_marker_name = .net_ball.vlnk_8_4.MARKER_701  &
   j_marker_name = .net_ball.hlnk_8_5.MARKER_702  &
   length = 25.0  &
   area_of_cross_section = 3.1415926536  &
   y_shear_area_ratio = 1.0  &
   z_shear_area_ratio = 1.0  &
   youngs_modulus = 7.1705E+04  &
   shear_modulus = 2.6956766917E+04  &
   ixx = 1.5707963268  &
   iyy = 0.7853981634  &
   izz = 0.7853981634  &
   damping_ratio = 1.0E-05  &
   formulation = linear
!
force create element_like beam  &
   beam_name = .net_ball.vBeam_9_4_R  &
   adams_id = 352  &
   i_marker_name = .net_ball.vlnk_8_4.MARKER_703  &
   j_marker_name = .net_ball.hlnk_8_5.MARKER_704  &
   length = 25.0  &
   area_of_cross_section = 3.1415926536  &
   y_shear_area_ratio = 1.0  &
   z_shear_area_ratio = 1.0  &
   youngs_modulus = 7.1705E+04  &
   shear_modulus = 2.6956766917E+04  &
   ixx = 1.5707963268  &
   iyy = 0.7853981634  &
   izz = 0.7853981634  &
   damping_ratio = 1.0E-05  &
   formulation = linear
!
force create element_like beam  &
   beam_name = .net_ball.vBeam_9_5_L  &
   adams_id = 353  &
   i_marker_name = .net_ball.vlnk_8_5.MARKER_705  &
   j_marker_name = .net_ball.hlnk_8_6.MARKER_706  &
   length = 25.0  &
   area_of_cross_section = 3.1415926536  &
   y_shear_area_ratio = 1.0  &
   z_shear_area_ratio = 1.0  &
   youngs_modulus = 7.1705E+04  &
   shear_modulus = 2.6956766917E+04  &
   ixx = 1.5707963268  &
   iyy = 0.7853981634  &
   izz = 0.7853981634  &
   damping_ratio = 1.0E-05  &
   formulation = linear
!
force create element_like beam  &
   beam_name = .net_ball.vBeam_9_5_R  &
   adams_id = 354  &
   i_marker_name = .net_ball.vlnk_8_5.MARKER_707  &
   j_marker_name = .net_ball.hlnk_8_6.MARKER_708  &
   length = 25.0  &
   area_of_cross_section = 3.1415926536  &
   y_shear_area_ratio = 1.0  &
   z_shear_area_ratio = 1.0  &
   youngs_modulus = 7.1705E+04  &
   shear_modulus = 2.6956766917E+04  &
   ixx = 1.5707963268  &
   iyy = 0.7853981634  &
   izz = 0.7853981634  &
   damping_ratio = 1.0E-05  &
   formulation = linear
!
force create element_like beam  &
   beam_name = .net_ball.vBeam_9_6_L  &
   adams_id = 355  &
   i_marker_name = .net_ball.vlnk_8_6.MARKER_709  &
   j_marker_name = .net_ball.hlnk_8_7.MARKER_710  &
   length = 25.0  &
   area_of_cross_section = 3.1415926536  &
   y_shear_area_ratio = 1.0  &
   z_shear_area_ratio = 1.0  &
   youngs_modulus = 7.1705E+04  &
   shear_modulus = 2.6956766917E+04  &
   ixx = 1.5707963268  &
   iyy = 0.7853981634  &
   izz = 0.7853981634  &
   damping_ratio = 1.0E-05  &
   formulation = linear
!
force create element_like beam  &
   beam_name = .net_ball.vBeam_9_6_R  &
   adams_id = 356  &
   i_marker_name = .net_ball.vlnk_8_6.MARKER_711  &
   j_marker_name = .net_ball.hlnk_8_7.MARKER_712  &
   length = 25.0  &
   area_of_cross_section = 3.1415926536  &
   y_shear_area_ratio = 1.0  &
   z_shear_area_ratio = 1.0  &
   youngs_modulus = 7.1705E+04  &
   shear_modulus = 2.6956766917E+04  &
   ixx = 1.5707963268  &
   iyy = 0.7853981634  &
   izz = 0.7853981634  &
   damping_ratio = 1.0E-05  &
   formulation = linear
!
force create element_like beam  &
   beam_name = .net_ball.vBeam_9_7_L  &
   adams_id = 357  &
   i_marker_name = .net_ball.vlnk_8_7.MARKER_713  &
   j_marker_name = .net_ball.hlnk_8_8.MARKER_714  &
   length = 25.0  &
   area_of_cross_section = 3.1415926536  &
   y_shear_area_ratio = 1.0  &
   z_shear_area_ratio = 1.0  &
   youngs_modulus = 7.1705E+04  &
   shear_modulus = 2.6956766917E+04  &
   ixx = 1.5707963268  &
   iyy = 0.7853981634  &
   izz = 0.7853981634  &
   damping_ratio = 1.0E-05  &
   formulation = linear
!
force create element_like beam  &
   beam_name = .net_ball.vBeam_9_7_R  &
   adams_id = 358  &
   i_marker_name = .net_ball.vlnk_8_7.MARKER_715  &
   j_marker_name = .net_ball.hlnk_8_8.MARKER_716  &
   length = 25.0  &
   area_of_cross_section = 3.1415926536  &
   y_shear_area_ratio = 1.0  &
   z_shear_area_ratio = 1.0  &
   youngs_modulus = 7.1705E+04  &
   shear_modulus = 2.6956766917E+04  &
   ixx = 1.5707963268  &
   iyy = 0.7853981634  &
   izz = 0.7853981634  &
   damping_ratio = 1.0E-05  &
   formulation = linear
!
force create element_like beam  &
   beam_name = .net_ball.vBeam_9_8_L  &
   adams_id = 359  &
   i_marker_name = .net_ball.vlnk_8_8.MARKER_717  &
   j_marker_name = .net_ball.hlnk_8_9.MARKER_718  &
   length = 25.0  &
   area_of_cross_section = 3.1415926536  &
   y_shear_area_ratio = 1.0  &
   z_shear_area_ratio = 1.0  &
   youngs_modulus = 7.1705E+04  &
   shear_modulus = 2.6956766917E+04  &
   ixx = 1.5707963268  &
   iyy = 0.7853981634  &
   izz = 0.7853981634  &
   damping_ratio = 1.0E-05  &
   formulation = linear
!
force create element_like beam  &
   beam_name = .net_ball.vBeam_9_8_R  &
   adams_id = 360  &
   i_marker_name = .net_ball.vlnk_8_8.MARKER_719  &
   j_marker_name = .net_ball.hlnk_8_9.MARKER_720  &
   length = 25.0  &
   area_of_cross_section = 3.1415926536  &
   y_shear_area_ratio = 1.0  &
   z_shear_area_ratio = 1.0  &
   youngs_modulus = 7.1705E+04  &
   shear_modulus = 2.6956766917E+04  &
   ixx = 1.5707963268  &
   iyy = 0.7853981634  &
   izz = 0.7853981634  &
   damping_ratio = 1.0E-05  &
   formulation = linear
!
!----------------------------- Simulation Scripts -----------------------------!
!
!
simulation script create  &
   sim_script_name = .net_ball.Last_Sim  &
   commands =   &
              "simulation single_run scripted sim_script_name=.net_ball.SIM_SCRIPT_1 reset_before_and_after=yes model_name=.net_ball"
!
simulation script create  &
   sim_script_name = .net_ball.SIM_SCRIPT_1  &
   solver_commands = "sim/stat", "deact/joint,id=5",  &
                     "sim/dyn,end=.3,dtout=0.01",  &
                     "sim/dyn,end=.5,dtout=0.001"
!
!------------------------------ Dynamic Graphics ------------------------------!
!
!
defaults coordinate_system  &
   default_coordinate_system = .net_ball.ground
!
geometry create shape gcontact  &
   contact_force_name = .net_ball.GCONTACT_184  &
   adams_id = 184  &
   contact_element_name = .net_ball.CONTACT_1  &
   force_display = components
!
geometry attributes  &
   geometry_name = .net_ball.GCONTACT_184  &
   color = RED
!
geometry create shape gcontact  &
   contact_force_name = .net_ball.GCONTACT_185  &
   adams_id = 185  &
   contact_element_name = .net_ball.CONTACT_2  &
   force_display = components
!
geometry attributes  &
   geometry_name = .net_ball.GCONTACT_185  &
   color = RED
!
geometry create shape gcontact  &
   contact_force_name = .net_ball.GCONTACT_186  &
   adams_id = 186  &
   contact_element_name = .net_ball.CONTACT_3  &
   force_display = components
!
geometry attributes  &
   geometry_name = .net_ball.GCONTACT_186  &
   color = RED
!
geometry create shape gcontact  &
   contact_force_name = .net_ball.GCONTACT_187  &
   adams_id = 187  &
   contact_element_name = .net_ball.CONTACT_4  &
   force_display = components
!
geometry attributes  &
   geometry_name = .net_ball.GCONTACT_187  &
   color = RED
!
!---------------------------------- Accgrav -----------------------------------!
!
!
force create body gravitational  &
   gravity_field_name = gravity  &
   x_component_gravity = 0.0  &
   y_component_gravity = 0.0  &
   z_component_gravity = -9806.65
!
!----------------------------- Analysis settings ------------------------------!
!
!
executive_control set numerical_integration_parameters  &
   model_name = net_ball  &
   formulation = si2  &
   hmax_time_step = 1.0E-03  &
   scale = 1.0, 1.0, 1.0E-03
!
executive_control set preferences  &
   model_name = net_ball  &
   thread_count = 8
!
!---------------------------- Adams View Variables ----------------------------!
!
!
variable create  &
   variable_name = .net_ball.myMod  &
   object_value = (NONE)
!
!---------------------- Set Adams View Object Variables -----------------------!
!
!
variable modify  &
   variable_name = .net_ball.myMod  &
   object_value = .net_ball
!
!--------------------------- Expression definitions ---------------------------!
!
!
defaults coordinate_system  &
   default_coordinate_system = ground
!
material modify  &
   material_name = .net_ball.aluminum  &
   density = (2740.0(kg/meter**3))  &
   youngs_modulus = (7.1705E+10(Newton/meter**2))
!
material modify  &
   material_name = .net_ball.steel  &
   density = (7801.0(kg/meter**3))  &
   youngs_modulus = (2.07E+11(Newton/meter**2))
!
model display  &
   model_name = net_ball
